#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/DrawingA.h>
#include <ToolKit/DrawingAreaClass.h>

/*
 * Function: AmDrawingAreaClass::AmDrawingAreaClass()
 *
 * Purpose:
 *   Default constructor.
 *
 * Comments:
 *   Clears out all the fields specific to AmDrawingAreaClass.
 */

AmDrawingAreaClass::AmDrawingAreaClass()
    : AmBaseWidgetClass()
{
    _wArea = NULL;
}


/*
 * Function: AmDrawingAreaClass::AmDrawingAreaClass( wParent, szName)
 *
 * Purpose:
 *   AmDrawingAreaClass constructor which creates the drawing areawidget
 *   using the passed in parent widget and passed in name.
 *
 * Parameters:
 *   Widget     wParent : Parent widget of the new widget.
 *   const char *szName : Name of the widget.
 */

AmDrawingAreaClass::AmDrawingAreaClass( Widget     wParent,
                                    const char *szName)
    : AmBaseWidgetClass( wParent, szName)
{
    _wArea = XtVaCreateManagedWidget( _szName,
                                      xmDrawingAreaWidgetClass, _wParent,
                                      NULL);
    _wBase = _wArea;
 
    addDestroyCallback();
}


/*
 * Function: AmDrawingAreaClass::AmDrawingAreaClass( bwcParent, szName)
 *
 * Purpose:
 *   AmDrawingAreaClass constructor which creates the row column
 *   widget using the passed in parent widget and passed in name.
 *
 * Parameters:
 *   AmBaseWidgetClass bwcParent : Parent widget of the new widget.
 *   const char      *szName   : Name of the widget.
 */

AmDrawingAreaClass::AmDrawingAreaClass( AmBaseWidgetClass *bwcParent,
                          const char      *szName)
    : AmBaseWidgetClass( bwcParent, szName)
{
    _wArea = XtVaCreateManagedWidget( _szName,
                                      xmDrawingAreaWidgetClass, _wParent,
                                      NULL);
    _wBase = _wArea;
 
    addDestroyCallback();
}

/*
 * Function: AmDrawingAreaClass::~AmDrawingAreaClass()
 *
 * Purpose:
 *   Deconstructor.
 */

AmDrawingAreaClass::~AmDrawingAreaClass()
{
}
