#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>

#include <Xm/Label.h>
#include <ToolKit/LabelClass.h>

void
AmLabelClass::initializeValues()
{
}

void
AmLabelClass::createInterface()
{
    _wLabel = XtVaCreateManagedWidget( _szName,
                                       xmLabelWidgetClass, _wParent,
                                       NULL);

    _wBase = _wLabel;

    addDestroyCallback();
}


AmLabelClass::AmLabelClass()
    : AmBaseWidgetClass()
{
    _wLabel = NULL;
}


AmLabelClass::AmLabelClass( Widget     wParent,
                        const char *szName)
    : AmBaseWidgetClass( wParent, szName)
{
    initializeValues();
    createInterface();
}



AmLabelClass::AmLabelClass( AmBaseWidgetClass *bwcParent,
                        const char      *szName)
    : AmBaseWidgetClass( bwcParent, szName)
{
    initializeValues();
    createInterface();
}


AmLabelClass::~AmLabelClass()
{
}


void
AmLabelClass::SetLabel( const char *szLabel)
{
    XmString xsz;

    xsz = XmStringCreateLocalized(( char *) szLabel); 
    XtVaSetValues( _wLabel, XmNlabelString, xsz, NULL);
    XmStringFree( xsz);
}
