#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/Separator.h>

#include <ToolKit/RadioPaneClass.h>

void
AmRadioPaneClass::initializeValues()
{
    _lstButtons = NULL;
}

void
AmRadioPaneClass::createInterface()
{
    _wRowCol = XtVaCreateManagedWidget( _szName,
                                        xmRowColumnWidgetClass, _wParent,
                                        XmNradioBehavior, TRUE,
                                        XmNrowColumnType, XmWORK_AREA,
                                        NULL);

    _wBase = _wRowCol;
 
    addDestroyCallback(); 
}

/*
 * Function: AmRadioPaneClass::AmRadioPaneClass()
 *
 * Description:
 *   Default constructor. 
 */

AmRadioPaneClass::AmRadioPaneClass()
    : AmBaseWidgetClass()
{
    _wRowCol = NULL;
    _lstButtons = NULL;
}


/*
 * Function: AmRadioPaneClass::AmRadioPaneClass( wParent, szName);
 *
 * Parameters:
 *   Widget     wParent : Parent of the row column widget.
 *   const char *szName : Name of the row column widget.
 * 
 * Description:
 *    
 */

AmRadioPaneClass::AmRadioPaneClass( Widget     wParent,
                                const char *szName)
    : AmBaseWidgetClass( wParent, szName)
{
    initializeValues();
    createInterface();
}

AmRadioPaneClass::AmRadioPaneClass( AmBaseWidgetClass *bwcParent,
                                const char      *szName)
    : AmBaseWidgetClass( bwcParent, szName)
{
    initializeValues();
    createInterface();
}

AmRadioPaneClass::~AmRadioPaneClass()
{
    if ( _lstButtons != NULL) {
        AmJustFreeLst( _lstButtons);
        _lstButtons = NULL;
    }
}


AmToggleButtonClass *
AmRadioPaneClass::AddButton( const char     *szName,
                           XtCallbackProc xcp,
                           XtPointer      xp)
{
    AmToggleButtonClass *pwcButton;

    if ( _wRowCol != NULL) {  

        pwcButton = new AmToggleButtonClass( _wRowCol, szName, xcp, xp);
        _lstButtons = AmInsertNodeLst( pwcButton, _lstButtons);

        return( pwcButton);

    } else {

        return( NULL);

    }
}
