#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>

#include <Xm/Separator.h>
#include <ToolKit/SeparatorClass.h>

void
AmSeparatorClass::initializeValues()
{
}

void
AmSeparatorClass::createInterface()
{
    _wSeparator = XtVaCreateManagedWidget( _szName,
                                           xmSeparatorWidgetClass, _wParent,
                                           NULL);

    _wBase = _wSeparator;

    addDestroyCallback();
}


AmSeparatorClass::AmSeparatorClass()
    : AmBaseWidgetClass()
{
    _wSeparator = NULL;
}


AmSeparatorClass::AmSeparatorClass( Widget     wParent,
                                const char *szName)
    : AmBaseWidgetClass( wParent, szName)
{
    initializeValues();
    createInterface();
}


AmSeparatorClass::AmSeparatorClass( AmBaseWidgetClass *bwcParent,
                                const char      *szName)
    : AmBaseWidgetClass( bwcParent, szName)
{
    initializeValues();
    createInterface();
}


AmSeparatorClass::~AmSeparatorClass()
{
}
