#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>

#include <Xm/Xm.h>
#include <Xm/TextF.h>

#include <ToolKit/TextFieldClass.h>

void
AmTextFieldClass::initializeValues()
{
}

void
AmTextFieldClass::createInterface()
{
    _wTextField = XtVaCreateManagedWidget( _szName,
                                           xmTextFieldWidgetClass, _wParent,
                                           NULL);
   
    _wBase = _wTextField;

    addDestroyCallback();
}

/*
 * Function: AmTextFieldClass::AmTextFieldClass()
 *
 * Description:
 *   Default constructor. 
 */

AmTextFieldClass::AmTextFieldClass()
    : AmBaseWidgetClass()
{
    _wTextField = NULL;
}


/*
 * Function: AmTextFieldClass::AmTextFieldClass( wParent, szName);
 *
 * Parameters:
 *   Widget     wParent : Parent of the text field widget.
 *   const char *szName : Name of the text field widget.
 * 
 * Description:
 *    
 */

AmTextFieldClass::AmTextFieldClass( Widget     wParent,
                                const char *szName)
    : AmBaseWidgetClass( wParent, szName)
{
    initializeValues();
    createInterface();
}

AmTextFieldClass::AmTextFieldClass( AmBaseWidgetClass *bwcParent,
                                const char      *szName)
    : AmBaseWidgetClass( bwcParent, szName)
{
    initializeValues();
    createInterface();
}

AmTextFieldClass::~AmTextFieldClass()
{
}


void
AmTextFieldClass::SetValue( char *sz)
{
    XtVaSetValues( _wTextField, XmNvalue, sz, NULL);
}
