#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/ToggleB.h>
#include <ToolKit/ToggleButtonClass.h>

AmToggleButtonClass::AmToggleButtonClass()
    : AmBaseWidgetClass()
{
    _wToggleButton = NULL;
}


AmToggleButtonClass::AmToggleButtonClass( Widget          wParent,
                                      const char      *szName,
                                      XtCallbackProc  xCallback,
                                      XtPointer       xpClientData)
    : AmBaseWidgetClass( wParent, szName)
{
    _wToggleButton = XtVaCreateManagedWidget( szName,
                                              xmToggleButtonWidgetClass,
                                              wParent,
                                              NULL);

    if ( xCallback != NULL) {
        XtAddCallback( _wToggleButton, XmNvalueChangedCallback,
                       ( XtCallbackProc) xCallback,
                       ( XtPointer) xpClientData);
    }

    _wBase = _wToggleButton;

    addDestroyCallback();
}


AmToggleButtonClass::AmToggleButtonClass( AmBaseWidgetClass *bwcParent,
                                      const char      *szName,
                                      XtCallbackProc  xCallback,
                                      XtPointer       xpClientData)
    : AmBaseWidgetClass( bwcParent, szName)
{
    _wToggleButton = XtVaCreateManagedWidget( szName,
                                              xmToggleButtonWidgetClass,
                                              _wParent,
                                              NULL);

    if ( xCallback != NULL) {
        XtAddCallback( _wToggleButton, XmNvalueChangedCallback,
                       ( XtCallbackProc) xCallback,
                       ( XtPointer) xpClientData);
    }

    _wBase = _wToggleButton;

    addDestroyCallback();
}


AmToggleButtonClass::~AmToggleButtonClass()
{
}


Boolean
AmToggleButtonClass::GetState()
{
    return( XmToggleButtonGetState( _wToggleButton));
}


void
AmToggleButtonClass::SetState( Boolean fState,
                             Boolean fSendEvent)
{
    XmToggleButtonSetState( _wToggleButton, fState, fSendEvent);
}
