#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>

#include <ToolKit/ToolKit.h>
#include <ToolKit/ApplicationClass.h>
#include <ToolKit/FormClass.h>
#include <ToolKit/ButtonClass.h>
#include <ToolKit/ToolBarClass.h>
#include <ToolKit/MenuClass.h>
#include <ToolKit/MenuPaneClass.h>
#include <ToolKit/DialogClass.h>
#include <ToolKit/MessageBoxClass.h>
#include <ToolKit/ErrorBoxClass.h>

void
ShowDialog( Widget    wBtn,
            XtPointer xpClientData,
            XtPointer xpCallData)
{

    AmDialogClass *dc = ( AmDialogClass *) xpClientData;
    dc->Show();
}


void
ShowMessageBox( Widget    wBtn,
                XtPointer xpClientData,
                XtPointer xpCallData)
{
    AmMessageBoxClass *mc = ( AmMessageBoxClass *) xpClientData;
    mc->Show();

    AmErrorBoxClass *eb;
    eb = new AmErrorBoxClass( AmGetTopLevelWidget( wBtn), "ERROR ERROR ERROR");
}

int
main( int argc, char **argv)
{
    AmApplicationClass *ac;
    AmFormClass        *fc;
    AmToolBarClass     *tb;
    AmDialogClass      *dc;
    AmMessageBoxClass  *mc1, *mc2;
    AmButtonClass      *bc1, *bc2;
    AmMenuClass        *mb;
    AmMenuPaneClass    *mpFile, *mpEdit, *mpHelp;

    ac = new AmApplicationClass( "TestApp", argc, argv);

    fc = new AmFormClass( ac, "Form"); 

    mc1 = new AmMessageBoxClass( fc, "MessageBox");
    mc1->SetError( "This is an error message.");
    mc1->HideOnDelete();

    mc2 = new AmMessageBoxClass( fc, "MessageBox");
    mc2->SetMessage( "This a message message.");
    mc2->HideOnDelete();

    mb = new AmMenuClass( fc, "MenuBar");
    mb->AttachLeft();
    mb->AttachTop();
    mb->AttachRight();

    mpFile = new AmMenuPaneClass( mb, "File");
    mpEdit = new AmMenuPaneClass( mb, "Edit");
    mpHelp = new AmMenuPaneClass( mb, "Help");

    mpFile->AddButton( "New", NULL, NULL);
    mpFile->AddButton( "Open", NULL, NULL);
    mpFile->AddButton( "Close", NULL, NULL);

    mpEdit->AddButton( "Cut", NULL, NULL);
    mpEdit->AddButton( "Copy", NULL, NULL);
    mpEdit->AddButton( "Paste", NULL, NULL);
    
    tb = new AmToolBarClass( fc, "ToolBar");
    tb->AttachLeft();
    tb->AttachTop( mb);
    tb->AttachRight();

    tb->AddButton( "Tool Bar Button 1", NULL, NULL);
    tb->AddButton( "Tool Bar Button 2", NULL, NULL);

    bc1 = new AmButtonClass( fc, "Push Me",
                             ( XtCallbackProc) ShowMessageBox,
                             ( XtPointer) mc1);

    bc1->AttachLeft();
    bc1->AttachTop( tb);
    bc1->AttachRight();

    bc2 = new AmButtonClass( fc, "Push Me Too",
                             ( XtCallbackProc) ShowMessageBox,
                             ( XtPointer) mc2);
    bc2->AttachLeft();
    bc2->AttachTop( bc1);
    bc2->AttachRight();

    ac->Realize();

    XtAppMainLoop( ac->GetAppContext());
}
