#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/xapp.h>
#include <anvil/envdefs.h>
#include <anvil/errlib.h>
#include <anvil/motif.h>
#include <anvil/user_data.h>

#include <cad/CadApplicationClass.h>

CadApplicationClass::CadApplicationClass()
    : AmApplicationClass()
{
    _pwcEditor = NULL;    
}

CadApplicationClass::CadApplicationClass( const char *szClass,
                                          int        nArgs,
                                          char       **pszArgs)
    : AmApplicationClass( szClass, nArgs, pszArgs)
{
    AmInitApplication( _wTop);

    if ( getenv( CONFIG_ENV) == NULL) {
        AmPrintError( "Missing environment variable: \"%s\".", CONFIG_ENV);
    } else {
        _pwcEditor = new CadEditorClass( _wTop, szClass);
    }
}


CadApplicationClass::~CadApplicationClass()
{
}


void
CadApplicationClass::Run()
{
    XEvent xEvent;

    AnvilBoolean _fRun = TRUE;

    do {
        XtAppNextEvent( _ac, &xEvent);
        AmHelpHandler( XtDisplay( _wTop), _ac, &xEvent);
        XtDispatchEvent( &xEvent);
    } while ( _fRun == TRUE );
}
