#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/list.h>

/*********************************************************************
 *
 * Description:
 *	append two lists together, lisp rplaca style, where the 
 * 	AmLast pointer of the AmFirst list is "hooked" to the head of
 *	the second list 
 * Arguments:
 *	a, b - lists to append.
 * Returns:
 *	b concatenated to a.
 *
 *********************************************************************/

AmListPtr 
AmAppendLst( AmListPtr 	a,
	   AmListPtr 	b)
{
    AmListPtr 	p;

    if ( a == NULL) {
	return( b);
    }
    if ( b == NULL) {
	return( a);
    }
    p = a;
    while ( a->next != NULL) {
	a = a->next;
    }
    a->next = b;
    return( p);
}

