#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <anvil/project.h>
#include <anvil/list.h>

/* basic equality comparator function... 
   Modifications:
	should return a AnvilBoolean
*/

int 
AmEquals( void 	*a,
	  void	*b)
{
    return( a == b);
}

/*************************************************************************
 *
 * Description:
 * 	given a list, a target, and a comparison function, return the 
 *	list node which matches the target 
 * Arguments:
 *	target - target to search for.
 *	lst - list to search on.
 *	cmpFn - comparator function.
 * Returns:
 *	the index of the found element, or -1 if it wasn't found
 *
 ****************************************************************************/

int 
AmIndexDataLst( void 		*target,
	        AmListPtr 	lst,
	        AmSearchFn	cmpFn)
{
    int		index = 0;

    while ( lst != NULL) {
	if ( ( cmpFn)( target, lst->data)) {
	    return( index);
	}
	index++;
	lst = lst->next;
    }
    return( -1);
}
