#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* list insertion utility functions. */

#include <stdio.h>
#include <malloc.h>
#include <anvil/project.h>
#include <anvil/list.h>
#include <anvil/errcode.h>

/*************************************************************************
 *
 * Description:
 * 	insert a node after the head of a list 
 * Arguments:
 *	newdata - new element to insert.
 *	after - element to insert it after.
 * Modifications:
 *	should return an error code if the malloc fails.
 *
 ****************************************************************************/

AmListPtr 
AmInsertNodeAfterLst( void 	*newdata,
		    AmListPtr 	after)
{
    AmListPtr 	newel;

    newel = ( AmListPtr) malloc( sizeof( AmListRec));
    if ( newel == NULL) {
	DO_ERROR( AmMALLOC_FAILED);
	return( after);
    }
    newel->data = newdata;
    newel->next = after->next;
    after->next = newel;
    return( after);
}
