#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <malloc.h>
#include <anvil/project.h>
#include <anvil/list.h>
#include <anvil/errcode.h>

/*************************************************************************
 *
 * Description:
 * 	insert a node at the end of a list 
 * Arguments:
 * 	newdata - element to insert.
 *	list - list to insert it into
 * Returns:
 *	the original list with the new element inserted at the end.
 * Modifications:
 *	should return an error if the malloc() fails
 *
 *************************************************************************/

AmListPtr AmInsertNodeAtEndLst( void 		*newdata,
				AmListPtr 	list)
{
    AmListPtr 	head;

/* if the list is NULL, create a list to return */

    head = list;
    if ( list == NULL) {
	list = ( AmListPtr) malloc( sizeof( AmListRec));
	if ( list == NULL) {
	    DO_ERROR( AmMALLOC_FAILED);
	    return( NULL);
	}
	list->data = newdata;
	list->next = NULL;
	return( list);
    }

/* otherwise, walk down the list and bloop one off the end. */

    for ( ; list->next != NULL; list = list->next);
    list->next = ( AmListPtr) malloc( sizeof( AmListRec));
    if ( list->next == NULL) {
	DO_ERROR( AmMALLOC_FAILED);
	return( NULL);
    }
    list->next->data = newdata;
    list->next->next = NULL;
    return( head);
}
