#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <malloc.h>
#include <anvil/project.h>
#include <anvil/list.h>
#include <anvil/errcode.h>

/*************************************************************************
 *
 * Description:
 *      insert a node at the head of a list
 * Arguments:
 *      newdata - element to insert.
 *      list - list to insert it into
 * Returns:
 *      the original list with the new element inserted at the head.
 * Modifications:
 *      should return an error if the malloc() fails
 *
 *************************************************************************/

/* insert a node at the head of a list */

AmListPtr 
AmInsertNodeLst( void 		*newdata,
		 AmListPtr 	lst)
{
    AmListPtr 	newel;

    newel = ( AmListPtr) malloc( sizeof( AmListRec));
    if ( newel == NULL) {
 	DO_ERROR( AmMALLOC_FAILED);
	return( NULL);
    }
    newel->data = newdata;
    newel->next = lst;
    return( newel);
}
