#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <anvil/project.h>
#include <anvil/list.h>

/*************************************************************************
 *
 * Description:
 * 	return a pointer to the AmLast element in a function which 
 *	passes some predicate function 
 * Arguments:
 *	cmpFn - comparison function.
 *	list - list to get the AmLast matching occurrence from.
 * Returns:
 *	the AmLast data pointer passing the predicate function.
 * Modifications:
 *	the predicate function should take client data.
 *
 **************************************************************************/

void *
AmLastOfLst( AmElementFn	cmpFn,
	     AmListPtr		list)
{
    AmListPtr	lastPtr = NULL;

    for ( ; list != NULL; list = list->next) {
	if (( cmpFn)( list->data)) {
	    lastPtr = list;
	}
    }
    return(( lastPtr != NULL) ? lastPtr->data : NULL);
}
