#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <anvil/project.h>
#include <anvil/list.h>

/***********************************************************************
 *
 * Description:
 * 	return the Nth element in the list or NULL if the index is 
 *	beyond the list
 * Arguments:
 * 	index - index of the element.
 * 	lst - list to get the index from.
 * Returns:
 *	the data pointer for the AmNth element in the list
 *
 ************************************************************************/

void *
AmNth( int		index,
       AmListPtr	lst)
{
    while ( index-- > 0) {
	if ( lst == NULL) break;
	lst = lst->next;
    }
    return(( lst != NULL) ? lst->data : NULL);
}

/***********************************************************************
 *
 * Description:
 * 	return the Nth list pointer in the list or NULL if the index is 
 *	beyond the list
 * Arguments:
 * 	index - index of the list pointer.
 * 	lst - list to get the index from.
 * Returns:
 *	the list pointer for the AmNth element in the list
 *
 ************************************************************************/

AmListPtr 
AmNthLst( int		index,
	  AmListPtr	lst)
{
    while ( index-- > 0) {
	if ( lst == NULL) break;
	lst = lst->next;
    }
    return( lst);
}
