#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <malloc.h>
#include <anvil/project.h>
#include <anvil/list.h>
#include <anvil/errcode.h>

/***********************************************************************
 *
 * Description:
 *	generate a "trace" of the source list, where the list elements
 *	are copied, with data pointers set to the original data elements.
 * Arguments:
 *	a - list to trace.
 * Returns:
 * 	the traced list.
 * 
 ***********************************************************************/

AmListPtr 
AmTraceLst( AmListPtr	a)
{
    AmListPtr	b, head;

    if ( a == NULL) {
	return( NULL);
    }
    b = head = ( AmListPtr) malloc( sizeof( AmListRec));
    do {
	b->data = a->data;
	a = a->next;
	if ( a == NULL) {
	    b->next = NULL;
	    break;
	}
	b->next = ( AmListPtr) malloc( sizeof( AmListRec));
	b = b->next;
    } while ( 1);
    return( head);
}

