#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* AmBetween-ness testing functions */

#include <anvil/geometry.h>

/****************************************************************************
 *
 * Description:
 * 	is a AmBetween b and c? (b and c don't have to be ordered)
 * Arguments:
 *	a - value to test.
 *	b, c - values it's hopefully AmBetween.
 * Returns:
 *	TRUE if a is AmBetween b and c, FALSE otherwise.
 *
 ****************************************************************************/

AnvilBoolean AmBetween( int	a,
		 int	b,
		 int	c)
{
    return((( a >= b) && ( a <= c)) || (( a >= c) && ( a <= b)));
}

/****************************************************************************
 *
 * Description:
 * 	is a AmBetween b and c? (b and c don't have to be ordered)
 *	(floating point version)
 * Arguments:
 *	a - value to test.
 *	b, c - values it's hopefully AmBetween.
 * Returns:
 *	TRUE if a is AmBetween b and c, FALSE otherwise.
 *
 ****************************************************************************/

AnvilBoolean AmBetweenFloat( float	a,
		      float	b,
		      float	c)
{
    return((( a >= b) && ( a <= c)) || (( a >= c) && ( a <= b)));
}
/****************************************************************************
 *
 * Description:
 * 	is a inside b and c? (b and c don't have to be ordered)
 *	(floating point version)
 * Arguments:
 *	a - value to test.
 *	b, c - values it's hopefully AmBetween.
 * Returns:
 *	TRUE if a is AmBetween b and c, FALSE otherwise.
 *
 ****************************************************************************/

AnvilBoolean AmInsideFloat( float	a,
		     float	b,
		     float	c)
{
    return((( a > b) && ( a < c)) || (( a > c) && ( a < b)));
}
