#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include <anvil/project.h>
#include <anvil/mem_funcs.h>

/****************************************************************************
 *
 * Description:
 * 	Copy a memory pointer to a newly allocated block.
 * Arguments:
 *	data - data to copy.
 *	size - size of the data. 
 * Returns:
 *	A copy of the source data pointer or NULL if it couldn't be
 *	allocated.
 *
 ****************************************************************************/

void *AmCopyVec( const void 	*data, 
	       int		size)
{
    void *newData;

    if (( data == NULL) || ( size == 0)) {
	return( NULL);
    }
    newData = malloc( size);
    if ( newData == NULL) {
	DO_ERROR( AmMALLOC_FAILED);
   	return( NULL);
    }
    if ( newData != NULL) {
	memcpy( newData, data, size);
    }
    return( newData);
}
