%{
#include <string.h>
#include <stdio.h>
#include <anvil/description.h>
#include "descr.tab.h"

extern int AmDescrErrorLineNo;
extern char AmDescrErrorString[];

#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) (  result = AmFpYYinput( buffer, maxSize))
%}
%option noyywrap
 
%%

struct			{
			    descrlval.string = strdup( yytext);
			    return( STRUCT);
			}

typedef			{
			    descrlval.string = strdup( yytext);
			    return( TYPEDEF);
			}
[A-Za-z][A-Za-z0-9_]*	{
			    descrlval.string = strdup( yytext);
			    return( IDENT);
			}
[0-9]*			{
			    descrlval.string = strdup( yytext);
			    return( NUMBER);
			}
[ \t]+			{   }
[\n]			{   
			    AmDescrErrorLineNo++;
			}
\;			{ 
			    descrlval.string = strdup( yytext);
			    return( ';');
			}
\{			{ 
			    descrlval.string = strdup( yytext);
			    return( '{');
			}
\}			{ 
			    descrlval.string = strdup( yytext);
			    return( '}');
			}
\[			{ 
			    descrlval.string = strdup( yytext);
			    return( '[');
			}
\]			{ 
			    descrlval.string = strdup( yytext);
			    return( ']');
			}

.			{
			    sprintf( AmDescrErrorString, 
				     "illegal character %s at line %d\n", 
				     yytext, AmDescrErrorLineNo);
			}
%%
