%{
#include <string.h>
#include <stdio.h>
#include <anvil/list.h>
#include <anvil/enums.h>
#include <anvil/enumsP.h>
#include "enums.tab.h"

extern int AmEnumsErrorLineNo;
extern char AmEnumsErrorString[];

#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) (  result = AmEnumsFpYYinput( buffer, maxSize))
%}
%option noyywrap
 
%%

enumClass		{
			    return( ENUMCLASS);
			}
subdir			{
			    return( SUBDIR);
			}
[A-Za-z][A-Za-z0-9_]*   {
			    enumslval.string = strdup( yytext);
			    return( IDENT);
			}
[-0-9][0-9]*   		{
			    enumslval.number = atoi( yytext);
			    return( NUMBER);
			}

\#.*			{
			    return( COMMENT);
			}
[.:]			{
			    enumslval.string = yytext;
			    return( yytext[ 0]);
			}
[ \t]+			{	}
[\n]			{
			    AmEnumsErrorLineNo++;
			    return( yytext[ 0]);
			}
.			{
			    sprintf( AmEnumsErrorString, 
				     "illegal character %s at line %d\n", 
				     yytext, AmEnumsErrorLineNo);
			}
%%
