%{
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <anvil/project.h>
#include <anvil/errcode.h>
#include <anvil/enums.h>
#include <anvil/enumsP.h>
int yylex( void);
int yyerror( const char *msg);
%}

%union {
    char	character;
    char	*string;
    int		number;
}

%token <string> IDENT
%token <number> NUMBER
%token <string> ENUMCLASS
%token <string> SUBDIR
%token <string> COMMENT
%token <character> '.'
%token <character> ':'


%%

decllist    	: enumdecl
	    	| decllist enumdecl

enumdecl    	: enumClassDef	
	    	| enumDef
		| subdirDef
		| comment
		| emptyLine
	    	;

comment		: COMMENT '\n'			    { }
	    	;

emptyLine   	: '\n'
	    	;

subdirDef	: IDENT '.' SUBDIR ':' IDENT '\n'    { AmAddSubdirDef( $1, $5); }
		;

enumClassDef	: IDENT '.' ENUMCLASS ':' IDENT '\n' { AmAddEnumClassDef( $1, $5); }
		;

enumDef		: IDENT '.' IDENT ':' NUMBER '\n'    { AmAddEnumDef( $1, $3, $5); }
	    	;

%%
