%{
#include <string.h>
#include <stdio.h>
#include <anvil/list.h>
#include <anvil/expr.h>
#include "expr.tab.h"


#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) (  result = AmExprYYinput( buffer, maxSize))
%}
%option noyywrap
 
%%

[A-Za-z][A-Za-z0-9_]*	{
			    exprlval.string = strdup( yytext);
			    return( IDENT);
			}
[-0-9][0-9.]* 		{
			    exprlval.string = strdup( yytext);
			    return( NUMBER);
			}
[\(\)]			{
			    exprlval.string = yytext;
			    return( yytext[ 0]);
			}
[\+\-]			{
			    exprlval.string = yytext;
			    return( yytext[ 0]);
			}
[\*\/]			{
			    exprlval.string = yytext;
			    return( yytext[ 0]);
			}
[\=\^\<\>]		{
			    exprlval.string = yytext;
			    return( yytext[ 0]);
			}
[\|\&]			{
			    exprlval.string = yytext;
			    return( yytext[ 0]);
			}
.			{
			    fprintf( stderr, "illegal character %s\n", yytext);
			}
%%
