#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* string vector freeing utility functions. */

#include <malloc.h>
#include <stdio.h>
#include <anvil/project.h>
#include <anvil/strlib.h>

/****************************************************************************
 *
 * Description:
 * 	free a NULL-terminated vector of strings don't forget to handle NULL 
 *	vectors 
 * Arguments:
 *      vector - vector to free.
 *
 ****************************************************************************/

void 
AmFreeStrVec( char **vector)
{
    char **vecPtr;

    if ( vector == NULL) {
	return;
    }
    if ( *vector == NULL ) {
	return;
    }
    for ( vecPtr = vector; *vecPtr != NULL; vecPtr++) {
	FREE( *vecPtr);
    }
    FREE( vector);
}

/****************************************************************************
 *
 * Description:
 * 	free a vector of strings with a length (assuming the vector's 
 *	not NULL-terminated.
 * Arguments:
 *      vector - vector to free.
 *	numStr - number of strings in the vector.
 *
 ****************************************************************************/

void AmFreeStrNumVec( char **vector,
		    int  numStr)
{
    int	ii;

    if ( vector == NULL) {
	return;
    }
    for ( ii = 0; ii < numStr; ii++) {
	FREE( vector[ ii]);
    }
    FREE( vector);
}
