#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <anvil/ratio.h>

/****************************************************************************
 *
 * Description:
 *      scale a floating point value over a floating point range into
 *	an integer range.
 * Arguments:
 *      minFloat, maxFloat - floating point range.
 *	valFlot - value to scale.
 *	minInt, maxInt - integer range to scale into.
 * Returns:
 *      integer scaled value.
 *
 ****************************************************************************/


int 
AmFloatScaleToInt( float 	minFloat,
		 float 	maxFloat,
		 float 	valFloat,
		 int 	minInt,
		 int 	maxInt)
{
    float 	range, newRange, scale;
    int		valInt;

/* determine the ratio of the two ranges. */

    range = maxFloat - minFloat;
    newRange = maxInt - minInt;
    scale = newRange/range;

/* subtract the min from the value, scale it, and add the new min */

    valInt = ( int) (( valFloat - minFloat)*scale + 0.5 + minInt);
    return( valInt);
}
