#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */




/* utility functions to find the index of values in vectors */

#include <anvil/mem_funcs.h>

/****************************************************************************
 *
 * Description:
 *      get the index of a value in a vector of values.
 * Arguments:
 *      target - target to find.
 *	list - vector of values.
 *	numel - number of elements in the vector.
 * Returns:
 *      the index of the value in the vector, or -1 if it wasn't found.
 *
 ****************************************************************************/

int AmGetIndex( void	*target,
	      void	**list,
	      int	numel)
{
    int	ii;

    for ( ii = 0; ii < numel;  ii++) {
	if ( list[ ii] == target) {
	    return( ii);
	}
    }
    return( -1);
}

/****************************************************************************
 *
 * Description:
 *      is an integer in a table of integers?
 * Arguments:
 *      target - target to find.
 *	list - vector of integers.
 *	numel - number of elements in the vector.
 * Returns:
 *      TRUE if it's found, FALSE otherwise.
 *
 ****************************************************************************/

AnvilBoolean AmInIntVector( int	target,
		     int	*vec,
		     int	numel)
{
    if ( vec == NULL) {
	return( FALSE);
    }
    while ( numel--) {
	if ( target == *vec++) {
	    return( TRUE);
	}
    }
    return( FALSE);
}
