#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <anvil/ratio.h>

/****************************************************************************
 *
 * Description:
 *      scale an integer point value over an integer point range into
 *      a floating point range.
 * Arguments:
 *      minInt, maxInt - integer range.
 *      valInt - value to scale.
 *      minFloat, maxFloat - floating point range to scale into.
 * Returns:
 *      floating point scaled value.
 *
 ****************************************************************************/

float AmIntScaleToFloat( int 	minInt,
		       int 	maxInt,
		       int 	valInt,
		       float 	minFloat,
		       float 	maxFloat)
{
    float range, newRange, scale, valFloat;

/* determine the ratio of the two ranges. */

    range = maxInt - minInt;
    newRange = maxFloat - minFloat;
    scale = newRange/range;

/* subtract the min from the value, scale it, and add the new min */

    valFloat = ( valInt - minInt)*scale + minFloat;
    return( valFloat);
}
