#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/project.h>
#include <anvil/files.h>

/****************************************************************************
 *
 * Description:
 * 	count the number of lines in a file.  return -1 if the file can't 
 *	be opened.  (lines are counted by newlines) 
 * Arguments:
 *      filename - ASCII file to count the lines for
 * Returns:
 *      the number of lines in the file, or -1 if the file couldn't be
 *	opened.
 *
 ****************************************************************************/

int 
AmNumLines( const char *filename)
{
    FILE 	*fp;
    int 	numLines = 0;
    char 	linebuf[ 1024];

    if (( fp = fopen( filename, "r")) == NULL) {
	return( -1);
    }
    do {
	if ( fgets( linebuf, sizeof( linebuf), fp) == NULL) {
	    break;
	}
	numLines++;
    } while ( TRUE);
    fclose( fp);
    return( numLines);
}
