#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */




#include <math.h>
#include <anvil/polyarea.h>

/****************************************************************************
 *
 * Description:
 * 	this polygon area calculation algorithm comes from graphics
 *	gems, and basically sums the project of each point with its
 *	successor, then subtracts the staggered products.
 * Arguments:
 *	polygon - polygon to get the area from.
 * Returns:
 *	area of the polygon.
 *
 ****************************************************************************/

float 
AmPolygonArea( AmPolygonPtr	polygon)
{
    int		ii, jj;
    float	sum;
 
    sum = 0;
    jj = polygon->numPts - 1;
    for ( ii = 0; ii < polygon->numPts; ii++) {
	sum += polygon->pts[ jj].x*polygon->pts[ ii].y;
	jj = ii;
    }
    jj = polygon->numPts - 1;
    for ( ii = 0; ii < polygon->numPts; ii++) {
	sum -= polygon->pts[ jj].y*polygon->pts[ ii].x;
	jj = ii;
    }
    return( fabs( sum/2.0));
}
