#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <malloc.h>
#include <anvil/vector.h>
#include <anvil/errcode.h>

/****************************************************************************
 *
 * Description:
 * 	make a vector of evenly spaced floats of length from min to max.
 * Arguments:
 *	min, max - range start and end.
 *	length - number of values to generate in the array.
 * Returns:
 *	generated length array, or NULL if it couldn't be allocated.
 *
 ****************************************************************************/

float *AmMakeRangeVector( float	min,
		        float	max,
		        int	length)
{
    float	*vec, *vecPtr, step;

    vecPtr = vec = ( float *) malloc( sizeof( float)*length);
    if ( vec == NULL) {
	DO_ERROR( AmMALLOC_FAILED);
	return( NULL);
    }
    step = (max - min)/(length - 1);
    while ( length--) {
	*vecPtr++ = min;
	min += step;
    }
    return( vec);
}
