#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <malloc.h>
#include <stdio.h>
#include <string.h>
#include <anvil/project.h>
#include <anvil/files.h>

#define LINESIZE 1024

/****************************************************************************
 *
 * Description:
 * 	find the number of lines, allocate the array ( and terminator), 
 *	read each line and copy it to a pointer walking down the vector, 
 *	close the file, terminate the vector and return the header pointer 
 * Arguments:
 * 	filename - file to read.
 * Returns:
 *	NULL terminated vector of strings from the file.
 *
 ****************************************************************************/

char **
AmReadLines( const char	*filename)
{
    FILE 	*fp;
    int 	numlines;
    char 	**result, **resPtr, line[ LINESIZE];

    numlines = AmNumLines( filename);
    if ( numlines == -1) {
	return( NULL);
    }
    result = resPtr = ( char **) malloc(( numlines + 1) * sizeof( char *));
    fp = fopen( filename, "r");
    do {
	if ( fgets( line, LINESIZE, fp) == NULL) break;
	line[ strlen( line) - 1] = '\0';
	*resPtr++ = strdup( line);
    } while ( TRUE);
    fclose( fp);
    *resPtr = NULL;
    return( result);
}
