%{
#include <string.h>
#include <stdio.h>
#include <anvil/list.h>
#include <anvil/units.h>
#include <anvil/unitsP.h>
#include "units.tab.h"

extern int AmUnitsErrorLineNo;
extern char AmUnitsErrorString[];

#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) (  result = AmUnitsFpYYinput( buffer, maxSize))
%}
%option noyywrap
 
%%

precision		{
			    unitslval.string = strdup( yytext);
			    return( PRECISION);
			}
print			{
			    unitslval.string = strdup( yytext);
			    return( PRINT);
			}
scan			{
			    unitslval.string = strdup( yytext);
			    return( SCAN);
			}
string			{
			    unitslval.string = strdup( yytext);
			    return( STRING);
			}
regexp			{
			    unitslval.string = strdup( yytext);
			    return( REGEXP);
			}
[A-Za-z][A-Za-z0-9_]*	{
			    unitslval.string = strdup( yytext);
			    return( IDENT);
			}
[-0-9][0-9.]* 		{
			    unitslval.string = strdup( yytext);
			    return( NUMBER);
			}
[ \t]+			{   }
[\n]			{   
			    AmUnitsErrorLineNo++;
			    return( '\n');
			}
\#.*			{
			    return( COMMENT);
			}
"->"			{ 
			    unitslval.string = yytext;
			    return( CONVERT);
			}
[()\+\-\*\/\/:\.]	{
			    unitslval.string = yytext;
			    return( yytext[ 0]);
			}
\"[^\n]*\"		{
			    unitslval.string = yytext;
			    return( ANYTHING);
			}
.			{
			    sprintf( AmUnitsErrorString, 
				     "illegal character %s at line %d\n", 
				     yytext, AmUnitsErrorLineNo);
			}
%%
