#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/project.h>
#include <anvil/strlib.h>

/****************************************************************************
 *
 * Description:
 * 	return the length of a NULL terminated vector of strings
 * Arguments:
 *      vector - NULL terminated vector of strings to get the length for.
 * Returns:
 *      the vector's length (what else would it return?)
 *
 ****************************************************************************/

int 
AmVeclen( char const **vector)
{
    int length = 0;

    if ( vector == NULL) {
	return( 0);
    }
    for ( ; *vector != NULL; vector++) {
	length++;
    }
    return( length);
}
