%{
#include <string.h>
#include <stdio.h>
#include <anvil/list.h>
#include <anvil/dialang.h>
#include "dialog.tab.h"

extern int dialogErrorLineNo;
extern FILE *dialogFp;

#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) (  result = AmDialogFpYYinput( buffer, maxSize))
%}
%option noyywrap
 
%%
if 			{ 
			    dialoglval.string = yytext;
			    return( IF);
			}
then 			{ 
			    dialoglval.string = yytext;
			    return( THEN);
			}
else 			{ 
			    dialoglval.string = yytext;
			    return( ELSE);
			}
[A-Za-z][A-Za-z0-9_\.]*	{
			    dialoglval.string = strdup( yytext);
			    return( IDENT);
			}
[A-Za-z0-9_\.-]*	{
			    dialoglval.string = strdup( yytext);
			    return( VALUE);
			}
[ \t]+			{   }
[\n]			{   
			    dialogErrorLineNo++;
			}
\=\=			{
			    dialoglval.string = yytext;
			    return( EQUALS);
			}
\!\=			{
			    dialoglval.string = yytext;
			    return( NOT_EQUALS);
			}
[;(){},=]		{ 
			    dialoglval.string = yytext;
			    return( yytext[ 0]);
			}
.			{
			    fprintf( stderr, "illegal character %s\n", yytext);
			}
%%
