#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */




#include <X11/cursorfont.h>
#include <Xm/Xm.h>

#include <anvil/project.h>
#include <anvil/motif.h>

#include <ToolKit/ToolKit.h>

/*****************************************************************************
 *
 * Function: AmForceDisplay( w, fMap)
 *
 * Purpose:
 *    AmForceDisplay makes sure that a dialog is either visible (when fMap
 *    is TRUE) or not visible (when fMap is FALSE).  This is useful when
 *    a dialog is to be displayed or removed before a long computation
 *    without returning to the X windows' main loop.
 *
 * Parameters:
 *     Widget  w    - The widget to be mapped or unmapped.
 *     AnvilBoolean fMap - Whether to wait for the widget to be mapped (TRUE)
 *                    or unmapped (FALSE).
 *
 *****************************************************************************/

void
AmForceDisplay( Widget  w,
                AnvilBoolean fMap)
{
    if ( fMap) {
        AmForceDisplayDialog( w);
    } else {
        AmForceRemoveDialog( w);
    }
}
