#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>

#include <anvil/project.h>
#include <anvil/motif.h>
#include <anvil/errdlog.h>
#include <anvil/resource.h>
#include <anvil/eventcodes.h>
#include <anvil/userevents.h>

#include <ToolKit/ToolKit.h>

Widget
AmMakeLogErrorDialog( Widget     wParent,
                      const char *szMessage)
{
    Widget     wDialog, w;
    const char *szResource, *szLabel;
    char       sz[ RESLEN];
    XmString   xsz;
    Arg        arg[ 20];
    int        n;

/*
 * Create a system dialog using the application wide visual, depth
 *   and colormap.
 */

    if ( wParent == NULL) {
        fprintf( stderr, "%s\n", szMessage);
        return( NULL);
    }

    xsz = XmStringCreateLtoR(( char *) szMessage, XmFONTLIST_DEFAULT_TAG);

    n = AmMakeArgList( arg,
            XmNmessageString, xsz,
            XmNdeleteResponse, XmDESTROY,
            NULL);

    wDialog = XmCreateErrorDialog( wParent, "logError", arg, n);
    XmStringFree( xsz);

    w = XmMessageBoxGetChild( wDialog, XmDIALOG_OK_BUTTON);
    szResource = AmGetResourceName( w); 
    sprintf( sz, "%s.labelString", szResource);
    szLabel = AmGetDefault( szResource, "OK");
    xsz = XmStringCreateLtoR(( char *) szLabel, XmFONTLIST_DEFAULT_TAG);
    XtVaSetValues( w, XmNlabelString, xsz, NULL);
    XmStringFree( xsz);

    w = XmMessageBoxGetChild( wDialog, XmDIALOG_HELP_BUTTON);
    szResource = AmGetResourceName( w); 
    sprintf( sz, "%s.labelString", szResource);
    szLabel = AmGetDefault( szResource, "Details ...");
    xsz = XmStringCreateLtoR(( char *) szLabel, XmFONTLIST_DEFAULT_TAG);
    XtVaSetValues( w, XmNlabelString, xsz, NULL);
    XmStringFree( xsz);

    w = XmMessageBoxGetChild( wDialog, XmDIALOG_CANCEL_BUTTON);
    XtUnmanageChild( w);

    XtManageChild( wDialog);
    AmForceDisplayDialog( wDialog);

    AmSendUserEvent( AM_PKG_ID, AM_MESSAGE_STRING, ( char *) szMessage);

    return( wDialog);
}
