#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <stdarg.h>
#include <Xm/Xm.h>
#include <anvil/motif.h>
        
/* create an Arg list from a varargs list */

/*
 * Function: AmMakeArgList( args, ... )
 *
 * Purpose:
 *     Create an argument list from the variable arguments passed in.
 *
 * Parameters:
 *     ArgList vArgs: Vector where the arguments are supposed to be 
 *                    stuffed into.
 *     ...          : The variable arguments that are supposed to be
 *                    stuffed into the vArgs array.
 *
 * Returns:
 *     int : The number of arguments stuffed into the vArgs array.
 */

int
AmMakeArgList( ArgList vArgs, ...)
{
    va_list	argList;
    int		n = 0;

    va_start( argList, vArgs);
    for ( ;;) {
        vArgs[ n].name = va_arg( argList, char *);
        if ( vArgs[ n].name == NULL) {
	    va_end( argList);
            return( n);
        }
	vArgs[ n++].value = va_arg( argList, XtArgVal);
    } 

    va_end( vArgs);
}
