#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <malloc.h>
#include <Xm/Xm.h>
#include <anvil/project.h>
#include <anvil/motif.h>

/* create a list of motif strings from a vector of strings ( NULL terminated) */

XmString *AmMotifStringList( char 	**strings,
			   int		*numStr)
{
    char	**strPtr;
    XmString	*mtPtr, *mtStrLst;

    *numStr = 0;
    if ( strings == NULL) {
	return( NULL);
    }
    for ( strPtr = strings; *strPtr != NULL; strPtr++) {
	( *numStr)++;
    }
    mtPtr = mtStrLst = ( XmString *) malloc( sizeof( XmString)*( *numStr));
    while ( *strings != NULL) {
	*mtPtr++ = MtString( *strings++);
    }
    return( mtStrLst);
}

/* free the list of XmStrings */

void AmFreeMotifStringList( XmString 	*strings,
			  int		numStr)
{
    int	ii;

    for ( ii = 0; ii < numStr; ii++) {
	XmStringFree( strings[ ii]);
    }
    free( strings);
}
