#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <malloc.h>
#include <Xm/Xm.h>
#include <anvil/strlib.h>
#include <anvil/motif.h>

/* popdown a dialog created by a convienience function */

void AmPopdownCback( Widget,
		   Widget	dialogForm,
		   XtPointer)
{
    XtDestroyWidget( XtParent( dialogForm));
}

void AmUnmapCback( Widget,
		 Widget	dialogForm,
		 XtPointer)
{
    XtUnmapWidget( XtParent( dialogForm));
}

/* popdown a shell */

void AmDestroyShellCallback( Widget,
			   Widget	shell,
			   XtPointer)
{
    XtDestroyWidget( shell);
}

/* free a struct pointer when a widget is destroyed */

void AmFreeStructPtrCallback( Widget,
			    XtPointer	clientData,
			    XtPointer)
{
    free( clientData);
}

/* free a string vector pointer wheh a widget is destroyed */

void AmFreeStrvecCallback( Widget,
			 char	**clientData,
			 XtPointer)
{
    AmFreeStrVec( clientData);
}

/* callbacks for managing and unmanaging dialogs */

void AmManageSubDialogCallback( Widget    button,
                              Widget    dlogShell,
                              XtPointer)
{
    XtSetSensitive( button, FALSE);
    XtManageChild( dlogShell);
    XtRemoveCallback( button, XmNactivateCallback,
                      ( XtCallbackProc) AmManageSubDialogCallback, dlogShell);
}

void AmUnmanageSubDialogCallback( Widget  okBtn,
                                Widget  launchBtn,
                                Widget  dlogShell,
                                XtPointer)
{
    XtUnmanageChild( dlogShell);
    XtAddCallback( launchBtn, XmNactivateCallback,
                   ( XtCallbackProc) AmManageSubDialogCallback, dlogShell);
    XtSetSensitive( launchBtn, TRUE);
}

/* callbacks for popping up and popping down dialogs */

void AmPopupSubDialogCallback( Widget    button,
                             Widget    dlogShell,
                             XtPointer)
{
    XtSetSensitive( button, FALSE);
    XtPopup( dlogShell, XtGrabNonexclusive);
    XtRealizeWidget( dlogShell);
    XtRemoveCallback( button, XmNactivateCallback,
                      ( XtCallbackProc) AmPopupSubDialogCallback, dlogShell);
}

void AmPopdownSubDialogCallback( Widget  okBtn,
                               Widget  launchBtn,
                               Widget  dlogShell,
                               XtPointer)
{
    XtPopdown( dlogShell);
    XtAddCallback( launchBtn, XmNactivateCallback,
                   ( XtCallbackProc) AmPopupSubDialogCallback, dlogShell);
    XtSetSensitive( launchBtn, TRUE);
}
