#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdarg.h>
#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <anvil/project.h>
#include <anvil/resource.h>
#include <anvil/motif.h>
#include <anvil/question_dlog.h>

#include <ToolKit/ToolKit.h>
#include <ToolKit/QuestionBoxClass.h>

#define HUGE_BUFFER 5096

/* Question dialog that uses a resource for the message string. */

AmAnswerEnum
AmQuestionResourceDialog( Widget     wParent,
                          const char *szResource,
                          ...)
{
    va_list            args;
    const char         *szFmt = NULL;
    char               sz[ MSGLEN];
    AmAnswerEnum       eAnswer;

    AmQuestionBoxClass *qb;

/* If no parent is supplied, the answer is obvious. */

    if ( wParent == NULL) {
        return( AmANSWER_NONE);
    }

/* Get the question string. */

    szFmt = AmGetDefault( szResource, szResource);

    va_start( args, szResource);
    vsprintf( sz, szFmt, args);
    va_end( args);

/* Create the question dialog. */
 
    qb = new AmQuestionBoxClass( wParent, szResource); 

/* Pop the question. */

    eAnswer = qb->AskQuestion( sz);
    delete qb;

    return( eAnswer);
}
