#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <anvil/project.h>
#include <anvil/files.h>
#include <anvil/strlib.h>
#include <anvil/getcolor.h>
#include <anvil/errlib.h>

/* file format 

   colors can be specified either as names hex values or as RGB 0..255 values

    numColors
    lowest color
      .
      . 
    color
      .
    highest color
*/

int readAndAllocColors( 
    Display 	*display,		/* connection to X server */
    char 	*colorFile,		/* color file to read */
    Colormap 	cmap,			/* colormap to read colors into */
    int 	*numColors,		/* number of colors read */
    int		*numFileColors,		/* number of colors in file */
    XColor 	**colorRet)		/* vector of XColors returned */
{
    int 	ii;
    XColor 	*colorPtr;

    if ( !AmReadColors( display, colorFile, numFileColors, colorRet)) {
	AmPrintError( "Failed to read colormap file %s", colorFile);
	return( FALSE);
    }

/* read the colors from the file and save them in sampleSet */

    colorPtr = *colorRet;
    for ( ii = *numFileColors, colorPtr = *colorRet; ii; ii--, colorPtr++) {
	if ( !XAllocColor( display, cmap, colorPtr)) {
	    AmPrintError( "Failed to allocate color %d %d %d in file %s",
			colorPtr->red, colorPtr->green, colorPtr->blue,
			colorFile);
	    break;
	}
    }
    *numColors = colorPtr - *colorRet;
    return( TRUE);
}
