#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <anvil/project.h>
#include <anvil/motif.h>

static void setCmapHandler( Widget		w,
			    Colormap		cmap,
			    XExposeEvent	*event,
			    AnvilBoolean		*cotinueDispatch)
{
AN_DEBUG( 40, ("setting colormap\n"));
    XtRemoveEventHandler( w, ExposureMask, FALSE,
		          ( XtEventHandler) setCmapHandler, ( XtPointer) cmap);
    XSetWindowColormap( XtDisplay( w), XtWindow( AmGetWidgetShell(w)), cmap);
}

void AmSetCmap( Widget	w,
	      Colormap	cmap)
{
    XtAddEventHandler( w, ExposureMask, FALSE,
		       ( XtEventHandler) setCmapHandler, ( XtPointer) cmap);
}
