#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <Xm/Xm.h>
#include <anvil/motif.h>


/**************************************************************************
|* Function Name: setlabel()
|*
|* Description:   Sets the label string of the passed in label to the
|*                passed in string.  Takes care of conversion from a char *
|*                to the motif string.
|*
|* Parameters:    Widget labelWidget - the label that is supposed to get
|*                                     the label string set.
|*                const char *labelString - the string that the label is
|*                                          supposed to be set to.
|*
|* Return Values: NONE
|*
|* Side Effects:  NONE
|*
|* Notes:         NONE
|*
|**************************************************************************/

void 
AmSetLabel( Widget     labelWidget,
	  const char *labelString)
{
    XmString string;

    string = XmStringCreateLtoR(( char *) labelString, XmFONTLIST_DEFAULT_TAG);
    XtVaSetValues( labelWidget, XmNlabelString, string, NULL);
    XmStringFree( string);
} 

