#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>

#include <anvil/colorcell.h>
#include <anvil/xapp.h>
#include <anvil/xcolor.h>
#include <anvil/motif.h>
#include <anvil/slick.h>

void okCb( Widget	btn,
	   Widget	editable,
	   XtPointer)
{
    float	x;

    AmGetObjectValue( editable, &x);
    printf( "value = %.2f\n", x);
}

void okStringCb( Widget	btn,
	         Widget	editable,
	         XtPointer)
{
    char	string[ 100];

    AmGetObjectValue( editable, string);
    printf( "value = %s\n", string);
}

void okColorCb( Widget	btn,
	        Widget	editable,
	        XtPointer)
{
    AmColorCellRec color;

    AmGetObjectValue( editable, &color);
    printf( "color = (%02X, %02X, %02X) = %08X\n",
            color.red, color.green, color.blue, color.pixel);
}

void newSlickDialog( Widget	btn,
		     XtPointer,
		     XtPointer)
{
    Widget         shell = AmGetWidgetShell( btn), formDlog, rowcol, 
                   field1, field2, field3, field4, field5, okBtn;
    float          x = 5.0, y = 10.0;
    char           string[ 100], string2[ 100];
    AmColorCellRec color = { 0, 0, 0, 0 };

    AmSetPixelValue( &color);

    strcpy( string, "stack string test");
    strcpy( string2, "more stack string test");
    formDlog = XmCreateFormDialog( shell, "formDlog", NULL, 0);
    rowcol = XtVaCreateManagedWidget( "rowcol", xmRowColumnWidgetClass, 
				      formDlog,
				      XmNorientation, XmVERTICAL,
				      NULL);
    field1 = AmAddObject( rowcol, &x, "x", AmFLOAT, AmLOCAL);
    field2 = AmAddObject( rowcol, &y, "y", AmFLOAT, AmLOCAL);
    field3 = AmAddObject( rowcol, string, "string", AmSTRING, AmLOCAL);
    field4 = AmAddObject( rowcol, string2, "string2", AmSTRING, AmLOCAL);
    field5 = AmAddObject( rowcol, &color, "color", AmCOLOR_CELL, AmLOCAL);
    okBtn = XtVaCreateManagedWidget( "button", xmPushButtonWidgetClass, rowcol,
				     NULL);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okCb, field1);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okCb, field2);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okStringCb, field3);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okStringCb, field4);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okColorCb, field5);
    AmSetOkButton( okBtn);
    XtManageChild( formDlog);
}





int main( int argc, char *argv[])
{
    Widget	top, rowcol, field1, field2, field3, field4, okBtn,
		dlogBtn;
    float	x = 5.0, y = 10.0;
    char	string[100], *string2;

    top = XtInitialize ( "slicktest", "slicktest-db", NULL, 0, &argc, argv);

    AmInitApplication( top);

    rowcol = XtVaCreateManagedWidget( "rowcol", xmRowColumnWidgetClass, top,
				      XmNorientation, XmVERTICAL,
				      NULL);
    strcpy( string, "this is a test");
    string2 = ( char *) malloc( 100);
    strcpy( string2, "this is another test");
    field1 = AmAddObject( rowcol, &x, "x", AmFLOAT, AmSTATIC);
    field2 = AmAddObject( rowcol, &y, "y", AmFLOAT, AmSTATIC);
    field3 = AmAddObject( rowcol, string, "string", AmSTRING, AmSTATIC);
    field4 = AmAddObject( rowcol, &string2, "string2", AmSTRING, AmDYNAMIC);
    dlogBtn = XtVaCreateManagedWidget( "moreBtn", xmPushButtonWidgetClass, 
					rowcol, NULL);
    okBtn = XtVaCreateManagedWidget( "button", xmPushButtonWidgetClass, rowcol,
				     NULL);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okCb, field1);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okCb, field2);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okStringCb, field3);
    XtAddCallback( okBtn, XmNactivateCallback, 
		   ( XtCallbackProc) okStringCb, field4);
    XtAddCallback( dlogBtn, XmNactivateCallback, 
		   ( XtCallbackProc) newSlickDialog, NULL);
    XtRealizeWidget( top);
    XtMainLoop();
}
