#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <windows.h>
#include <winreg.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <anvil/project.h>
#include <anvil/registry.h>


/* take a resource file from X windows format and import it into the 
   registry */

AnvilBoolean importANVILregistry( char	*appName,
			     char 	*filename)
{
    FILE	*fp;
    LONG 	lResult;
    char	buffer[ 1024], *namePtr, *p, *valPtr, keyBuf[ 1024];
    HKEY	hKeyResult;
    DWORD 	dwDisposition;

    if (( fp = fopen( filename, "r")) == NULL) {
    	return( FALSE);
    }

    do {
    	if ( fgets( buffer, sizeof( buffer), fp) == NULL) {
	    break;
	}
	if ( buffer[ 0] == '#') {
	    continue;			/* skip comments */
	}
	namePtr = buffer;
	for ( p = buffer; (( *p != '\0') && ( *p != ';')); p++) {};
	if ( *p == '\0') {
	    continue;			/* skip over bad parses */
	}
	*p = '\0';
	p++;
	for ( ; isspace( *p); p++) {};
	valPtr = p;
	sprintf( keyBuf, "%s\\%s", appName, namePtr);

/* create the key in the registry using the appication name and
   the resource name */

	lResult = RegCreateKeyEx( HKEY_LOCAL_MACHINE,
				  keyBuf,
				  NULL, 
				  "",
				  REG_OPTION_NON_VOLATILE,
				  KEY_ALL_ACCESS,
				  NULL,
				  &hKeyResult,
				  &dwDisposition);

/* set the string value under the key in the registry */

	lResult = RegSetValueEx( hKeyResult, 
				 keyBuf,
				 NULL, 
				 REG_SZ,
				 ( const unsigned char *) valPtr,
				 strlen( valPtr));
    } while ( TRUE);
    fclose( fp);
    return( FALSE);
}
