#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



/*  Bacon Globular, Apian Globular I and Ortelius Oval */
#ifndef lint
static const char SCCSID[]="@(#)PJ_bacon.c	4.4	93/06/13	GIE	REL";
#endif
# define HLFPI2	2.46740110027233965467
# define EPS	1e-10
#define PROJ_PARMS__ \
	int bacn; \
	int ortl;
#define PJ_LIB__
#include <anvil/projectsP.h>
FORWARD(s_forward); /* spheroid */
	double ax, f;

	xy.y = P->bacn ? HALFPI * sin(lp.phi) : lp.phi;
	if ((ax = fabs(lp.lam)) >= EPS) {
		if (P->ortl && ax >= HALFPI)
			xy.x = sqrt(HLFPI2 - lp.phi * lp.phi + EPS) + ax - HALFPI;
		else {
			f = 0.5 * (HLFPI2 / ax + ax);
			xy.x = ax - f + sqrt(f * f - xy.y * xy.y);
		}
		if (lp.lam < 0.) xy.x = - xy.x;
	} else
		xy.x = 0.;
	return (xy);
}
FREEUP; if (P) pj_dalloc(P); }
ENTRY0(pj_bacon)
	P->bacn = 1;
	P->ortl = 0;
	P->es = 0.; P->fwd = s_forward;
ENDENTRY(P)
ENTRY0(pj_apian)
	P->bacn = P->ortl = 0;
	P->es = 0.; P->fwd = s_forward;
ENDENTRY(P)
ENTRY0(pj_ortel)
	P->bacn = 0;
	P->ortl = 1;
	P->es = 0.; P->fwd = s_forward;
ENDENTRY(P)
