#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#include <anvil/project.h>
#include <anvil/projects.h>
#include <anvil/projectsP.h>

void projectPt( PJ 	*pj,
		AnvilBoolean	invFlag,
		float	*x,
		float	*y)
{
    UV	uv;

    if ( !invFlag) {
	uv.u = *x*DEG_TO_RAD;
	uv.v = *y*DEG_TO_RAD;
	uv = pj_fwd( uv, pj);
	*x = uv.u;
	*y = uv.v;
    } else {
	uv.u = *x;
	uv.v = *y;
	uv = pj_inv( uv, pj);
	*x = uv.u*RAD_TO_DEG;
	*y = uv.v*RAD_TO_DEG;
    }
}
