#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



/* open structure for NAD27<->NAD83 conversion */
#ifndef lint
static const char SCCSID[]="@(#)nad_init.c	4.3   93/08/25 GIE REL";
#endif

#define PJ_LIB__

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <anvil/projects.h>
#include <anvil/projectsP.h>

extern FILE *pj_open_lib(char *, char *);

struct CTABLE *
nad_init(char *name) 
{

    char fname[FILENAME_MAX+1];
    struct CTABLE *ct;
    FILE *fid;
    size_t i;

    errno = pj_errno = 0;
    strcpy(fname, "nad2783/");
    strcat(fname, name);
    if (!(fid = pj_open_lib(fname, "rb"))) {
    	pj_errno = errno;
    	return 0;
    }

#ifdef sgi
    if (!(ct = pj_malloc(sizeof(struct CTABLE))) ||
#else
    if (!(ct = (struct CTABLE *)pj_malloc(sizeof(struct CTABLE))) ||
#endif
    	fread(ct, sizeof(struct CTABLE), 1, fid) != 1 ||
    	!(ct->cvs = (FLP *)pj_malloc(i=sizeof(FLP)*ct->lim.lam*ct->lim.phi)) ||
    	fread(ct->cvs, i, 1, fid) != 1) {

    	nad_free(ct);
    	pj_errno = -38;
    	ct = 0;
    	return 0;

    }

    fclose(fid);
    pj_errno = 0;
    return ct;

}



void
nad_free(struct CTABLE *ct) 
{
    if (ct) {
    	pj_dalloc(ct->cvs);
    	pj_dalloc(ct);
    }

}
