#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



#ifndef lint
static const char SCCSID[]="@(#)pj_list.c	4.5	93/06/12	GIE	REL";
#endif
/* Projection System: List of projections
** When adding a projection both of the following statements
** need to be updated.
*/
#include <anvil/projectsP.h>
	/* Prototypes */
extern PJ
	*pj_aea( PJ *), *pj_aeqd( PJ *), *pj_bipc( PJ *), *pj_bonne( PJ *),
        *pj_ob_tran( PJ *), *pj_cea( PJ *), *pj_eck4( PJ *), *pj_eck6( PJ *),
        *pj_eqc( PJ *), *pj_eqdc( PJ *), *pj_gnom( PJ *), *pj_laea( PJ *),
        *pj_lcc( PJ *), *pj_merc( PJ *), *pj_mill( PJ *), *pj_moll( PJ *),
        *pj_nsper( PJ *), *pj_omerc( PJ *), *pj_ortho( PJ *), *pj_poly( PJ *),
        *pj_sinu( PJ *), *pj_stere( PJ *), *pj_tmerc( PJ *), *pj_ups( PJ *),
        *pj_utm( PJ *), *pj_vandg( PJ *), *pj_cass( PJ *), *pj_tpers( PJ *),
        *pj_tcea( PJ *), *pj_ocea( PJ *), *pj_parab( PJ *), *pj_gall( PJ *),
        *pj_eck5( PJ *), *pj_wink1( PJ *), *pj_hammer( PJ *), *pj_august( PJ *),
        *pj_hataea( PJ *), *pj_mbtfps( PJ *), *pj_mbtfpq( PJ *),
        *pj_putp2( PJ *), *pj_eck3( PJ *), *pj_none( PJ *), *pj_mbtfpp( PJ *),
        *pj_putp5( PJ *), *pj_quau( PJ *), *pj_dense( PJ *), *pj_robin( PJ *),
        *pj_aitoff( PJ *), *pj_wintri( PJ *), *pj_eck1( PJ *), *pj_eck2( PJ *),
        *pj_boggs( PJ *), *pj_pconic( PJ *), *pj_rpoly( PJ *), *pj_airy( PJ *),
        *pj_bacon( PJ *), *pj_eisen( PJ *), *pj_fourn( PJ *), *pj_lagrng( PJ *),
        *pj_nicol( PJ *), *pj_ortel( PJ *), *pj_vandg2( PJ *),
        *pj_vandg3( PJ *), *pj_vandg4( PJ *), *pj_wag7( PJ *), *pj_leac( PJ *),
	*pj_loxim( PJ *), *pj_apian( PJ *), *pj_cc( PJ *), *pj_tcc( PJ *),
	*pj_collg( PJ *), *pj_goode( PJ *), *pj_chamb( PJ *), *pj_lsat( PJ *),
	*pj_alsk( PJ *), *pj_gs50( PJ *), *pj_tpeqd( PJ *), *pj_mil_os( PJ *),
	*pj_lee_os( PJ *), *pj_nzmg( PJ *), *pj_gs48( PJ *), *pj_labrd( PJ *);

	struct PJ_LIST
pj_list[] = {
	{"aea",		pj_aea,		"Albers Egual Area - Inv"},
	{"aeqd",		pj_aeqd,	"Azimuthal equidistant - Inv"},
	{"airy",		pj_airy,	"Airy"},
	{"aitoff",	pj_aitoff,	"Aitoff"},
	{"alsk",		pj_alsk,	"Alaska Mod.-Stereographics - Inv"},
	{"apian",	pj_apian,	"Apian Globular - Inv"},
	{"august",	pj_august,	"August Epicycloidal"},
	{"bacon",	pj_bacon,	"Bacon Globular"},
	{"bipc",		pj_bipc,	"Bipolar Conic - Inv"},
	{"boggs",	pj_boggs,	"Boggs Eumorphic"},
	{"bonne",	pj_bonne,	"Bonne - Inv"},
	{"cass",		pj_cass,	"Cassini - Inv"},
	{"cc",		pj_cc,		"Central Cylindrical - Inv"},
	{"cea",		pj_cea,		"Cylindrical Equal Area - Inv"},
	{"chamb",	pj_chamb,	"Chamberlin Trimetric"},
	{"collg",	pj_collg,	"Collignon - Inv"},
	{"dense",	pj_dense,	"Denoyer Semi-Elliptical"},
	{"eck1",		pj_eck1,	"Eckert I - Inv"},
	{"eck2",		pj_eck2,	"Eckert II - Inv"},
	{"eck3",		pj_eck3,	"Eckert III - Inv"},
	{"eck4",		pj_eck4,	"Eckert IV - Inv"},
	{"eck5",		pj_eck5,	"Eckert V - Inv"},
	{"eck6",		pj_eck6,	"Eckert VI - Inv"},
	{"eisen",	pj_eisen,	"Eisenlohr"},
	{"eqc",		pj_eqc,		"Equidistant Cylindrical - Inv"},
	{"eqdc",		pj_eqdc,	"Equidistant Conic - Inv"},
	{"fourn",	pj_fourn,	"Fournier Globular"},
	{"gall",		pj_gall,	"Gall (Stereographic) - Inv"},
	{"goode",	pj_goode,	"Goode Homolosine"},
	{"gnom",		pj_gnom,	"Gnomonic - Inv"},
	{"gs50",		pj_gs50,	"50 State U.S. Mod.-Stereographic - Inv"},
	{"gs48",		pj_gs48,	"48 State U.S. Mod.-Stereographic - Inv"},
	{"hammer",	pj_hammer,	"Hammer (Elliptical)"},
	{"hataea",	pj_hataea,	"Hatano Asymmetrical Equal Area - Inv"},
	{"labrd",	pj_labrd,	"Laborde - Inv"},
	{"lagrng",	pj_lagrng,	"Lagrange"},
	{"laea",		pj_laea,	"Lambert Azimuthal Equal Area - Inv"},
	{"leac",		pj_leac,	"Lambert Equal Area Conic - Inv"},
	{"lee_os",	pj_lee_os,	"Lee Oblate Stereographics Pacific - Inv"},
	{"lcc",		pj_lcc,		"Lambert Conformal Conic - Inv"},
	{"loxim",	pj_loxim,	"Loximuthal - Inv"},
	{"lsat",		pj_lsat,	"LANDSAT Space Oblique Mercator - Inv"},
	{"mbtfpp",	pj_mbtfpp,	"McBryde-Thomas Flat-Polar Parabolic - Inv"},
	{"mbtfps",	pj_mbtfps,	"McBryde-Thomas Flat-Polar Sinusoidal - Inv"},
	{"mbtfpq",	pj_mbtfpq,	"McBryde-Thomas Flat-Polar Quartic - Inv"},
	{"merc",		pj_merc,	"Mercator - Inv"},
	{"mill",		pj_mill,	"Miller - Inv"},
	{"mill_os",	pj_mil_os,	"Miller Oblate Stereographics Eur-Africa - Inv"},
	{"moll",		pj_moll,	"Mollweides - Inv"},
	{"nicol",	pj_nicol,	"Nicolosi Globular"},
	{"none",		pj_none,	"No Projection"},
	{"nsper",	pj_nsper,	"General Vertical Persepective - Inv"},
	{"nzmg",		pj_nzmg,	"New Zealand Map Grid - Inv"},
	{"ob_tran",	pj_ob_tran,	"General Oblique/Transverse translator"},
	{"ocea",		pj_ocea,	"Oblique Cylindrical Equal Area - Inv"},
	{"omerc",	pj_omerc,	"Oblique Mercator - Inv"},
	{"ortel",	pj_ortel,	"Ortelius"},
	{"ortho",	pj_ortho,	"Orthographic - Inv"},
	{"parab",	pj_parab,	"Caster Parabolic - Inv"},
	{"pconic",	pj_pconic,	"Perspective Conic"},
	{"poly",		pj_poly,	"Polyconic (American) - Inv"},
	{"putp2",	pj_putp2,	"Putnins P2' - Inv"},
	{"putp5",	pj_putp5,	"Putnins P5 - Inv"},
	{"rpoly",	pj_rpoly,	"Rectangular Polyconic"},
	{"quau",		pj_quau,	"Quartic Authalic - Inv"},
	{"robin",	pj_robin,	"Robinson - Inv"},
	{"sinu",		pj_sinu,	"Sinusoidal - Inv"},
	{"stere",	pj_stere,	"Stereographic - Inv"},
	{"tcc",		pj_tcc,		"Transverse Central Cylindrical - Inv"},
	{"tcea",		pj_tcea,	"Transverse Cylindrical Equal Area - Inv"},
	{"tmerc",	pj_tmerc,	"Transverse Mercator - Inv"},
	{"tpeqd",	pj_tpeqd,	"Two Point Equidistant"},
	{"tpers",	pj_tpers,	"Tilted perspective - Inv"},
	{"ups",		pj_ups,		"Universal Polar Stereographic - Inv"},
	{"utm",		pj_utm,		"Universal Transverse Mercator - Inv"},
	{"vandg",	pj_vandg,	"Van der Grinten - Inv"},
	{"vandg2",	pj_vandg2,	"Van der Grinten II"},
	{"vandg3",	pj_vandg3,	"Van der Grinten III"},
	{"vandg4",	pj_vandg4,	"Van der Grinten IV"},
	{"wag7",		pj_wag7,	"Wagner VII"},
	{"wink1",	pj_wink1,	"Winkel I - Inv"},
	{"wintri",	pj_wintri,	"Winkel Tripel"},
	{0,		0,	"list terminator"}
};
