#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */



/* standard location file open procedure */

#ifndef lint
static const char SCCSID[]="@(#)pj_open_lib.c	4.2   93/08/25 GIE REL";
#endif

#define PJ_LIB__
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <anvil/projectsP.h>
#include <anvil/envdefs.h>

static char  *proj_lib_name =
#ifdef HOME_LIB
HOME_LIB;
#else
0;
#endif


FILE  *pj_open_lib ( char    *name, 
		     char    *mode ) 
{
    char	fname[FILENAME_MAX+1], *sysname;
    FILE	*fid;
    int 	n = 0;

    /* check if ~/name */

    if ( *name == '~'  &&  name[1] == DIR_CHAR ) {
        if ( (sysname = getenv("HOME")) != NULL ) {
            strcpy ( fname, sysname );
            fname[n = strlen(fname)] = DIR_CHAR;
            fname[++n] = '\0';
            strcpy ( fname+n, name + 1 );
            sysname = fname;
        } else {
            return NULL;
	}

    /* or fixed path: /name, ./name or ../name */
    } else if ( *name == DIR_CHAR  ||  
	      (*name == '.' && name[1] == DIR_CHAR)  ||
              (!strncmp(name, "..", 2) && name[2] == DIR_CHAR) ) {

        sysname = name;

    } else if ( (sysname = getenv( CONFIG_ENV))  || 
		(sysname = proj_lib_name) ) {

        strcpy ( fname, sysname );
        fname[n = strlen(fname)] = DIR_CHAR;
        fname[++n] = '\0';
        strcpy ( fname+n, name );
        sysname = fname;

    /* just try it bare bones */
    } else {
        sysname = name;
    }

    if ( (fid = fopen(sysname, mode)) != NULL ) errno = 0;

    return ( fid );

}
