#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/DrawingA.h>
#include <anvil/project.h>
#include <anvil/motif.h>
#include <anvil/tagstrs.h>
#include <anvil/errlib.h>
#include <anvil/colorcell.h>
#include <anvil/visual.h>
#include <anvil/xapp.h>
#include <anvil/xcolor.h>
#include <anvil/cadplot.h>
#include <anvil/motifdisplay.h>

int main( int argc, char *argv[])
{
    AmCadPlotClass	*cadPlot;
    AmMotifDisplayClass	*motifDisplay;
    Widget		top, form, area;

    top = XtInitialize ( "polartest", "polartest-db", NULL, 0, &argc, argv);
    AmInitApplication( top);
    XtVaSetValues( top,
                   XmNcolormap, AmGetAppColormap(),
                   XmNvisual, AmGetAppVisual(),
                   XmNdepth, AmGetAppDepth(),
                   NULL);
    form = XtVaCreateManagedWidget( "form", xmFormWidgetClass, top,
    				    NULL);
    area = XtVaCreateManagedWidget( "area", xmDrawingAreaWidgetClass,
    				    form,
    				    StickLeft, StickRight,
    				    StickTop, StickBottom,
    				    XmNwidth, 300, 
    				    XmNheight, 300,
    				    NULL);
    motifDisplay = new AmMotifDisplayClass( area);
    cadPlot = new AmCadPlotClass( motifDisplay->GetDisplay(), "cad",
                                AmNheader, argv[ 1],
                                AmNx, 0,
                                AmNy, 0,
                                AmNwidth, 300,
                                AmNheight, 300,
                                AmNbottomMargin, 0,
                                AmNleftMargin, 0,
                                AmNrightMargin, 0,
                                AmNtopMargin, 0,
                                NULL);
    motifDisplay->AddObject( cadPlot);
    XtRealizeWidget( top);
    XtMainLoop();
}
