%{

#include <stdio.h>
#include <string.h>
#include <anvil/project.h>
#include <anvil/templateP.h>
#include "templ.tab.h"


#undef YY_INPUT
#define YY_INPUT( buffer, result, maxSize) \
    ( result = AmTemplFpYYinput( buffer, maxSize))

extern int templLineNo;
%}

/* Some of the basic types: */

%option noyywrap
%%
[(){}:]			{
			    templlval.string = yytext;
			    return( yytext[ 0]);
			}
[A-Za-z][A-Za-z0-9_\.]* {
			    templlval.string = strdup( yytext);
			    return( IDENT);
			}
\<.*\>			{
			    yytext[ strlen( yytext) - 1] = '\0';
			    templlval.string = strdup( &yytext[ 1]);
			    templLineNo++;
			    return( VALUE);
			}
\#.*			{ }
[ \t]+			{ }
\n			{
			    templLineNo++;
			}
.			{ fprintf( stderr, "illegal character %s\n", yytext); }
%%
