#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdlib.h>
#include <Xm/Xm.h>
#include <anvil/plot.h>
#include <anvil/errlib.h>
#include <anvil/overlay.h>
#include <anvil/plot_cback.h>

/* set the transparency for a plot */

AnvilBoolean AmSetTransparencyCallback( Widget		scale,
  			         AmMotifDisplayClass	*motifDisplay,
			         AmPlotClass		*plot,
			         XtPointer)
{
    int			min, max, val;
    float		transparency;

    if ( !plot->IsType( AmIMAGE_PLOT)) {
	AmAddResourceToLog( "transparencyImagePlotOnly");
	return( FALSE);
    }

/* get the values and range from the scale and scale it from 0 to 1 */

    XtVaGetValues( scale,
		   XmNminimum, &min,
		   XmNmaximum, &max,
		   XmNvalue, &val,
		   NULL);
    transparency = (( float) ( val - min))/(( float) ( max - min));
    AN_DEBUG( 60, ("transparency = %.2f\n", transparency));

/* update the plot and make it redraw */

    plot->SetVaFields( AmNtransparency, transparency,
		       NULL);

    return( TRUE);
}
