#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <anvil/ratio.h>
#include <anvil/strlib.h>
#include <anvil/datafmt.h>
#include <anvil/files.h>
#include <anvil/project.h>
#include <anvil/tagstrs.h>
#include <anvil/xresource.h>


int main( int argc, char *argv[])
{
    AmXResourceDbClass	*db;
    int			fdIn, rows, ii, size;
    FILE		*fpOut;
    AmLinePtr		line;
    AnvilBoolean		pipeFlag;
    uchar_t		*lineBuf;


/* open the input header, and output files */
 
    if (( fdIn = AmOpenReadFile( argv[ 2], &pipeFlag)) < 0) {
	fprintf( stderr, "failed to open input file %s\n", argv[ 3]);
	exit( -1);
    }
    if (( fpOut = fopen( argv[ 3], "w")) == NULL) {
	fprintf( stderr, "failed to open output file %s\n", argv[ 3]);
	exit( -1);
    }

    db = new AmXResourceDbClass( argv[ 1]);

    if ( !db->IsValid()) {
	fprintf( stderr, "failed to read header file %s\n", argv[ 1]);
	exit( -1);
    }
	
    if ( !db->GetResource( AmNrows, &rows)) {
	fprintf( stderr, "failed to read rows from vector file\n");
	exit( -1);
    }
    if ( !db->GetResource( AmNsize, &size)) {
	fprintf( stderr, "failed to read size from vector file\n");
	exit( -1);
    }
    lineBuf = ( uchar_t *) malloc( size);
    for ( ii = 0; ii < rows; ii++) {
	if ( AmReadLoopFile( fdIn, lineBuf, size) < size) {
	    fprintf( stderr, "failed to read line %d\n", ii);
	    exit( -1);
	}
	line = (AmLinePtr) lineBuf;
	fprintf( fpOut, "%.2f %.2f %.2f %.2f\n", 
		 line->x0, line->y0, line->x1, line->y1);
    }
}
