#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/project.h>
#include <anvil/files.h>
#include <anvil/strlib.h>
#include <util/utils.h>

/* take all the fields in a header file, and dump the ones which aren't
   in the specified list */

AnvilBoolean AmDumpHeaderExcept( char	*header,
		          char	**fields,
		          FILE	*fp)
{
    AnvilBoolean	found;
    char	**fieldptr, **lines, **saveLinePtr;

    saveLinePtr = lines = AmReadLines( header);
    if ( lines == NULL) {
	return( FALSE);
    }
    for ( ; *lines != NULL; lines++) {
	found = FALSE;
	for ( fieldptr = fields; *fieldptr != NULL; fieldptr++) {
	     if ( !strncmp( *lines, *fieldptr, strlen( *fieldptr))) {
		found = TRUE;
		break;
	    }
	}
	if ( !found) {
	    fprintf( fp, "%s\n", *lines);
	}
    }
    AmFreeStrVec( saveLinePtr);
    return( TRUE);
}
