#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/**********************************************************************
 *
 *  geo_free.c  -- Public routines for GEOTIFF GeoKey access.
 *
 *    Written By: Niles D. Ritter.
 *
 *  copyright (c) 1995   Niles D. Ritter
 *
 *  Permission granted to use this software, so long as this copyright
 *  notice accompanies any products derived therefrom.
 *
 **********************************************************************/

#include "geotiff.h"   /* public interface        */
#include "geo_tiffp.h" /* external TIFF interface */
#include "geo_keyp.h"  /* private interface       */


/**********************************************************************
 *
 *                        Public Routines
 *
 **********************************************************************/


void GTIFFree(GTIF* gtif)
{
	if (!gtif) return;
	
	/* Free parameter arrays */
	if (gtif->gt_ascii) _GTIFFree (gtif->gt_ascii);
	if (gtif->gt_double) _GTIFFree (gtif->gt_double);
	if (gtif->gt_short) _GTIFFree (gtif->gt_short);
	
	/* Free GeoKey arrays */
	if (gtif->gt_keys) _GTIFFree (gtif->gt_keys);
	if (gtif->gt_keyindex) _GTIFFree (gtif->gt_keyindex);
	
	_GTIFFree (gtif);
}
