#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/tagstrs.h>
#include <anvil/projects.h>
#include <anvil/macros.h>
#include <anvil/geometry.h>
#include <anvil/datafmt.h>
#include <anvil/resource.h>
#include <anvil/files.h>
#include <anvil/choppath.h>
#include <util/utils.h>

int main( int argc, char **argv)
{
    char   *xyFields[] = { AmNxunits, AmNyunits, NULL },
	   *xyzFields[] = { AmNxunits, AmNyunits, AmNzunits, NULL },
	   tmpPath[ PATHLEN];
    FILE   *hdrFp;

    if ( argc < 4) {	
	fprintf( stderr, "%s header xunits yunits [zunits]\n", argv[ 0]);
	exit( -1);
    }

/* rename requires the same file system */

    if ( *argv[ 1] == '/') {
	sprintf( tmpPath, "%s/hdrXXXXXX", AmGetPath( argv[ 1]));
    } else {
	strcpy( tmpPath, "hdrXXXXXX");
    }
    mktemp( tmpPath);
    if (( hdrFp = fopen( tmpPath, "w")) == NULL) {
	fprintf( stderr, "failed to open temporary header file %s\n", tmpPath);
	exit( -1);
    }
    fprintf( hdrFp, "xunits:	%s\n", argv[ 3]);
    fprintf( hdrFp, "yunits:	%s\n", argv[ 5]);
    if ( argc == 5) {
	fprintf( hdrFp, "zunits:	%s\n", argv[ 6]);
	AmDumpHeaderExcept( argv[ 1], xyzFields, hdrFp);
    } else {
	AmDumpHeaderExcept( argv[ 1], xyFields, hdrFp);
    }
    fclose( hdrFp);
    if ( rename( tmpPath, argv[ 1]) < 0) {
	fprintf( stderr, "failed to rename temp file %s to %s\n",
		 tmpPath, argv[ 1]);
	exit( -1);
    }
}

