#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/DrawingA.h>
#include <Xm/BulletinB.h>
#include <anvil/project.h>
#include <anvil/xdisplay.h>
#include <anvil/xapp.h>
#include <anvil/xcolor.h>
#include <anvil/visual.h>

AmXDisplayClass	*xdisplay;
AmXWindowClass	*xwin;
AmXGlyphClass	*glyph;
AnvilBoolean		AmFirst = TRUE;
char		*symfile;
Widget		top;

void drawCback( Widget	area,
		XtPointer,
		XtPointer)
{
    if ( AmFirst) {
	xdisplay = new AmXDisplayClass( top, 
				      DefaultColormap( XtDisplay( top),
					    DefaultScreen( XtDisplay( top))));
	xwin = new AmXWindowClass( area);
	glyph = new AmXGlyphClass( xdisplay, xwin, symfile, 255);
	AmFirst = FALSE;
    } 
    xdisplay->DrawGlyph( xwin, glyph, 100, 100);
    xdisplay->DrawGlyph( xwin, glyph, 105, 100);
}

void main( int argc, char *argv[])
{
    Widget bboard, area;

    top = XtInitialize ( "editor", "editor-db", NULL, 0, &argc, argv);
    symfile = argv[ 1];
    AmInitApplication( top);
    XtVaSetValues( top,
    		   XmNcolormap, AmGetAppColormap(),
    		   XmNvisual, AmGetAppVisual(),
    		   XmNdepth, AmGetAppDepth(),
    		   NULL);
    bboard = XtVaCreateManagedWidget( "bboard", xmBulletinBoardWidgetClass,
				      top, NULL);
    area = XtVaCreateManagedWidget( "bboard", xmDrawingAreaWidgetClass,
				    bboard, 
				    XmNwidth, 300,
				    XmNheight, 300,
				    NULL);
    XtAddCallback( area, XmNexposeCallback, drawCback, NULL);
    XtRealizeWidget( top);
    XtMainLoop();
}
