#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <X11/cursorfont.h>

#include <editor/SelectObjClass.h>


AmSelectObjClass::AmSelectObjClass()
{
    _pScreenObj = NULL;
    _pOutline = NULL;
}

AmSelectObjClass::AmSelectObjClass( AmScreenObjClass     *pScreenObj,
                                AmObjectOutlineClass *pOutline)
{
    _pScreenObj = pScreenObj;
    _pOutline = pOutline;
}

AmSelectObjClass::~AmSelectObjClass()
{
}

AmScreenObjClass *
AmSelectObjClass::GetScreenObj()
{
    return( _pScreenObj);
}

AmObjectOutlineClass *
AmSelectObjClass::GetOutline()
{
    return( _pOutline);
}
