#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <math.h>


int main( int argc, char *argv[])
{
    int		rows, cols, ii, jj, fd;
    float	*matrix;

    rows = atoi( argv[ 1]);
    cols = atoi( argv[ 2]);

    matrix = ( float *) malloc( rows*cols*sizeof( float));
    for ( ii = 0; ii < rows; ii++) {
	for ( jj = 0; jj < cols; jj++) {
	    matrix[ ii*cols + jj] = fabs( sin( M_PI*ii/rows)*sin( M_PI*jj/cols));
	}
    }
    if (( fd = open( argv[ 3], O_WRONLY | O_CREAT, 0666)) < 0) {
	fprintf( stderr, "failed to open file %s\n", argv[ 3]);
	exit( -1);
    }
    write( fd, matrix, rows*cols*sizeof( float));
    close( fd);
}
