#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <anvil/xdisplay.h>
#include <anvil/pixthing.h>

int main( int argc, char *argv[])
{
    int		width, height;
    uchar_t	*data;
    FILE	*fp;
    int		fd;
    char	filename[ 512];

    if ( !AmReadBitmapFileData( argv[ 1], &width, &height, &data, 1, 0)) {
	fprintf( stderr, "failed to read bitmap file %s\n", argv[ 1]);
	exit( -1);
    }
    sprintf( filename, "%s.hdr", argv[ 1]);
    if (( fp = fopen( filename, "w")) == NULL) {
	fprintf( stderr, "failed to open %s\n", filename);
	exit( -1);
    }
    fprintf( fp, "filename:	%s\n", filename);
    fprintf( fp, "rows:		%d\n", height);
    fprintf( fp, "cols:		%d\n", width);
    fprintf( fp, "size:		%d\n", sizeof( uchar_t));
    fprintf( fp, "dataType:	unsignedChar\n");
    fclose( fp);
    sprintf( filename, "%s.dat", argv[ 1]);
    if (( fd = open( filename, O_CREAT | O_WRONLY, 0666)) < 0) {
	fprintf( stderr, "failed to open %s\n", filename);
	exit( -1);
    }
    write( fd, data, width*height);
    close( fd);
    free( data);
}
