#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <anvil/enums.h>

int main( int argc, char *argv[])
{
    char	errorString[ 512], **lines, tag[ 512], enumName[ 512],
		**enumStrings;
    int		enumVal, ii, *enumValues, numValues;

    if ( argc < 3) {
	fprintf( stderr, "usage: %s enums-file strings-file\n", argv[ 0]);
	exit( -1);
    }

/* parse the units file */

    if ( AmParseEnumerationFile( argv[ 1], errorString)) {
	fprintf( stderr, "failed to parse enums file: %s\n", errorString);
	exit( -1);
    }

/* read the lines */

    lines = AmReadLines( argv[ 2]);

/* get enumeration code/string test */

    for ( ii = 0; lines[ ii] != NULL; ii++) {
	sscanf( lines[ ii], "%s %s", tag, enumName);
	if ( !AmGetStrEnum( tag, enumName, &enumVal)) {
	    printf( "failed to get enumeration for %s %s\n", tag, enumName);
	} else {
	    printf( "%s.%s: %d\n", tag, enumName, enumVal);
	    if ( !AmGetEnumStr( tag, enumVal, enumName)) {
		printf( "failed to get string for %s %d\n", tag, enumVal);
	    } else {
		printf( "%s.%s: %d\n", tag, enumName, enumVal);
	    }
	}
    }

/* get enumeration values test */

    for ( ii = 0; lines[ ii] != NULL; ii++) {
	sscanf( lines[ ii], "%s %s", tag, enumName);
	if ( !AmEnumStringValues( tag, &enumStrings, &enumValues, 
	    printf( "failed to get enumeration for %s %s\n", tag, enumName);
	} else {
	    printf( "%s.%s: %d\n", tag, enumName, enumVal);
	    if ( !AmGetEnumStr( tag, enumVal, enumName)) {
		printf( "failed to get string for %s %d\n", tag, enumVal);
	    } else {
		printf( "%s.%s: %d\n", tag, enumName, enumVal);
	    }
	}
    }

}
