#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/files.h>

int main( int argc, char *argv[])
{
    char	*fileString, **lines;
    int		numLines, *intVec, ii;
    float	*floatVec;

/* numlines and read file string tests */

    numLines = AmNumLines( argv[ 1]);
    printf( "numlines %s = %d\n", argv[ 1], numLines);
    fileString = AmReadFileString( argv[ 1]);
    if ( fileString == NULL) {
	printf( "read file string %s = NULL\n", argv[ 1]);
    } else {
	printf( "read file string %s:\n", fileString);
	free( fileString);
    }

/* read float vector tests */

    numLines = AmNumLines( argv[ 2]);
    floatVec = AmReadFloatVec( argv[ 2]);
    if ( floatVec != NULL) {
	printf( "numlines %s = %d\n", argv[ 2], numLines);
	for ( ii = 0; ii < numLines; ii++) {
	    printf( "%f\n", floatVec[ ii]);
	}
	free( floatVec);
	fileString = AmReadFileString( argv[ 2]);
	floatVec = AmReadFloatStrVec( fileString);
	printf( "read from string\n");
	for ( ii = 0; ii < numLines; ii++) {
	    printf( "%f\n", floatVec[ ii]);
	}
	free( floatVec);
    } else {
	printf( "failed to read file %s\n", argv[ 2]);
    }

/* read int vector tests */

    numLines = AmNumLines( argv[ 3]);
    intVec = AmReadIntVec( argv[ 3]);
    if ( intVec != NULL) {
	printf( "numlines %s = %d\n", argv[ 3], numLines);
	for ( ii = 0; ii < numLines; ii++) {
	    printf( "%d\n", intVec[ ii]);
	}
	free( intVec);
	fileString = AmReadFileString( argv[ 3]);
	intVec = AmReadIntStrVec( fileString);
	printf( "read from string\n");
	for ( ii = 0; ii < numLines; ii++) {
	    printf( "%d\n", intVec[ ii]);
	}
	free( intVec);
    } else {
	printf( "failed to read file %s\n", argv[ 3]);
    }

/* read string vector tests */

    lines = AmReadLines( argv[ 1]);
    printf( "read lines %s\n", argv[ 1]);
    if ( lines != NULL) {
	for ( ii = 0; lines[ ii] != NULL; ii++) {
	    printf( "%s\n", lines[ ii]);
	}
    } else {
	printf( "lines are NULL\n");
    }
}
