#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/geometry.h>


int main( int argc, char *argv[])
{
    FILE	*fp;
    int		x0, y0, x1, y1, x, y, rectX, rectY, rectWidth, rectHeight,
		lineX0, lineY0, lineX1, lineY1;
    float	slope;

    if (( fp = fopen( argv[ 1], "r")) == NULL) {
	fprintf( stderr, "failed to open file %s\n", argv[ 1]);
	exit( -1);
    }
    if ( fscanf( fp, "%d %d %d %d %d %d", &x0, &y0, &x1, &y1, &x, &y) != 6) {
	fprintf( stderr, "failed to read x, y values\n");
	exit( -1);
    }
    if ( fscanf( fp, "%f", &slope) != 1) {
	fprintf( stderr, "failed to slope\n");
	exit( -1);
    }
    if ( fscanf( fp, "%d %d %d %d", 
		 &rectX, &rectY, &rectWidth, &rectHeight) != 4) {
	fprintf( stderr, "failed to read rectangle values\n");
	exit( -1);
    }
    fclose( fp);

    printf( "lineat( %d, %d, %d, %d, %d) = %d\n",
	    x0, y0, x1, y1, x, AmLineat( x0, y0, x1, y1, x));
    printf( "lineaty( %d, %d, %d, %d, %d) = %d\n",
	    x0, y0, x1, y1, y, AmLineaty( x0, y0, x1, y1, y));
    printf( "slopeat( %d, %d, %f, %d) = %d\n",
	    x0, y0, slope, x, AmSlopeat( x0, y0, slope, x));
    printf( "slopeaty( %d, %d, %f, %d) = %d\n",
	    x0, y0, slope, y, AmSlopeaty( x0, y0, slope, y));
    AmLineSlopeRect( x0, y0, slope, rectX, rectY, rectWidth, rectHeight,
		     &lineX0, &lineY0, &lineX1, &lineY1);
    printf( "lineSlopeRect( %d, %d, %f), (%d, %d, %d, %d) = %d %d %d %d\n", 
	    x0, y0, slope, rectX, rectY, rectWidth, rectHeight,
	    lineX0, lineY0, lineX1, lineY1);
}
