#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/files.h>

int main( int argc, char *argv[])
{
    int		fd, nbytes, totalBytes;
    FILE	*fp;
    char	buffer[ 8192];
    AnvilBoolean	pipeFlag;

    printf( "file descriptor test\n");
    fd = AmOpenReadFile( argv[ 1], &pipeFlag);
    if ( fd < 0) {
	fprintf( stderr, "failed to open %s\n", argv[ 1]);
	exit( -1);
    }
    totalBytes = 0;
    do {
	nbytes = AmReadLoopFile( fd, buffer, sizeof( buffer));
	printf( "%s", buffer);
	totalBytes += nbytes;
    } while ( nbytes == sizeof( buffer));
    printf( "totalBytes = %d\n", nbytes);
    AmCloseReadFile( fd, pipeFlag);

    printf( "file pointer test\n");
    fp = AmOpenReadFilePointer( argv[ 1], &pipeFlag);
    totalBytes = 0;
    do {
	nbytes = AmReadLoopFilePointer( fp, buffer, sizeof( buffer));
	printf( "%s", buffer);
	totalBytes += nbytes;
    } while ( nbytes == sizeof( buffer));
    printf( "totalBytes = %d\n", nbytes);
    AmCloseReadFilePointer( fp, pipeFlag);
}
