#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/choppath.h>
#include <anvil/files.h>

int main( int argc, char *argv[])
{
    char path[ 1024], *subdirPath, *envPath;

/* root, path, and extension tests */

    strcpy( path, argv[ 1]);
    printf( "path = %s, root = %s\n", argv[ 1], AmGetRootName( path));
    strcpy( path, argv[ 1]);
    AmChopExtension( path);
    printf( "path = %s, extension chopped = %s\n", argv[ 1], path);
    strcpy( path, argv[ 1]);
    printf( "path = %s, extension = %s\n", argv[ 1], AmGetExtension( path));
    strcpy( path, argv[ 1]);
    printf( "path = %s, path prefix = %s\n", argv[ 1], AmGetPath( path));
    strcpy( path, argv[ 1]);
    if ( AmAbsolutePath( path)) {
	printf( "%s is absolute\n");
    } else {
	printf( "%s is not absolute\n");
    }

/* sane path tests */

    strcpy( path, argv[ 1]);
    AmSanePath( path);
    printf( "path = %s, sane path = %s\n", argv[ 1], path);

/* get file with environment variable test */

    if ( argc >= 4) {
	envPath = AmGetEnvFile( argv[ 2], argv[ 3]);
	if ( envPath != NULL) {
	    printf( "env = %s, file = %s, path = %s\n",
		    argv[ 2], argv[ 3], envPath);
	} else {
	    printf( "env = %s, file = %s, path = NULL\n",
		    argv[ 2], argv[ 3], NULL);
	}
    }
    if ( argc >= 5) {
	subdirPath = AmGetEnvSubdirFile( argv[ 2], argv[ 3], argv[ 4]);
	if ( subdirPath != NULL) {
	    printf( "env = %s, subdir = %s, file = %s, path = %s\n",
		    argv[ 2], argv[ 3], argv[ 4], subdirPath);
	} else {
	    printf( "env = %s, subdir = %s, file = %s, path = NULL\n",
		    argv[ 2], argv[ 3], argv[ 4]);
	}
    }

/* expand environment variable tests */

    if ( argc >= 6) {
	printf( "path = %s, envpath = %s\n", argv[ 5], AmFileEnvPath( argv[ 5]));
    }
}
