#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <Xm/Xm.h>
#include <anvil/template.h>
#include <anvil/postscript.h>
#include <anvil/xapp.h>
#include <anvil/log.h>


int main( int argc, char *argv[])
{
    AmPostScriptClass		*postScript;
    AmPostScriptOutputClass	*postScriptOutput;
    AmPostScriptGCClass		*postScriptGC;
    Widget			top;
    AmScreenObjClass		*screenObj;
    const char			*logFile;
    char			errorBuf[ 4096];
    FILE			*logFp, *printFp;

    top = XtInitialize ( "testplot", "testplot-db", NULL, 0, &argc, argv);
    AmInitApplication( top);
    postScript = new AmPostScriptClass( 24, AmTRUE_COLOR, 150);
    printFp = fopen( argv[ 2], "w");
    postScriptOutput = new AmPostScriptOutputClass( printFp, 8.5, 11.0,
						    postScript, FALSE,
						    "HP-650C");
    postScriptGC = new AmPostScriptGCClass( postScriptOutput);
    AmInitLog();

printf( "creating layer from header\n");

    if ( AmAddLayerFromHeader( postScriptOutput, argv[ 1], NULL, "NetMentor",
			       &screenObj) != AmOK) {
	printf( "failed to create object from %s\n", argv[ 1]);
	logFile = AmGetLogFile();
	logFp = fopen( logFile, "r");
	if ( logFp != NULL) {
	    fread( errorBuf, 1, sizeof( errorBuf), logFp);
	    fclose( logFp);
	    printf( "error log:\n%s\n", errorBuf);
	}
	exit( -1);
    }
    if ( screenObj->IsValid()) {
	printf( "%s is valid\n", screenObj->getObjectName());
    } else {
	printf( "%s is not valid\n", screenObj->getObjectName());
    }
    screenObj->Update();
    screenObj->Draw( postScriptOutput, postScriptGC, 
		     screenObj->GetRect(), 1);
    delete screenObj;
    delete postScriptGC;
    delete postScriptOutput;
    delete postScript;
    fclose( printFp);
}
