#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdio.h>
#include <string.h>
#include <anvil/project.h>
#include <anvil/regexp.h>
#include <anvil/files.h>

int main( int argc, char *argv[])
{
    AnvilBoolean 	partialFlag;

    if ( argc < 3) {
	fprintf( stderr, "usage: %s regexp string [partial]\n");
	exit( -1);
    }
    if ( argc == 4) {
	partialFlag = !strcasecmp( argv[ 3], "partial");
    } else {
	partialFlag = FALSE;
    }
    if ( AmRegexpMatch( argv[ 1], argv[ 2], partialFlag)) {
	printf( "%s matches %s\n", argv[ 2], argv[ 1]);
    } else {
	printf( "%s does not match %s\n", argv[ 2], argv[ 1]);
    }
}
