#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_action_area_class_h_
#define _tool_kit_action_area_class_h_

#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/FormClass.h>
#include <ToolKit/SeparatorClass.h>
#include <ToolKit/ButtonClass.h>

class AmActionAreaClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    AmFormClass      *_pwcForm;
    AmSeparatorClass *_pwcSeparator;
    AmFormClass      *_pwcButtonForm;

    int              _nButtons;
  
public:

    /* Constructors/Desctructors. */

    AmActionAreaClass();
    AmActionAreaClass( Widget     wParent,
                       const char *szName);
    AmActionAreaClass( AmBaseWidgetClass *bwcParent,
                       const char      *szName);
    virtual ~AmActionAreaClass();

    virtual const char *GetClassName() { return( "AmActionAreaClass"); };

    virtual AmButtonClass *AddButton( char           *szName,
                                      XtCallbackProc xcp,
                                      XtPointer      xp);
};

#endif /* _tool_kit_action_area_class_h_ */
