#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_application_class_h_
#define _tool_kit_application_class_h_

#include <ToolKit/BaseWidgetClass.h>

extern Boolean g_fRun;

class AmApplicationClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface( int  nArgs, char **pszArgs);

protected:

    XtAppContext _ac;
    Widget       _wTop;

public:

    /* Constructors/Desctructors. */

    AmApplicationClass();
    AmApplicationClass( const char *szName,
                        int        nArgs,
                        char       **pszArgs);
    virtual ~AmApplicationClass();

    void                 Realize();

    virtual void         Stop();
    virtual void         Run();

    /* Accessor functions. */

    XtAppContext         GetAppContext();
    virtual const char * GetClassName() { return( "AmApplicationClass"); };
};

void AmQuit();

#endif /* _tool_kit_application_class_h_ */
