#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_box_class_h_
#define _tool_kit_box_class_h_

#include <ToolKit/BaseWidgetClass.h>

class AmBoxClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    Widget _wShell;
    Widget _wBox;

    void   setIcon( int iType);
    void   setMessageString( const char *sz);

    void   hideOkButton();
    void   hideCancelButton();
    void   hideHelpButton();

    void   setOkCallback( XtCallbackProc xcp,
                          XtPointer      xp);
    void   setCancelCallback( XtCallbackProc xcp,
                              XtPointer      xp);
    void   setHelpCallback( XtCallbackProc xcp,
                            XtPointer      xp);
  
  
public:

    /* Constructors/Desctructors. */

    AmBoxClass();
    AmBoxClass( Widget     wParent,
                const char *szName);
    AmBoxClass( AmBaseWidgetClass *bwcParent,
                const char        *szName);
    virtual ~AmBoxClass();

    virtual const char *GetClassName() { return( "AmBoxClass"); };

    virtual void Show();
    virtual void Hide();

    virtual void DestroyOnDelete();
    virtual void HideOnDelete();

};

#endif /* _tool_kit_box_class_h_ */
