#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_dialog_class_h_
#define _tool_kit_dialog_class_h_

#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/ActionAreaClass.h>

class AmDialogClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    Widget            _wShell;
    Widget            _wDialogForm;
    Widget            _wForm;

    AmActionAreaClass *_pwcActionArea;
  
public:

    /* Constructors/Desctructors. */

    AmDialogClass();
    AmDialogClass( Widget     wParent,
                   const char *szName);
    AmDialogClass( AmBaseWidgetClass *bwcParent,
                   const char      *szName);
    virtual ~AmDialogClass();

    virtual const char *GetClassName() { return( "AmDialogClass"); };

    virtual Widget     GetForm();

    virtual void       Position( int x,
                                 int y);

    virtual void       Show();
    virtual void       Hide();

    virtual void       DestroyOnDelete();
    virtual void       HideOnDelete();

    virtual void       AddButton( char           *szName,
                                  XtCallbackProc callback,
                                  XtPointer      xpClientData);

};

#endif /* _tool_kit_dialog_class_h_ */
