#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_list_class_h_
#define _tool_kit_list_class_h_

#include <ToolKit/BaseWidgetClass.h>

class AmListClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    Widget _wList;

public:

    /* Constructors/Desctructors. */

    AmListClass();
    AmListClass( Widget         wParent,
               const char     *szName,
               XtCallbackProc xcp = NULL,
               XtPointer      xp = NULL);
    AmListClass( AmBaseWidgetClass *bwcParent,
               const char      *szName,
               XtCallbackProc  xcp = NULL,
               XtPointer       xp = NULL);
    virtual ~AmListClass();

    void SetSingleSelect();
    void SetBrowseSelect();
    void SetMultipleSelect();
    void SetExtendedSelect();
    void SetNumVisibleItems( int nItems);

    void AddItem( char    *szName,
                  int     iPos = 0,
                  Boolean fShowSelected = TRUE);
    void AddItems( char    **vszName,
                   int     nName, 
                   int     iPos = 0,
                   Boolean fShowSelected = TRUE);

    void DeleteItem( char *szName);
    void DeleteItems( char **vszName,
                      int  nName);
    void DeleteAllItems();

    void GetSelectedPositions( int **vPos,
                               int *nPos);


    void AddActionCallback( XtCallbackProc xcp,
                            XtPointer      xp);
    void RemoveActionCallback( XtCallbackProc xcp,
                               XtPointer      xp);

    void AddBrowseCallback( XtCallbackProc xcp,
                            XtPointer      xp);
    void RemoveBrowseCallback( XtCallbackProc xcp,
                               XtPointer      xp);

    void AddSingleCallback( XtCallbackProc xcp,
                            XtPointer      xp);
    void RemoveSingleCallback( XtCallbackProc xcp,
                               XtPointer      xp);

    void AddMultipleCallback( XtCallbackProc xcp,
                              XtPointer      xp);
    void RemoveMultipleCallback( XtCallbackProc xcp,
                                 XtPointer      xp);

    void AddExtendedCallback( XtCallbackProc xcp,
                              XtPointer      xp);
    void RemoveExtendedCallback( XtCallbackProc xcp,
                                 XtPointer      xp);

    virtual const char *GetClassName() { return( "AmListClass"); };
};

#endif /* _tool_kit_list_class_h_ */
