#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_option_menu_class_h_
#define _tool_kit_option_menu_class_h_

#include <anvil/list.h>

#include <ToolKit/BaseWidgetClass.h>

class AmComboBoxClass : public AmBaseWidgetClass {

private:

    void         initializeValues();
    void         createInterface();

    static void  AmActivateCallback( Widget    w,
                                   XtPointer xpClientData,
                                   XtPointer xpCallData);

    void activate( Widget    w,
                   XtPointer xpCallData);
     

protected:

    Widget         _wPulldownMenu;
    Widget         _wRowColumn;

    AmListPtr        _lstButtons;
  
    XtCallbackProc _xCallback;
    XtPointer      _xpClientData;

public:

    /* Constructors/Desctructors. */

    AmComboBoxClass();
    AmComboBoxClass( Widget     wParent,
                     const char *szName);
    AmComboBoxClass( AmBaseWidgetClass *bwcParent,
                     const char      *szName);
    virtual ~AmComboBoxClass();

    virtual void       AddButton( const char     *szName, 
                                  XtCallbackProc xCallback,
                                  XtPointer      xpClientData);

    /* Accessor functions */

    virtual const char *GetClassName() { return( "AmComboBoxClass"); };
    virtual Widget     GetRowColumn();
    virtual int        GetSelectedPosition();

    /* Mutator functions */

    virtual void       SetSelectedPosition( int iPos);
    virtual void       SetCallback( XtCallbackProc xCallback, 
                                    XtPointer      xpClientData);

};

#endif /* _tool_kit_option_menu_class_h_ */
