#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_popup_menu_class_h_
#define _tool_kit_popup_menu_class_h_

#include <Xm/RowColumn.h>

#include <anvil/list.h>

#include <ToolKit/ButtonClass.h>
#include <ToolKit/ToggleButtonClass.h>
#include <ToolKit/SeparatorClass.h>

class AmPopupMenuClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

    static void AmPopupEvent( Widget    w,
                            XtPointer xpClientData,
                            XEvent    *pxEvent);
    void popup( Widget w,
                XEvent *pxEvent);

protected:

    Widget    _wPane;
    AmListPtr _lstButtons;
    AnvilBoolean   _fAttached;

public:

    /* Constructors/Desctructors. */

    AmPopupMenuClass();
    AmPopupMenuClass( Widget     wParent,
                      const char *szName);
    AmPopupMenuClass( AmBaseWidgetClass *bwcParent,
                      const char      *szName);
    virtual ~AmPopupMenuClass();

    AmButtonClass *AddButton( const char     *szName,
                              XtCallbackProc xcp,
                              XtPointer      xp);

    AmToggleButtonClass *AddToggleButton( const char     *szName,
                                          XtCallbackProc xcp,
                                          XtPointer      xp);

    AmSeparatorClass *AddSeparator();

    AmBaseWidgetClass *GetButton( const char *szName);

    void Attach();

    virtual const char *GetClassName() { return( "AmPopupMenuClass"); };
};

#endif /* _tool_kit_popup_menu_class_h_ */
