#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_progress_bar_class_h_
#define _tool_kit_progress_bar_class_h_

#include <anvil/list.h>

#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/FrameClass.h>
#include <ToolKit/DrawingAreaClass.h>

class AmProgressBarClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

    void createGC();

    static void AmExposeCallback( Widget    w,
                                XtPointer xpClientData,
                                XtPointer xpCallData);
    void expose( Widget    w,
                 XtPointer xpCallData);

protected:

    static XtResource _xResources[];

    AmFrameClass       *_pwcFrame;
    AmDrawingAreaClass *_pwcArea;

    Display          *_pxDisplay;
    Window           _xWindow;
    GC               _xGC;
    Font             _xFont;

    long             _lFgPixel;
    long             _lBgPixel;

    int              _iMinValue;
    int              _iMaxValue;
    int              _iCurrValue;

    int              _cxBar;

    AnvilBoolean          _fShowPercentage;

    char             *_szLabel;

public:

    /* Constructors/Desctructors. */

    AmProgressBarClass();
    AmProgressBarClass( Widget     wParent,
                        const char *szName);
    AmProgressBarClass( AmBaseWidgetClass *bwcParent,
                        const char      *szName);
    virtual ~AmProgressBarClass();

    void SetMinValue( int iMinValue); 
    void SetMaxValue( int iMaxValue); 
    void SetCurrValue( int iCurrValue); 
  
    void ShowPercentage( AnvilBoolean fShowPercentage = TRUE);
    void ShowProgress( AnvilBoolean fShowProgress = TRUE);

    virtual const char *GetClassName() { return( "AmProgressBarClass"); };
};

#endif /* _tool_kit_progress_bar_class_h_ */
