#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_question_box_class_h_
#define _tool_kit_question_box_class_h_

#include <ToolKit/BoxClass.h>

typedef enum {
    AmANSWER_NONE   = 0,
    AmANSWER_YES    = 1,
    AmANSWER_NO     = 2,
    AmANSWER_CANCEL = 3
} AmAnswerEnum;

class AmQuestionBoxClass : public AmBoxClass {

private:

    void initializeValues();
    void createInterface();

protected:

    static XtResource _xResources[];

    Boolean           _fShowCancel; 
    AmAnswerEnum      _eAnswer;

    static void activateCallback( Widget    wButton,
                                  XtPointer xpClientData,
                                  XtPointer xpCallData);
    void activate( Widget    wButton,
                   XtPointer xpCallData);

public:

    /* Constructors/Desctructors. */

    AmQuestionBoxClass();
    AmQuestionBoxClass( Widget     wParent,
                        const char *szName);
    AmQuestionBoxClass( AmBaseWidgetClass *bwcParent,
                        const char        *szName);
    virtual ~AmQuestionBoxClass();

    AmAnswerEnum AskQuestion( const char *szMessage);
    AmAnswerEnum AskResourceQuestion( const char *szMessage);

    virtual const char *GetClassName() { return( "AmQuestionBoxClass"); };
};

#endif /* _tool_kit_question_box_class_h_ */
