#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_radio_pane_class_h_
#define _tool_kit_radio_pane_class_h_

#include <anvil/list.h>

#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/ToggleButtonClass.h>

class AmRadioPaneClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    Widget    _wRowCol;
    AmListPtr _lstButtons;

public:

    /* Constructors/Desctructors. */

    AmRadioPaneClass();
    AmRadioPaneClass( Widget     wParent,
                      const char *szName);
    AmRadioPaneClass( AmBaseWidgetClass *bwcParent,
                      const char      *szName);
    virtual ~AmRadioPaneClass();

    AmToggleButtonClass *AddButton( const char     *szName,
                                  XtCallbackProc xcp,
                                  XtPointer      xp);

    virtual const char *GetClassName() { return( "AmRadioPaneClass"); };
};

#endif /* _tool_kit_radio_pane_class_h_ */
