#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_ruler_class_h_
#define _editor_ruler_class_h_

#include <anvil/resource.h>
#include <anvil/xfonts.h>

#include <ToolKit/BaseWidgetClass.h>

class AmRulerClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();

protected:

    static XtResource _xResources[];

    Widget  _wFrame;
    Widget  _wRuler;
    Widget  _wArea; 

    GC      _xGC;
    Pixmap  _xPixmap;

    int     _iPos;
    int     _iWidth;
    int     _iHeight;
    int     _iDPI;
    int     _iDepth;

    int     _lFgPixel;
    int     _lBgPixel;
    int     _lRulerPixel;

    AnvilBoolean _fVertical;
    AnvilBoolean _fExposed;

    static void AmExposeRulerCallback( Widget    wRuler,
				     XtPointer pClientData,
				     XtPointer pCallData);
    static void AmExposeAreaCallback( Widget    wArea,
				    XtPointer pClientData,
				    XtPointer pCallData);
    static void AmResizeAreaCallback( Widget    wArea,
				    XtPointer pClientData,
				    XtPointer pCallData);
    
    void        CreateGC();
    void        CreatePixmap( int iWidth,
			      int iHeight);
    void        DrawPixmapVertical();
    void        DrawPixmapHorizontal();
    
public:
    
    /* Constructors/Desctructors. */
    
    AmRulerClass();
    AmRulerClass( Widget     wParent,
                  const char *szName,
                  Widget     wArea,
                  AnvilBoolean    fVertical);
    AmRulerClass( AmBaseWidgetClass *pwcParent,
                  const char      *szName,
                  Widget          wArea,
                  AnvilBoolean         fVertical);
    virtual ~AmRulerClass();
    
    /* Mutator functions. */
    
    void       SetDPI( int     iDPI,
                       AnvilBoolean fUpdate = TRUE);
    
    /* Accessor functions. */

    int        GetDPI;
    
    Widget GetFrameWidget();
    Widget GetRulerWidget();

    virtual const char *GetClassName() { return( "AmRulerClass"); };
};

#endif /* _editor_ruler_class_h_ */
