#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _tool_kit_scrolled_text_h_
#define _tool_kit_scrolled_text_h_

#include <ToolKit/BaseWidgetClass.h>

class AmScrolledTextClass : public AmBaseWidgetClass {

private:

    void         initializeValues();
    void         createInterface();

protected:

    Widget       _wText;
    Widget       _wWindow;
    Boolean      _fVariable;

public:

    /* Constructors/Desctructors. */

    AmScrolledTextClass();
    AmScrolledTextClass( Widget     wParent,
                         const char *szName,
                         Boolean    fVariable = TRUE);
    AmScrolledTextClass( AmBaseWidgetClass *bwcParent,
                         const char      *szName,
                         Boolean    fVariable = TRUE);
    virtual ~AmScrolledTextClass();

    void ShowCursorPosition( Boolean fShow = TRUE);
    void WrapWords( Boolean fWrap = TRUE);
    void AllowEditing( Boolean fEditable = TRUE);
    void SetAlwaysVisible( Boolean fVisible = TRUE);
    void SetVisibleWhenNeeded( Boolean fWhenNeeded = TRUE);

    void ShowHorizontalScrollBar( Boolean fShow);
    void ShowVerticalScrollBar( Boolean fShow);

    void SetText( char *sz);
    void AppendText( char *sz);

    virtual const char *GetClassName() { return( "AmScrolledTextClass"); };
};

#endif /* _tool_kit_scrolled_text_h_ */
