#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_tool_bar_class_h_
#define _editor_tool_bar_class_h_

#include <anvil/list.h>

#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/FrameClass.h>
#include <ToolKit/PaneClass.h>
#include <ToolKit/ButtonClass.h>
#include <ToolKit/ToggleButtonClass.h>
#include <ToolKit/SeparatorClass.h>

class AmToolBarClass : public AmBaseWidgetClass {

private:

    void initializeValues();
    void createInterface();
    
protected:

    AmFrameClass *_pwcFrame;
    AmPaneClass  *_pwcPane;
    AmListPtr    _lstButtons;
    
public:
    
    /* Constructors/Desctructors. */
    
    AmToolBarClass();
    AmToolBarClass( Widget     wParent,
                    const char *szName);
    AmToolBarClass( AmBaseWidgetClass *bwcParent,
                    const char      *szName);
    virtual ~AmToolBarClass();
    
    /* Mutator functions. */
    
    AmButtonClass *AddButton( const char     *szName,
                              XtCallbackProc xcp,
                              XtPointer      xp);
    AmToggleButtonClass *AddToggleButton( const char     *szName,
                                          XtCallbackProc xcp,
                                          XtPointer      xp);
    void AddSeparator();
    
    virtual const char *GetClassName() { return( "AmToolBarClass"); };
};

#endif /* _editor_tool_bar_class_h_ */
