#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_edit_layer_dialog_class_h_
#define _anvil_edit_layer_dialog_class_h_

#include <anvil/PickLayerDialogClass.h>

class AmEditLayerDialogClass : public AmPickLayerDialogClass {

private:

    void         initializeValues();
    void         createInterface();

    virtual void action( Widget    w,
                         XtPointer xpCallData);

protected:

    AmMotifDisplayClass *_pMotifDisplay;
    Widget            _wArea;

public:

    /* Constructors/Desctructors. */

    AmEditLayerDialogClass();
    AmEditLayerDialogClass( Widget            wParent,
                          const char        *szName,
                          AmOverlayClass      *pOverlay,
                          AmMotifDisplayClass *pMotifDisplay);
    AmEditLayerDialogClass( AmBaseWidgetClass   *bwcParent,
                          const char        *szName,
                          AmOverlayClass      *pOverlay,
                          AmMotifDisplayClass *pMotifDisplay);
    virtual ~AmEditLayerDialogClass();

    /* Accessor functions. */

    virtual const char *GetClassName() { return( "AmEditLayerDialogClass"); };
};

#endif /* _anvil_edit_layer_dialog_class_h_ */
