#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_bargraph_h_
#define _anvil_bargraph_h_
#include <anvil/graph.h>
#include <anvil/overlay.h>

typedef enum {
    AmBAR_ERROR = 0,
    AmBAR_HEIGHT = 1,		/* evenly spaced bars with heights speced */
    AmBAR_WIDTH = 2,		/* same height, but bars show width */
    AmBAR_WIDTH_AND_HEIGHT = 3	/* show width and height fields */
} AmBarStyleEnum;

class AmBarGraphClass : public AmGraphClass {
protected:
    AmIndexDataRec	colorIndex;	/* index to color vector */
    int			barSpacing;	/* AmBAR_HEIGHT:spacing WIDTH: v off */
    int			barHeight;	/* AmBAR_WIDTH only bar height */
    AmBarStyleEnum	barStyle;	/* style */
    void	    	initializeFields( AmWindowClass  *windowArg,
					  const char   *nameArg);
    virtual AnvilBoolean	checkValues();
public:
		    AmBarGraphClass( AmWindowClass  *windowArg,
				   const char	*nameArg,
				   ...);
		    AmBarGraphClass( AmOverlayClass      *overlayArg,
				   const char        *nameArg,
				   ...);
		    AmBarGraphClass();
    void	    destroyBarGraph();
    virtual 	    ~AmBarGraphClass();
    virtual int     setFields( AmTagValuePtr  tagValues,
			       int          numValues);
    virtual int     getFields( AmTagValuePtr  tagValues,
			       int          numValues);
    virtual void    updateFields();
    virtual int	    dumpFields( AmFieldLengthPtr    fieldLengths,
				AnvilBoolean	      allFields = FALSE);
    virtual	    AnvilBoolean	IsType( AmObjectTypeEnum type);
    void 	    GetFieldDefinitions( AmFieldDefPtr   *fieldDefs,
					 int           *numFieldDefs);
    virtual AmErrorCode draw( AmWindowClass  	 *window,
			      AmGCClass	   	 *gc,
			      AmRectangleRec const *exposeRects,
			      int		 nRects);
    virtual AmErrorCode DrawSelection( AmWindowClass  	  *window,
				       AmGCClass	   	  *gc,
				       AmRectangleRec const *exposeRects,
				       int		  nRects,
				       AnvilBoolean		  fHighlight);
};

#endif /* _anvil_bargraph_h_ */
