#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef ERROR_H
#define ERROR_H

/* Constant definitions: */

#define AmOK				1 
#define AmERROR_MALLOC_FAILED		2
#define AmERROR_NULL_PARAM		3
#define AmERROR_BAD_PARAM		4
#define AmERROR_SEGMENT_INVALID		5
#define AmERROR_SEGMENT_FULL		6
#define AmERROR_MEMORY_FREE		7
#define AmERROR_SEGMENT_TABLE_FULL	8
#define AmERROR_OBJECT_INVALID		9
#define AmERROR_OBJECT_NOT_REFERENCE	10	
#define AmERROR_OBJECT_TABLE_FULL	11	
#define AmERROR_CACHE_EMPTY		12
#define AmERROR_SEGMENT_NOT_IN_CACHE	13
#define AmERROR_FILE_OPEN		14
#define AmERROR_FILE_SEEK		15
#define AmERROR_FILE_READ		16
#define AmERROR_FILE_WRITE		17
#define AmERROR_ID_NOT_IN_CACHE		18
#define AmERROR_SEGMENT_INACTIVE	19
#define AmERROR_OBJECT_STILL_REFERENCED	20
#define AmERROR_UNIMPLEMENTED		21
#define AmERROR_OBJECT_NOT_POINT	22

/* Type definitions: */

typedef int AmErrorCode;

/* Extern definitions: */

extern AmErrorCode ANVIL_ERROR_CODE;

/* Function prototypes: */

void printAnvilError();

#endif
