#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef HASH_H
#define HASH_H

/* Constant definitions: */

#define AmHASH_FULL	0x01
#define AmHASH_EMPTY	0x02
#define AmHASH_DELETED	0x06

#define AmCACHE_INVALID	0xffff

typedef struct hashRec_ {
    ushort_t status;
    ushort_t offset;
} AmHashRec, *AmHashPtr;

typedef struct cacheRec_ {
    long     ID;
    ushort_t prev;
    ushort_t next;
    ushort_t offset;
} AmCacheRec, *AmCachePtr;

typedef struct chTableRec_ {
    ushort_t num;
    ushort_t cacheSize;
    ushort_t hashSize;
    ushort_t AmFirst;
    ushort_t AmLast;
    AmCacheRec *cache;
    AmHashRec  *hash;
} AmChTableRec, *AmChTablePtr;

/* Function prototypes: */

AmChTablePtr  AmMakeCHTable( ushort_t hashSize, ushort_t cacheSize);
AmErrorCode AmFreeCHTable( AmChTablePtr table);
AmErrorCode AmInsertCHTable( AmChTablePtr table, long ID, long *swapID);
AmErrorCode AmTouchCHTable( AmChTablePtr table, long ID);
AmErrorCode AmDeleteCHTable( AmChTablePtr table, long ID);
AmErrorCode AmPrintCHTable( AmChTablePtr table);

#endif
