#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _CAD_LIST_H
#define _CAD_LIST_H

/* Type defenitions: */

typedef struct cadNodeRec_ {
    void        *data;
    cadNodeRec_ *next;
} AmCadNodeRec, *AmCadNodePtr;

typedef struct cadListRec_ {
    AmCadNodePtr head;
    AmCadNodePtr tail;
} AmCadListRec, *AmCadListPtr;

/* Function prototypes: */

AmCadListPtr  AmMakeList();
AmErrorCode AmFreeList( AmCadListPtr list);
AmCadNodePtr  AmMakeNode( void *data);
AmErrorCode AmInsertHead( AmCadListPtr list, void *data);
AmErrorCode AmInsertTail( AmCadListPtr list, void *data);
void *      AmGetHead( AmCadListPtr list);
void *      AmGetTail( AmCadListPtr list);
AmCadNodePtr  AmGetNode( AmCadListPtr list, void *cmpData, AmSearchFn cmpFn); 
AmCadNodePtr  AmGetNode( AmCadNodePtr temp, void *cmpData, AmSearchFn cmpFn);

#endif /* _CAD_LIST_H */
