#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef MEM_H
#define MEM_H

#include "segment.h"
#include "object.h"
#include "hash.h"

/* Constant definitions: */

/* Inline functions: */

/* Type definitions: */

typedef struct memoryRec_ {
    AmSegmentTablePtr segTable;
    AmObjectTablePtr  objTable;
    AmChTablePtr      chTable; 
    char            *filename;
    long            firstID;
    long            lastID;
} AmMemoryRec, *AmMemoryPtr;

/* Function prototypes: */

AmMemoryPtr   AmMakeMemory( long     numSegs,
                        long     numObjs,
                        ushort_t cacheSize,
                        ushort_t hashSize,
                        char     *filename);
AmErrorCode AmFreeMemory( AmMemoryPtr memory);
AmMemoryPtr   AmLoadMemory( char      *filename,
                        long      objSize,
                        ushort_t  cacheSize,
                        ushort_t  hashSize);
AmErrorCode AmDumpMemory( AmMemoryPtr memory);

#endif
