#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef OBJECT_PROTO_H
#define OBJECT_PROTO_H

/* Function prototypes: */

uchar_t *      AmAllocObject( AmMemoryPtr memory,
                            long      size,
                            long      type,
                            long      *ID);
AmErrorCode    AmFreeObject( AmMemoryPtr memory,
                           long      ID);
uchar_t *      AmReallocObject( AmMemoryPtr memory,
                              long      ID,
                              long      size);
AmErrorCode AmAddReference( AmMemoryPtr memory,
                          long      objectID,
                          long      refObjectID);
AmErrorCode AmRemoveReference( AmMemoryPtr memory,
                             int       objectID,
                             int       refObjectID);

AmObjectTablePtr AmMakeObjectTable( long segSize);
AmErrorCode    AmFreeObjectTable( AmObjectTablePtr table);
AmErrorCode    AmUpdateObjectOffset( AmMemoryPtr mem,
                                   long      ID,
                                   long      newOffset);
AmErrorCode    AmDumpObjectTable( AmMemoryPtr memory);
AmObjectTablePtr AmLoadObjectTable( char *filename, long segSize);

uchar_t *       AmGetData( AmMemoryPtr memory, long ID);
AmCadObjectRefPtr AmGetObject( AmMemoryPtr memory, long ID);
AmErrorCode     AmSetObject( AmMemoryPtr memory, long ID, long seg, long offset);

long            AmMakePoint( AmMemoryPtr memory,
                           float     x,
                           float     y);
AmCadPointPtr     AmGetPoint( AmMemoryPtr memory,
                          long      pointID);
AmErrorCode     AmRemovePoint( AmMemoryPtr memory,
                             long      pointID);

long            AmMakeLine( AmMemoryPtr memory,
                          long      p1,
                          long      p2);
AmCadLinePtr      AmGetLine( AmMemoryPtr memory,
                         long      lineID);
AmErrorCode     AmRemoveLine( AmMemoryPtr memory,
                            long      ID);

long            AmMakePolyLine( AmMemoryPtr memory,
                              long      numPoints,
                              long      *pointList);
AmCadPolyLinePtr  AmGetPolyLine( AmMemoryPtr memory,
                             long      polyLineID);
AmErrorCode     AmRemovePolyLine( AmMemoryPtr memory,
                                long      polyLineID);

long            AmMakePolygon( AmMemoryPtr memory,
                             long      AmNumLines,
                             long      *lineList);
AmCadPolygonPtr   AmGetPolygon( AmMemoryPtr memory,
                            long      polygonID);

AmErrorCode     AmRemovePolygon( AmMemoryPtr memory,
                               long      polygonID);


AmCadRefListPtr   AmGetReferences( AmMemoryPtr memory,
                               long      objectID);

AmErrorCode     AmChangedObject( AmMemoryPtr memory,
                               long      objectID);
#endif
