#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef SEGMENT_PROTO_H
#define SEGMENT_PROTO_H

#include "mem.h"

/* Function prototypes: */

AmErrorCode     AmActivateSegment( AmMemoryPtr memory, long ID);
AmErrorCode     AmCompactSegment( AmMemoryPtr memory, AmMemorySegmentPtr segment);
AmMemorySegmentPtr      AmMakeSegment( AmMemoryPtr memory, long ID, long size);

void *          AmAllocBlock( AmMemorySegmentPtr segment, long size);
AmErrorCode     AmFreeBlock( AmMemorySegmentPtr segment, void *mem);

AmSegmentTablePtr AmMakeSegmentTable( long);
AmErrorCode     AmFreeSegmentTable( AmSegmentTablePtr table);
void            printSegment( AmMemorySegmentPtr segment);
long            AmFreeSpace( AmMemorySegmentPtr segment);
long            AmTotalFreeSpace( AmMemorySegmentPtr segment);
AmErrorCode     AmDumpSegments( AmMemoryPtr memory);
AmErrorCode     AmDumpSegmentTable( AmMemoryPtr memory);
AmSegmentTablePtr AmLoadSegmentTable( char *filename);

#endif
