#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_colorhist_h_
#define _anvil_colorhist_h_
#include <sys/types.h>
#include <anvil/colorcell.h>


#define NUMHIST         32768
#define NUMCOLORS       256
#define MAXDEPTH        8
#define SRC_RES         8
#define DST_RES         5
#define LOSS            ( SRC_RES - DST_RES)
#define DST_MASK        0x1f

typedef struct AmHist_ {
    AmColorCellRec        color;
    ulong_t             hist;
    int                 cmapIndex;
    int                 index;
} AmHistRec, *AmHistPtr;

typedef struct AmColorAssign_ {
    AmColorCellRec        color;          /* color to use in colormap */
    AnvilBoolean             assigned;       /* whether color cell was assigned */
} AmColorAssignRec, *AmColorAssignPtr;

int AmOnIndex( AmHistPtr    a,
             AmHistPtr    b);

int AmBigHistFirst( AmHistPtr       a,
                  AmHistPtr       b);

unsigned long AmReducePixel( ulong_t      pixel);

void AmDecomposeReducedPixel( ulong_t     pixel,
                            uchar_t     *red,
                            uchar_t     *green,
                            uchar_t     *blue);

int AmClosestColorIndex( AmHistPtr          hist,
                       AmColorCellPtr     color,
                       int              numHist);

void AmImage8to24( uchar_t         *imageData,
                 int             width,
                 int             height,
                 AmColorCellPtr    colors,
                 int             numColors,
                 ulong_t         **newImageData);

void AmImage24to8( ulong_t        *imageData,
                 int            width,
                 int            height,
                 uchar_t        **newImageData,
                 AmColorCellPtr   *colors,
                 int            *numColors);

#endif /* _anvil_colorhist_h_ */
