#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_contour_h_
#define _anvil_contour_h_
#include <anvil/project.h>
#include <anvil/list.h>
#include <anvil/datafmt.h>
#include <anvil/fns.h>

AmErrorCode AmMakeContourList(
    uchar_t	*matrix,
    AmAccessFn	zFn,
    void	*clientData,
    int		size,
    int         rows,
    int         cols,
    float	zmin,
    float	zmax,
    float	step,
    AmListPtr	*edgeListList,
    AmListPtr	*inListList,
    int		*maxLength,
    float	xmin,
    float	ymin,
    float	xmax,
    float	ymax
);

AmErrorCode AmBinnedContourList(
    uchar_t	*matrix,
    AmAccessFn	zFn,
    void	*clientData,
    int		size,
    int         rows,
    int         cols,
    float	*binvec,
    int		numbins,
    AmListPtr	*edgeListList,
    AmListPtr	*inListList,
    int		*maxLength,
    float	xmin,
    float	ymin,
    float	xmax,
    float	ymax
);

void AmFreeContourList(
    AmListPtr	conList
);

void AmSetConlineExtents(
    AmPolygonPtr	Polygon
);

void AmScaleContourList( AmListPtr      conList,
                         int            rows,
                         int            cols,
		         float		xmin,
		         float		ymin,
		         float		xmax,
		         float		ymax,
		         AnvilBoolean	flipRows = FALSE,
			 AnvilBoolean	flipCols = FALSE);

AnvilBoolean AmMakeContours( uchar_t      *matrix,
                        AmAccessFn   zFn,
                        void         *clientData,
                        int          size,
                        uchar_t      *markGrid,
                        int          rows,
                        int          cols,
                        float        z,
                        AmListPtr    *edgeList,
                        AmListPtr    *inList,
                        int          *maxLength);    /* longest contour */

AmErrorCode
AmContourMatrixFile( uchar_t            *matrix,
                     int                rows,
                     int                cols,
                     int                size,
                     AmAccessFn         zFn,
                     void               *clientData,
                     float              xmin,
                     float              ymin,
                     float              xmax,
                     float              ymax,
		     AnvilBoolean		flipRows,
		     AnvilBoolean		flipCols,
                     float              min,
                     float              max,
                     float              step,   
                     char               *headerPath,
                     char               *dataPath);

AmCoordPtr
AmClosePoly( AmPolygonPtr       poly,
             float              xmin,
             float              ymin,
             float              xmax,
             float              ymax,
             int                *numpts);

#endif /* _anvil_contour_h_ */
