#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_createobject_h_
#define _anvil_createobject_h_



typedef AmScreenObjClass *( *AmCreateObjectFn)( AmWindowClass   *,
						AmScreenObjClass *,
						char           **,
						void           *);

typedef AmScreenObjClass *(*AmMakeObjectFn)( AmWindowClass	*,
					     AmScreenObjClass	*,
					     char		*,
					     AmTagValuePtr,
					     int);

AmScreenObjClass *AmMakeOverlay( AmWindowClass		*window,
				 AmScreenObjClass 	*,
				 char	    		*name,
				 AmTagValuePtr		tagValues,
				 int			numValues);

AmScreenObjClass *AmMakeImagePlot( AmWindowClass	*window,
				   AmScreenObjClass	*parent,
				   char			*name,
				   AmTagValuePtr	tagValues,
				   int			numValues);

AmScreenObjClass *AmMakeCadPlot( AmWindowClass		*window,
				 AmScreenObjClass	*parent,
				 char			*name,
				 AmTagValuePtr		tagValues,
				 int			numValues);
		    
AmScreenObjClass *AmMakeLinePlot( AmWindowClass		*window,
				  AmScreenObjClass	*parent,
				  char			*name,
				  AmTagValuePtr		tagValues,
				  int			numValues);
		    
AmScreenObjClass *AmMakePolyLinePlot( AmWindowClass	*window,
				      AmScreenObjClass	*parent,
				      char		*name,
				      AmTagValuePtr	tagValues,
				      int		numValues);
		    
AmScreenObjClass *AmMakePolygonPlot( AmWindowClass	*window,
				     AmScreenObjClass	*parent,
				     char		*name,
				     AmTagValuePtr	tagValues,
				     int		numValues);
		    
AmScreenObjClass *AmMakeObjectPlot( AmWindowClass	*window,
				    AmScreenObjClass	*parent,
				    char		*name,
				    AmTagValuePtr	tagValues,
				    int			numValues);
		    
AmScreenObjClass *AmMakeScatterPlot( AmWindowClass	*window,
				     AmScreenObjClass	*parent,
				     char		*name,
				     AmTagValuePtr	tagValues,
				     int		numValues);
		    
AmScreenObjClass *AmMakeScatterGraph( AmWindowClass	*window,
				      AmScreenObjClass	*parent,
				      char		*name,
				      AmTagValuePtr	tagValues,
				      int		numValues);
		    
AmScreenObjClass *AmMakeBarGraph( AmWindowClass		*window,
				  AmScreenObjClass	*parent,
				  char			*name,
				  AmTagValuePtr		tagValues,
				  int			numValues);
		    
AmScreenObjClass *AmMakeLineGraph( AmWindowClass	*window,
				   AmScreenObjClass	*parent,
				   char			*name,
				   AmTagValuePtr	tagValues,
				   int			numValues);
		    
AmScreenObjClass *AmMakeCircleAnnot( AmWindowClass	*window,
				     AmScreenObjClass   *,
				     char		*name,
				     AmTagValuePtr	tagValues,
				     int		numValues);
		    
AmScreenObjClass *AmMakeRectangleAnnot( AmWindowClass	 *window,
					AmScreenObjClass *,
					char		 *name,
					AmTagValuePtr	 tagValues,
					int		 numValues);
		    
AmScreenObjClass *AmMakeTextAnnot( AmWindowClass	*window,
				   AmScreenObjClass 	*,
				   char			*name,
				   AmTagValuePtr	tagValues,
				   int			numValues);
		    
AmScreenObjClass *AmMakeMultiLineTextAnnot( AmWindowClass	*window,
					    AmScreenObjClass    *,
					    char		*name,
					    AmTagValuePtr	tagValues,
					    int			numValues);
		    
AmScreenObjClass *AmMakeDistanceScale( AmWindowClass	*window,
				       AmScreenObjClass	*,
				       char		*name,
				       AmTagValuePtr	tagValues,
				       int		numValues);
		    
AmScreenObjClass *AmMakeImageAnnot( AmWindowClass	*window,
				    AmScreenObjClass 	*,
				    char		*name,
				    AmTagValuePtr	tagValues,
				    int			numValues);
		    
AmScreenObjClass *AmMakeLineAnnot( AmWindowClass	*window,
				   AmScreenObjClass   	*,
				   char			*name,
				   AmTagValuePtr	tagValues,
				   int			numValues);
		    
AmScreenObjClass *AmMakeImageLegend( AmWindowClass	*window,
				    AmScreenObjClass	*parent,
				    char		*name,
				    AmTagValuePtr	tagValues,
				    int			numValues);
		    
AmScreenObjClass *AmMakeLineLegend( AmWindowClass	*window,
				    AmScreenObjClass	*parent,
				    char		*name,
				    AmTagValuePtr	tagValues,
				    int			numValues);
		    
AmScreenObjClass *AmMakeScatterLegend( AmWindowClass	*window,
				       AmScreenObjClass	*parent,
				       char		*name,
				       AmTagValuePtr	tagValues,
				       int		numValues);
			
AmScreenObjClass *AmMakePolyLegend( AmWindowClass	*window,
				    AmScreenObjClass	*parent,
				    char		*name,
				    AmTagValuePtr	tagValues,
				    int			numValues);
		    
AmScreenObjClass *AmMakeGrid( AmWindowClass	*window,
			      AmScreenObjClass	*parent,
			      char		*name,
			      AmTagValuePtr	tagValues,
			      int		numValues);
		    
		    
AmScreenObjClass *AmMakeTicks( AmWindowClass	*window,
			       AmScreenObjClass	*parent,
			       char		*name,
			       AmTagValuePtr	tagValues,
			       int		numValues);

AmScreenObjClass *AmMakeDistanceScale( AmWindowClass	*window,
				       AmScreenObjClass	*parent,
				       char		*name,
				       AmTagValuePtr	tagValues,
				       int		numValues);

AmScreenObjClass *makeObjectByName( AmWindowClass	*window,
                                    AmScreenObjClass    *parent,
                                    char                *name,
                                    AmTagValuePtr	tagValues,
				    int			numValues);

AmScreenObjClass *AmCreateNamedObject( AmWindowClass		*window,
				       AmScreenObjClass     	*parent,
				       char                 	*name,
				       char                 	*typeName,
				       AmTagValuePtr		tagValues,
				       int			numValues);

#endif /* _anvil_createobject_h_  */
