#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_datafmt_h_
#define _anvil_datafmt_h_
#include <anvil/project.h>

#define AM_MBR_FLAG	    0x1
#define AM_CONVEX_FLAG 	    0x2
#define AM_ISLANDS_FLAG     0x4
#define AM_CONTAINS_FLAG    0x8

typedef struct AmLine_ {
    float	x0;
    float	y0;
    float	x1;
    float	y1;
} AmLineRec, *AmLinePtr;

typedef struct AmCoord_ {
    float	x;
    float	y;
} AmCoordRec, *AmCoordPtr;


typedef struct AmPolygon_ {
    float		xmin;		/* set on polygon read */
    float		ymin;
    float		xmax;
    float		ymax;
    uchar_t		flags;		/* MBR set, convex flags */
    ushort_t        	numPts;         /* number of points in polygon */
    AmCoordPtr          pts;            /* polygon points */
} AmPolygonRec, *AmPolygonPtr;

typedef struct AmPolygon_ AmPolylineRec, *AmPolylinePtr;

typedef struct AmComplexPolygon_ AmComplexPolygonRec, *AmComplexPolygonPtr;

struct AmComplexPolygon_ {
    float		xmin;
    float		ymin;
    float		xmax;
    float		ymax;
    uchar_t		flags;
    ushort_t		numPts;
    AmCoordPtr		pts;
    AmComplexPolygonPtr	container;
    ushort_t		numIslands;
    AmComplexPolygonPtr	*islands;
};
    
typedef AnvilBoolean ( *AmPolyTestFn)( AmPolygonPtr poly, void *data, void *clientData);
typedef float ( *AmDistFn)( float	x, 
			  float	y,
			  void	*data,
			  void	*clientData);

#endif /* _anvil_datafmt_h_ */
