#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_datatype_h_
#define _anvil_datatype_h_

/* different types of data representation (on-the-fly types) */

typedef enum dataType {
	AmNO_TYPE = 0,
        AmFLOAT = 1,
        AmINT = 2,
	AmENUM = 3,
        AmDOUBLE = 4,
        AmCHAR = 5,
        AmUNSIGNED_CHAR = 6,
        AmSHORT = 7,
        AmUNSIGNED_SHORT = 8,
	AmLONG = 9,
	AmUNSIGNED_LONG = 10,
	AmUNSIGNED_INT = 11,
	AmSTRING = 12,
	AmINT_PTR = 13,
	AmFLOAT_PTR = 14,
	AmVOID_PTR = 15,		/* registered void pointer */
	AmBOOLEAN = 16,
	AmSTRING_PTR = 17,		/* NULL terminated vector of strings */
	AmFUNC_PTR = 18,		/* pointer to registered function */
	AmCOLOR_CELL = 19,
	AmCOLOR_CELL_PTR = 20,
	AmFILE = 21,
	AmOBJECT = 22,			/* subclass of record (getFields) */
	AmOBJECT_PTR = 23,		/* NULL-terminated object vector */
	AmUNITS = 24,			/* enumeration defines a known unit */
	AmVARIABLE = 25,		/* enum defines a known variable */
        AmUNKNOWN = 26
} AmDataTypeEnum;

/* different methods for reading data */
 
typedef enum sourceType {
    AmERROR_SOURCE = 0,
    AmFILE_SOURCE = 1,			/* entire file is read */
    AmMMAP_SOURCE = 2,			/* file is mmapped */
    AmDIRECT_SOURCE = 3,		/* data passed as direct pointer */
    AmREAD_SOURCE = 4,			/* file read each display */
    AmPYRAMID_SOURCE = 5,		/* pyramidal file format */
    AmNO_SOURCE = 6,
    AmCUSTOM = 7			/* a custom file format is employed */
} AmSourceTypeEnum;

/* storage type enumerations */

typedef enum storageType_ {
    AmSTORAGE_ERROR = 0,
    AmSTATIC = 1,               /* static array: copy new value */
    AmDYNAMIC = 2,              /* pointer, free if not NULL, copy new value */
    AmLOCAL = 3                 /* flag to ignore */
} AmStorageTypeEnum;


typedef struct AmStrdef_ {
    char                *tag;		/* argument tag name */
    AmDataTypeEnum        dataType;	/* argument type */
} AmStrdefRec, *AmStrdefPtr;
 
#endif /* _anvil_datatype_h_ */
