#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_dispatch_h_
#define _anvil_dispatch_h_

#include <windows.h>
#include <anvil/errcode.h>

typedef void ( *AmNtHandlerFn)( HWND	hWnd,
			      UINT	iMsg,
			      WPARAM	wParam,
			      LPARAM	lParam,
			      void	*clientData);

AmErrorCode InsertHandler( HWND		hWnd,
			   UINT		iMsg,
			   WPARAM	wParam,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode InsertHandler( HWND		hWnd,
			   UINT		*pMsgVec,
			   WPARAM	*wParamVec,
			   int		nMsg,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode InsertHandler( HWND		hWnd,
			   HWND		hWndChild,
			   UINT		iMsg,
			   WPARAM	wParam,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode AppendHandler( HWND		hWnd,
			   HWND		hWndChild,
			   UINT		iMsg,
			   WPARAM	wParam,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode AppendHandler( HWND		hWnd,
			   UINT		*pMsgVec,
			   WPARAM	*wParamVec,
			   int		nMsg,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode AppendHandler( HWND		hWnd,
			   UINT		iMsg,
			   WPARAM	wParam,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode DeleteHandler( HWND		hWnd,
		  	   UINT		iMsg,
			   WPARAM	wParam,
			   AmNtHandlerFn	handler,
			   void		*clientData);

AmErrorCode DeleteHandler( HWND		hWnd,
		  	   UINT		*pMsgVec,
			   WPARAM	*wParamVec,
			   int		nMsg,
			   AmNtHandlerFn	handler,
			   void		*clientData);

LRESULT CALLBACK dispatchEvent( HWND	hWnd,
				UINT	iMsg,
				WPARAM	wParam,
				LPARAM	lParam);

void RegisterDialog( HWND	hDlg);

void UnregisterDialog( HWND	hDlg);

AnvilBoolean IsDialogEvent( MSG	*msg);
    	
#endif _anvil_dispatch_h_
