#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_dispmgrargs_h_
#define _anvil_dispmgrargs_h_

#include <anvil/coordinates.h>
#include <anvil/outline.h>

typedef struct AmDispMgrArgs_ {
    AmMapManagerClass   		*displayManager;	
    AmCoordClass          	*coords;	 /* object being changed */
    AmOutlineClass        	*outline;	 /* outline being drawn */
    AnvilBoolean			flag;
} AmDispMgrArgsRec, *AmDispMgrArgsPtr;

AmDispMgrArgsPtr AmMakeDispMgrArgs( AmMapManagerClass 	*displayManager,
				AmCoordClass        	*coords,
				AmOutlineClass		*outline);


AmErrorCode AmFreeDispMgrArgs( AmDispMgrArgsPtr dispMgrArgs);

void AmSuspendCursorHandler( AmDispMgrArgsPtr	dispMgrArgs);
void AmRestartCursorHandler( AmDispMgrArgsPtr	dispMgrArgs);
void AmRemoveCursorHandler( AmDispMgrArgsPtr	dispMgrArgs);

#endif /* _anvil_dispmgrargs_h_ */
