#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_distscale_h_
#define _anvil_distscale_h_
#include <anvil/datagraphic.h>

typedef enum {
    AmTICK_STYLE = 1,
    AmBAR_STYLE = 2 
} AmDistScaleStyleEnum;

class AmDistanceScaleClass : public AmScaleClass {

protected:
    AmDistScaleStyleEnum _eScaleStyle; /* Show tickmarks or checkered bars. */
    int                _nTicks;      /* Number of tickmarks to show.      */
    float              _dSpacing;    /* Tickmark spacing.                 */
    AnvilBoolean            _fShowMinor;  /* Subdivide one of the ticks.       */
    int                _nMinorTicks; /* Number of subdivisions to show.   */
    int                _iTickSize;   /* Height of the tick.               */
    unitType           _uUnits;      /* Units of the distance scale.      */

    void                initializeFields( AmWindowClass *pWindow,
                                          AmCoordClass  *pCoord,
                                          const char  *szName);
    void                GetFieldDefinitions( AmFieldDefPtr *vFieldDefs,
                                             int         *nFieldDefs);

public:

/* Constructors/Destructor. */

    AmDistanceScaleClass();
    AmDistanceScaleClass( AmWindowClass *pWindow,
                        AmCoordClass  *pCoord,
                        const char  *szName,
                        ...);
    virtual ~AmDistanceScaleClass();

/* Misc functions. */

    virtual int         getFields( AmTagValuePtr vTagValues,
                                   int         nTagValues);
    virtual int         setFields( AmTagValuePtr tagValues,
                                   int         numValues);
    virtual int         dumpFields( AmFieldLengthPtr fieldLengths,
                                    AnvilBoolean        allFields = FALSE);
    virtual AnvilBoolean     IsType( AmObjectTypeEnum type);

    virtual AmErrorCode draw( AmWindowClass        *pWindow,
                              AmGCClass            *pGC,
                              AmRectangleRec const *pExposeRects,
                              int                nExposeRects);
    virtual void        SetRect( int x,
                                 int y,
                                 int width,
                                 int height);
};

#endif /* anvil_distscale_h_ */
