#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_dither_h
#define _anvil_dither_h

#include <sys/types.h>
#include <anvil/project.h>
#include <anvil/colorcell.h>

#define FIRSTBYTE( l) ( (l & 0x000000ff))
#define SECONDBYTE( l) ( (l & 0x0000ff00) >> 8)
#define SECONDWORD( l) ( l >> 16)

#define DITHER_LEVEL        8
#define NUM_DITHER_MATRICES (DITHER_LEVEL * DITHER_LEVEL + 1)

AmErrorCode 
AmInitDitherMatrices( ushort_t    numRedShades,
		    ushort_t    numGreenShades,
		    ushort_t    numBlueShades,
		    uchar_t     decisionMatrix[ NUM_DITHER_MATRICES][ DITHER_LEVEL][ DITHER_LEVEL],
		    ulong_t     *redDitherMatrix,
		    ulong_t     *greenDitherMatrix,
		    ulong_t     *blueDitherMatrix);


AmErrorCode
AmCreateColorCube( AmColorCellPtr   cubeColors,
                 uint_t         numRed,
                 uint_t         numGreen,
                 uint_t         numBlue,
                 ulong_t        *redOffset,
                 ulong_t        *greenOffset,
                 ulong_t        *blueOffset);

#endif /* _anvil_dither_h_ */
