#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_editobjectP_h_
#define _anvil_editobjectP_h_
#include <anvil/motifdisplay.h>
#include <anvil/plot_cback.h>

typedef struct AmEditData_ {
    AmScreenObjClass	*object;
    AmMotifDisplayClass	*motifDisplay;
    AmRectangleRec        extents;
} AmEditDataRec, *AmEditDataPtr;

typedef struct AmCustomEdit_ {
    char	*name;
    char	*fullName;
    void	(*editor)();
} AmCustomEditRec, *AmCustomEditPtr;

AmCustomEditRec	customEditors[] = {
    { 
      "coloredit", 
      "Color Editor", 
      ( void (*)()) AmColormapDialogCallback 
    },
    { 
      "fontedit", 
      "Font Editor", 
      ( void (*)()) AmFontDialogCallback 
    },
    {  
      "rangeedit", 
      "Range Editor", 
      ( void (*)()) AmRangeDialogCallback 
    },
    {
      "lightshadeedit",
      "Light Shade Angle Editor",
      ( void (*)()) AmLightShadeDialogCallback
    },
    {
      "rangecoloredit",
      "Range/Colormap Editor",
      ( void (*)()) AmRangeColorDialogCallback
    }
};

#endif /* _anvil_editobjectP_h_ */
