#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_errlib_h_
#define _anvil_errlib_h_
#include <X11/Intrinsic.h>
#include <anvil/waitdlog.h>
#include <anvil/errcode.h>

void AmInitializeError( Widget	shell);

Widget AmPrintError( const char *fmt, ...);
Widget AmPrintError( Widget	shell, const char *fmt, ...);
Widget AmPrintResourceError( const char *res, ...);
Widget AmPrintResourceError( Widget shell, const char *res, ...);

Widget AmPrintWarn( const char *fmt, ...);
Widget AmPrintWarn( Widget shell, const char *fmt, ...);
Widget AmPrintResourceWarn( const char *res, ...);
Widget AmPrintResourceWarn( Widget shell, const char *res, ...);

Widget AmPrintInfo( const char *fmt, ...);
Widget AmPrintInfo( Widget shell, const char *fmt, ...);
Widget AmPrintResourceInfo( const char *res, ...);
Widget AmPrintResourceInfo( Widget shell, const char *res, ...);

AmWaitPtr AmShowWait( const char *fmt, ...);
AmWaitPtr AmShowWait( Widget shell, const char *fmt, ...);
AmWaitPtr AmShowResourceWait( const char *res, ...);
AmWaitPtr AmShowResourceWait( Widget shell, const char *res, ...);

void AmRemoveWait( AmWaitPtr wait);

void AmSetErrorColor( Widget      w, 
                    AnvilBoolean     errorFlag);

AmErrorCode AmInitLog();
AmErrorCode AmAddResourceToLog( const char *res, ...);
Widget AmPrintLogError( Widget	 shell,
		      const char *res,
		      ...);

#endif /* _anvil_errlib_h_ */
