#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_events_h_
#define _anvil_events_h_


void AmSendExpose(
    Display 	*display,
    Window	win
);

void AmSendExposeRect(
    Display 	*display,
    Window	win,
    int		x,
    int		y,
    int		width,
    int		height
);

void AmSendEnter(
    Display	*display,
    Window	win
);

void AmSendLeave(
    Display	*display,
    Window	win
);

void AmSendButtonPress(
    Display	*display,
    Window	win,
    int		x,
    int		y
);

void AmSendButtonRelease(
    Display	*display,
    Window	win,
    int		x,
    int		y
);

void AmSendMotion(
    Display	*display,
    Window	win,
    int		x,
    int		y
);

void AmSendEventByCode(
    Display	*display,
    Window	win,
    long 	eventCode,
    int		x,
    int		y
);

void AmSendClientMessage( 
    Display       *display,
    Window        win,
    int           format,
    void          *data
);          

void AmSetExposeClip( 
    Display		*display,
    GC			gc,
    XExposeEvent	*event
);

void AmSendExposeCback( Widget    w,
                      Widget    dst,
                      XtPointer callData);


#endif /* _anvil_events_h_ */
