#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_files_h_
#define _anvil_files_h_

#include <stdio.h>
#include <anvil/project.h>

int AmNumLines( const char *filename);

char **AmReadLines( const char *filename);

int *AmReadIntVec( const char *filename);

float *AmReadFloatVec( const char *filename);

char *AmGetEnvFile( const char *envName, const char *filename);

char *AmGetEnvSubdirFile( const char *envName,
			const char *dirName,
			const char *filename);

FILE *AmOpenEnvFile( const char *envName, const char *filename, const char *type);

char *AmFileEnvPath( const char *path);

int AmOpenReadFile( const char *filename, AnvilBoolean *pipeFlag);

int AmCloseReadFile( int  fd, AnvilBoolean pipeFlag);

int AmReadLoopFile( int   fd,
                  void  *buffer,
                  int   nbytes);

FILE *AmOpenReadFilePointer( const char   *filename,
                           AnvilBoolean      *pipeFlag);

int AmCloseReadFilePointer( FILE          *fp,
                          AnvilBoolean       pipeFlag);

int AmReadLoopFilePointer( FILE   *fp,
                         void   *buffer,
                         int    nbytes);

int *AmReadIntStrVec( char *str);

float *AmReadFloatStrVec( char *str);

char *AmReadFileString( const char *filename);

AnvilBoolean AmAbsolutePath( const char *pathname);

void AmSanePath( char *pathname);

#endif 	/* _anvil_files_h_ */
