#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_fonts_h
#define _anvil_fonts_h

#include <anvil/errcode.h>

/* Constants: */

#define SCALEABLEFONTS  "-*-*-*-*-*-*-0-0-0-0-*-0-*-*"
#define MAXFONTS        1000

/* font enumerations */

typedef enum fontWeight_ {
    AmWEIGHT_ERROR = 0,
    AmWEIGHT_MEDIUM = 1,
    AmWEIGHT_BOLD = 2,
    AmWEIGHT_ANY = 3,
    AmWEIGHT_NONE = 4
} AmFontWeightEnum;

typedef enum fontSlant_ {
    AmSLANT_ERROR = 0,
    AmSLANT_ROMAN = 1,
    AmSLANT_ITALIC = 2,
    AmSLANT_OBLIQUE = 3,
    AmSLANT_ANY = 4,
    AmSLANT_NONE = 5
} AmFontSlantEnum;

/* Type definitions: */

typedef struct AmFontRec_ {
    char           *szFont;
    char           *szFamily;
    AmFontWeightEnum eWeight;
    AmFontSlantEnum  eSlant;
    int            iSize;
    double         dxScale;
    double         dyScale;
    int            iDPI;
} AmFontRec, *AmFontPtr;

/* Retrieve a font from the font cache: */

const char *
AmGetFontFromCache( const char     *family, 
                  AmFontWeightEnum weight,
                  AmFontSlantEnum  slant);

const char **
AmGetFontFamilies();

#endif /* _anvil_fonts_h_ */
