#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_geometry_h_
#define _anvil_geometry_h_

#include <anvil/project.h>
#include <anvil/datafmt.h>

AnvilBoolean AmLineIntersection( 
    float 	x0,
    float	y0,
    float 	x1,
    float	y1,
    float 	x2,
    float	y2,
    float 	x3,
    float	y3,
    float 	*x,
    float	*y 
);

AnvilBoolean AmIntLineIntersection( 
    int x0,
    int	y0,
    int x1,
    int	y1,
    int x2,
    int	y2,
    int x3,
    int	y3,
    int *x,
    int	*y 
);

AnvilBoolean AmBetween( 
    int	a,
    int	b,
    int	c 
);

AnvilBoolean AmBetweenFloat( 
    float	a,
    float	b,
    float	c
);

AnvilBoolean AmInsideFloat( 
    float	a,
    float	b,
    float	c
);


AnvilBoolean AmPtAboveLine( 
    float 	x,
    float 	y,
    float 	x0,
    float 	y0,
    float 	x1,
    float 	y1 
);

AnvilBoolean AmIntPtAboveLine( 
    int 	x,
    int 	y,
    int 	x0,
    int 	y0,
    int 	x1,
    int 	y1 
);

int AmLineat( 
    int 	x0,
    int 	y0,
    int 	x1,
    int 	y1,
    int 	x
);

int AmLineaty( 
    int 	x0,
    int 	y0,
    int 	x1,
    int 	y1,
    int 	y
);

int AmSlopeat( 
    int 	x0,
    int 	y0,
    float	m,
    int		x
);

int AmSlopeaty(
    int 	x0,
    int 	y0,
    float	m,
    int		y
);

AnvilBoolean AmClip2d( 
    float 	*x0,
    float	*y0,
    float	*x1,
    float	*y1,
    float	xmin,
    float	ymin,
    float	xmax,
    float	ymax 
);

AnvilBoolean AmClipPoly( AmCoordPtr      pts,
                  AmCoordPtr      tmpPts,
                  AmCoordPtr      resPts,
                  float         xmin,
                  float         ymin,
                  float         xmax,
                  float         ymax,
                  int           *numpts);


void AmLineSlopeRect( 
    int         x0,
    int         y0,
    float       m,
    int         rectX0,
    int         rectY0,
    int         rectWidth,
    int         rectHeight,
    int         *lineX0,
    int         *lineY0,
    int         *lineX1,
    int         *lineY1 
);

float AmDist( 
    float x0,
    float y0,
    float x1,
    float y1 
);


float AmDist3D( 
    float x0,
    float y0,
    float z0,
    float x1,
    float y1,
    float z1
);

float AmSqrDist( 
    float x0,
    float y0,
    float x1,
    float y1 
);

float AmLineDist( float	x0,
		float	y0,
		float	x1,
		float	y1,
		float	x2,
		float	y2);

float AmLineAngle( float	x0,
		 float	y0,
		 float	x1,
		 float	y1,
		 float	x2,
		 float	y2);

#endif /* _anvil_geometry_h_ */
