#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_getcolor_h_
#define _anvil_getcolor_h_

#include <X11/Intrinsic.h>

Pixel *extractPixels( XColor *colorLst,     /* XColor structure array */
                      int    numColors);     /* number of colors in array */

int readAndAllocColors(
    Display     *display,               /* connection to X server */
    char        *colorFile,             /* color file to read */
    Colormap    cmap,                   /* colormap to read colors into */
    int         *numColors,             /* number of colors read */
    int         *numFileColors,         /* number of colors in file */
    XColor      **colorRet);            /* vector of XColors returned */

int AmReadColors( Display        *display,       /* server connection */
                char           *colorfile,     /* file with colors */
                int            *numColors,     /* num colors in file */
                XColor         **colorRet);    /* returned color vector */

void interpolateXcolors( XColor      *colors,
                         int         numColors,
                         XColor      **newColors,
                         int         numNewColors);

void freeColors( Display        *display,
                 Colormap       cmap,
                 XColor         *colors,
		 int		numColors);

#endif _anvil_getcolor_h_
