#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_getset_h_
#define _anvil_getset_h_
#include <anvil/project.h>
#include <anvil/datatype.h>

AnvilBoolean AmSetScalar( uchar_t              *offsetPtr, 
                   AmDataTypeEnum         dataType, 
                   AmStorageTypeEnum      storageType,
                   void                 *value);

AnvilBoolean AmSetVector( uchar_t              *offsetPtr,
                   AmDataTypeEnum         dataType,
                   AmStorageTypeEnum      storageType,
                   void                 *value,
                   int                  length);

AnvilBoolean AmGetValue( uchar_t               *offsetPtr,
                  AmDataTypeEnum          dataType,
                  AmStorageTypeEnum       storage,
                  void                  **ptr,
                  int                   length);

AnvilBoolean AmPrintValue( char                *buffer,
                    char                *tagStr,
                    int                 length,
                    void                *value,
                    AmDataTypeEnum        dataType);

AmErrorCode AmScanValue( char         *tagStr,
		         char         *valueStr,
		         void         **value,
		         AnvilBoolean      *copied);

#endif /* _anvil_getset_h_ */
