#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_gifP_h_
#define _anvil_gifP_h_


#define MAXCOLORMAPSIZE         256
#define TRUE                    1
#define FALSE                   0
#define CM_RED                  0
#define CM_GREEN                1
#define CM_BLUE                 2
#define MAX_LWZ_BITS            12
#define INTERLACE               0x40
#define LOCALCOLORMAP           0x80
#define BitSet(byte, bit)       (((byte) & (bit)) == (bit))
#define ReadOK(file,buffer,len) (fread(buffer, len, 1, file) != 0)
#define LMToUint(a,b)         (((b)<<8)|(a))

struct {
    unsigned int        Width;
    unsigned int        Height;
    unsigned char       ColorMap[3][MAXCOLORMAPSIZE];
    unsigned int        BitPixel;
    unsigned int        ColorResolution;
    unsigned int        Background;
    unsigned int        AspectRatio;
} GifScreen;

struct {
    int transparent;
    int delayTime;
    int inputFlag;
    int disposal;
} Gif89 = { -1, -1, -1, 0 };

static int ReadColorMap( 
    FILE                *fd, 
    int                 number, 
    unsigned char       buffer[3][MAXCOLORMAPSIZE] 
);

static int DoExtension( 
    FILE        *fd, 
    int         label 
);

static int GetDataBlock( 
    FILE                *fd, 
    unsigned char       *buf 
);

static int GetCode( 
    FILE                *fd, 
    int                 codeSize, 
    int                 flag 
);

static int LWZReadByte( 
    FILE                *fd, 
    int                 flag, 
    int                 inputCodeSize 
);


static int ReadImage( 
    FILE                *fd,
    int                 width, 
    int                 height,
    int                 interlace, 
    int                 ignore,
    unsigned char       **image
);

#endif /* anvil_gifP_h_ */

