#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_graph_h_
#define _anvil_graph_h_
#include <anvil/datagraphic.h>

extern const int AmGRAPH_WIDTH, AmGRAPH_HEIGHT;

class AmGraphClass : public AmDataGraphicClass {
protected:
	AmIndexDataRec	heightIndex;	/* fn for height field */
   	void		initializeFields( AmWindowClass	*windowArg,
					  const char	*nameArg);
        void            GetFieldDefinitions( AmFieldDefPtr  *fieldDefs,
        				     int	  *numDefs);
	virtual void    GetDataExtents( float   *xmin,
					float   *ymin,
					float   *xmax,
					float   *ymax);
        virtual AnvilBoolean	checkValues();
public:
			AmGraphClass();
	virtual 	~AmGraphClass();
        virtual int     setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
        virtual int     getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    	virtual void 	updateFields();
	virtual int     dumpFields( AmFieldLengthPtr    fieldLengths,
				    AnvilBoolean	      allFields = FALSE);
	virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
};

#endif /* _anvil_graph_h_ */
