#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_grid_h_
#define _anvil_grid_h_
#include <anvil/projects.h>
#include <anvil/plot.h>
#include <anvil/tick.h>
#include <anvil/coordinates.h>

typedef enum {
    AmGRID_GRID = 1,
    AmGRID_PLUS = 2
} AmGridStyleEnum;

class AmGridClass : public AmCoordClass {
private:
    AmTickClass           *upperTicks;
    AmTickClass           *leftTicks;
    AmTickClass           *rightTicks;
    AmTickClass           *lowerTicks;
    AnvilBoolean		drawGrid;
    AnvilBoolean		sameTickSpacing;
    AmGridStyleEnum	gridStyle;
    AmLineStyleEnum	lineStyle;
    float		_dLineWidth;
    char		*dashes;
    int			ndash;
    int			plusSize;
    void	        GetFieldDefinitions( AmFieldDefPtr        *fieldDefs,
				             int                *numDefs);
    void 		initializeFields( AmWindowClass	*windowArg,
					  AmCoordClass 	*graphicArg,
					  const char	*nameArg);
public:
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
    virtual int		getFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		setFields( AmTagValuePtr	tagValues,
				   int		numValues);
			AmGridClass();
			AmGridClass( AmWindowClass	*windowArg,
				   AmCoordClass 	*graphic, 
				   const char 	*name,
				   ...);
    virtual 		~AmGridClass();
    virtual void	SetRect( int	x,
				 int	y,
				 int	width,
				 int	height);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields);
    virtual AmErrorCode draw( AmWindowClass		*w,
			      AmGCClass			*gc,
			      AmRectangleRec const	*exposeRects,
			      int			nRects);
};
    
#endif /* _anvil_grid_h_ */
