#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_histogram_h_
#define _anvil_histogram_h_

typedef struct AmHistRec_ {
    int   histValue;
    float dataValue;
} AmHistRec, *AmHistPtr;

typedef struct AmThematicHistRec_ {
    int   histValue;
    int   dataValue;
} AmThematicHistRec, *AmThematicHistPtr;

void AmHistogramContinuousMatrix( uchar_t              *matrix,
				AmAccessFn             zFn,
				void                 *clientData,
				int		     offset,
				int                  size,
				int                  rows,
				int                  cols,
				AmHistRec              *histogram,
				int                  numValues,
				float                *bins,
				AnvilBoolean		     minClip,
				AnvilBoolean		     maxClip);

void AmHistogramContinuousSubmatrix( uchar_t              *matrix,
                                   AmAccessFn             zFn,
                                   void                 *clientData,
				   int			offset,
                                   int                  size,
                                   int                  rows,
                                   int                  cols,
                                   AmRectangleRec const   *rect,
                                   AmHistRec              *histogram,
                                   int                  numValues,
                                   float                *bins,
				   AnvilBoolean		minClip,
				   AnvilBoolean		maxClip);

void AmHistogramThematicMatrix( uchar_t                *matrix,
			      AmIntAccessFn            AmIntFn,
			      void                   *clientData,
			      int		     offset,
			      int                    size,
			      int                    rows,
			      int                    cols,
			      AmThematicHistRec        *histogram,
			      int                    numValues,
			      int                    *table);

void AmHistogramThematicSubmatrix( uchar_t                *matrix,
                                 AmIntAccessFn            AmIntFn,
                                 void                   *clientData,
			         int			offset,
                                 int                    size,
                                 int                    rows,
                                 int                    cols,
                                 AmRectangleRec const     *rect,
                                 AmThematicHistRec        *histogram,
                                 int                    numValues,
                                 int                    *table);

void AmHistogramContinuousScatter( uchar_t             *vector,
				 AmAccessFn            zFn,
				 void                *zClientData,
				 int		     zOffset,
				 int                 size,
				 int                 rows,
				 AmHistRec             *histogram,
				 int                 numValues,
				 float               *bins,
				 AnvilBoolean	     minClip,
				 AnvilBoolean	     maxClip);

void AmHistogramContinuousSubscatter( uchar_t             *vector,
                                    AmAccessFn            xFn,
                                    AmAccessFn            yFn,
				    int			xOffset,
				    int			yOffset,
				    void		*xyClientData,
                                    AmAccessFn            zFn,
				    int			zOffset,
                                    void                *zClientData,
                                    int                 size,
                                    int                 rows,
                                    AmRealRectRec const   *rect,
                                    AmHistRec             *histogram,
                                    int                 numValues,
                                    float               *bins,
				    AnvilBoolean		minClip,
				    AnvilBoolean		maxClip);

void AmHistogramThematicScatter( uchar_t               *vector,
			       AmIntAccessFn           AmIntFn,
			       int		     offset,
			       void                  *clientData,
			       int                   size,
			       int                   rows,
			       AmThematicHistPtr       histogram,
			       int                   numValues,
			       int                   *table);

void AmHistogramThematicSubscatter( uchar_t               *vector,
                                  AmAccessFn              xFn,
                                  AmAccessFn              yFn,
				  int			xOffset,
				  int			yOffset,
				  void			*xyClientData,
                                  AmIntAccessFn           AmIntFn,
				  int			intOffset,
                                  void                  *intClientData,
                                  int                   size,
                                  int                   rows,
                                  AmRealRectRec const     *rect,
                                  AmThematicHistPtr       histogram,
                                  int                   numValues,
                                  int                   *table);

#endif /* _anvil_histogram_h_ */
