#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_imageP_h_
#define _anvil_imageP_h_

int *AmMakeFwdDiffVec( int    max,
                     int    length);

void AmFwdDiffVec( int	max,
		 int	length,
		 int	*vec);

int *AmMakeDitherVec( int		spacing,
                    int         length);

int *AmMakeIndexVec( int	max,
		   int	length);

void AmRealFwdDiffVec( float      min,
                     float      max,
                     int        length,
                     int        *vec);

int *AmMakeRealFwdDiffVec( float  min,
                         float  max,
                         int    length);

int *AmMakeRealIndexVec( float    min,
                       float    max,
                       int      length);

void AmGenRGBLookups( float               srcWeight,
                    unsigned long       *srcRed,
                    unsigned long       *srcGreen,
                    unsigned long       *srcBlue,
                    unsigned long       *dstRed,
                    unsigned long       *dstGreen,
                    unsigned long       *dstBlue);

ulong_t AmInterpPixels( ulong_t	pt1,
		      ulong_t	pt2,
		      ulong_t	pt3,
		      ulong_t	pt4,
		      int	remRow,
		      int	remCol);

int *AmMakeRealRemainVec( float	min,
			  float	max,
			  int	length);

void AmRealRemainVec( float	min,
		    float	max,
		    int		length,
		    int		*vec);

#endif /* _anvil_imageP_h_ */
