#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_imageannot_h_
#define _anvil_imageannot_h_

#include <anvil/annotation.h>

#define AmIMAGEANNOT_NUMCOLORS	64

class AmImageAnnotClass : public AmAnnotationClass {
private:
    ulong_t		*_plSrcData;
    int			_cxSrcPixels;
    int			_cySrcPixels;

    AnvilBoolean		_fFlipRows;
    AnvilBoolean		_fFlipCols;
    AmImageClass		*_pImage;
    AnvilBoolean		_fInterpolate;

    char		*_szFile;

    AmColormapTypeEnum	_eColormapType;

    void		projectImage();
    void        	initializeFields( AmWindowClass  *windowArg,
					  const char   *nameArg);
    void        	GetFieldDefinitions( AmFieldDefPtr       *fieldDefs,
					     int               *numDefs);
public:
    virtual int     	getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int		dumpFields( AmFieldLengthPtr fieldLengths,
				    AnvilBoolean	   allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmImageAnnotClass( AmWindowClass  *windowArg,
					 const char   *name,
					 ...);
			AmImageAnnotClass();
    virtual 		~AmImageAnnotClass();
    virtual AmErrorCode draw( AmWindowClass           *w,
                              AmGCClass               *gc,
                              AmRectangleRec const    *exposeRects,
			      int		    nRects);
    virtual void	SetRect( int	x,
				 int	y,
				 int	width,
				 int	height);
};

#endif /* _anvil_imageannot_h_ */
