#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_imagelegend_h_
#define _anvil_imagelegend_h_
#include <anvil/legend.h>
#include <anvil/imageplot.h>

class AmImageLegendClass : public AmLegendClass {
private:
    AmImageClass          **images;
    void                GetFieldDefinitions( AmFieldDefPtr *fieldDefs,
                                             int         *numDefs);
protected:
    void 		initializeFields( AmWindowClass     *windowArg,
					  AmImagePlotClass  *plotArg,
					  const char	  *nameArg);
public:
    virtual int		setFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		getFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmImageLegendClass( AmWindowClass     *windowArg,
					  AmImagePlotClass  *plotArg,
					  const char	  *name,
					  ...);
    virtual 		~AmImageLegendClass();
    virtual AmErrorCode Update( int	*eventCodes = NULL,
				int	numCodes = 0);
    virtual AmErrorCode	DrawItem( AmWindowClass		*w,
			           AmGCClass 	        *gc,
                                   int                  ,
			           AmRectangleRec const	*itemRect);
    virtual AmErrorCode	DrawItems( AmWindowClass		*w,
			           AmGCClass 	        *gc,
			           AmRectangleRec const	*itemRects);
    virtual AmErrorCode	fillImages();
    virtual AmErrorCode	fillImagesCB();
};

#endif /* _anvil_imagelegend_h_ */
