#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_lineannot_h_
#define _anvil_lineannot_h_

#include <anvil/annotation.h>

typedef enum {
    AmARROW_ERROR = 0,
    AmARROW_NONE = 1,
    AmARROW_HEAD = 2,
    AmARROW_TAIL = 3,
    AmARROW_BOTH = 4,
} AmArrowEnum;

class AmLineAnnotClass : public AmAnnotationClass {
private:
    AmArrowEnum    arrows;
    float        _dLineWidth;
    int          numPoints;
    int          *points;
    AmRectangleRec originalRect;

    void        initializeFields( AmWindowClass  *windowArg,
				  const char   *nameArg);
    void        GetFieldDefinitions( AmFieldDefPtr       *fieldDefs,
				     int               *numDefs);
public:
    virtual int     	getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int		dumpFields( AmFieldLengthPtr fieldLengths,
				    AnvilBoolean	   allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmLineAnnotClass( AmWindowClass  *windowArg,
					const char   *name,
					...);
			AmLineAnnotClass();
			~AmLineAnnotClass();
    virtual void	SetRect( int	x,
				 int	y,
				 int	width,
				 int	height);
    virtual AmErrorCode draw( AmWindowClass           *w,
                              AmGCClass               *gc,
                              AmRectangleRec const    *exposeRects,
			      int		    nRects);
    virtual AmErrorCode	Update( int	*eventCodes = NULL,
				int	numCodes = 0);
};

#endif /* _anvil_lineannot_h_ */
