#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_linelegend_h_
#define _anvil_linelegend_h_

#include <anvil/legend.h>
#include <anvil/lineplot.h>

class AmLineLegendClass : public AmLegendClass {
private:
    AnvilBoolean       showColors;		/* show colors */

    AnvilBoolean       _fShowLineWidth;	/* show line widths */
    float         _dLineWidth;
    float         *_pdLineWidth;
    float         *_pdLineWidthScale;
    AmIndexDataRec  _indexLineWidth; 

    float         itemExtents;

    void          GetFieldDefinitions( AmFieldDefPtr       *fieldDefs,
				       int               *numDefs);
    void	  initializeFields( AmWindowClass	*windowArg,
				    AmLinePlotClass  *plotArg,
				    const char	*name);
public:
    virtual int     	getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
                AmLineLegendClass( AmWindowClass	*windowArg,
				 AmLinePlotClass  *plotArg,
				 const char	*name,
				 ...);
                AmLineLegendClass();
    virtual     ~AmLineLegendClass();
    virtual AmErrorCode Update( int	*eventCodes = NULL,
				int	numCodes = 0);
    virtual AmErrorCode DrawItem( AmWindowClass           *w,
                                   AmGCClass              *gc,
                                   int                  ,
                                   AmRectangleRec const   *itemRect);
    virtual AmErrorCode DrawItems( AmWindowClass          *w,
                                   AmGCClass              *gc,
                                   AmRectangleRec const   *itemRects);
};

#endif /* _anvil_linelegend_h_ */
