#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_macros_h_
#define _anvil_macros_h_

#define MY_PI	3.14159265358979323846
#define MY_TINY 	1e-10
#define MY_SMALL 	0.01

/* because windows defines HUGE */

#ifndef MY_HUGE
#define MY_HUGE		1e20
#endif

/* because windows defines HUGEINT */

#ifndef MY_HUGEINT
#define MY_HUGEINT	67108864
#endif

#ifndef FNEAR
#define FNEAR(a,b) (fabs((a) - (b)) < MY_TINY)
#endif

#ifndef ODD
#define ODD(x) ((x) & 0x1)
#endif

#ifndef EVEN
#define EVEN(x) (!((x) & 0x1))
#endif

#ifndef MAX
#define MAX( a, b) (((a) > (b)) ? (a): (b))
#endif

#ifndef MIN
#define MIN( a, b) (((a) < (b)) ? (a): (b))
#endif

#ifndef SQRDIST
#define SQRDIST( x0, y0, x1, y1) \
	((((x1)-(x0))*((x1)-(x0)))+(((y1)-(y0))*((y1)-(y0))))
#endif

#ifndef RADTODEG
#define RADTODEG(x) ((180.0*(x))/MY_PI)
#endif

#ifndef DEGTORAD
#define DEGTORAD(x) ((x)*M_PI/180.0)
#endif

#ifndef MALLOCPTR
#define MALLOCPTR( x) (( x) malloc( sizeof( *x)))
#endif

#ifndef SQR
#define SQR( x) ((x)*(x))
#endif

#ifndef VECLEN
#define VECLEN( x) ( sizeof( x)/sizeof( x[ 0]))
#endif

#ifndef SGN
#define SGN(x) ((x) ? 1 : -1)
#endif

#endif /* _anvil_macros_h_ */
