#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_magicmgr_h_
#define _anvil_magicmgr_h_

#include <anvil/mapmgr.h>
#include <anvil/userevents.h>

class AmMagicClass;

class AmMagicManagerClass : public AmMapManagerClass {
protected:
    AmListPtr       _lstMagic;        /* Magic window list (AmMagicClass).     */
public:
    AmMagicManagerClass();
    AmMagicManagerClass( AmDisplayClass	*pDisplayClass,
		       AmWindowClass	*pWindowClass,
                       AnvilBoolean 		fDoubleBuffer = FALSE);
    virtual 	       ~AmMagicManagerClass();
    AmMagicClass         *findMagic( int        xpos,
                                   int        ypos,
                                   AnvilBoolean    *inResize);
    virtual void       AddMagic( AmMagicClass *magic);
    virtual void       RemoveMagic( AmMagicClass *magic);
    virtual void       AddUserCallback( int		packageId,
					int		eventId,
					callbackProc  	proc,
					void	  	*clientData) = 0;
    virtual void       RemoveUserCallback( int	  	packageId,
					   int		eventId,
					   callbackProc proc,
					   void	  	*clientData) = 0;
    virtual void       ReDraw( AmRectangleRec const *vExposeRect,
			       int		  nExposeRect);
};

#endif /* _anvil_magicmgr_h_ */
