#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_multitextannot_h_
#define _anvil_multitextannot_h_

#include <anvil/textannot.h>

class AmMultiTextAnnotClass : public AmAnnotationClass {
private:
    void        GetFieldDefinitions( AmFieldDefPtr       *fieldDefs,
				     int               *numDefs);
protected:
    char           *font;
    int            fontSize;
    AmFontWeightEnum fontWeight;
    AmFontSlantEnum  fontSlant;
    float          fontXScale;
    float          fontYScale;
    AmGCClass        *textGC;             /* for set font efficiency */
    char           *label;
    int            labelAngle;
    void           initializeFields( AmWindowClass *windowArg,
                                     const char   *nameArg);
public:
    virtual int     	getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int		dumpFields( AmFieldLengthPtr fieldLengths,
				    AnvilBoolean	   allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmMultiTextAnnotClass( AmWindowClass *dispArg,
					     const char   *nameArg,
					     ...);
			AmMultiTextAnnotClass();
    virtual 		~AmMultiTextAnnotClass();
    virtual void        SetRect( int    x,
                                 int    y,
                                 int    width,
                                 int    height);
    virtual AmErrorCode draw( AmWindowClass           *w,
                              AmGCClass               *gc,
                              AmRectangleRec const    *exposeRects,
			      int		    nRects);
};

#endif /* _anvil_multitextannot_h_ */
