#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_neighbor_h_
#define _anvil_neighbor_h_

#include <sys/types.h>
#include <anvil/image.h>

AmErrorCode AmMakeNeighborColorIndexes( uchar_t         *matrix,
					int             rows,
					int             cols,
					int             size,
					AmIntAccessFn	intFn,
					void		*clientData,
					int		*idTable,
					int		numIds,
					int             **indexes,
                                        int             *maxnabor);

AmErrorCode AmDiskBasedNeighborColorIndexes( int          	fd,
                                             int          	rows,
                                             int          	cols,
                                             int          	size,
                                             int          	skipBytes,
                                             AmScanlineFn 	AmScanFn,
                                             void         	*scanData,
					     AmIntAccessFn	intFn,
					     void		*clientData,
					     int		*idTable,
					     int		numIds,
                                             int          	**indexes,
                                             int          	*maxnabor);

AmErrorCode AmMakeNeighborTable( uchar_t          *matrix,
			         int              rows,
			         int              cols,
			         int              size,
			         AmIntAccessFn	  valFn,
			         void		  *clientData,
			         int              offset,
			         int              **table,
			         int              *length);

AmErrorCode AmDiskBasedNeighborTable( int         	fd,
                                      int         	rows,
                                      int         	cols,
                                      int         	size,
                                      int         	skipBytes,
                                      AmScanlineFn  	AmScanFn,
                                      void        	*scanData,
                                      AmIntAccessFn 	valFn,
				      void		*clientData,
                                      int         	offset,
                                      int         	**table,
                                      int         	*length);

AmErrorCode allocateNeighborColors( AmDisplayClass   *display,
                                    int              numColors,
                                    AmColorCellPtr   *colors,
                                    int              *colorIndexes,
                                    int              length,
                                    int              maxnabor);

#endif /* _anvil_neighbor_h_ */
