#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_nt_state_hand_h_
#define _anvil_nt_state_hand_h_

#include <windows.h>
#include <anvil/dispatch.h>

typedef void ( *AmStateHandlerFn)( void *clientData);

void TurnOnControl( HWND	hWnd,
		    UINT	messageId);

void TurnOffControl( HWND	hWnd,
		     UINT	messageId);

AmErrorCode AmAddHandler( HWND           launchControl,
			UINT	       messageId,
                        HWND	       window,
                        UINT	       eventCode,
                        AmNtHandlerFn    AmHandlerFn,
                        void	       *clientData,
                        uint_t         priority,
                        AmStateHandlerFn removeFn = NULL,
                        AmStateHandlerFn suspendFn = NULL,
                        AmStateHandlerFn restartFn = NULL);

AmErrorCode AmRemoveHandler( HWND		    window,
                           UINT		    eventCode,
                           AmNtHandlerFn      AmHandlerFn,
                           void		    *clientData);

AmErrorCode AmFlushHandler( HWND		 window,
                          uint_t         priority);

AmErrorCode AmAddHandler( HWND           launchControl,
			UINT	       messageId,
                        HWND	       window,
                        UINT	       *eventCodeVec,
			int	       numEvents,
                        AmNtHandlerFn    AmHandlerFn,
                        void	       *clientData,
                        uint_t         priority,
                        AmStateHandlerFn removeFn = NULL,
                        AmStateHandlerFn suspendFn = NULL,
                        AmStateHandlerFn restartFn = NULL);

AmErrorCode AmRemoveHandler( HWND		    window,
                           UINT		    *eventCodeVec,
			   int		    numEvents,
                           AmNtHandlerFn      AmHandlerFn,
                           void		    *clientData);

AmErrorCode AmFlushHandler( HWND		 window,
                          uint_t         priority);

#endif /* _anvil_nt_state_hand_h_ */
