#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_nt_state_handP_h_
#define _anvil_nt_state_handP_h_

#include <windows.h>
#include <anvil/list.h>
#include <anvil/dispatch.h>

#define HANDLER_MAGIC 10201
#define HANDLER_STRING "StateHandler"
const int MAXEVENTS = 16;

/* private data structure used by event handlers, this is stored in a
   generic list (stack ordering) in the window's user data (the window
   that the event handler is active on */

typedef struct AmHandler_ {
    HWND		launchControl;	/* started handler (may be NULL) */
    UINT		messageId;	/* message ID which called handler */
    HWND		window;		/* window handler is attached to */
    AmNtHandlerFn		AmHandlerFn;	/* event handler function */
    void		*clientData;	/* client data for handler */
    UINT		eventCodeVec[ MAXEVENTS];   /* handler's event codes */
    int			numEvents;	/* number of event codes */
    uint_t		priority;	/* suspend or cancel current handler */
    AmStateHandlerFn      suspendFn;	/* user functions that get called */
    AmStateHandlerFn      restartFn;	/* when the handlers get suspended, */
    AmStateHandlerFn      removeFn;	/* restarted, or removed. */
} AmHandlerRec, *AmHandlerPtr;

/* this is the top-level user data stored in the window.  The magicNo
   field is used to check the user data, because it's more than possible 
   that some other idiot stuffed their own user data in there */

typedef struct AmHandlerData_ {
    int		magicNo;		/* to prevent bad user data */
    AmListPtr	handlerList;		/* current handler stack */
} AmHandlerDataRec, *AmHandlerDataPtr;

#endif /* _anvil_nt_state_handP_h_ */
