#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_ntcolor_h
#define _anvil_ntcolor_h

#include <anvil/colorcell.h>
#include <anvil/dither.h>

const HPALETTE     GetAppPalette();
const LPLOGPALETTE GetAppLogPalette();
const ulong_t      *GetAppPaletteOffsets();

const AmColorCellRec *GetAppColorCube();

const ulong_t      *GetNTRedOffsetLookup();
const ulong_t      *GetNTGreenOffsetLookup();
const ulong_t      *GetNTBlueOffsetLookup();

ushort_t           GetNTNumRedShades();
ushort_t           GetNTNumGreenShades();
ushort_t           GetNTNumBlueShades();

const ulong_t      *GetNTRedDitherMatrix();
const ulong_t      *GetNTGreenDitherMatrix();
const ulong_t      *GetNTBlueDitherMatrix();

int                GetAppNumColors();
int                AmGetAppDepth();

AmErrorCode        InitColormaps();
void               FreeColormaps(); 

void               SetPalette( HDC hDC);
void               AmSetPixelValue( AmColorCellPtr cell); 

extern uchar_t     pcDecisionMatrix[ NUM_DITHER_MATRICES][ DITHER_LEVEL][ DITHER_LEVEL];

#endif /* _anvil_ntcolor_h_ */
