#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_ntdispmgr_h_
#define _anvil_ntdispmgr_h_

#include <windows.h>
#include <anvil/magicmgr.h>
#include <anvil/ntdisplay.h>

/* Windows NT  display manager class */

class AmNTDisplayManagerClass : public AmMagicManagerClass {
protected:
public:
    AmNTDisplayManagerClass();
    AmNTDisplayManagerClass( AmNTDisplayClass	*pNTDisplay,
			   AmNTWindowClass	*pNTWindow,
                           AnvilBoolean 		fDoubleBuffer = FALSE);
    virtual 	    ~AmNTDisplayManagerClass();
    virtual int     GetWidth();
    virtual int     GetHeight();
    virtual void    Flush();
    virtual void    AddMagic( AmMagicClass *magic);
    virtual void    RemoveMagic( AmMagicClass *magic);
    virtual void    AddUserCallback( int		packageId,
				     int		eventId,
				     callbackProc  	proc,
				     void	  	*clientData);
    virtual void    RemoveUserCallback( int	  	packageId,
				        int		eventId,
				        callbackProc 	proc,
				        void	  	*clientData);
    virtual void    AmSendUserEvent( int  iPackageID,
				   int  iEventID,
				   void *pClientData);
};

#endif /* _anvil_ntdispmgr_h_ */
