#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_overlay_h_
#define _anvil_overlay_h_
#include <anvil/datagraphic.h>
#include <anvil/list.h>

class AmOverlayClass : public AmCoordClass {
private:
	AmImageClass	 *displayImage;
	AmListPtr		 layerList;	/* list of overlays */
	AnvilBoolean		 maintainRange;	/* force consistent y range in layers */
	AnvilBoolean		 maintainXRange;
	AmDataGraphicClass *currLayer;
protected:
public:
			AmOverlayClass( AmWindowClass  *windowArg,
				      char	   *nameArg,
				      ...);
			AmOverlayClass();
	void		destroyOverlay();
	virtual 	~AmOverlayClass();
	virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
	AmImageClass	*GetImage();
	void		SetImage( AmImageClass *);
	void 		GetFieldDefinitions( AmFieldDefPtr   *fieldDefs,
					     int           *numFieldDefs);
	virtual int	setFields( AmTagValuePtr	tagValues,
				   int		numValues);
	virtual int	getFields( AmTagValuePtr	tagValues,
				   int		numValues);
	virtual int	dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields);
	virtual AmErrorCode 	draw( AmWindowClass  	 *window,
				      AmGCClass	   	 *gc,
				      AmRectangleRec const *exposeRects,
				      int		 nRects);
	virtual void	SetCoords( float currXmin,
                                   float currYmin,
                                   float currXmax,
                                   float currYmax);
	virtual void	SetRect( int	x,
				 int	y,
				 int	width,
				 int	height);
	void		AddLayer( AmDataGraphicClass	*layer);
	void		RemoveLayer( AmDataGraphicClass	*layer);
	AnvilBoolean		IsLayer( AmDataGraphicClass	*layer);
	AmErrorCode     GetLayers( AmDataGraphicClass     ***layers,
				   int           	*numLayers);
	AmErrorCode     GetLayersByAppId( AmDataGraphicClass     ***layers,
					  int                  *numLayers,
					  const char	       *appId);
	void		SetLayers( AmDataGraphicClass	**layers,
				   int			numLayers);
	virtual AmErrorCode	Update( int	*eventCodes = NULL,
					int	numCodes = 0);
	AmErrorCode	syncDisplayImage();
};

AnvilBoolean AmImageTypeLayer( AmDataGraphicClass *a);


#endif /* _anvil_overlay_h_ */
