#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_plot_h_
#define _anvil_plot_h_

#include <sys/types.h>
#include <anvil/project.h>
#include <anvil/coordinates.h>
#include <anvil/display.h>
#include <anvil/units.h>
#include <anvil/list.h>
#include <anvil/fns.h>
#include <anvil/tagstrs.h>
#include <anvil/envdefs.h>
#include <anvil/newtile.h>
#include <anvil/datagraphic.h>

/* default width and height for a plot */

extern const int AmPLOT_WIDTH, AmPLOT_HEIGHT;

/* combination structure of the common information for the plots. */

class AmPlotClass : public AmDataGraphicClass {	/* inherits graphic data */
protected:
    AmIndexDataRec	stringIndex;	/* string index function and data */
    char		**strings;	/* string table to index into */
    AnvilBoolean		showStrings;	/* whether to show strings */
    AmIndexDataRec	colorIndex;	/* index fn/data into colors */
    AmStringFn		nameFn;		/* for retreiving item names */
    void		*nameClientData; /* nameFn client data */
    AmItemFn		nameClientDataFreeFn;	/* free client data */
    void GetFieldDefinitions( AmFieldDefPtr       *fieldDefs,
			      int               *numDefs);
    void		expandTile( AmTilePtr	tile,
				    void	*obj);
    AmErrorCode		readTileData();
    virtual AmErrorCode getDataFromDescription();       /* get dataInfo */
    virtual AnvilBoolean	checkValues();
public:
    virtual int		setFields( AmTagValuePtr  tagValues,
				   int          numValues);
    virtual int		getFields( AmTagValuePtr      tagValues,
				   int              numValues);
    virtual void 	updateFields();
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmPlotClass(); 
    virtual int         dumpFields( AmFieldLengthPtr      fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    void 		initializeFields( AmWindowClass	*windowArg,
					  const char	*nameArg); 
    virtual 		~AmPlotClass();
};

#endif /* _anvil_plot_h_ */
