#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_plot_cback_h_
#define _anvil_plot_cback_h_

#include <X11/Intrinsic.h>
#include <anvil/motifdisplay.h>
#include <anvil/plot.h>
#include <anvil/reference.h>
#include <anvil/imageplot.h>
#include <anvil/scatterplot.h>
#include <anvil/sphereplot.h>
#include <anvil/overlay.h>
#include <anvil/eventcodes.h>


typedef AnvilBoolean (*AmAddLayerFn)( AmDisplayClass	*display,
			       AmOverlayClass	*overlay,
			       AmTagValuePtr	tagValues,
			       int		numValues,
			       AmDataGraphicClass	**dataGraphic,
			       void		*clientData);

typedef void (*AmFileBrowserFn)( Widget	parent,
			       void	*clientData,
			       void	*layerAddData);
		    
typedef AnvilBoolean ( *addFunc)( void *, void *);

AnvilBoolean AmZoom2xCallback( Widget            w,
                        AmMotifDisplayClass *motifDisplay,
                        AmCoordClass        *pCoord,
                        XtPointer         xpCallData);

AnvilBoolean AmUnzoomCallback( Widget            w,
                        AmMotifDisplayClass *pMotifDisplay,
                        AmCoordClass        *pCoord,
                        XtPointer         xpCallData);

AnvilBoolean AmPanCallback( Widget            w,
                     AmMotifDisplayClass *pMotifDisplay,
                     AmCoordClass        *pCoord,
                     XtPointer         xpCallData);

AnvilBoolean AmUnzoomHalfCallback( Widget            w,
                            AmMotifDisplayClass *pMotifDisplay,
                            AmCoordClass        *pCoord,
                            XtPointer         xpCallData);

AnvilBoolean AmZoomRectCallback( Widget            w,
                          AmMotifDisplayClass *pMotifDisplay,
                          AmCoordClass        *pCoord,
                          XtPointer         xpCallData);

AnvilBoolean AmRangeDialogCallback( Widget     w,
                             AmPlotClass  *pPlot,
			     char	**args,
			     XtPointer  xpCallData);

AnvilBoolean AmSetRangeDialogCallback( Widget             w,
                                AmMotifDisplayClass  *motifDisplay,
                                AmPlotClass		*plot,
                                XtPointer          callData);

AnvilBoolean SetShadeDialogCallback( Widget             w,
                                AmMotifDisplayClass  *motifDisplay,
			        AmImagePlotClass	*plot,
                                XtPointer          callData);

AnvilBoolean AmSetHatchAngleRangeDialogCallback( Widget             w,
			   	          AmMotifDisplayClass  *motifDisplay,
				          AmPlotClass	  *plot,
				          XtPointer          callData);

AnvilBoolean AmSetLineWidthRangeDialogCallback( Widget             w,
				         AmMotifDisplayClass  *motifDisplay,
				         AmPlotClass	  	*plot,
				         XtPointer          callData);

AnvilBoolean AmSetSymbolRangeDialogCallback( Widget             w,
				      AmMotifDisplayClass  *motifDisplay,
				      AmPlotClass	  	*plot,
				      XtPointer          callData);

AnvilBoolean AmSetSymbolSizeRangeDialogCallback( Widget             w,
				          AmMotifDisplayClass  *motifDisplay,
				          AmPlotClass	  *plot,
				          XtPointer          callData);

AnvilBoolean AmSetColormapDialogCallback( Widget             	w,
				     AmMotifDisplayClass  	*motifDisplay,
				     AmPlotClass	   	*plot,
				     XtPointer          	callData);

AnvilBoolean AmColormapDialogCallback( Widget    	w,
			          AmPlotClass 	*pPlot,
				  char		**args,
				  XtPointer 	xpCallData);

AnvilBoolean AmFontDialogCallback( Widget             w,
			    AmPlotClass	    *plot,
                            char               **args,
			    XtPointer          callData);

AnvilBoolean AmDeleteLayerCallback( Widget,
                             AmMotifDisplayClass     *motifDisplay,
                             AmOverlayClass          *overlay,
                             XtPointer);

AnvilBoolean AmSetCurrLayerCallback( Widget,
                              AmMotifDisplayClass    *motifDisplay,
                              AmOverlayClass         *overlay,
                              XtPointer);

AnvilBoolean AmSetTransparencyCallback( Widget            scale,
                                 AmMotifDisplayClass *motifDisplay,
                                 AmPlotClass         *plot,
                                 XtPointer);

AnvilBoolean AmDataProfileCallback( Widget                btn,
                             AmMotifDisplayClass     *mainDisplay,
                             AmPlotClass             *plot,
                             char                  *name,
                             XtPointer);

AnvilBoolean AmRefreshCallback( Widget,
                         AmMotifDisplayClass *motifDisplay,
                         XtPointer);


AnvilBoolean AmMoveObjectCallback( Widget                 btn,
                            AmMotifDisplayClass      *motifDisplay,
                            AmPlotClass              *plot,
                            XtPointer);

AnvilBoolean AmCopyObjectCallback( Widget                 btn,
                            AmMotifDisplayClass      *motifDisplay,
                            AmPlotClass              *plot,
			    addFunc		addFn,
			    void			*addFnClientData,
                            XtPointer);

AnvilBoolean AmDeleteSelectedObjectsCallback(
        Widget                  btn,
        AmMotifDisplayClass       *motifDisplay,
        AmPlotClass               *plot,
        AnvilBoolean                 ( *deleteFn)( void *, void *),
        void                    *deleteFnClientData,
        XtPointer);

AnvilBoolean AmAddObjectsCallback( Widget                 btn,
                            AmMotifDisplayClass      *motifDisplay,
                            AmPlotClass              *plot,
                            AnvilBoolean                ( *addFn)( void *, void *),
                            void                   *addFnClientData,
                            XtPointer);

AnvilBoolean AmSetPlotFlagToggle( Widget              tgl,
			   AmMotifDisplayClass   *motifDisplay,
			   AmPlotClass           *plot,
			   char		    *fieldName);

AnvilBoolean AmSetPlotEnumToggle( Widget              tgl,
			   AmMotifDisplayClass   *motifDisplay,
			   AmPlotClass           *plot,
			   char		       *fieldName,
			   int		       enumValue);

AnvilBoolean AmSetPlotValueScale( Widget                scl,
			     AmMotifDisplayClass   *motifDisplay,
			     AmPlotClass           *plot,
			     char		   *fieldName);

AnvilBoolean AmSetPlotFloatValueScale( Widget              	scl,
				  AmMotifDisplayClass   *motifDisplay,
				  AmPlotClass           *plot,
				  char		    	*fieldName);

AnvilBoolean AmScaleTransparencyCallback( Widget                  scale,
                                   AmMotifDisplayClass       *motifDisplay,
                                   AmPlotClass               *plot,
                                   XtPointer);

Widget AmTransparencyScale( Widget                parent,
                          AmMotifDisplayClass     *motifDisplay,
                          AmImagePlotClass        *plot);

AnvilBoolean AmLightShadeCallback( Widget                 btn,
                            AmMotifDisplayClass      *motifDisplay,
                            AmImagePlotClass         *plot,
                            XtPointer);

AnvilBoolean
AmLightShadeDialogCallback( Widget              w,
                            AmImagePlotClass    *plot,
                            char                **args,
                            XtPointer           callData);

void DefaultFileBrowser( Widget		parent,
			 void		*clientData,
			 void		*layerAddData);
    
void DefaultSingleFileBrowser( Widget		parent,
			       void		*clientData,
			       void		*layerAddData);
    
AnvilBoolean AddTheLayer( char		**headerStrings,
		     void		*layerAddData,
		     AmDataGraphicClass	**dataGraphic);

AmMotifDisplayClass *getLayerAddDataMotifDisplay( void *layerAddData);

char **AmLayerStringList( AmOverlayClass	*overlay,
			AnvilBoolean		showOverlay);

char *AmGetLayerName( AmDataGraphicClass	*layer);

AnvilBoolean AmSortLayersCallback( Widget                 button,
                            AmMotifDisplayClass      *motifDisplay,
                            AmOverlayClass           *overlay,
                            XtPointer);

AnvilBoolean AmSelectObjectCallback( Widget               btn,
                              AmMotifDisplayClass    *motifDisplay,
                              AmPlotClass            *plot,
                              XtPointer);

AnvilBoolean AmSelectScatterCallback( Widget              btn,
                               AmMotifDisplayClass   *motifDisplay,
                               AmPlotClass           *plot,
                               XtPointer);

AnvilBoolean AmSelectPolygonCallback( Widget              btn,
                               AmMotifDisplayClass   *motifDisplay,
                               AmPlotClass           *plot,
                               XtPointer);

AnvilBoolean AmSelectLineCallback( Widget                 btn,
                            AmMotifDisplayClass      *motifDisplay,
                            AmPlotClass              *plot,
                            XtPointer);

AnvilBoolean AmZoomTextCallback( Widget                   w,
                          AmMotifDisplayClass        *motifDisplay,
                          AmCoordClass               *plot,
                          XtPointer);

AnvilBoolean AmReferenceWindowCallback( Widget    btn,
                                 AmMotifDisplayClass *motifDisplay,
                                 AmCoordClass  		*source,
                                 XtPointer);

AnvilBoolean AmSetReferenceHandler( AmMotifDisplayClass     *motifDisplay,
                             AmMotifDisplayClass     *sourceDisplay,
                             AmReferenceWindowClass  *refWin);

AnvilBoolean AmScatterReadoutHandlerCallback( Widget              btn,
                                       AmMotifDisplayClass   *motifDisplay,
                                       AmScatterPlotClass    *scatterPlot,
                                       XtPointer);

AnvilBoolean AmAddSphereRotationHandlers( Widget                  area,
                                   AmMotifDisplayClass       *motifDisplay,
                                   AmSpherePlotClass         *spherePlot);

AnvilBoolean AmAddLayerCallback( Widget                btn,
		          AmMotifDisplayClass     *motifDisplay,
		          AmOverlayClass          *overlay,
		          XtPointer	     callData);

AnvilBoolean AmMagnifyGlassCallback( Widget               btn,
                              AmMotifDisplayClass    *motifDisplay,
                              AmPlotClass            *plot,
                              XtPointer            callData);

AnvilBoolean AmMagnifyGlassDialogCallback( Widget                 btn,
                                    AmMotifDisplayClass      *motifDisplay,
                                    AmPlotClass              *plot,
                                    XtPointer              callData);

AnvilBoolean AmShowHistogramCallback( Widget                 btn,
                               AmMotifDisplayClass      *motifDisplay,
                               AmPlotClass              *plot,
                               XtPointer);

AnvilBoolean AmTransparencyGlassCallback( Widget                  btn,
                                   AmMotifDisplayClass       *motifDisplay,
                                   AmOverlayClass            *srcOverlay,
                                   AmImagePlotClass          *imagePlot,
                                   XtPointer               callData);

AnvilBoolean AmGradientCursorCallback( Widget             btn,
                                AmMotifDisplayClass  *MotifDisplay,
                                AmImagePlotClass     *imagePlot,
                                XtPointer);

AnvilBoolean AmContourCursorCallback( Widget              btn,
                               AmMotifDisplayClass   *motifDisplay,
                               AmImagePlotClass      *imagePlot,
                               XtPointer);

AnvilBoolean AmDifferenceCursorCallback( Widget              btn,
                                  AmMotifDisplayClass   *motifDisplay,
                                  AmPlotClass           *plot1,
                                  AmPlotClass           *plot2,
                                  XtPointer);

AnvilBoolean AmDifferenceLayerCursorCallback( Widget              btn,
                                       AmMotifDisplayClass   *motifDisplay,
                                       AmOverlayClass        *overlay,
                                       XtPointer);

AmErrorCode AmDestroyDialogOnDeleteObject( AmMagicManagerClass  *dispMgr,
					   Widget               dialog,
					   AmScreenObjClass     *obj);
AnvilBoolean AmRender3DCallback( Widget                  btn,
                            AmMotifDisplayClass     *motifDisplay,
                            AmOverlayClass          *overlay,
                            AmImagePlotClass        *elevationPlot,
                            XtPointer);

AnvilBoolean AmRangeColorDialogCallback( Widget        parent,
			            AmPlotClass   *plot,
				    char	  **args,
				    XtPointer);

#endif /* _anvil_plot_cback_h */
