#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_plot_handlers_h_
#define _anvil_plot_handlers_h_

#include <windows.h>
#include <anvil/overlay.h>
#include <anvil/plot.h>
#include <anvil/ntdispmgr.h>

typedef void (*AmScreenObjCallbackFn)( AmDisplayManagerClass	*displayManager,
				     AmScreenObjClass		*obj,
				     void			*clientData);

void AmZoom2xCallback( HWND			hWnd,
		     UINT			iMsg,
		     WPARAM			wParam,
		     LPARAM			lParam,
		     AmNTDisplayManagerClass	*displayManager,
		     AmCoordClass			*coords);

void AmUnzoomCallback( HWND			hWnd,
		     UINT			iMsg,
		     WPARAM			wParam,
		     LPARAM			lParam,
		     AmNTDisplayManagerClass	*displayManager,
		     AmCoordClass			*coords);

void AmPanCallback( HWND			hWnd,
		  UINT			iMsg,
		  WPARAM		wParam,
		  LPARAM		lParam,
		  AmNTDisplayManagerClass	*displayManager,
		  AmCoordClass		*coords);


void AmUnzoomHalfCallback( HWND			hWnd,
			 UINT			iMsg,
			 WPARAM			wParam,
			 LPARAM			lParam,
			 AmNTDisplayManagerClass	*displayManager,
			 AmCoordClass		*coords);

void AmRefreshCallback( HWND			hWnd,
		      UINT			iMsg,
		      WPARAM			wParam,
		      LPARAM			lParam,
		      AmNTDisplayManagerClass	*displayManager);

void AmAddLayerCallback( HWND			hWnd,
		       UINT			iMsg,
		       WPARAM			wParam,
		       LPARAM			lParam,
		       AmNTDisplayManagerClass	*displayManager,
		       AmOverlayClass		*overlay);

void AddLayerAndCallbackCallback( HWND			hWnd,
				  UINT			iMsg,
				  WPARAM		wParam,
				  LPARAM		lParam,
				  AmNTDisplayManagerClass	*displayManager,
				  AmOverlayClass		*overlay,
				  AmScreenObjCallbackFn	screenObjCallback,
				  void			*clientData);

void AmDeleteLayerCallback( HWND			hWnd,
			  UINT			iMsg,
		          WPARAM		wParam,
		          LPARAM		lParam,
		          AmNTDisplayManagerClass	*displayManager,
		          AmOverlayClass		*overlay);

void AmMagnifyGlassCallback( HWND				hWnd,
			   UINT				iMsg,
			   WPARAM			wParam,
			   LPARAM			lParam,
			   AmNTDisplayManagerClass	*displayManager,
			   AmOverlayClass			*overlay);


void SetColorsCallback( HWND				hWnd,
		        UINT				iMsg,
		        WPARAM				wParam,
		        LPARAM				lParam,
		        AmNTDisplayManagerClass		*displayManager,
		        AmPlotClass			*plot);

void SetRangeCallback( HWND			hWnd,
		       UINT			iMsg,
		       WPARAM			wParam,
		       LPARAM			lParam,
		       AmNTDisplayManagerClass	*displayManager,
		       AmPlotClass		*plot);

#endif /* _anvil_plot_handlers_h_ */
