#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_polargrid_h_
#define _anvil_polargrid_h_
#include <anvil/projects.h>
#include <anvil/plot.h>
#include <anvil/legend.h>

class AmPolarGridClass : public AmScaleClass {
private:
    void        	GetFieldDefinitions( AmFieldDefPtr        *fieldDefs,
					     int                *numDefs);
    int			numSpokes;
    AmTickStyleEnum       style;             /* spacing style */
    float               spacing;           /* spacing value */
    float               base;              /* start value */
    int			numTicks;	   /* for END_END spacing */
    int			maxTicks;	   /* cap on # of tickmarks */
    AnvilBoolean		showAngles;	   /* show the #'s for each angle */
    AnvilBoolean		showRadii;	   /* show #'s for each radius */
    AnvilBoolean		navigational;	   /* 0.0 at top */
    AnvilBoolean		clockwise;	   /* clockwise/ctrclockwise flag */
protected:
    void 		initializeFields( AmWindowClass		*windowArg,
					  AmPolarGraphClass 	*graphicArg,
					  const char		*nameArg);
public:
    virtual int		getFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		setFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmPolarGridClass();
			AmPolarGridClass( AmWindowClass		*windowArg,
					AmPolarGraphClass 	*graphic, 
					const char 		*nameArg,
					...);
    virtual 		~AmPolarGridClass();
    virtual AmErrorCode draw( AmWindowClass		*w,
			      AmGCClass			*gc,
			      AmRectangleRec const	*exposeRects,
			      int			nRects);
};
    
#endif /* _anvil_polargrid_h_ */
