#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_polylegend_h_
#define _anvil_polylegend_h_

#include <anvil/legend.h>
#include <anvil/polygonplot.h>

class AmPolyLegendClass : public AmLegendClass {
private:
    AnvilBoolean	 showColors;		/* show legend by colors */
    AnvilBoolean	 showHatchAngles;	/* show legend by hatch angles */
    AnvilBoolean	 showHatchWidths;	/* show legend by hatch widths */

/* The next set of values is used to store the information
   gotten from the parent. */

    AmIndexDataRec hatchWidthIndex;
    float        *hatchWidthList;
    float        hatchWidth;		/* default hatch width */
    AmIndexDataRec hatchAngleIndex;
    float        *hatchAngleList;
    float        hatchAngle;		/* default hatch angle */
    AnvilBoolean      hatched;		/* flag to draw hatch marks */
    AnvilBoolean      solid;			/* flag to draw solid */

    float        itemExtents;

    void         GetFieldDefinitions( AmFieldDefPtr *fieldDefs,
                                      int         *numDefs);
protected:
    void	 initializeFields( AmWindowClass	  *windowArg,
				   AmPolygonPlotClass *plotArg,
				   const char	  *name);
public:
    virtual int         getFields( AmTagValuePtr tagValues,
                                   int         numValues);
    virtual int         setFields( AmTagValuePtr tagValues,
                                   int         numValues);
    virtual int         dumpFields( AmFieldLengthPtr fieldLengths,
                                    AnvilBoolean        allFields = FALSE);
    virtual AnvilBoolean     IsType( AmObjectTypeEnum type);
                        AmPolyLegendClass( AmWindowClass	  *windowArg,
		        		 AmPolygonPlotClass *plotArg,
		        		 const char	  *name,
		        		 ...);
                        AmPolyLegendClass();
    virtual             ~AmPolyLegendClass();
    virtual AmErrorCode Update( int	*eventCodes = NULL,
				int	numCodes = 0);
    virtual AmErrorCode	DrawItem( AmWindowClass		*w,
			           AmGCClass 	        *gc,
                                   int                  ,
			           AmRectangleRec const	*itemRect);
    virtual AmErrorCode	DrawItems( AmWindowClass		*w,
			           AmGCClass 	        *gc,
			           AmRectangleRec const	*itemRects);
};

#endif /* _anvil_polylegend_h */
