#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_dither_h
#define _anvil_dither_h

#include <sys/types.h>
#include <anvil/project.h>

#define FIRSTBYTE( l) ( (l & 0x000000ff))
#define SECONDBYTE( l) ( (l & 0x0000ff00) >> 8)
#define SECONDWORD( l) ( l >> 16)

#define DITHER_LEVEL        8
#define NUM_DITHER_MATRICES (DITHER_LEVEL * DITHER_LEVEL + 1)

const ulong_t  *GetRedDitherMatrix();
const ulong_t  *GetGreenDitherMatrix();
const ulong_t  *GetBlueDitherMatrix();

extern uchar_t decisionMatrix[ NUM_DITHER_MATRICES][ DITHER_LEVEL][ DITHER_LEVEL];
AmErrorCode AmInitDitherMatrices();

#endif /* _anvil_dither_h_ */
