#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_postscriptcolor_h
#define _anvil_postscriptcolor_h

#include <anvil/colorcell.h>
#include <anvil/dither.h>

const ulong_t  *AmGetPostScriptRedOffsetLookup();
const ulong_t  *AmGetPostScriptGreenOffsetLookup();
const ulong_t  *AmGetPostScriptBlueOffsetLookup();
ushort_t AmGetPostScriptNumRedShades();
ushort_t AmGetPostScriptNumGreenShades();
ushort_t AmGetPostScriptNumBlueShades();
ulong_t *AmGetPostScriptRedDitherMatrix();
ulong_t *AmGetPostScriptGreenDitherMatrix();
ulong_t *AmGetPostScriptBlueDitherMatrix();


extern uchar_t PostScriptDecisionMatrix[ NUM_DITHER_MATRICES][ DITHER_LEVEL][ DITHER_LEVEL];

AmErrorCode
AmCreatePostScriptColorCube( AmColorCellPtr         *cubeColors,
                           uint_t               numRed,
                           uint_t               numGreen,
                           uint_t               numBlue);


#endif /* _anvil_postscriptcolor_h_ */
