#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_quadnet_h_
#define _anvil_quadnet_h_

 
#define MAXARCS 65536


typedef struct AmLineArc_ LineArcRec, *LineArcPtr;
typedef struct AmNode_ NodeRec, *NodePtr;

struct AmNode_ {
    float	x;
    float	y;
    LineArcPtr	lineArcLeft;
    LineArcPtr	lineArcRight;
    LineArcPtr	*arcs;
    int		narcs;
    AnvilBoolean	visit;
};

struct AmLineArc_ {
    NodePtr	leftNode;
    NodePtr	rightNode;
};

AmErrorCode AmReduceLines( AmLinePtr	lines,
			 int		*AmNumLines,
			 int		linesz,
			 float		xmin,
			 float		ymin,
			 float		xmax,
			 float		ymax,
			 float 		vectorTolerance,
			 float		angleTolerance,
			 float		nodeTolerance,
			 AnvilBoolean	multiCallFlag);

AmErrorCode AmReducePolygons( AmPolygonPtr  polys,
                            int         numPolys,
                            int         polySize,
                            float       xmin,
                            float       ymin,
                            float       xmax,
                            float       ymax,
                            float       vectorTolerance,
			    float	angleTolerance,
                            float       nodeTolerance,
                            AnvilBoolean     multiCallFlag);

void AmFreeQuadMultiCallData();

#endif /* _anvil_quadnet_h_ */
