#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_raspoly_h_
#define _anvil_raspoly_h_

#include <anvil/datafmt.h>
#include <anvil/datatype.h>
#include <anvil/fns.h>

typedef struct AmPt {
    int x;
    int y;
} AmPtRec, *AmPtPtr;

/* rasterize a polygon into a matrix:

   poly:	polygon with points and attribute information.
   offset:	offset of attribute information.
   dataType:	type of attribute information.
   xmin, ymin, xmax, ymax:	extents of target matrix.
   matrix:	matrix to rasterize into.
   matrixDataType:	the matrix's data type 
   rows, cols:	dimensions of matrix 
*/
 
void AmRasterizePolygon( AmPolygonPtr       poly,
                       int              offset,
                       AmDataTypeEnum     dataType,
                       float            xmin,
                       float            ymin,
                       float            xmax,
                       float            ymax,
                       uchar_t          *matrix,
		       AmDataTypeEnum	matrixDataType,
                       int              rows,
                       int              cols);

/* rasterize an integer defined polygon into a matrix.  The points in the polygon
   are converted the the reference system of the matrix dimensions.

   points:	integer points for polygon.
   numpts:	number of polygon points.
   val:		value to rasterize.
   matrix:	destination matrix.
   cols:	matrix columns.
   dataType:	matrix data type.
*/

void AmRasterPoly( AmPtPtr          points,
                 int            numpts,
                 int            val,
                 uchar_t        *matrix,
                 AmDataTypeEnum   dataType,
                 int            rows,
                 int            cols);

/* set the extents for a polygon */

void AmExtentsPoly( AmPolygonPtr	poly);

#endif /* _anvil_raspoly_h_ */
