#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_reference_h_
#define _anvil_reference_h_

#include <anvil/project.h>
#include <anvil/coordinates.h>
#include <anvil/display.h>

/* reference window class */

class AmReferenceWindowClass : public AmScreenObjClass {    
private:
    AmCoordClass		*plot;
    AmWindowClass		*pixWin;
    AmGCClass		*gc;
public:
    			AmReferenceWindowClass();
			AmReferenceWindowClass( AmWindowClass	*windowArg,
					      AmCoordClass	*parentArg,
					      const char	*nameArg,
					      ...);
			~AmReferenceWindowClass();
    AmCoordClass		*GetPlot();
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         getFields( AmTagValuePtr      tagValues,
                                   int              numValues = FALSE);
    virtual int         dumpFields( AmFieldLengthPtr      fieldLengths,
                                    AnvilBoolean             allFields);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);

    virtual AmErrorCode draw( AmWindowClass               *w,
                              AmGCClass                   *gc,
                              AmRectangleRec const        *exposeRects,
			      int			nRects);
    virtual void        SetRect( int    x,
                                 int    y,
                                 int    width,
                                 int    height);
    void                GetFieldDefinitions( AmFieldDefPtr        *fieldDefs,
                                             int                *numDefs);
    virtual AmErrorCode	Update( int	*eventCodes = NULL,
				int	numCodes = 0);
};

#endif /* _anvil_reference_h_ */
