#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_region_h_
#define _anvil_region_h_

#include <anvil/graphstructs.h>

typedef struct AmRegionPoly_ {
    AmPointPtr	pts;
    int		numPts;
} AmRegionPolyRec, *AmRegionPolyPtr;

typedef struct AmRegionCover_ {
    AmRegionPolyRec	poly;
    AmRegionPolyPtr	holes;
    int			numHoles;
} AmRegionCoverRec, *AmRegionCoverPtr;

typedef struct AmRegion_ {
    AmRegionCoverPtr	regionList;
    int			numRegions;
} AmRegionRec, *AmRegionPtr;


void intersectRegion( AmRegionCoverPtr	a,
		      AmRegionCoverPtr	b);

void differenceRegion( AmRegionCoverPtr	a,
		       AmRegionCoverPtr	b);
		       
void unionRegion( AmRegionCoverPtr	a,
		  AmRegionCoverPtr	b);
		       
void xorRegion( AmRegionCoverPtr	a,
	        AmRegionCoverPtr	b);


AmErrorCode
AmIntersectPolygons( AmPointPtr    aPoly,
                     int           aNumpts,
                     AmPointPtr    bPoly,
                     int           bNumpts,
                     AmPointPtr    *intPolys,
                     int           *intNumpts,
                     int           *numIntPolys);

#endif /* _anvil_region_h_ */
