#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_resource_h_
#define _anvil_resource_h_

#include <anvil/project.h>

/* base resource database class */

class AmResourceDbClass {
protected:
    char		*filename;
public:
    AmResourceDbClass( const char *filenameArg);
    virtual 		~AmResourceDbClass();
    const char		*GetFilename();
    virtual AnvilBoolean	IsValid() = 0;
    virtual void	SaveResourceDb() = 0;
    virtual AnvilBoolean	GetResource( const char *tag, char **value) = 0;
    virtual AnvilBoolean	GetResource( const char *tag, int *value) = 0;
    virtual AnvilBoolean	GetResource( const char *tag, float *value) = 0;
    virtual AnvilBoolean	GetResource( const char *tag, AnvilBoolean *value) = 0;
    virtual AnvilBoolean	PutResource( const char *tag, const char *value) = 0;
    virtual AnvilBoolean	PutResource( const char *tag, int value) = 0;
    virtual AnvilBoolean	PutResource( const char *tag, float value) = 0;
    virtual AnvilBoolean	PutResource( const char *tag, AnvilBoolean value) = 0;
};

/* functions for getting and setting the global resources database */

void AmSetTheResourceDb( AmResourceDbClass	*db);
AmResourceDbClass *AmGetTheResourceDb();

/* Resource functions for retreiving defaults */

const char *AmGetDefault( const char *tag, const char *defaultValue);
int AmGetDefault( const char *tag, int defaultValue);
float AmGetDefault( const char *tag, float defaultValue);
AnvilBoolean AmGetDefault( const char *tag, AnvilBoolean defaultValue);

/* Resource functions for setting defaults */

AnvilBoolean AmPutDefault( const char *tag, const char *value);
AnvilBoolean AmPutDefault( const char *tag, int value);
AnvilBoolean AmPutDefault( const char *tag, float value);
AnvilBoolean AmPutDefault( const char *tag, AnvilBoolean value);

#endif /* _anvil_resource_h_ */
