#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_scale_h_
#define _anvil_scale_h_
#include <anvil/datagraphic.h>

typedef enum {
    AmBASE_TEN = 1,
    AmEND_END = 2,
    AmSPACED = 3
} AmTickStyleEnum;

class AmScaleClass : public AmScreenObjClass {

protected:
    float		min;		  /* these values are pulled from */
    float		max;		  /* the plot, and can be changed */
    AnvilBoolean             showTitle;
    char		*title;		  /* title to display */
    char		*titleFont;	  /* font for title */
    int			titleFontSize;	  /* title font size */
    AmFontWeightEnum	titleFontWeight;  /* font weight enumeration */
    AmFontSlantEnum	titleFontSlant;	  /* font slant enumeration */
    float		titleFontXScale;  /* font x and y scaling multipliers */
    float		titleFontYScale;  /* font x and y scaling multipliers */
    int			titleOffset;	  /* title offset from main body */
    int			titleSpacing;	  /* title spacing from edge */
    AnvilBoolean		titleVertical;	  /* title vertical orient flag */
    char		*font;		  /* text font */
    int			fontSize;	  /* text font size */
    AmFontWeightEnum	fontWeight;	  /* font weight enumeration */
    AmFontSlantEnum	fontSlant;	  /* font slant enumeration */
    float		fontXScale;	  /* font x and y scaling multipliers */
    float		fontYScale;	  /* font x and y scaling multipliers */
    int			textOffset;	  /* offset to scales or objects */
    AnvilBoolean		textVertical;	  /* text vertical orientation flag */
    AnvilBoolean		showText;	  /* show text flag */
    float	        _dLineWidth;	  /* line width to use */
    AmGCClass		*titleGC;	  /* keep GC's for speed */
    AmGCClass		*textGC;

    AmRectangleRec        _rectInterior;    /* Extends of the scale item. */ 

    void		initializeFields( AmWindowClass	   *windowArg,
					  AmScreenObjClass   *graphicArg,
					  const char	   *nameArg);
    void		GetFieldDefinitions( AmFieldDefPtr	*fieldDefs,
					     int		*numDefs);
public:
    virtual int		getFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		setFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	DumpFields( FILE *fp);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmScaleClass();
    virtual 		~AmScaleClass();
};

void AmScaleBaseTenSpacing( float         min,
                          float         max,
                          int           maxTicks,
                          float         *spacing,
                          float         *base);

#endif /* anvil_scale_h_ */

