#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_scatterlegend_h_
#define _anvil_scatterlegend_h_

#include <anvil/legend.h>
#include <anvil/scatterplot.h>

typedef struct AmSymbolRec {
    uchar_t *data;
    AnvilBoolean dataCopied;
    int     width;
    int     height;
    float   scale;
} AmSymbolRec, *AmSymbolPtr;

class AmScatterLegendClass : public AmLegendClass {
private:
    AnvilBoolean	 showColors;		/* show colors */
    AnvilBoolean	 showSymbols;		/* show different symbols */
    AnvilBoolean	 showSymbolSizes;	/* show different symbol sizes */
    AmImageClass   *image;
    AmSymbolPtr    *symbols;
    int          numSymbols;
    char         *symfile;
    AmIndexDataRec symbolIndex;
    char         **symbolList;
    AmIndexDataRec symbolSizeIndex;
    float        *symbolSizeList;
    AmIndexDataPtr index; 
    void	 GetFieldDefinitions( AmFieldDefPtr	*fieldDefs,
                                      int		*numDefs);
protected:
    void	initializeFields( AmWindowClass		*windowArg,
				  AmScatterPlotClass 	*plotArg,
				  const char		*nameArg);
public:
    virtual int     	getFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int         setFields( AmTagValuePtr  tagValues,
                                   int          numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmScatterLegendClass( AmWindowClass		*windowArg,
					    AmScatterPlotClass 	*plotArg,
					    const char		*nameArg,
					    ...);
			AmScatterLegendClass();
    virtual		~AmScatterLegendClass();
    virtual AmErrorCode Update( int	*eventCodes = NULL,
				int	numCodes = 0);
    virtual AmErrorCode DrawItem( AmWindowClass           *w,
                                   AmGCClass              *gc,
                                   int                  ,
                                   AmRectangleRec const   *itemRect);
    virtual AmErrorCode DrawItems( AmWindowClass          *w,
                                   AmGCClass              *gc,
                                   AmRectangleRec const   *itemRects);

};

#endif /* _anvil_scatterlegend_h_ */
