#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_shmimg_h_
#define _anvil_shmimg_h_

#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <anvil/errcode.h>

XImage *AmShmMakeImage( 
    Display 		*display, 	/* the usual server connection */
    Visual 		*visual,   	/* DefaultVisual( display, screen) */
    int 		depth,        	/* DefaultDepth( display, screen) */
    int 		format,       	/* always ZPixmap */
    unsigned int 	width, 		/* dimensions of the image */
    unsigned int 	height,
    XShmSegmentInfo 	**shminfoPtr	
);  

void AmShmShowImage( 
    Display		*display,
    Window		window,
    GC			gc,
    XImage 		*image,
    int			srcX,
    int			srcY,
    int			dstX,
    int			dstY,
    int			srcWidth,
    int			srcHeight,
    XShmSegmentInfo 	*shminfoPtr
);

AmErrorCode AmShmDestroyImage( 
    Display 		*display,
    XImage 		*image,
    XShmSegmentInfo 	*shminfo
);

#endif /* _anvil_shmimg_h_ */
