#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_slick_h_
#define _anvil_slick_h_

#include <anvil/record.h>

Widget AmAddObject( AmRecordClass *record,
                  Widget      parent,
                  char        *tag);

Widget AmAddObject( Widget       		parent,
                  void         		*valuePtr, 
                  char         		*tag,
                  AmStorageTypeEnum 	storageType = AmSTATIC,
                  int          		*lengthPtr = NULL);

Widget AmAddObject( Widget       		parent,
                  void         		*valuePtr, 
                  char         		*name,
                  AmDataTypeEnum		type,
                  AmStorageTypeEnum 	storageType = AmSTATIC,
                  int          		*lengthPtr = NULL);

Widget AmAddObject( Widget       		parent,
                  void         		*valuePtr, 
                  char         		*name,
                  AmDataTypeEnum		type,
		  unitType		units,
                  AmStorageTypeEnum 	storageType = AmSTATIC,
                  int          		*lengthPtr = NULL);

AnvilBoolean AmSetObjectValue( Widget  w,
			void    *value);

AnvilBoolean AmGetObjectValue( Widget	w,
			void	*valuePtr);

AnvilBoolean AmImmediateAccept( Widget  w);

AnvilBoolean AmAlignObjects( Widget rowcol);
AnvilBoolean AmSetOkButton( Widget button, AmRecordClass *record = NULL);
AnvilBoolean AmSetAlrightButton( Widget button, AmRecordClass *record);
AnvilBoolean AmSetRevertButton( Widget button);
AnvilBoolean AmSetCancelButton( Widget button,
			 Widget	formDlog);
Widget AmGetLabel( Widget	w);

const int AM_OK = 9001;
const int AM_REVERT = 9002;
const int AM_FINAL = 9003;

#endif /* _anvil_slick_h_ */
