#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_slickP_h_
#define _anvil_slickP_h_

#include <anvil/record.h>

#define UNIQUE_FORM_LABEL	"slickForm"

#define TEXT_BUFFER		256

#define MAX_ARGS		20

typedef void ( *AmCallbackFn)( int, void *, void *);

typedef enum {
    AmWIDGET_TEXT = 1,
    AmWIDGET_SCALE = 2,
    AmWIDGET_TOGGLE = 3,
    AmWIDGET_BUTTON = 4,
    AmWIDGET_FILESB = 5,
    AmWIDGET_LIST = 6,
    AmWIDGET_OPTION = 7,
    AmWIDGET_COLOR_BUTTON = 8,
    AmWIDGET_MULTILINE_TEXT = 9,
    AmWIDGET_DEFAULT = 100
} AmWidgetEnum;

typedef struct AmSlickRec {
    Widget          	widget;		/* widget to get data from */
    AmRecordClass     	*record;	/* record to set (may be NULL) */
    char            	*tag;		/* tag within record */
    void            	*value;		/* type-free variable */
    void		*currValue;
    AmDataTypeEnum    	type;		/* variable type */
    unitType        	units;
    void            	*range;
    Widget          	*buttons;
    void            	*valuePtr;
    AmStorageTypeEnum    storageType;
    int             	*lengthPtr;
    AmWidgetEnum		widgetType;
    int			size;		/* keep track of valuePtr size */
} AmSlickRec, *AmSlickPtr;

typedef struct AmOkArgs_ {
    AmRecordClass *record;
    AmTagValuePtr tagValues;
    int         numTags;
} AmOkArgsRec, *AmOkArgsPtr;


AnvilBoolean
AmSetTagValue(
    void         *value,
    AmDataTypeEnum type,
    char         *tag,
    AmOkArgsPtr    okArgs);


#endif /* _anvil_slickP_h_ */
