#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_sphere_h_
#define _anvil_sphere_h_

#include <anvil/colorcell.h>
#include <anvil/display.h>
#include <anvil/fns.h>
#include <anvil/errcode.h>

AmErrorCode AmComputeSphericalAngles( int         rows,
                                    int         cols,
                                    int         radius,
                                    float       **sinphis,
                                    float       **cosphis,
                                    float       **sinthetas,
                                    float       **costhetas);

void AmSphericalPlotTables(
    AmImageClass         *image,         /* destination image */
    uchar_t             *points,        /* 2-D data matrix */
    int                 size,
    int                 rows,           /* data matrix dimensions */
    int                 cols,
    AmAccessFn            colorsFn,
    void                *colorsClientData,
    float               colorsMin,
    float               colorsMax,
    AmColorCellPtr        colors,
    int			numColors,
    float               *sinphis,       /* sin( phi)*radius */
    float               *cosphis,       /* cos( phi)*radius */
    float               *sinthetas,     /* sin( theta) */
    float               *costhetas,     /* cos( theta) */
    float		theta,		/* horizontal and vertical rotations */
    float               gamma);


#endif /* _anvil_sphere_h_ */
