#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_sphereplot_h_
#define _anvil_sphereplot_h_
#include <anvil/datagraphic.h>

class AmSpherePlotClass : public AmDataGraphicClass {
private:
protected:
    float		theta;		/* sphere rotation angles */
    float		phi;
    AmImageClass	*displayImage;
    void		*colorsClientData;
    AmItemFn		colorsClientDataFreeFn;
    AmAccessFn		colorsFn;
    float		colorsMin;
    float		colorsMax;
    float		*sinphis;
    float		*cosphis;
    float		*sinthetas;
    float		*costhetas;
    void            	GetFieldDefinitions( AmFieldDefPtr  *fieldDefs,
					     int	  *numDefs);
    void		initializeFields( AmWindowClass	*windowArg,
					  const char	*nameArg);
    virtual AnvilBoolean	checkValues();
public:
                        AmSpherePlotClass( AmWindowClass  *windowArg,
                                         const char   *nameArg,
                                         ...);
    virtual 		~AmSpherePlotClass();
    virtual int     	setFields( AmTagValuePtr  tagValues,
				   int          numValues);
    virtual int     	getFields( AmTagValuePtr  tagValues,
				   int          numValues);
    virtual void 	updateFields();
    virtual int     	dumpFields( AmFieldLengthPtr    fieldLengths,
				    AnvilBoolean	      allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
    virtual AmErrorCode	draw( AmWindowClass		*window,
			      AmGCClass			*gc,
			      AmRectangleRec const	*exposeRects,
			      int			nRects);
    virtual AmErrorCode	Update( int	*eventCodes = NULL,
				int	numCodes = 0);
};

#endif /* _anvil_sphereplot_h_ */
