#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_state_handP_h_
#define _anvil_state_handP_h_

#include <X11/Intrinsic.h>
#include <anvil/list.h>

#define HANDLER_MAGIC 10201
#define HANDLER_STRING "StateHandler"

typedef void ( *AmStateHandlerFn)( void *clientData);

typedef struct AmHandler_ {
    Widget		launchWidget;	/* started handler (may be NULL) */
    Widget		handlerWidget;	/* widget handler is attached to */
    XtEventHandler	AmHandlerFn;	/* event handler function */
    XtPointer		clientData;	/* client data for handler */
    EventMask		event_mask;	/* handler's event mask */
    unsigned int	priority;	/* suspend or cancel current handler */
    AmStateHandlerFn      suspendFn;	/* user functions that get called */
    AmStateHandlerFn      restartFn;	/*   when the handlers get suspended, */
    AmStateHandlerFn      removeFn;	/*   restarted, or removed. */
} AmHandlerRec, *AmHandlerPtr;

typedef struct AmHandlerData_ {
    int		magicNo;		/* to prevent bad user data */
    AmListPtr	handlerList;		/* current handler stack */
} AmHandlerDataRec, *AmHandlerDataPtr;

#endif /* _anvil_state_handP_h_ */
