#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_strdefs_h_
#define _anvil_strdefs_h_

#include <anvil/datatype.h>
#include <anvil/tagstrs.h>

/* THIS VECTOR MUST BE ALPHABETCALLY SORTED */

static AmStrdefRec strLookup[] = {
    { AmNWProjArg, AmFLOAT },
    { AmNaEllipseArg, AmFLOAT },
    { AmNalphaProjArg, AmFLOAT },
    { AmNangleClientData, AmVOID_PTR },
    { AmNangleClientDataFreeFn, AmFUNC_PTR },
    { AmNangleFn, AmFUNC_PTR },
    { AmNangleMax, AmFLOAT },
    { AmNangleMin, AmFLOAT },
    { AmNangleType, AmENUM },
    { AmNangleUnits, AmUNITS },
    { AmNappId, AmSTRING },
    { AmNarrows, AmENUM },
    { AmNaspectFactor, AmFLOAT },
    { AmNattributes, AmSTRING_PTR },
    { AmNaziProjArg, AmFLOAT },
    { AmNbEllipseArg, AmFLOAT },
    { AmNbackground, AmCOLOR_CELL },
    { AmNbarHeight, AmINT },
    { AmNbarSpacing, AmINT },
    { AmNbarStyle, AmENUM },
    { AmNbinvec, AmFLOAT_PTR },
    { AmNbottomMargin, AmINT },
    { AmNbottomTicks, AmOBJECT },
    { AmNclientData, AmVOID_PTR },
    { AmNclipAtMin, AmBOOLEAN },
    { AmNclockwise, AmBOOLEAN },
    { AmNcolormap, AmFILE },
    { AmNcolors, AmCOLOR_CELL_PTR },
    { AmNcolorsBinvec, AmFLOAT_PTR },
    { AmNcolorsClientData, AmVOID_PTR },
    { AmNcolorsClientDataFreeFn, AmFUNC_PTR },
    { AmNcolorsFn, AmFUNC_PTR },
    { AmNcolorsIntFn, AmFUNC_PTR },
    { AmNcolorsMax, AmFLOAT },
    { AmNcolorsMin, AmFLOAT },
    { AmNcolorsName, AmSTRING },
    { AmNcolorsOffset, AmINT },
    { AmNcolorsStrings, AmSTRING_PTR },
    { AmNcolorsTable, AmINT_PTR },
    { AmNcolorsType, AmENUM },
    { AmNcolorsUnits, AmUNITS },
    { AmNcols, AmINT },
    { AmNcurrLayer, AmVOID_PTR },
    { AmNcurrXmax, AmFLOAT },
    { AmNcurrXmin, AmFLOAT },
    { AmNcurrYmax, AmFLOAT },
    { AmNcurrYmin, AmFLOAT },
    { AmNcustomEllipse, AmBOOLEAN },
    { AmNdashes, AmSTRING },
    { AmNdata, AmVOID_PTR },
    { AmNdataType, AmENUM },
    { AmNdescription, AmFILE },
    { AmNdetailLevel, AmINT },
    { AmNdims, AmINT_PTR },
    { AmNdistanceUnits, AmUNITS },
    { AmNdpi, AmINT },
    { AmNdrawFn, AmFUNC_PTR },
    { AmNdrawFnClientData, AmVOID_PTR },
    { AmNdrawFnClientDataFreeFn, AmFUNC_PTR },
    { AmNdrawGrid, AmBOOLEAN },
    { AmNdrawSolid, AmBOOLEAN },
    { AmNdrawTiles, AmBOOLEAN },
    { AmNdummy, AmINT },
    { AmNeEllipseArg, AmFLOAT },
    { AmNeditable, AmBOOLEAN },
    { AmNelevationPlot, AmVOID_PTR },
    { AmNellipse, AmSTRING },
    { AmNenableCacheFlag, AmBOOLEAN },
    { AmNendArc, AmINT },
    { AmNesEllipseArg, AmFLOAT },
    { AmNex, AmFLOAT },
    { AmNey, AmFLOAT },
    { AmNez, AmFLOAT },
    { AmNfEllipseArg, AmFLOAT },
    { AmNfd, AmINT },
    { AmNfilename, AmFILE },
    { AmNfilled, AmBOOLEAN },
    { AmNflipCols, AmBOOLEAN },
    { AmNflipRows, AmBOOLEAN },
    { AmNfn, AmFUNC_PTR },
    { AmNfocal, AmFLOAT },
    { AmNfont, AmSTRING },
    { AmNfontSize, AmINT },
    { AmNfontSlant, AmENUM },
    { AmNfontWeight, AmENUM },
    { AmNfontXScale, AmFLOAT },
    { AmNfontYScale, AmFLOAT },
    { AmNforeground, AmCOLOR_CELL },
    { AmNframe, AmBOOLEAN },
    { AmNgridStyle, AmENUM },
    { AmNhProjArg, AmFLOAT },
    { AmNhatchAngle, AmFLOAT }, 
    { AmNhatchAngleBinvec, AmFLOAT_PTR },
    { AmNhatchAngleClientData, AmVOID_PTR },
    { AmNhatchAngleClientDataFreeFn, AmFUNC_PTR },
    { AmNhatchAngleFn, AmFUNC_PTR },
    { AmNhatchAngleIntFn, AmFUNC_PTR },
    { AmNhatchAngleLength, AmINT },
    { AmNhatchAngleList, AmFLOAT_PTR },
    { AmNhatchAngleMax, AmFLOAT },
    { AmNhatchAngleMin, AmFLOAT },
    { AmNhatchAngleName, AmSTRING },
    { AmNhatchAngleOffset, AmINT },
    { AmNhatchAngleStrings, AmSTRING_PTR },
    { AmNhatchAngleTable, AmINT_PTR },
    { AmNhatchAngleType, AmENUM },
    { AmNhatchAngleUnits, AmUNITS },
    { AmNhatchPattern, AmFILE }, 
    { AmNhatchPatternBinvec, AmFLOAT_PTR },
    { AmNhatchPatternClientData, AmVOID_PTR },
    { AmNhatchPatternClientDataFreeFn, AmFUNC_PTR },
    { AmNhatchPatternFn, AmFUNC_PTR },
    { AmNhatchPatternIntFn, AmFUNC_PTR },
    { AmNhatchPatternLength, AmINT },
    { AmNhatchPatternList, AmSTRING_PTR },
    { AmNhatchPatternMax, AmFLOAT },
    { AmNhatchPatternMin, AmFLOAT },
    { AmNhatchPatternName, AmSTRING },
    { AmNhatchPatternOffset, AmINT },
    { AmNhatchPatternStrings, AmSTRING_PTR },
    { AmNhatchPatternTable, AmINT_PTR },
    { AmNhatchPatternType, AmENUM },
    { AmNhatchPatternUnits, AmUNITS },
    { AmNhatchWidth, AmFLOAT },
    { AmNhatchWidthBinvec, AmFLOAT_PTR },
    { AmNhatchWidthClientData, AmVOID_PTR },
    { AmNhatchWidthClientDataFreeFn, AmFUNC_PTR },
    { AmNhatchWidthFn, AmFUNC_PTR },
    { AmNhatchWidthIntFn, AmFUNC_PTR },
    { AmNhatchWidthLength, AmINT },
    { AmNhatchWidthList, AmFLOAT_PTR },
    { AmNhatchWidthMax, AmFLOAT },
    { AmNhatchWidthMin, AmFLOAT },
    { AmNhatchWidthName, AmSTRING },
    { AmNhatchWidthOffset, AmINT },
    { AmNhatchWidthStrings, AmSTRING_PTR },
    { AmNhatchWidthTable, AmINT_PTR },
    { AmNhatchWidthType, AmENUM },
    { AmNhatchWidthUnits, AmUNITS },
    { AmNhatched, AmBOOLEAN },
    { AmNheader, AmFILE },
    { AmNheaderStrings, AmSTRING_PTR },
    { AmNheight, AmSHORT },
    { AmNheightClientData, AmVOID_PTR },
    { AmNheightClientDataFreeFn, AmFUNC_PTR },
    { AmNheightFn, AmFUNC_PTR },
    { AmNheightIntFn, AmFUNC_PTR },
    { AmNheightMax, AmFLOAT },
    { AmNheightMin, AmFLOAT },
    { AmNheightName, AmSTRING },
    { AmNheightOffset, AmINT },
    { AmNheightType, AmENUM },
    { AmNheightUnits, AmUNITS },
    { AmNhighlightColor, AmCOLOR_CELL },
    { AmNinProjection, AmSTRING_PTR },
    { AmNincreaseCols, AmBOOLEAN },
    { AmNincreaseItems, AmBOOLEAN },
    { AmNincreaseRows, AmBOOLEAN },
    { AmNinterpolate, AmBOOLEAN },
    { AmNinvProj, AmSTRING },
    { AmNinverseProjection, AmBOOLEAN },
    { AmNitemExtents, AmFLOAT },
    { AmNitemHeight, AmINT },
    { AmNitemSpacing, AmINT },
    { AmNitemWidth, AmINT },
    { AmNkProjArg, AmFLOAT },
    { AmNkeepData, AmBOOLEAN },
    { AmNlabel, AmSTRING },
    { AmNlabelAngle, AmINT },
    { AmNlabelsPerItem, AmINT },
    { AmNlandscape, AmBOOLEAN },
    { AmNlat_0ProjArg, AmFLOAT },
    { AmNlat_1ProjArg, AmFLOAT },
    { AmNlat_2ProjArg, AmFLOAT },
    { AmNlat_bProjArg, AmFLOAT },
    { AmNlat_tsProjArg, AmFLOAT },
    { AmNleftMargin, AmINT },
    { AmNleftTicks, AmOBJECT },
    { AmNlegendType, AmENUM },
    { AmNlength, AmINT },
    { AmNlightShadeAngle, AmFLOAT },
    { AmNlightShadeFlag, AmBOOLEAN },
    { AmNlightShadeHeight, AmFLOAT },
    { AmNlineStyle, AmENUM },
    { AmNlineWidth, AmFLOAT },
    { AmNlineWidthBinvec, AmFLOAT_PTR },
    { AmNlineWidthClientData, AmVOID_PTR },
    { AmNlineWidthClientDataFreeFn, AmFUNC_PTR },
    { AmNlineWidthFn, AmFUNC_PTR },
    { AmNlineWidthIntFn, AmFUNC_PTR },
    { AmNlineWidthLength, AmINT },
    { AmNlineWidthList, AmFLOAT_PTR },
    { AmNlineWidthMax, AmFLOAT },
    { AmNlineWidthMin, AmFLOAT },
    { AmNlineWidthName, AmSTRING },
    { AmNlineWidthOffset, AmINT },
    { AmNlineWidthStrings, AmSTRING_PTR },
    { AmNlineWidthTable, AmINT_PTR },
    { AmNlineWidthType, AmENUM },
    { AmNlineWidthUnits, AmUNITS },
    { AmNlon_0ProjArg, AmFLOAT },
    { AmNlon_1ProjArg, AmFLOAT },
    { AmNlon_2ProjArg, AmFLOAT },
    { AmNloncProjArg, AmFLOAT },
    { AmNlsatProjArg, AmINT },
    { AmNmainItemHeight, AmINT },
    { AmNmaintainRange, AmBOOLEAN },
    { AmNmaintainXRange, AmBOOLEAN },
    { AmNmax, AmFLOAT },
    { AmNmaxClip, AmBOOLEAN },
    { AmNmaxTicks, AmINT },
    { AmNmemory, AmVOID_PTR },
    { AmNmin, AmFLOAT },
    { AmNminClip, AmBOOLEAN },
    { AmNmmap, AmFILE },
    { AmNname, AmSTRING },
    { AmNnameClientData, AmVOID_PTR },
    { AmNnameClientDataFreeFn, AmFUNC_PTR },
    { AmNnameFn, AmFUNC_PTR },
    { AmNnavigational, AmBOOLEAN },
    { AmNno_cutProjArg, AmBOOLEAN },
    { AmNno_rotProjArg, AmBOOLEAN },
    { AmNnsProjArg, AmBOOLEAN },
    { AmNnumAttributes, AmINT },
    { AmNnumDashes, AmINT },		/* numDashes */
    { AmNnumInProjStrs, AmINT },
    { AmNnumItems, AmINT },
    { AmNnumMinorTicks, AmINT },
    { AmNnumPoints, AmINT },
    { AmNnumProjArgs, AmINT },
    { AmNnumProjStrs, AmINT },
    { AmNnumRows, AmINT },
    { AmNnumSymbolSizes, AmINT },
    { AmNnumSymbols, AmINT },
    { AmNnumTagValues, AmINT },
    { AmNnumTicks, AmINT },
    { AmNnumColors, AmINT },		/* numcolors */
    { AmNnumdims, AmINT },
    { AmNnumShades, AmINT },
    { AmNoffset, AmINT },
    { AmNopaque, AmBOOLEAN },
    { AmNoutline, AmBOOLEAN },
    { AmNpageHeight, AmFLOAT },
    { AmNpageWidth, AmFLOAT },
    { AmNpalette, AmFILE },
    { AmNpathProjArg, AmINT },
    { AmNphi, AmFLOAT },
    { AmNpoints, AmINT_PTR },
    { AmNpreserveAspect, AmBOOLEAN },
    { AmNpriority, AmINT },
    { AmNproj, AmSTRING },
    { AmNprojCurrXmax, AmFLOAT },
    { AmNprojCurrXmin, AmFLOAT },
    { AmNprojCurrYmax, AmFLOAT },
    { AmNprojCurrYmin, AmFLOAT },
    { AmNprojXmax, AmFLOAT },
    { AmNprojXmin, AmFLOAT },
    { AmNprojYmax, AmFLOAT },
    { AmNprojYmin, AmFLOAT },
    { AmNprojectScale, AmBOOLEAN },
    { AmNprojection, AmSTRING_PTR },
    { AmNresizeFont, AmBOOLEAN },
    { AmNrfEllipseArg, AmFLOAT },
    { AmNrightMargin, AmINT },
    { AmNrightTicks, AmOBJECT },
    { AmNrows, AmINT },
    { AmNsameTickSpacing, AmBOOLEAN },
    { AmNscaleFn, AmFUNC_PTR },
    { AmNscaleLineWidthList, AmFLOAT_PTR },
    { AmNscaleStyle, AmENUM },
    { AmNscanLineClientData, AmVOID_PTR },
    { AmNscanLineClientDataFreeFn, AmFUNC_PTR },
    { AmNscanLineFn, AmFUNC_PTR },
    { AmNscreenHeight, AmFLOAT },
    { AmNscreenWidth, AmFLOAT },
    { AmNsetXFn, AmFUNC_PTR },
    { AmNsetXYFn, AmFUNC_PTR },
    { AmNsetYFn, AmFUNC_PTR },
    { AmNshared, AmBOOLEAN },
    { AmNshowAngles, AmBOOLEAN },
    { AmNshowAnnotation, AmBOOLEAN },
    { AmNshowColors, AmBOOLEAN },
    { AmNshowHatchAngles, AmBOOLEAN },
    { AmNshowHatchWidths, AmBOOLEAN },
    { AmNshowLineWidths, AmBOOLEAN },
    { AmNshowMinorScale, AmBOOLEAN },
    { AmNshowRadii, AmBOOLEAN },
    { AmNshowStrings, AmBOOLEAN },
    { AmNshowSymbolSizes, AmBOOLEAN },
    { AmNshowSymbols, AmBOOLEAN },
    { AmNshowText, AmBOOLEAN },
    { AmNshowTitle, AmBOOLEAN },
    { AmNsize, AmINT },
    { AmNskipBytes, AmINT },
    { AmNsourceType, AmENUM },
    { AmNsouthProjArg, AmBOOLEAN },
    { AmNstartArc, AmINT },
    { AmNstringList, AmSTRING_PTR },
    { AmNstringsBinvec, AmFLOAT_PTR },
    { AmNstringsClientData, AmVOID_PTR },
    { AmNstringsClientDataFreeFn, AmFUNC_PTR },
    { AmNstringsFn, AmFUNC_PTR },
    { AmNstringsIntFn, AmFUNC_PTR },
    { AmNstringsLength, AmINT },
    { AmNstringsMax, AmFLOAT },
    { AmNstringsMin, AmFLOAT },
    { AmNstringsName, AmSTRING },
    { AmNstringsOffset, AmINT },
    { AmNstringsTable, AmINT_PTR },
    { AmNstringsType, AmENUM },
    { AmNsubCols, AmINT },
    { AmNsubRows, AmINT },
    { AmNsubXmax, AmFLOAT },
    { AmNsubXmin, AmFLOAT },
    { AmNsubYmax, AmFLOAT },
    { AmNsubYmin, AmFLOAT },
    { AmNsymbol, AmSTRING },
    { AmNsymbolBinvec, AmFLOAT_PTR },
    { AmNsymbolClientData, AmVOID_PTR },
    { AmNsymbolClientDataFreeFn, AmFUNC_PTR },
    { AmNsymbolFn, AmFUNC_PTR },
    { AmNsymbolIntFn, AmFUNC_PTR },
    { AmNsymbolLength, AmINT },
    { AmNsymbolList, AmSTRING_PTR },
    { AmNsymbolMax, AmFLOAT },
    { AmNsymbolMin, AmFLOAT },
    { AmNsymbolName, AmSTRING },
    { AmNsymbolOffset, AmINT },
    { AmNsymbolSizeBinvec, AmFLOAT_PTR },
    { AmNsymbolSizeClientData, AmVOID_PTR },
    { AmNsymbolSizeClientDataFreeFn, AmFUNC_PTR },
    { AmNsymbolSizeFn, AmFUNC_PTR },
    { AmNsymbolSizeIntFn, AmFUNC_PTR },
    { AmNsymbolSizeLength, AmINT },
    { AmNsymbolSizeList, AmFLOAT_PTR },
    { AmNsymbolSizeMax, AmFLOAT },
    { AmNsymbolSizeMin, AmFLOAT },
    { AmNsymbolSizeName, AmSTRING },
    { AmNsymbolSizeOffset, AmINT },
    { AmNsymbolSizeStrings, AmSTRING_PTR },
    { AmNsymbolSizeTable, AmINT_PTR },
    { AmNsymbolSizeType, AmENUM },
    { AmNsymbolSizeUnits, AmUNITS },
    { AmNsymbolStrings, AmSTRING_PTR },
    { AmNsymbolTable, AmINT_PTR },
    { AmNsymbolType, AmENUM },
    { AmNsymbolUnits, AmUNITS },
    { AmNtable, AmINT_PTR },
    { AmNtagValues, AmVOID_PTR },
    { AmNtexHeight, AmINT },
    { AmNtexWidth, AmINT },
    { AmNtextGridDensity, AmINT },
    { AmNtextOffset, AmINT },
    { AmNtextSize, AmINT },
    { AmNtextVertical, AmBOOLEAN },
    { AmNtheta, AmFLOAT },
    { AmNtickBase, AmFLOAT },
    { AmNtickNumSpokes, AmINT },
    { AmNtickNumber, AmINT },
    { AmNtickOutside, AmBOOLEAN },
    { AmNtickPosition, AmENUM }, 
    { AmNtickSize, AmINT },
    { AmNtickSpacing, AmFLOAT },
    { AmNtickStyle, AmENUM },
    { AmNtickZoom, AmINT },
    { AmNtileDetailFlag, AmBOOLEAN },
    { AmNtiltProjArg, AmFLOAT },
    { AmNtitle, AmSTRING },
    { AmNtitleFont, AmSTRING },
    { AmNtitleFontSize, AmINT },
    { AmNtitleFontSlant, AmENUM },
    { AmNtitleFontWeight, AmENUM },
    { AmNtitleFontXScale, AmFLOAT },
    { AmNtitleFontYScale, AmFLOAT },
    { AmNtitleOffset, AmINT },
    { AmNtitleSpacing, AmINT },
    { AmNtitleVertical, AmBOOLEAN },
    { AmNtopMargin, AmINT },
    { AmNtopTicks, AmOBJECT },
    { AmNtransparency, AmFLOAT },
    { AmNtrueColor, AmBOOLEAN },
    { AmNunits, AmUNITS },
    { AmNvertical, AmBOOLEAN },
    { AmNverticalExaggeration, AmFLOAT },
    { AmNwidth, AmSHORT },
    { AmNwrap, AmBOOLEAN },
    { AmNx, AmSHORT },
    { AmNxFn, AmFUNC_PTR },
    { AmNxOffset, AmINT },
    { AmNxType, AmENUM },
    { AmNx_0ProjArg, AmFLOAT },
    { AmNxmax, AmFLOAT },
    { AmNxmin, AmFLOAT },
    { AmNxunits, AmUNITS },
    { AmNy, AmSHORT },
    { AmNyClientData, AmVOID_PTR },
    { AmNyClientDataFreeFn, AmFUNC_PTR },
    { AmNyFn, AmFUNC_PTR },
    { AmNyOffset, AmINT },
    { AmNyType, AmENUM },
    { AmNy_0ProjArg, AmFLOAT },
    { AmNymax, AmFLOAT },
    { AmNymin, AmFLOAT },
    { AmNyunits, AmUNITS },
    { AmNzFn, AmFUNC_PTR },
    { AmNzoneProjArg, AmINT },
    { AmNzunits, AmUNITS },
};

#endif /* _anvil_strdefs_h_ */
