#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_streets_h_
#define _anvil_streets_h_
#include <anvil/graphstructs.h>

typedef struct AmNode_ AmNodeRec, *AmNodePtr;
typedef struct AmPolyline_ AmPolylineRec, *AmPolylinePtr;

struct AmNode_ {
    AmPolylinePtr	*arcs;
    int			numarcs;
};

struct AmPolyline_ {
    int		numpts;
    AmPointPtr	pts;
    AmNodePtr	left;
    AmNodePtr	right;
};

struct AmStrand_ {
    int			numlines;
    AmPolylinePtr	*lines;
} AmStrandRec, *AmStrandPtr;

typedef struct AmStreet_ {
    AmLineRec		line;
    int			code;
    char		name[ 32];
} AmStreetRec, *AmStreetPtr;

#endif /* _anvil_streets_h_ */
