#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_strlib_h_
#define _anvil_strlib_h_

#include <anvil/project.h>

void stringfor( 
    int 	low,
    int 	hi,
    int 	length,
    char 	***vector
);

void stringnums( 
    float 	low,
    float 	hi,
    int 	length,
    char 	***vector
);

void stringnumsFormat( 
    float 	low,
    float 	hi,
    int 	length,
    char	*format, 
    char 	***vector
);

char **strIntVec( 
    int 	*vec,
    int 	numEl
);

char **strFloatVec( 
    float 	*vec,
    int 	numEl,
    char	*fmt
);

char *elimWspaceQuotes( 
    char 	*str
);

char *elimWhitespace( 
    char 	*str
);

char *AmSubstStr( char	*str,
		int	a,
		int	b);

void strnocpy( 
    char 	*dst, 
    char 	*src, 
    int 	size
);

char *floatStr( 
    float 	x
);

char *intStr( 
    int 	x
);

char *strappend( 
    char	*x,
    char	*y
);

char *AmElimLeadWspace( 
    char 	*str 
);

char *AmElimTrailWspace( 
    char 	*str 
);


char **AmCopyStrVec(
    char const **vec 
);

void AmFreeStrVec( 
    char **vec
);

void AmFreeStrNumVec( 
    char **vec,
    int	numStr
);

int AmVeclen( 
    char const **vector 
);

char **AmReadStrvec(
    const char *filename
);

int AmCmpStrvec( const char	**a,
	       const char	**b);

AnvilBoolean AmEndswith(
    const char	*string,
    const char	*tgt
);

void strnocpy(
    char	*dst,
    char	*src,
    int		size
);

char *floatPrecStr( 
    int	prec 
);

AnvilBoolean AmWriteStrvec( 
   const char	*file,
   const char	**vec
);

char **AmChopString( char *string,
		   int	delim);

int AmCountTokens ( char	*buf,
		  char	*sep );

int AmGetTokens ( char	*buf,
		char	*sep,
		char	***tokens );

void AmFreeTokens ( int	numTokens,
		  char	***tokens );
    
char **AmVectorQuotedStrings( char *string);

AnvilBoolean AmInStrvec( const char    *target,
		    const char	  **vec);

int AmIndexStrvec( const char    *target,
		   const char    **vec);

char **AmAppendStrvec( const char **a,
		     const char **b);

void AmCopyNewlineString( char 	*dst,
			char	*src);

void AmReplaceNewlines( char *str);

void AmStrvecToString( const char **strvec,
                     char *buffer,
                     int  delim);

#endif /* _anvil_strlib_h_ */
