#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_template_h_
#define _anvil_template_h_

#include <anvil/screenobj.h>
#include <anvil/overlay.h>
#include <anvil/createobject.h>

AmScreenObjClass **AmParseTemplateFile( char         	*file,
				    AmWindowClass 	*window,
                                    AmCreateObjectFn      fnCreateObject,
                                    void                *clientData);

AmScreenObjClass **AmParseTemplateFp( FILE			*fp,
				  AmWindowClass 		*window,
                                  AmCreateObjectFn        fnCreateObject,
                                  void                  *clientData);

void AmAddDefaultObjectInits();

AmErrorCode AmAddObjectInit( const char           *typeName,
                           AmObjectTypeEnum       type,
                           AmMakeObjectFn         createFn);

AmScreenObjClass *AmCreateObjectFromType( AmWindowClass       *window,
                                      AmScreenObjClass    *parent,
				      char		*name,
                                      AmObjectTypeEnum    objectType,
                                      AmTagValuePtr       tagValues,
                                      int               numValues);

AmErrorCode AmAddLayerFromHeader( AmWindowClass	*window,
				const char	*headerFile,
				AmOverlayClass	*overlay,
				const char	*prefsDir,
				AmScreenObjClass	**pScreenObj);


AmErrorCode AmAddLayerFromTagValues( AmWindowClass		*window,
				   AmOverlayClass         *overlay,
                                   AmTagValuePtr          tagValues,
                                   int                  nTagValues,
				   const char		*headerFile,
                                   const char           *prefsDir,
                                   AmScreenObjClass       **pScreenObj);


#endif /* _anvil_template_h_ */
