#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_templateP_h_
#define _anvil_templateP_h_

#include <anvil/datatype.h>
#include <anvil/list.h>
#include <anvil/screenobj.h>
#include <anvil/createobject.h>


typedef enum fieldType_ {
    AmFIELD_ERRROR = 0,
    AmFIELD_ATOMIC = 1,				/* simple field */
    AmFIELD_OBJECT = 2				/* embedded object fields */
} AmFieldTypeEnum;

typedef struct AmTemplDecl_ {			/* symbol table entry */
    char    	       *name;			/* object name */
    AmObjectTypeEnum     type;			/* what it is */
    char    	       *parent;			/* the object's parent */
    AmListPtr 	       fields;			/* list of templFields */
} AmTemplDeclRec, *AmTemplDeclPtr;

typedef struct AmTemplField_ {
    AmFieldTypeEnum	type;			/* ATOMIC or OBJECT */
    char    		*tag;			/* field tag */
    union {
	char    	*atomicValue;		/* union keyed by type */
	AmTemplDeclPtr	objectValue;
    } u;
} AmTemplFieldRec, *AmTemplFieldPtr;

typedef struct AmTemplSymbol_ {
    char           *name;
    AmScreenObjClass *object;
} AmTemplSymbolRec, *AmTemplSymbolPtr;

typedef struct AmObjectInit_ {
    char		*typeName;		/* well-known object string */
    AmObjectTypeEnum	objectType;		/* screen object code */
    AmMakeObjectFn	createFn;		/* creation fn */
} AmObjectInitRec, *AmObjectInitPtr;

AnvilBoolean AmTemplAddDecl( AmTemplDeclPtr decl);

AmTemplDeclPtr AmTemplCreateDecl( char    		*name,
                              AmObjectTypeEnum     type,
                              char    		*parent,
                              AmListPtr 		fields);

AmTemplFieldPtr AmTemplCreateField( char    *tag,
                                char    *value);

AmTemplFieldPtr AmTemplCreateChild( char		*tag,
				AmTemplDeclPtr	value);

int AmTemplFpYYinput( char *buffer,
                    int  maxSize);

objectType AmFindKeyword( char *name);

#endif /* _anvil_templateP_h_ */
