#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_tick_h_
#define _anvil_tick_h_
#include <anvil/projects.h>
#include <anvil/plot.h>
#include <anvil/legend.h>

const int MAXTICKS = 1024;
const int MAXDISPTICKS = 20, MINDISPTICKS = 4;

typedef enum {
    AmLEFT = 1,
    AmRIGHT = 2,
    AmTOP = 3,
    AmBOTTOM = 4
} AmTickPosEnum;

class AmTickClass : public AmScaleClass {
private:
    AmTickPosEnum		tickPos;	   /* orientation relative to plot */
    int			offset;		   /* offset from plot rectangle */
    AmTickStyleEnum	style;		   /* spacing style */
    float		spacing;	   /* spacing value */
    float		base;		   /* start value */
    int			numTicks;	   /* # of tickmarks */
    int			maxTicks;	   /* max # of ticks to display */
    int			size;		   /* tick length */
    AnvilBoolean		outside;	   /* ticks inside or outside */
    void        	GetFieldDefinitions( AmFieldDefPtr        *fieldDefs,
					     int                *numDefs);
    void 		initializeFields( AmWindowClass	*windowArg,
					  AmCoordClass 	*graphicArg,
					  const char	*nameArg);
public:
    virtual int		getFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		setFields( AmTagValuePtr	tagValues,
				   int		numValues);
    virtual int		dumpFields( AmFieldLengthPtr	fieldLengths,
				    AnvilBoolean		allFields = FALSE);
    virtual AnvilBoolean	IsType( AmObjectTypeEnum type);
			AmTickClass();
			AmTickClass( AmWindowClass		*windowArg,
				   AmCoordClass 		*graphic, 
				   const char 		*nameArg,
				   ...);
    virtual 		~AmTickClass();
    virtual AmErrorCode draw( AmWindowClass	 *w,
			      AmGCClass		 *gc,
			      AmRectangleRec const *exposeRects,
			      int		 nRects);
};
    
#endif /* _anvil_tick_h_ */
