#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _TSEARCH_H
#define	_TSEARCH_H 1

/* For tsearch */

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32) || defined(__BSD44__) 

typedef enum {
  preorder,
  postorder,
  endorder,
  leaf
} VISIT;


typedef int (*AmSearchFn)( const void *, const void *); 

typedef void ( *AmWalkFn)( const void *nodep, 
			 VISIT value, 
			 int level);

/* Action which shall be performed in the call the hsearch.  */


/* The tsearch routines are very interesting. They make many
   assumptions about the compiler.  It assumes that the AmFirst field
   in node must be the "key" field, which points to the datum.
   Everything depends on that.  */


extern void *tsearch( const void *key, void **rootp, AmSearchFn compar);

#if defined(__BSD44__)
extern void *tfind( const void *key, void * const *rootp, AmSearchFn compar);
#else
extern void *tfind( const void *key, const void **rootp, AmSearchFn compar);
#endif

extern void *tdelete( const void *key, void **rootp, AmSearchFn compar);

extern void twalk(const void *root, AmWalkFn action);

#else	/* defined(_WIN32) */

typedef void ( *AmWalkFn)( const void *nodep, 
			 VISIT value, 
			 int level);
#endif
#ifdef __cplusplus
};
#endif

#endif /* TSEARCH_H */
