#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_units_h_
#define _anvil_units_h_

#include <anvil/project.h>
#include <anvil/errcode.h>

typedef int unitType;
typedef int varType;

extern const unitType AmUNIT_UNDEFINED, AmVARIABLE_UNDEFINED;
extern unitType AmUNIT_METER, AmUNIT_LONGITUDE_ARCDEG, AmUNIT_LATITUDE_ARCDEG, 
		AmUNIT_ARCDEG;

AnvilBoolean AmConvertValue( unitType  sourceCode,
                      unitType  destCode,
                      float     value,
                      float     *convertValue);

AnvilBoolean AmConverterExists( unitType  sourceCode,
			 unitType  destCode);

AnvilBoolean AmPrintValue( unitType    unitCode,
                    float       value,
                    char        *buffer);

AnvilBoolean AmScanValue( unitType    unitCode,
                   char        *buffer,
                   float       *value);

AnvilBoolean AmPrintValueNoUnits( unitType    unitCode,
			   float       value,
			   char        *buffer);

AnvilBoolean AmGetUnitCode( const char       *unitString, 
                     unitType         *unitCode);

AnvilBoolean AmGetUnitString( unitType unitCode,
                       char     **unitString);

AnvilBoolean AmGetVariableString( varType varCode,
			   char     **varString);

AnvilBoolean AmGetVariableCode( const char       *varString,
                         varType    	  *varCode);

AnvilBoolean AmGetVariableUnits( varType    varCode,
                          unitType   *unitCode);

AnvilBoolean AmGetRegexp( unitType	unitCode,
		   char		**unitRegexp);

AmErrorCode AmParseVariableFile( char 	*file);

AmErrorCode AmParseUnitsFile( char	*file,
			    char	*errorString);

void AmGetUnitCodeList( int       **codes,
                      int       *numCodes);

void AmGetUnitStringList( char    ***strings,
                        int     *numStrings);

AnvilBoolean AmInitUnits();

AmErrorCode AmInitUnitStuff();

void AmRegisterUnitFns();

#endif /* _anvil_units_h_ */
