#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_usereventsP_h_
#define _anvil_usereventsP_h_

#include <anvil/list.h>

/* list of handlers assigned to a single event */

typedef struct AmUserHandlerList {
    int		packageId;
    int		eventId;		/* event id */
    AmListPtr	handlerList;		/* list of user event handlers */
} AmUserHandlerListRec, *AmUserHandlerListPtr;

typedef struct AmUserHandler {
    void	*clientData;			/* pass to func */
    void	(*proc)( int, void *, void *);	/* user procedure */
    AnvilBoolean	callOnce;			/* call once and remove? */
    Widget	widget;				/* widget associated with */
    AnvilBoolean	deleted;			/* handler deleted mark flag */
} AmUserHandlerRec, *AmUserHandlerPtr;

typedef struct AmUserDestroy {
    void	(*proc)( int, void *, void *);	/* arbitrary # of args */
    void	*clientData;			/* pass to func */
    int		packageId;
    int		eventId;			/* to find it */
} AmUserDestroyRec, *AmUserDestroyPtr;

static AnvilBoolean addCallbackHandler( int	    packageId,
				   int      eventId,
				   void     ( *proc)( int   id,
						      void  *clientData,
						      void  *callData),
				   void     *clientData,
				   AnvilBoolean  callOnce,
				   Widget   w);

static void removeCallbackDestroy( Widget               w,
                                   AmUserDestroyPtr       userDestroy,
                                   XtPointer            callData);


#endif /* _anvil_usereventsP_h_ */
