#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_utility_h_
#define _anvil_utility_h_

#define ELEMENTS(array) ( sizeof( array)/sizeof( *array))

const unsigned MAX_ACTIONS = 32;
const unsigned SPACING = 20;

typedef struct AmActionDefRec_ {
    char           *name;
    XtCallbackProc AmCallbackFn;
    void           *clientData;
} AmActionDefRec, *AmActionDefPtr;

typedef struct AmActionRec_ {
    Widget separator;
    Widget form;
    Widget buttonArea;
    Widget buttons[ MAX_ACTIONS];
} AmActionRec, *AmActionPtr;

Widget
AmMakeActionArea( Widget       parent,
                AmActionDefPtr actionDefs,
                unsigned     numActions,
                AmActionPtr    action,
                Boolean      makeSep = TRUE);

typedef struct AmFrameRec_ {
    Widget frame;
    Widget label;
} AmFrameRec, *AmFramePtr;

Widget
AmMakeFrame( Widget   parent,
           char     *name,
           Boolean  label,
           AmFramePtr frame);

#endif /* _anvil_utility_h_ */

