#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_va_cback_h_
#define _anvil_va_cback_h_

#include <stdarg.h>
#include <anvil/list.h>

extern char *END_LIST;

typedef void (*VarargsCallback)(...);
typedef void (*VarargsHandler)(...);

void AmAddVaCallback( Widget      	w,
                    String      	callbackName,
		    VarargsCallback	proc,
                    ...);

void AmAddVaCallbackVararg( Widget      		w,
			  String      		callbackName,
			  VarargsCallback	proc,
			  va_list		args);

void AmRemoveVaCallback( Widget      	w,
                       String      	callbackName,
		       VarargsCallback	proc,
                       ...);

void AmAddVaHandler( Widget              w,
                   unsigned int        eventMask,
                   int                 propFlag,
		   VarargsHandler	proc,
                   ...);

void AmAddVaHandlerVararg( Widget         w,
		         unsigned int   eventMask,
		         int            propFlag,
		         VarargsHandler	proc,
			 va_list	clientDataArgs);

void AmRemoveVaHandler( Widget              w,
                      unsigned int        eventMask,
                      int                 propFlag,
		      VarargsHandler	  proc,
                      ...);

void AmVaCbackWrapper( Widget             w,
                     AmListPtr            clientDataLst,
                     XtPointer          callData);

void AmVaHndlrWrapper( Widget       w,
                     AmListPtr      clientDataLst,
                     XEvent       *event,
                     AnvilBoolean      *continueDispatch);

AmListPtr	AmVaArgList( va_list	args);

#endif /* _anvil_va_cback_h_ */
