#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_xcolor_h
#define _anvil_xcolor_h

#include <anvil/colorcell.h>
#include <anvil/dither.h>

const XColor   *AmGetAppColors();
Colormap AmGetAppColormap();
const ulong_t  *AmGetXRedOffsetLookup();
const ulong_t  *AmGetXGreenOffsetLookup();
const ulong_t  *AmGetXBlueOffsetLookup();
ushort_t AmGetXNumRedShades();
ushort_t AmGetXNumGreenShades();
ushort_t AmGetXNumBlueShades();
ulong_t *AmGetXRedDitherMatrix();
ulong_t *AmGetXGreenDitherMatrix();
ulong_t *AmGetXBlueDitherMatrix();


AmErrorCode AmInitColormaps( Display *display, Window window, Visual *visual);
void        AmFreeColormap( Display *display); 
void        AmSetPixelValue( AmColorCellPtr cell); 

AmColorCellRec AmGetColorFromString( Display *display, const char *name);

extern uchar_t XdecisionMatrix[ NUM_DITHER_MATRICES][ DITHER_LEVEL][ DITHER_LEVEL];


#endif /* _anvil_xcolor_h_ */
