#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_xfonts_h
#define _anvil_xfonts_h

#include <X11/Xlib.h>

#include <anvil/errcode.h>
#include <anvil/fonts.h>

/* Default font values. */

#define DEFAULT_FONT      "adobe-helvetica"
#define DEFAULT_FULL_FONT "-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-1"
#define DEFAULT_SIZE      14
#define DEFAULT_WEIGHT    AmWEIGHT_MEDIUM
#define DEFAULT_SLANT     AmSLANT_ROMAN
#define DEFAULT_POST_FONT "Helvetica"

/* Initialize the font name cache: */

AmErrorCode AmInitFontCache( Display *display);

Font
AmLoadFont( Display        *display,
          const char     *family,
          int            size = 14,
          AmFontWeightEnum weight = AmWEIGHT_MEDIUM,
          AmFontSlantEnum  slant = AmSLANT_ROMAN,
          float          xScale = 1.0,
          float          yScale = 1.0,
          int            DPI = 72);

XFontStruct *
AmLoadQueryFont( Display        *display,
               const char     *family,
               int            size = 14,
               AmFontWeightEnum weight = AmWEIGHT_MEDIUM,
               AmFontSlantEnum  slant = AmSLANT_ROMAN,
               float          xScale = 1.0,
               float          yScale = 1.0,
               int            DPI = 72);

const char **
AmGetFontFamilies();

const char **
AmGetFontFamilies();

#endif /* _anvil_xfonts_h_ */
