#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _anvil_xresource_h_
#define _anvil_xresource_h_

#include <X11/Intrinsic.h>
#include <anvil/resource.h>

class AmXResourceDbClass : public AmResourceDbClass {
private:
    XrmDatabase	db;
public:
    AmXResourceDbClass( const char *filenameArg);
    AmXResourceDbClass( XrmDatabase dbArg);
    ~AmXResourceDbClass();
    AnvilBoolean		IsValid();	/* should be IsValid() for consist */
    virtual void	SaveResourceDb();
    virtual AnvilBoolean	GetResource( const char *tag, char **value);
    virtual AnvilBoolean	GetResource( const char *tag, int *value);
    virtual AnvilBoolean	GetResource( const char *tag, float *value);
    virtual AnvilBoolean	GetResource( const char *tag, AnvilBoolean *value);
    virtual AnvilBoolean     PutResource( const char *tag, const char *value);
    virtual AnvilBoolean     PutResource( const char *tag, int value);
    virtual AnvilBoolean     PutResource( const char *tag, float value);
    virtual AnvilBoolean     PutResource( const char *tag, AnvilBoolean value);
};

AnvilBoolean InitXResources( char	*filenameArg);

#endif /* _anvil_xresource_h_ */
