#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _cad_cad_class_h_
#define _cad_cad_class_h_

#include <anvil/motifdisplay.h>
#include <anvil/coordinates.h>
#include <anvil/question_dlog.h>

#if 0
#else
#include <ToolKit/BaseWidgetClass.h>
#include <ToolKit/LabelClass.h>
#include <ToolKit/FormClass.h>
#include <ToolKit/FrameClass.h>
#include <ToolKit/MenuClass.h>
#include <ToolKit/MenuPaneClass.h>
#include <ToolKit/PopupMenuClass.h>
#include <ToolKit/ToolBarClass.h>
#include <ToolKit/RulerClass.h>
#include <ToolKit/ScrolledTextClass.h>
#include <ToolKit/ScrolledWindowClass.h>
#include <ToolKit/ProgressBarClass.h>
#endif

class CadEditorClass : public AmBaseWidgetClass {

private:

/* Initialization and creation functions. */

    void initializeValues(); 
    void createInterface();


protected:

    AmMotifDisplayClass     *_pMotifDisplay;
    AnvilBoolean               _fStandalone;

    /* Interface widgets. */

    AmFormClass             *_pwcForm;

    AmFrameClass            *_pwcCornerFrame;
    AmScrolledWindowClass   *_pwcWindow;
    AmDrawingAreaClass      *_pwcArea;

    AmMenuClass             *_pwcMenu;
    AmMenuPaneClass         *_pwcFilePane;
    AmMenuPaneClass         *_pwcEditPane;
    AmMenuPaneClass         *_pwcPopPane;
    AmMenuPaneClass         *_pwcPushPane;

    AmToolBarClass          *_pwcToolBar;

    AmFormClass             *_pwcRightForm;
    AmToolBarClass          *_pwcStateUtilityBar;
    AmToolBarClass          *_pwcZoomUtilityBar;

    AmRulerClass            *_pwcHorizontalRuler;
    AmRulerClass            *_pwcVerticalRuler;

    AmFormClass             *_pwcStatusForm;
    AmFrameClass            *_pwcMessageFrame;
    AmLabelClass            *_pwcTextMessage;
    AmProgressBarClass      *_pwcProgressBar;

    AmXDisplayClass         *_pXDisplay;
    AmXWindowClass          *_pXWindow;

public:

    /* Constructors/Desctructors. */

    CadEditorClass();
    CadEditorClass( Widget          wParent,
                    const char      *szName);
    CadEditorClass( AmBaseWidgetClass *pwcParent,
                    const char      *szName);
    virtual ~CadEditorClass();

    /* Accessor functions. */

    virtual const char *GetClassName() { return( "EditorCLass"); };

    /* Mutator functions. */

    /* Misc functions. */

    /* Object selection functions. */

};

#endif /* _cad_cad_class_h_ */
