#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_editor_application_class_h_
#define _editor_editor_application_class_h_

#include <ToolKit/ApplicationClass.h>
#include <editor/EditorClass.h>

class AmEditorApplicationClass : public AmApplicationClass {

protected:

    AmEditorClass *_pwcEditor;

public:

    /* Constructors/Desctructors. */

    AmEditorApplicationClass();
    AmEditorApplicationClass( const char *szName,
                            int        nArgs,
                            char       **pszArgs);
    virtual ~AmEditorApplicationClass();

#ifdef PSCOPE
    void LoadInstr(char* file);
    void UnloadInstr();
#elif defined(LISTEN_SIGNAL)
    void LoadInstr(char* file);
    void UnloadInstr();
#endif

    virtual void Run();
    virtual const char * GetClassName() { return( "AmEditorApplicationClass"); };
};

#endif /* _editor_editor_application_class_h_ */
