#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_editor_tool_bar_class_h_
#define _editor_editor_tool_bar_class_h_

#include <anvil/screenobj.h>

#include <editor/enums.h>

#include <ToolKit/ToolBarClass.h>

class AmEditorToolBarClass : public AmToolBarClass {
    
private:

    static void AmSelectionChangedCallback( int       iEventID,
                                          XtPointer xpCallData,
                                          XtPointer xpClientData);

public:
    
    /* Constructors/Desctructors. */
    
    AmEditorToolBarClass();
    AmEditorToolBarClass( Widget     wParent,
                        const char *szName);
    AmEditorToolBarClass( AmBaseWidgetClass *pwcParent,
                        const char      *szName);
    virtual ~AmEditorToolBarClass();
    
    /* Mutator functions. */
    
    AmButtonClass *AddButton( const char     *szName,
                            XtCallbackProc xcp,
                            XtPointer      xp);

    AmButtonClass *AddButton( const char     *szName,
                            XtCallbackProc xcp,
                            XtPointer      xp,
                            AmSelectEnum     eSelect,
                            AmObjectTypeEnum eType);
};

#endif /* _editor_editor_tool_bar_class_h_ */
