#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_legend_dialog_class_h_
#define _editor_legend_dialog_class_h_

#include <anvil/xdisplay.h>
#include <anvil/screenobj.h>
#include <anvil/motifdisplay.h>
#include <anvil/imagelegend.h>

#include <ToolKit/DialogClass.h>
#include <ToolKit/FormClass.h>
#include <ToolKit/PaneClass.h>
#include <ToolKit/RadioPaneClass.h>
#include <ToolKit/FrameClass.h>
#include <ToolKit/DrawingAreaClass.h>
#include <ToolKit/SeparatorClass.h>
#include <ToolKit/LabelClass.h>
#include <ToolKit/ButtonClass.h>
#include <ToolKit/ToggleButtonClass.h>
#include <ToolKit/TextFieldClass.h>

#include <editor/FontDialogClass.h>

class AmLegendDialogClass : public AmDialogClass {

private:

    void         initializeValues();
    void         createInterface();

    static void  AmTextCallback( Widget    w,
                               XtPointer xpClientData,
                               XtPointer xpCallData);
    void text( Widget    w,
               XtPointer xpCallData);

    static void  AmToggleCallback( Widget    w,
                                 XtPointer xpClientData,
                                 XtPointer xpCallData);
    void toggle( Widget    w,
                 XtPointer xpCallData);

    static void AmActivateCallback( Widget    w,
                                  XtPointer xpClientData,
                                  XtPointer xpCallData);
    void activate( Widget    w,
                   XtPointer xpCallData);

    static void AmFontCallback( Widget    w,
                              XtPointer xpClientData,
                              XtPointer xpCallData);
    void font( Widget    w,
               XtPointer xpCallData);

    static void AmFontApplyCallback( Widget    w,
                                   XtPointer xpClientData,
                                   XtPointer xpCallData);
    void fontApply( Widget    w,
                    XtPointer xpCallData);

    static void AmLabelFontApplyCallback( Widget    w,
                                        XtPointer xpClientData,
                                        XtPointer xpCallData);
    void labelFontApply( Widget    w,
                         XtPointer xpCallData);

    static void AmFontCancelCallback ( Widget    w,
                                     XtPointer xpClientData,
                                     XtPointer xpCallData);
    void fontCancel( Widget    w,
                     XtPointer xpCallData);

    static void AmOffsetCallback ( Widget    w,
                                 XtPointer xpClientData,
                                 XtPointer xpCallData);
    void offset( Widget    w,
                 XtPointer xpCallData);

protected:

    AmButtonClass       *_pwcTitleButton;
    AmButtonClass       *_pwcLabelsButton;
    AmButtonClass       *_pwcItemsButton;

    AmFrameClass        *_pwcTitleFrame;

    AmTextFieldClass    *_pwcTitleText;
    AmButtonClass       *_pwcTitleFont;
    AmTextFieldClass    *_pwcTitleOffset;
    AmToggleButtonClass *_pwcTitleVert;
    AmToggleButtonClass *_pwcTitleHoriz;

    AmFrameClass        *_pwcLabelsFrame;

    AmButtonClass       *_pwcLabelFont;
    AmTextFieldClass    *_pwcLabelOffset;

    AmFrameClass        *_pwcItemsFrame;

    AmTextFieldClass    *_pwcItemWidth;
    AmTextFieldClass    *_pwcItemHeight;

    AmFrameClass        *_pwcMainItemFrame;
    AmFrameClass        *_pwcLegendFrame;

    AmFontDialogClass   *_pwcTitleFontDialog;
    AmFontDialogClass   *_pwcLabelFontDialog;

    AmDrawingAreaClass  *_pwcArea;
    AmMotifDisplayClass *_pMotifDisplay;

    AmImageLegendClass  *_pImageLegend;

    char              *_szTitle;
    char              *_szTitleFont;
    int               _iTitleSize;
    AmFontWeightEnum    _eTitleWeight;
    AmFontSlantEnum     _eTitleSlant;
    float             _dTitleXScale;
    float             _dTitleYScale;

    char              *_szLabelFont;
    int               _iLabelSize;
    AmFontWeightEnum    _eLabelWeight;
    AmFontSlantEnum     _eLabelSlant;
    float             _dLabelXScale;
    float             _dLabelYScale;

public:

    /* Constructors/Desctructors. */

    AmLegendDialogClass();
    AmLegendDialogClass( Widget      wParent,
                      const char  *szName);
    AmLegendDialogClass( AmBaseWidgetClass *bwcParent,
                      const char      *szName);
    virtual ~AmLegendDialogClass();

    /* Accessor functions. */

    virtual const char *GetClassName() { return( "AmLegendDialogClass"); };

    /* Mutator functions. */

};

#endif /* _editor_legend_dialog_class_h_ */
