#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_outline_classes_h_
#define _editor_outline_classes_h_

#include <anvil/outline.h>
#include <anvil/motifdisplay.h>

class AmResizeOutlineClass : public AmObjectOutlineClass {

protected:

public:

    /* Constructors/Destructors */

    AmResizeOutlineClass()
        : AmObjectOutlineClass() {};

    AmResizeOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmObjectOutlineClass( pMotifDisplay) {};

    AmResizeOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                        int               x,
                        int               y,
                        int               iWidth,
                        int               iHeight)
        : AmObjectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight) {};

    virtual ~AmResizeOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};

class AmMoveOutlineClass : public AmObjectOutlineClass {

protected:

public:

    /* Constructors/Destructors */

    AmMoveOutlineClass()
        : AmObjectOutlineClass() {};

    AmMoveOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmObjectOutlineClass( pMotifDisplay) {};

    AmMoveOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                      int               x,
                      int               y,
                      int               iWidth,
                      int               iHeight)
        : AmObjectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight) {};

    virtual ~AmMoveOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};

class AmAddOutlineClass : public AmMoveOutlineClass {

protected:

public:

    /* Constructors/Destructors */

    AmAddOutlineClass()
        : AmMoveOutlineClass() {};

    AmAddOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmMoveOutlineClass( pMotifDisplay) {};

    AmAddOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                     int               x,
                     int               y,
                     int               iWidth,
                     int               iHeight)
        : AmMoveOutlineClass( pMotifDisplay, x, y, iWidth, iHeight) {};

    virtual ~AmAddOutlineClass() {};

};

class AmHighlightOutlineClass : public AmObjectOutlineClass {

protected:

public:

    /* Constructors/Destructors */

    AmHighlightOutlineClass()
        : AmObjectOutlineClass() {};

    AmHighlightOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmObjectOutlineClass( pMotifDisplay) {};

    AmHighlightOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                           int               x,
                           int               y,
                           int               iWidth,
                           int               iHeight)
        : AmObjectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight) {};

    virtual ~AmHighlightOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};


class AmSelectOutlineClass : public AmObjectOutlineClass {

protected:

    AmColorCellRec _colBorder;
    AmColorCellRec _colFill;

    void initializeValues();

public:

    /* Constructors/Destructors */

    AmSelectOutlineClass()
        : AmObjectOutlineClass()
    { AmSelectOutlineClass::initializeValues(); };

    AmSelectOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmObjectOutlineClass( pMotifDisplay)
    { AmSelectOutlineClass::initializeValues(); };

    AmSelectOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                        int               x,
                        int               y,
                        int               iWidth,
                        int               iHeight)
        : AmObjectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight)
    { AmSelectOutlineClass::initializeValues(); };

    virtual ~AmSelectOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};



class AmFirstSelectOutlineClass : public AmSelectOutlineClass {

protected:

    void initializeValues();

public:

    /* Constructors/Destructors */

    AmFirstSelectOutlineClass()
        : AmSelectOutlineClass()
    { AmFirstSelectOutlineClass::initializeValues(); };

    AmFirstSelectOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmSelectOutlineClass( pMotifDisplay)
    { AmFirstSelectOutlineClass::initializeValues(); };

    AmFirstSelectOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                             int               x,
                             int               y,
                             int               iWidth,
                             int               iHeight)
        : AmSelectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight)
    { AmFirstSelectOutlineClass::initializeValues(); };

    virtual ~AmFirstSelectOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};


class AmOutlineOutlineClass : public AmObjectOutlineClass {

protected:

public:

    /* Constructors/Destructors */

    AmOutlineOutlineClass()
        : AmObjectOutlineClass() {};

    AmOutlineOutlineClass( AmMotifDisplayClass *pMotifDisplay)
        : AmObjectOutlineClass( pMotifDisplay) {};

    AmOutlineOutlineClass( AmMotifDisplayClass *pMotifDisplay,
                         int               x,
                         int               y,
                         int               iWidth,
                         int               iHeight)
        : AmObjectOutlineClass( pMotifDisplay, x, y, iWidth, iHeight) {};

    virtual ~AmOutlineOutlineClass() {};

    /* Display functions. */

    virtual AmErrorCode Draw( AmDisplayClass *display,
                              AmWindowClass  *window,
                              AmGCClass      *gc);
};

#endif /* _editor_outline_classes_h_ */
