#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _editor_handlers_h_
#define _editor_handlers_h_

#include <anvil/list.h>
#include <anvil/screenobj.h>
#include <anvil/motifdisplay.h>
#include <anvil/outline.h>

#include <editor/EditorClass.h>

AmListPtr AmGenerateMoveOutlines( AmEditorClass *pEditorClass);
AmListPtr AmGenerateResizeOutlines( AmEditorClass *pEditorClass);

void AmRemoveOutlines( AmMotifDisplayClass *pMotifDisplay,
                       AmListPtr           lstOutlines);

void AmHideOutlines( AmMotifDisplayClass *pMotifDisplay,
                     AmListPtr           lstOutlines);

void AmShowOutlines( AmMotifDisplayClass *pMotifDisplay,
                     AmListPtr           lstOutlines);

void AmSetupAddHandler( AmEditorClass    *pEditorClass,
                        AmScreenObjClass *pScreenObj);

void AmSetupAddObjectsHandler( AmEditorClass *pEditorClass,
                               AmListPtr     lstObjects);

void AmSetupMoveHandler( AmEditorClass *pEditorClass,
                         int           x,
                         int           y);

void AmSetupResizeHandler( AmEditorClass *pEditorClass,
                           int           x,
                           int           y,
                           AmActionEnum  eAction);

void AmSetupOutlineHandler( AmEditorClass *pEditorClass,
                            int           x,
                            int           y);

void AmSetupSecondaryHandler( AmEditorClass    *pEditorClass,
                              AmScreenObjClass *pScreenObj,
                              int              x,
                              int              y,
                              AmActionEnum     eAction);

#endif /* _editor_handers_h_ */
