#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _util_bilin_h_
#define _util_bilin_h_

#include <anvil/fns.h>
#include <anvil/colorcell.h>

/* client data for the different bilinear interpolation functions */

typedef struct intensityInterp_ {
    AmAccessFn	fn;
    AmSetFn	setValFn;
} intensityInterpRec, *intensityInterpPtr;

typedef struct pseudoColorInterp_ {
    AmColorCellPtr	palette;
    int			numColors;
} pseudoColorInterpRec, *pseudoColorInterpPtr;

typedef struct thematicInterp_ {
    AmIntAccessFn	fn;
    AmIntSetFn	setValFn;
} thematicInterpRec, *thematicInterpPtr;
	
typedef void ( *interpolateFn)( uchar_t	*src,
				void	*fnData,
				int	size,
				float	x,
				float	y,
				uchar_t	*dst);


void AmInterpolateTrueColor( uchar_t      *src,
                           void         *fnData,
                           int          size,
                           float        x,
                           float        y,
                           uchar_t      *dst);

void AmInterpolateIntensity( uchar_t              *src,
                           intensityInterpPtr   fnData,
                           int                  size,
                           float                x,
                           float                y,
                           uchar_t              *dst);

void AmInterpolatePseudoColor( uchar_t                    *src,
                             pseudoColorInterpPtr       fnData,
                             int                        size,
                             float                      x,
                             float                      y,
                             uchar_t                    *dst);

void AmInterpolateThematic( uchar_t               *src,
                          thematicInterpPtr     fnData,
                          int                   size,
                          float                 x,
                          float                 y,
                          uchar_t               *dst);

AnvilBoolean AmCreateInterpolationArgs( AmResourceDbClass        *db,
                                 void                   **clientData,
                                 interpolateFn          *interpFn);

#endif /* _util_bilin_h_ */
