#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _util_endian_h_
#define _util_endian_h_
#include <anvil/endian.h>
#include <sys/types.h>


#if BYTE_ORDER == LITTLE_ENDIAN
#define BIG_LONG( x) 								\
{										\
    ulong_t y = ( ulong_t) (x);							\
    y = ((y << 24) | ((y & 0xff00) << 8) | ((y >> 8) & 0xff00) | (y >> 24));	\
    (x) = y;								\
}
#define BIG_DOUBLE( x)								\
{										\
    ulong_t xlo = (( ulong_t *) &(x))[ 0], xhi = (( ulong_t *) &(x))[ 1], 	\
	    *p = ( ulong_t *) &(x);						\
    BIG_LONG( xlo);								\
    BIG_LONG( xhi);								\
    p[ 0] = xlo;								\
    p[ 1] = xhi;								\
}
#define LITTLE_LONG( x)
#define LITTLE_DOUBLE( x)
#else 
#define BIG_LONG( x)
#define BIG_DOUBLE( x)
#define LITTLE_LONG( x) 							\
{										\
    ulong_t y = ( ulong_t) x, *p = ( ulong_t *) &x;				\
    y = ((y << 24) | ((y & 0xff00) << 8) | ((y >> 8) & 0xff00) | (y >> 24));	\
    *p = y;									\
}
#define LITTLE_DOUBLE( x)							\
{										\
    ulong_t xlo = (( ulong_t *) &(x))[ 0], xhi = (( ulong_t *) &(x))[ 1], 	\
	    *p = ( ulong_t *) &(x);						\
    LITTLE_LONG( xlo);								\
    LITTLE_LONG( xhi);								\
    p[ 0] = xlo;								\
    p[ 1] = xhi;								\
}
#endif


#endif /* _util_endian_h_ */
