#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _util_tile_h_
#define _util_tile_h_

#include <anvil/datatype.h>
#include <anvil/errcode.h>
#include <anvil/newtile.h>

int AmFilterVec( uchar_t          *buffer,
               int              numread,
               int              size,
               AmDataTypeEnum     lookupType,
               int              lookupOffset,
               int              *filterIds,
               int              numIds);

int AmFilterPolygonVec( uchar_t          *buffer,
                      int              numread,
                      int              size,
                      AmDataTypeEnum     lookupType,
                      int              lookupOffset,
                      int              *filterIds,
		      float	       *filterSizes,
                      int              numIds);

AmErrorCode AmCompressTree( memTilePtr    tile,
                          seekAddress   *losses,
                          int           *fds);


AnvilBoolean AmReadAndPrintTileInfo( char      *tileFile);

AnvilBoolean AmWriteTileInfo( char             *outputFile,
                       char             **filenames,
                       int              numFiles,
                       memTilePtr       tiles);

void AmPrintTileTree( memTilePtr  tile);

AnvilBoolean AmSameFilter( int *filter1,
                    int length1,
                    int *filter2,
                    int length2);

void AmSumsToIndices( int *sums,
                    int *indices,
                    int length);

#endif /* _util_tile_h_ */
