
/*
 * xa_utils.c
 *
 * Copyright (C) 1991,1992,1993,1994,1995,1996 by Mark Podlipec. 
 * All rights reserved.
 *
 * This software may be freely copied, modified and redistributed without
 * fee for non-commerical purposes provided that this copyright notice is
 * preserved intact on all copies and modified copies.
 * 
 * There is no warranty or other guarantee of fitness of this software.
 * It is provided solely "as is". The author(s) disclaim(s) all
 * responsibility and liability with respect to this software's usage
 * or its effect upon hardware or computer systems.
 *
 */
/* revhist
 * 12dec94  +bCdm caused core on Alpha OSF/1 v3.0. 
 *           found and fixed by David Mosberger-Tang.
 *
 */ 
#include "xanim.h"

/* Routine to read a little endian long word.
 */
xaULONG UTIL_Get_LSB_Long(fp)
FILE *fp;
{
 xaULONG ret;

 ret =  fgetc(fp);
 ret |= fgetc(fp) << 8;
 ret |= fgetc(fp) << 16;
 ret |= fgetc(fp) << 24;
 return ret;
}

/* Routine to read a little endian half word.
 */
xaULONG UTIL_Get_LSB_Short(fp)
FILE *fp;
{
 xaULONG ret;

 ret =  fgetc(fp);
 ret |= fgetc(fp) << 8;
 return ret;
}

/* Routine to read a big endian long word.
 */
xaULONG UTIL_Get_MSB_Long(fp)
FILE *fp;
{
 xaULONG ret;

 ret  = fgetc(fp) << 24;
 ret |= fgetc(fp) << 16;
 ret |= fgetc(fp) << 8;
 ret |=  fgetc(fp);
 return ret;
}

/* Routine to read a big endian half word.
 */
xaLONG UTIL_Get_MSB_Short(fp)
FILE *fp;
{
 xaLONG ret;
 xaSHORT tmp;

 tmp  =  fgetc(fp) << 8;
 tmp |=  fgetc(fp);
 ret = tmp;
 return ret;
}

/* 
 * Routine to read a big endian half word.
 */
xaULONG UTIL_Get_MSB_UShort(fp)
FILE *fp;
{
 xaULONG ret;

 ret  =  fgetc(fp) << 8;
 ret |=  fgetc(fp);
 return ret;
}

/**************************
 * Reverse Index
 * Searches string "s" for character "c" starting at the 
 * end of the string.
 **************************/
char *XA_rindex(s,c)
char *s,c;
{ int len;
  char *p = s;

  if (c == 0) return((char *)(NULL));
  if (s == (char *)(NULL)) return((char *)(NULL));
  len = strlen(s);
  p += len;
  while(len >= 0)
  { if (*p == c) return(p);
    else {p--; len--;}
  }
  return( (char *)(NULL) );
}
