#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <Xm/Xm.h>
#include <Xm/ToggleB.h>
#include <Xm/Frame.h>
#include <Xm/Form.h>
#include <signal.h>
#include <stdio.h>

enum status1 {Neutral, Recognizing, Recording} status = Neutral;
Widget recognizing, recording;

void usr1()
{
  Arg args[1];

  printf ("User 1\n");

  if (status == Neutral) {
    XtSetArg (args[0], XmNset, True);
    XtSetValues (recording, args, 1);
    status = Recording;
  } else if (status == Recording) {
    XtSetArg (args[0], XmNset, False);
    XtSetValues (recording, args, 1);
    XtSetArg (args[0], XmNset, True);
    XtSetValues (recognizing, args, 1);
    status = Recognizing;
  } else if (status == Recognizing) {
    XtSetArg (args[0], XmNset, False);
    XtSetValues (recognizing, args, 1);
    status = Neutral;
  } /* endif */
  XFlush(XtDisplay(recognizing));
}

void usr2()
{
  Arg args[1];

  printf ("User 2\n");

  XtSetArg (args[0], XmNset, False);
  XtSetValues (recording, args, 1);
  XtSetValues (recognizing, args, 1);
  XFlush(XtDisplay(recognizing));
  status = Neutral;
}

int main (int argc, char* argv[]) 
{
  XtAppContext app_context;
  Widget topLevel, dialog_frame, form;
  Arg args[5];

  XtSetLanguageProc (NULL, (XtLanguageProc)NULL, NULL);
  
  topLevel = XtVaAppInitialize (&app_context, "spstatus", NULL, 0, 
				&argc, argv, NULL, XtNtitle, 
				"Speech Status", NULL);

  /* Create a frame for the speech dialog */
  XtSetArg(args[0], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(args[1], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(args[2], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(args[3], XmNrightAttachment, XmATTACH_FORM);
  dialog_frame = XtCreateManagedWidget ("frame", xmFrameWidgetClass,
					topLevel, args, 4);
      
  /* Create the main form for the dialog */
  form = XtCreateManagedWidget ("form", xmFormWidgetClass, dialog_frame,
				NULL, 0);

  XtSetArg(args[0], XmNtopAttachment, XmATTACH_FORM);
  XtSetArg(args[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(args[2], XmNrightAttachment, XmATTACH_FORM);
  recording = XtCreateManagedWidget ("Recording", xmToggleButtonWidgetClass,
				     form, args, 3);

  XtSetArg(args[0], XmNtopAttachment, XmATTACH_WIDGET);
  XtSetArg(args[1], XmNleftAttachment, XmATTACH_FORM);
  XtSetArg(args[2], XmNrightAttachment, XmATTACH_FORM);
  XtSetArg(args[3], XmNbottomAttachment, XmATTACH_FORM);
  XtSetArg(args[4], XmNtopWidget, recording);
  recognizing = XtCreateManagedWidget ("Recognizing", 
				       xmToggleButtonWidgetClass,
				       form, args, 5);   

  XtRealizeWidget(topLevel);

  /* Await input from speech app */
  signal (SIGUSR1, usr1);
  signal (SIGUSR2, usr2);

  XtAppMainLoop (app_context);
  return 0;
}
