#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#define USAGE \
        { fprintf(stderr, \
                "Usage: %s [-debug] [-html] [-noimage] [-generatelog]\n" \
                "       %*c [-lowest <num>] [-low <num>] [-mid <num>] [-high <num>]\n" \
		" -debug:       turn on debugging messages\n" \
		" -html:        turn on HTML distillation\n" \
		" -noimage:     turn off image distillation\n" \
                " -generatelog: generate log (for turning into a trace)\n" \
                " -lowest, -low, -mid, -high: set the quality level for\n" \
                "               that range of adaptation\n", \
                argv[0], strlen(argv[0]), ' '); \
        exit(-1); }

#define DEBUG(cmd) \
do { \
    if (debugging) \
        cmd; \
} while (0)

int  parse_args(int current, int argc, char **argv);

int  do_remote(void);

int  bogus_accept(int        reqid,
		  const void *data,
		  int        size);

int handle_remote(struct SWWW_fetch_in  *inp,
		  struct SWWW_fetch_out *outp);

int  process_requests(struct SWWW_fetch_in  *inp,
		      struct SWWW_fetch_out *outp);

void adapt_to_bw(int          reqid,
		 unsigned int rsrc,
		 int          val);

void adapt_to_en(int          reqid,
		 unsigned int rsrc,
		 int          val);

#ifdef BW_TOOL
void poke_monitor(int level);
#endif
