#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

enum html_state {
    NONE         = 12,
    IN_ANCHOR    = 41,
    IN_HEADER    = 93,
    IN_BEGIN_TAG = 105,
    IN_END_TAG   = 213,
    DONE         = 592,
    UNKNOWN      = 912
};

enum html_dispose {
    DISPOSE = 9,
    KEEP    = 15
};

struct html_buffer {
    char       *buffer;
    char       *index;
    int         size;
    int         remaining;
    ds_safeq_t *queue;
};

#define INIT_HTML_BUFFER(bp, qp) \
do { \
    (bp)->buffer    = NULL; \
    (bp)->size      = 0; \
    (bp)->remaining = 0; \
    (bp)->index     = (bp)->buffer; \
    (bp)->queue     = qp; \
} while (0)

#define SEND_ALONG(text, buffer) \
do { \
    char *big_buf = (char *) malloc(strlen(buffer) + 10); \
    sprintf(big_buf, text, buffer); \
    accept_html_data(reqid, big_buf, strlen(big_buf)); \
    free(big_buf); \
} while (0)

char *get_bytes_to_char(char                c,
			struct html_buffer *html_buffer,
			enum html_dispose   disposable,
			int                *size);

void html_main(ds_safeq_t *readq, int reqid);
