#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __DigestDialog_h__
#define __DigestDialog_h__

#include <Xm/Xm.h>
#include "sets.h"

/* Client data structure for digest dialogs */
typedef struct {
  Widget parent;
  Widget dialog; 
  Widget list;
  Widget label;
  int set;
  Display* display;
  Window* pNetscapeWindow;
} Digest_ClientData;

/* A linked list of digest dialog structures ordered by most recent usage */
typedef struct DigestDialogLL {
  Digest_ClientData* pClientData;
  struct DigestDialogLL* pNext;
} DigestDialogLL;

/* Function prototypes */
Digest_ClientData* findDigestDialog (Display* display, Window w);
Digest_ClientData* firstDigestDialog ();
void Digest_Open_Member (Digest_ClientData* pClientData, int mem);
void Digest_Open_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Digest_Rewind_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Digest_Redigest_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Digest_Cancel_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Populate_Digest_List (Widget list, Widget label, Digest* pDigest);
void Create_Digest_Dialog (Widget parent, int set, char* name, Digest* pDigest,
			   Display* display, Window* pNetscapeWindow);

#endif

