#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __UnionDialog_h__
#define __UnionDialog_h__

#include <Xm/Xm.h>

/* Client data structure for Set dialogs */
typedef struct {
  Widget parent;
  Widget dialog; 
  Widget menuItem;
  Widget unionWidget;
  Widget intersectWidget;
  int set;
  char* setName;
  Display* display;
  Window* pNetscapeWindow;
} Set_ClientData;

/* A linked list of set dialog structures ordered by most recent usage */
typedef struct DialogLL {
  Set_ClientData* pClientData;
  struct DialogLL* pNext;
} DialogLL;

/* Function prototypes */
Set_ClientData* findSetDialog (Display* display, Window w);
Set_ClientData* firstSetDialog ();
void Set_Iterate_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Set_Rewind_Callback (Widget w, XtPointer client_data, 
			  XtPointer call_data);
void Set_Digest_Callback (Widget w, XtPointer client_data, 
			  XtPointer call_data);
void Set_Size_Callback (Widget w, XtPointer client_data, 
			XtPointer call_data);
void Set_Close_Callback (Widget w, XtPointer client_data, 
			 XtPointer call_data);
void Set_Cancel_Callback (Widget w, XtPointer client_data, 
			  XtPointer call_data);
void Set_Help_Callback (Widget w, XtPointer client_data, 
			XtPointer call_data);
void Set_MenuItem_Callback (Widget w, XtPointer client_data, 
			    XtPointer call_data);
void Create_Set_Dialog (Widget parent, Widget menu, Widget unionWidget,
			Widget intersectWidget, int sp, char* url, 
			Display* display, Window* pNetscapeWindow);

#endif





