#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __WWWSets_h__
#define __WWWSets_h__

#include <Xm/Xm.h>

/* Data for a specific Netscape window and its sets extension */
struct SetsData;

typedef struct {
  Window           netscapeWindow; 
  Window           urlWindow;
  Window           buttonWindow;
  Window           setWindow;
  Widget           topLevel;
  Widget           mainWidget;
  Widget           setsMenuWidget;
  Widget           setsMenuBarWidget;
  Widget           frameWidget;
  Widget           unionWidget;
  Widget           intersectWidget;
  struct SetsData* pSetsData;
  int              controlPress;
} WindowData;

/* Item in a linked list */
typedef struct WindowItem {
  WindowData* pData;
  struct WindowItem* pNext;
} WindowItem;

/* Data global to the entire sets program */
typedef struct SetsData {
  Display*    display;
  Widget      topLevel;
  WindowItem* pWindowList;
} SetsData;

typedef struct WindowLL {
  Window window;
  struct WindowLL* pNext;
} WindowLL;

struct {
  int x_offset, y_offset;
  Window window;
} activeGrab;

/* Defines */
#define NAV_TITLE "Netscape Navigator"
#define SPEECH_MODEL "net"

/* Function prototypes */
void handleResize (Widget w, XtPointer client_data, XEvent* pEvent, 
		   Boolean* continueToDispatch);
int netscapeRemoteOpenURL (char* url, Display* display, Window* pWindow,
			   int waitForCompletion);
int netscapeRemote (char* command, Display* display, Window* pWindow,
		    int waitForCompletion);
void reparentNetscapeWindow(Display* display, Window window, Window dsetWindow,
			    Window frameWindow);
void unparentNetscapeWindow(Display* display, Window window, 
			    Window dsetWindow);
void netscapeString (char* str, Display* display, Window* pNetscapeWindow);
char* getNetscapeURL (Display* display, Window netscapeWindow);
void handleSpecialButtonRelease (WindowData* pWindowData, XEvent* pPressEvent, 
				 XEvent* pReleaseEvent);
WindowData* findURLWindow (SetsData* pSetsData, Window window);

#endif
