#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __sets_h__
#define __sets_h__

/* Structure returned by GetDigestOfSet() */
#define MAX_DIGEST_NAME_LEN 4096
typedef struct DigestElem {
  char name[MAX_DIGEST_NAME_LEN];
  char isFetched;
  struct DigestElem* pNext;
} DigestElem;

typedef struct {
  int numberOfMembers;
  short isFullDigest;
  DigestElem* pList;
} Digest;
  
/* Function prototypes */
int OpenSetForURL (char* url);
int IterateOnSet (int set, char* url, int len);
int GetSetSize (int set);
void RewindSetDigest (int set);
void RewindSetIterator (int set);
void GetDigestOfSet (int set, Digest* pDigest);
int CreateSetUnion (char* set1, char* set2, char* setName);
int CreateSetIntersection (char* set1, char* set2, char* setName);
void CloseSet (int set);
int GetNumberOfOpenSets ();
void GetOpenSetNames (char*** names, int* number);

#endif
