#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __XUTILS_H__
#define __XUTILS_H__

#include <Xm/Xm.h>

/* Structure used for sorting windows by geometrical position */
typedef struct {
  Window win;
  int dist;
} WindowGeom;

enum directionType { DIR_NORTH, DIR_SOUTH, DIR_EAST, DIR_WEST, DIR_NORTHEAST,
                     DIR_NORTHWEST, DIR_SOUTHEAST, DIR_SOUTHWEST };

/* Function Prototypes */
Window getParent (Display* display, Window window);
Window getRoot (Display* display, Window window);
int isWindowMapped (Display* display, Window window);
int getChildOffset (Display* display, Window child, Window ancestor, 
		    int* x_ret, int* y_ret);
int isDescendant (Display* display, Window descendant, Window ancestor);
int getChildCoord (Display* display, Window ancestor, int x, int y,
		   Window* child, int* x_ret, int* y_ret);
Window getChildByGeometry (Display* display, Window parent, 
			   enum directionType dir, int num);
void pressButton (Display* display, Window w);
void pressKey (Display* display, Window w, unsigned int state, 
	       unsigned int keycode);

#endif
