#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __SPEECH_DIALOG_H__
#define __SPEECH_DIALOG_H__

enum inputType { USE_AUDIO, USE_FILE };

/* Client data structure */
typedef struct {
  XtAppContext* pAppContext;
  Widget parent;
  Widget frame;
  Widget text;
  Widget button;
  Widget currentPopup;
  Widget inputLabel;
  Widget effortLabel;
  Widget dialog;
  Widget effortText;
  int fd;
  char* model;
  int recording;
  enum inputType input;
  char* inputFilename;
  float searchEffort;
} ClientData;

/* Function Prototypes */
int readBytes (int fd, char* buffer, int bytesToRead);
void Recognize_Callback (Widget w, XtPointer client_data, XtPointer call_data);
void Config_Local_Callback (Widget w, XtPointer client_data, 
			    XtPointer call_data);
void Config_Hybrid_Callback (Widget w, XtPointer client_data, 
			     XtPointer call_data);
void Config_Remote_Callback (Widget w, XtPointer client_data, 
			     XtPointer call_data);
void Config_Odyssey_Callback (Widget w, XtPointer client_data, 
			      XtPointer call_data);
void Input_Audio_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void Input_File_Callback (Widget w, XtPointer client_data, 
			  XtPointer call_data);
void File_Cancel_Callback (Widget w, XtPointer client_data, 
			   XtPointer call_data);
void File_OK_Callback (Widget w, XtPointer client_data, XtPointer call_data);
void Options_Effort_Callback (Widget w, XtPointer client_data, 
			      XtPointer call_data);
void Stats_Callback (Widget w, XtPointer client_data, XtPointer call_data);
void Cancel_Callback (Widget w, XtPointer client_data, XtPointer call_data);
ClientData* Create_Speech_Frame (Widget parent, XtAppContext* pAppContext, 
				 int fd, char* model);
Widget Create_Speech_Menu (ClientData* pClientData); 

#define STATS_FILE "/tmp/xspeech.stats"

#endif
