#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __SPEECH_CLIENT_MAIN_H__
#define __SPEECH_CLIENT_MAIN_H__

#define DEFAULT_LOCAL_CPU_RATIO 1.0
#define DEFAULT_REMOTE_CPU_RATIO 0.116
#define DEFAULT_BANDWIDTH 460000
#define LRPC_BANDWIDTH 460000
#define MAX_BANDWIDTH 999999999

typedef void (*callback_fn) (enum strategyType, void* arg);

/* Function prototypes */
#ifdef MULTRES
float localHybridEval (int num, ody_req_res_val_t* pValues);
float hybridRemoteEval (int num, ody_req_res_val_t* pValues);
void setResourceWindow (ody_req_res_val_t* presvals);
void resetWindow (int reqid, int resnum, ody_req_res_val_t* pValues);
#else
void setBandwidthWindow(int reqid, unsigned int rsrc, int val);
#endif
int initStrategy (int fd, float localCPU, float remoteCPU, char* model);
void speech_set_callback (callback_fn fn, void* callback_args);
int speech_init ();

#endif
