#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * (Thread-)safe queues
 */

#ifndef _DS_SAFEQ_H_
#define _DS_SAFEQ_H_

#include "include/odytypes.h"

typedef struct ds_safeq_t ds_safeq_t;

/* 
 * observer - test that a safeq is a valid structure 
 */
extern bool   ds_safeq_valid (ds_safeq_t *q);

/*
 * observer - return the number of elements in a safeq
 */

extern int           ds_safeq_count     (ds_safeq_t *q);

/*
 * Mutators
 *
 * A deq will block until there is something to return, or the queue is
 * destroyed, in which case it returns null.
 *
 * Enq should return zero on success, 1 if the queue is dying.
 *
 * A destroy will block until the queue is empty.
 */
extern ds_safeq_t   *ds_safeq_create  ();
extern void          ds_safeq_destroy (ds_safeq_t *q);
extern int           ds_safeq_enq     (ds_safeq_t *q, void *i);
extern void         *ds_safeq_deq     (ds_safeq_t *q);

#endif /* _DS_SAFEQ_H_ */
