#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * ds_safeq.private.h: Implementation details of ds_safeq_t
 */

#ifndef _DS_SAFEQ_PRIVATE_H_
#define _DS_SAFEQ_PRIVATE_H_

#include "include/odytypes.h"
#include "ds_thread.h"
#include "ds_safeq.h"

extern const magic_t ds_safeq_magic;

struct ds_safeq_t {
    magic_t        sq_magic;
    char           sq_dying;
    char           sq_signal;
    char           sq_MTsignal;
    int            sq_waiters;
    ds_lock_t      sq_lock;
    ds_list_t     *sq_list;
};

#define DS_SAFEQ_VALID(qp)   ((qp) && ((qp)->sq_magic == ds_safeq_magic))

#endif /* _DS_SAFEQ_PRIVATE_H_ */
