#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * ds_thread.private.h
 */

#ifndef _DS_THREAD_PRIVATE_H_
#define _DS_THREAD_PRIVATE_H_

struct threadinfo_t {
    /* The following are setup by the creating thread. */
    PFIC         ti_body;   /* Function that is the body of this thread */
    void         *ti_arg;   /* Argument pointer to the thread */
    char         *ti_name;  /* Name of this thread (unique) */
    ds_thread_t  ti_ptid;   /* Parent (creator) of this thread */
    ds_log_t     *ti_log;   /* The log used by this thread */
    /* The following is setup by the created thread. */
    /* The created thread must also actually hide the rock */
    ds_thread_t  ti_tid;    /* This thread's id */
};

#define mainthread   "Main"

#define TINFO_ROCK 0x58ac

#endif /* _DS_THREAD_PRIVATE_H_ */
