#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * errors.h -- error bodies for SimpleWWW error conditions
 *
 * this header file defines several constant strings which are to
 * be returned as the HTTP object bodies when various SWWW error
 * conditions occur.
 *
 */

/* HTTP/1.0 400 Bad Request (URL malformed) */

char *SWWW_400 =
 "The URL supplied is not a valid URL.\n";

/* HTTP/1.0 501 Not Implemented */
char *SWWW_501 =
 "The access scheme requested is not yet implemented.\n";

/* HTTP/1.0 500 Internal Server Error (no such host) */
char *SWWW_500_no_such_host =
 "Document fetch failed (no such host).\n";

/* HTTP/1.0 500 Internal Server Error (couldn't create socket) */
char *SWWW_500_couldnt_create_socket =
 "Document fetch_failed (couldn't create a socket).\n";

/* HTTP/1.0 500 Internal Server Error (unable to connect to server) */
char *SWWW_500_unable_to_connect =
 "Document fetch failed (unable to connect to server).\n";

/* Null response */
/* XXX unclear if this is needed */
char *SWWW_null_response =
 "This is a default error message. Getting this error message means "
 "that someone was lazy in coding.\n";
