#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * Private functions for server.c
 * (should only be included by server.c)
 */

/* this structure is used by SWWW_accept_requests() to pass relevant
   data to fetch_url_LWPshell() */
typedef struct fetch_params {
    SWWW_fetch_url_fn     fetch_url;
    SWWW_method_t         method;
    char                  *url;
    int                   reqid;
    SWWW_headers_t        *headers;
    SWWW_acceptheaders_fn acceptheaders;
    SWWW_acceptdata_fn    acceptdata;
    
    /* POST-specific parameters */
    int                   length;
    char                  *buffer;
    int                   bufsize;
    SWWW_fetchdata_fn     fetchdata;
} fetch_params_t;

int fetch_url_LWP_shell(void *request_q);

int parse_request(const char    *the_request,
		  SWWW_method_t *the_method,
		  char          **the_url,
		  char          **version);

int send_headers(int            reqid,
		 int            status_code,
		 char           *status,
		 int            header_size,
		 SWWW_headers_t *headers);

/* parse_request errors */
#define PR_UNKNOWN_METHOD -1
#define PR_BAD_REQUEST    -2
