#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * test-proxy.c -- test proxy for SimpleWWW library
 */

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include <sys/stat.h>
#include <base/ds/ds_safeq.h>
#include <base/simplewww/swww.h>
#include <lwp/lwp.h>
#include "test-proxy.h"

int main(int argc, char **argv) {
  int response_code;
  PROCESS pid;
  ds_safeq_t *request_q;

  if(SWWW_version(SWWW_VERSION)) {
    /* if library version doesn't match header file, we're hosed */
    exit(1);
  }

  /* XXX For now, leave this here. I'll be moving it into
         SimpleWWW at some later point, once I figure out the
	 proper way to do it. */
  signal(SIGPIPE, SIG_IGN);

  if(LWP_Init(LWP_VERSION, LWP_NORMAL_PRIORITY, &pid) != LWP_SUCCESS) {
    fprintf(stderr, "main: can't initialize LWP!\n");
    exit(-1);
  }

  if(IOMGR_Initialize() != LWP_SUCCESS) {
    fprintf(stderr, "main: can't initialize IOMGR!\n");
    exit(-1);
  }

  SWWW_server_init(8, &request_q);
  response_code = SWWW_accept_requests(8001,
				       (SWWW_fetch_url_fn) SWWW_fetch_url,
				       LWP,
				       request_q);

  return(-1);			/* shouldn't ever reach here */
}

int process_requests(SWWW_method_t         method,
		     char                  *url,
		     int                   reqid,
		     char                  **status,
		     int                   *header_size,
		     SWWW_headers_t        *headers,
		     SWWW_acceptheaders_fn acceptheaders,
		     SWWW_acceptdata_fn    acceptdata)
{
  /* here is where you would put code to deal with requests before
     they you pass them to SWWW_fetch_url. For example, this code
     might service requests from the cache, or from the local file
     system (if the URL is a local path, rather than a full URL).
     Important things to make sure to do include:

       * if you pass something different as the acceptheaders_fn, make sure
         that the function you pass will also invoke the acceptheaders_fn
	 passed to this function. acceptheaders_fn may be NULL, in which
	 case it should be disregarded.

       * same thing holds true for the acceptdata_fn. a good approach is
         probably to keep a data structure around for each reqid, containing
	 pointers to the original acceptheaders_fn and acceptdata_fn.

       * be sure to pass back the appropriate data in status, header_size,
         and headers, as well as to return the response code via return(). */

  return(-1);			/* this shell doesn't do anything */
}
