#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * Private functions for util.c
 * (should only be included by swww *.c files. not for use by applications
 *  using swww).
 */

/*
 * debugging information macro
 */

#ifndef SWWW_DEBUGLEVEL
extern int SWWW_debuglevel;
#endif /* SWWW_DEBUGLEVEL */

#define SWWW_DEBUG(cmd) \
do { \
    if (SWWW_debuglevel) \
        cmd; \
} while (0)

/*
 * parse_headers -- given an open file descriptor, it returns back a headerent
 *                  structure, and a buffer containing any data following the
 *                  headers which it may have inadvertantly read. (the calling
 *                  function will have to deal with the contents of that buffer,
 *                  if any, before getting further data off of the open file
 *                  descriptor.)
 */

int parse_headers(int                   openfd,
		  SWWW_threading_type_t threading,
		  char                  **status,
		  int                   *header_size,
		  SWWW_headers_t        **headers,
		  int                   *retbuffer_size,
		  char                  **retbuffer);

/*
 * parse_headers error codes
 */

#define PH_BROKEN_CONNECTION    -1
