#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _CACHE_MGR_H_
#define _CACHE_MGR_H_

/* NOTE: depends on warden.h */

/*
 * cache_entry
 */
struct cache_entry {
    TAILQ_ENTRY(cache_entry) ce_link;
    void                    *ce_key;
    char                     ce_fname[8];
    int                      ce_flags;
    struct warden           *ce_owner;
    void                    *ce_data; /* pointer to type-spec. data */
    /* XXX want inode/dev, lock, refcnt here? */
};

/*
 * cache_entry flags
 * XXX save 0x0100 and above for warden specific flags??
 */
#define CE_FLUSHED   0x0001

void                cache_init     __P((void));
struct cache_entry *cache_request  __P((struct warden *requester,
					long kilobytes,
					int  num_cfiles));
int                 cache_open     __P((struct cache_entry *centry,
					int flags));
int                 cache_close    __P((struct cache_entry *centry,
					int cfile_fd,
					int modified));
int                 cache_truncate __P((struct cache_entry *centry));

#endif
