#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
   cm_rpc2.h -- defines RPC2 data types so that the comm package
   can use RPC2 as one of the underlying layers */

#ifndef _CM_RPC2_H_
#define _CM_RPC2_H_

#include <lwp/lwp.h>
#include <rpc2/rpc2.h>

/* initial parameters to be passed to set up a connection */

typedef struct cmgr_rpc2_initparams {
    RPC2_HostIdent hid;
  //    RPC2_PortalIdent pid;
    RPC2_PortIdent pid;
    RPC2_SubsysIdent sid;
    RPC2_BindParms   bp;
} cmgr_rpc2_initparams_t;


#if 0
/* information about the connection */

typedef struct cmgr_rpc2_conninfo {
    int            crc_bandwidth; /* in bytes/sec */
    struct timeval crc_latency;
    int            crc_traffic;   /* bytes transferred during measurement
				    window */
    struct timeval crc_winstart;
    struct timeval crc_winstop;   /* the measurement window */
} cmgr_rpc2_conninfo_t;
#endif

/* handle to an RPC2 connection */
typedef RPC2_Handle cmgr_rpc2_handle_t;

#define CMGR_RPC2_HANDLE(connp) ((connp)->cc_handle.rpc2)

/* Logging level to use for log entries */
extern int cmgr_rpc2_estimlevel;

#endif /* _CM_RPC2_H_ */
