#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __ODY_POWER_H__
#define __ODY_POWER_H__

/* Start battery modulation.  First parameter specifies fully-charged
   capacity of the emulated battery (in joules).  Second parameter 
   specifies the amount of charge.  This must be between 0.0 (fully
   discharged) and 1.0 fully charged. */
int ody_bmod_start (int joules, float charge);

/* Stops battery modulation. */
int ody_bmod_stop ();

/* Specifies the amount of time until the next expected battery recharge. */
int ody_time_to_recharge (int seconds);

#endif 
