#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _VICEROY_ONODE_H
#define _VICEROY_ONODE_H

#include <kernel/vfs/includes/ody.h>
#include "base/ds/ds_thread.h"
#include "base/ds/ds_hash.h"
#include "base/ds/ds_hwlock.h"

typedef void (*ofree_t) __P((void *));

struct viceroy_onode {
    struct ofid           o_fid;
    u_int32_t             o_flags;
    dev_t                 o_device;
    ino_t                 o_inode;
    u_int16_t             o_ocount;
    u_int16_t             o_owrite;
    char                 *o_cachefile;
    enum ody_vtype        o_vtype;
    union {
	struct ofid       ou_mountedon;
	struct ofid       ou_root;
    } o_u;
    u_int16_t             o_refcnt;
    ds_hwlock_t           o_lock;
    ofree_t               o_ofree;
    void                 *o_data;
};

/* shared with kernel (onode.h) */
#define ON_WANTED        0x040	/* lock wanted */
#define ON_UNCACHEABLE   0x080	/* Cannot use ufs file as cache */
#define ON_CURSOR        0x100  /* both (?): Dynamic Sets style cursor */

/* viceroy only */
#define ON_ROOTOFVOL     0x200  /* viceroy: root of some tome */
#define ON_MOUNTPT       0x400  /* viceroy: some tome mounted here */

/* Convenient macros for testing flags bigs */
#define IS_UNCACHEABLE(op)      ((op)->o_flags & ON_UNCACHEABLE)
#define IS_CURSOR(op)           ((op)->o_flags & ON_CURSOR)
#define IS_AROOT(op)            ((op)->o_flags & ON_ROOTOFVOL)
#define IS_MOUNTEDON(op)        ((op)->o_flags & ON_MOUNTPT)

/*
 * Vnode attributes.  A field value of VNOVAL represents a field whose value
 * is unavailable (getattr) or which is not to be changed (setattr).
 */

#ifndef _OUID_T_
#define _OUID_T_
typedef unsigned int ouid_t;
typedef unsigned int ogid_t;
#endif

#endif
