package odyssey.api;

import odyssey.util.*;

public class WebTest implements UpcallHandler {
    final int ELAST = 13013; // XXX BOGONS. need odyerr.java class
    final int ODY_ENOTINWINDOW = 1;
    int errno          = 0;

    int lowest_quality = 10;
    int low_quality    = 25;
    int mid_quality    = 50;
    int high_quality   = 100;
    
    boolean debugging = true;	        /* debugging messages off by default */
    boolean html_distillation  = false;	/* html distillation off by default */
    boolean image_distillation = true;  /* image distillation ON by default */
    boolean generate_log       = false;	/* log generation off by default */

    int speculative_fetch = 0;

    int last_level = 4;

    void DEBUG(String foo, int val, int val2)
    {
	if(debugging) {
	    System.err.println(foo + " (val: " + val +
			       ") (val2: " + val2 + ")");
	}
    }

    public void handleUpcall(int reqid, int rsrc, int val)
    {
	adapt_to_bw(reqid, rsrc, val);
    }

    public void adapt_to_bw(int reqid, int rsrc, int val)
    {
	OdyRequestDesc     new_request;
	boolean            flag = true;
	int                result;
	int                quality;
	IntegerRef         value = new IntegerRef();
	
	if (rsrc != OdyRequestDesc.ODY_GR_NETBW) {
	    System.err.println("Resource (" + rsrc +
			       ") is not ODY_GR_NETBW (" +
			       OdyRequestDesc.ODY_GR_NETBW +
			       ")!");
	    return;
	}
	
	if (val == 0) {
	    /* XXX This is Jason's way of telling us the connection went
	     * down.  Is there something intelligent to do here? */
	    System.err.println("Connection Down notification.");
	}

	new_request = new OdyRequestDesc(OdyRequestDesc.ODY_GR_NETBW,
					 0, 0, this,
					 www.getOdyVers());
	
	/* adapt, based on bandwidth.
	   XXX these numbers are totally arbitrary, and don't have
           much hysteresis built-in */
	while (flag) {
	    if (val < 6000) {
		new_request.low  = 0; /* XXX fix for 0 BW notification */
		new_request.high = 6000;
	    } else if (val < 20000) { /* a slow modem (less then 14.4KB/s */
		new_request.low  = 6000;
		new_request.high = 20000;
	    } else if (val < 100000) {
		new_request.low  = 20000;
		new_request.high = 100000;
	    } else {   /* wavelan or better */
		new_request.low  = 100000;
		new_request.high = (10000000 * 8);
	    }
	    
	    
	    result = OdysseyAPI.request("/ody/www", new_request, value);
	    if (result != 0) {
		/* if (errno != ODY_ENOTINWINDOW) {
		    /* sanity check against API problems */
		/* perror("ody_request");
		    exit(-1);
		} */
		DEBUG("ody_request: thought we were at %d, really at %d\n",
		      val, value.getValue());
		val = value.getValue();	/* try again with new value */
	    } else {
		DEBUG("ody_request: succeeded at %d " +
		      "(thought we were at %d)\n",
		      value.getValue(), val);
		flag = false;		/* success */
	    }
	}
	
	/* at this point, we've registered the proper new upcall, and
	   feel pretty confident that "val" is representative of the
	   current state of things. based on "val", then, set a new
	   quality level */
	if (val < 6000) {
	    quality = lowest_quality;
	    speculative_fetch = 0;
	    last_level = 1;
	} else if (val < 20000) {	        /* a modem (less then 20KB/s */
	    quality = low_quality;
	    speculative_fetch = 0;
	    last_level = 2;
	} else if (val < 100000) {
	    quality = mid_quality;
	    if (last_level < 3)
		speculative_fetch = 1;
	    else
		speculative_fetch = 0;
	    last_level = 3;
	} else {			/* wavelan or better */
	    quality = high_quality;
	    last_level = 4;
	}
	
	if (image_distillation)
	    www.setMinQuality("image/gif", quality);
	if (html_distillation)
	    www.setMinQuality("text/html", quality);
    }
}
