#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifdef 0

#include "base/simplewww/swww.h"
#include "odyssey/wardens/www/webwarden.h"
#include "include/odyssey.h"
#include "javaody_test.h"

#define ELAST 13013

/*********************************************/

int lowest_quality = 10;
int low_quality    = 25;
int mid_quality    = 50;
int high_quality   = 100;

int   debugging          = 0;	 /* debugging messages off by default */
int   html_distillation  = 0;	 /* html distillation off by default */
int   image_distillation = 1;	 /* image distillation ON by default */
int   generate_log       = 0;	 /* log generation off by default */
char *remote_control     = NULL; /* remote control mode off by default */

int speculative_fetch = 0;

void adapt_to_bw(int reqid, unsigned int rsrc, int val)
{
    struct ody_req_des new_request;
    int                flag = 1;
    int                result, value;
    webw_quality_t     quality;
    static int         last_level = 4; /* last level we were in */

    if (rsrc != ODY_GR_NETBW) {
	fprintf(stderr, "Resource (%d) is not ODY_GR_NETBW (%d)!\n",
	       rsrc, ODY_GR_NETBW);
	return;
    }

    if (val == 0) {
	/* XXX This is Jason's way of telling us the connection went
	 * down.  Is there something intelligent to do here? */
	fprintf(stderr, "Connection Down notification.\n");
	return;
    }

    new_request.ord_resource          = ODY_GR_NETBW;
    new_request.ord_version.ov_gs     = ODY_GENERIC_INTERFACE;
    new_request.ord_version.ov_type   = ODY_NO_TYPE;
    new_request.ord_version.ov_tsvnum = ODY_GENERIC_INTERFACE;
    new_request.ord_fp                = adapt_to_bw;

    /* adapt, based on bandwidth.
       XXX these numbers are totally arbitrary, and don't have
           much hysteresis built-in */
    while (flag) {
	if (val < 6000) {
	    new_request.ord_low  = 0; /* XXX fix for 0 BW notification */
	    new_request.ord_high = 6000;
	} else if (val < 20000) { /* a slow modem (less then 14.4KB/s */
	    new_request.ord_low  = 6000;
	    new_request.ord_high = 20000;
	} else if (val < 100000) {
	    new_request.ord_low  = 20000;
	    new_request.ord_high = 100000;
	} else {   /* wavelan or better */
	    new_request.ord_low  = 100000;
	    new_request.ord_high = (10000000 * 8);
	}

	
	result = ody_request("/ody/www", &new_request, &value);
	if (result) {
	    if (errno != ODY_ENOTINWINDOW) {
		/* sanity check against API problems */
		perror("ody_request");
		exit(-1);
	    }
	    DEBUG(fprintf(stderr,
			  "ody_request: thought we were at %d, really at %d\n",
		   val, value));
	    val = value;	/* try again with new value */
	} else {
	    DEBUG(fprintf(stderr,
			  "ody_request: succeeded at %d "
			  "(thought we were at %d)\n",
		   value, val));
	    flag = 0;		/* success */
	}
    }
    
    /* at this point, we've registered the proper new upcall, and
       feel pretty confident that "val" is representative of the
       current state of things. based on "val", then, set a new
       quality level */
    if (val < 6000) {
	quality = lowest_quality;
	speculative_fetch = 0;
	last_level = 1;
    } else if (val < 20000) {	        /* a modem (less then 20KB/s */
	quality = low_quality;
	speculative_fetch = 0;
	last_level = 2;
    } else if (val < 100000) {
	quality = mid_quality;
	if (last_level < 3)
	    speculative_fetch = 1;
	else
	    speculative_fetch = 0;
	last_level = 3;
    } else {			/* wavelan or better */
	quality = high_quality;
	last_level = 4;
    }

#ifdef BW_TOOL
    poke_monitor(last_level);
#endif
    if (image_distillation)
	Web_setMinQuality("image/gif", quality);
    if (html_distillation)
	Web_setMinQuality("text/html", quality);
}

#endif /* 0 */
