package odyssey.api;

public class whiteboard {
    static final int WBOARD_VERSION = 1;
    static final int WBOARD_TTYPE   = 0x5;

    static final int WBOARD_SENDPOINTS = 1;
    static final int WBOARD_GETPOINTS  = 2;

    public static void sendPoints(int x1, int y1, int x2, int y2)
    {
	byte  buffer[];
	byte  retBuffer[];
	int   result;

	buffer    = new byte[16];
	fill(x1, buffer, 0);
	fill(y1, buffer, 4);
	fill(x2, buffer, 8);
	fill(y2, buffer, 12);

	retBuffer = new byte[0];

	result = OdysseyAPI.tsop("/ody/whiteboard", getOdyVers(),
				 WBOARD_SENDPOINTS,
				 buffer,
				 retBuffer);
    }

    public static byte[] getPoints()
    {
	byte            buffer[];
	byte            retBuffer[];
	int             result;

	buffer    = new byte[0];
	retBuffer = new byte[16];

	result = OdysseyAPI.tsop("/ody/whiteboard", getOdyVers(),
				 WBOARD_GETPOINTS,
				 buffer,
				 retBuffer);

	if (result == 0) {
	    return(retBuffer);
	} else {
	    return(null);
	}
    }

    public static OdyVers getOdyVers()
    {
	return (new OdyVers(WBOARD_TTYPE, WBOARD_VERSION));
    }

    private static void fill(int value, byte[] buffer, int index)
    {
	for (int loop = 0; loop < 4; loop++) {
	    buffer[loop + index] = getByte(value, loop);
	}
    }

    private static byte getByte(int value, int position)
    {
	long mask = 0xFF;
	mask = mask << (8 * position);
	long intermediate =  (value & mask);
	long result = intermediate >>> (8 * position);
	return((byte) result);
    }
}
