package odyssey.guestroom;

import java.io.*;
import java.net.*;

public class ClassServer implements Runnable
{
    ServerSocket srvSock;

    public ClassServer() throws IOException
    {
	srvSock = new ServerSocket(0);
	(new Thread(this)).start();
    }

    public int getPort()
    {
	return srvSock.getLocalPort();
    }

    public void run()
    {
	Socket incoming = null;
	BufferedReader reader;

	// read off of the server socket
	while(true) {
	    try {
		// System.out.println("waiting on " + srvSock.getLocalPort());
		incoming = srvSock.accept();
		// System.out.println("accepting http");
		reader = new BufferedReader(
                           new InputStreamReader(
                             incoming.getInputStream()));

		String request = reader.readLine();
		String munch   = reader.readLine();
		while(!munch.equals("")) {
		    munch = reader.readLine();
		}
		
		String path = request.substring(4,request.length() - 9);
		// System.out.println(path);
		
		BufferedOutputStream out = new BufferedOutputStream(
					     incoming.getOutputStream());

		File classDescription = new File("/home/tilt/develop"
						 + path);
		if (classDescription.exists()) {
		    String message;
		    
		    message = "HTTP/1.0 200 OK\n";
		    out.write(message.getBytes());
		    message = "Server: odyssey.guestroom.ClassServer\n";
		    out.write(message.getBytes());
		    message = "Content-Length: ";
		    out.write(message.getBytes());
		    
		    try {
			byte[] result =
			    new byte[(int) classDescription.length()];
			out.write((int)classDescription.length());
			message = "\n\n";
			out.write(message.getBytes());
			FileInputStream in =
			    new FileInputStream(classDescription);
			in.read(result);
			for (int loop = 0; loop < result.length; loop++) {
			    out.write(result[loop]);
			}
		    } catch (IOException e) {
			System.err.println("error reading " + path + "\n" + e);
		    }
		} else {
		    String message;
		    
		    message = "HTTP/1.0 404 Class Not Found\n\n";
		    out.write(message.getBytes());
		}
		    
		out.flush();
		incoming.close();
	    } catch (IOException e) {
		System.err.println("in ClassServer.run() " + e);
	    }
	}
    }
}
