package odyssey.guestroom;

import java.io.*;
import java.net.*;
import java.rmi.*;
import java.rmi.server.RMIClassLoader;

class NetworkObjectInputStream extends java.io.ObjectInputStream
{
    //private NetworkClassLoader loader;
    java.net.URL hostURL;
    Socket incomingSock;
        
    protected NetworkObjectInputStream(Socket incoming)
        throws IOException, StreamCorruptedException, NotBoundException
    {
        super(incoming.getInputStream());
        incomingSock = incoming;

        hostURL = new java.net.URL("http://" +
                                   incoming.getInetAddress().getHostAddress() +
                                   "/");
    }
    
    protected void setURL(int port) throws MalformedURLException
    {
        hostURL = new java.net.URL("http://" +
                                   incomingSock.getInetAddress().getHostAddress() +
                                   ":" + port + "/");
    }
        
    protected Class resolveClass(ObjectStreamClass v)
        throws IOException, ClassNotFoundException
    {
        try {
            Class result = super.resolveClass(v);
            return result;
        } catch (ClassNotFoundException e) {
            System.out.println("trying to resolve " +
                               v.getName());
            try {
                // Class result = loader.loadClass(v.getName(), true);
                Class result = RMIClassLoader.loadClass(hostURL,v.getName());
                return result;
            } catch (Exception e2) {
                System.out.println("got exception: " + e2);
            }
        }
        return null;
    }
}