package odyssey.whiteboard;

import java.awt.*;
import java.awt.event.*;
import odyssey.api.whiteboard;

public class Whiteboard extends Canvas
    implements MouseMotionListener,MouseListener,Runnable {
    Point last = null;

    public Whiteboard()
    {
	setBackground(Color.white);

	/* MouseHandler handler = new MouseHandler(this);
	   addMouseListener(handler); */
	addMouseListener(this);
	addMouseMotionListener(this);
	new Thread(this).start();
    }

    public void run()
    {
	byte[] points;
	int foo[] = new int[4];
	int sum;
	int value;

	Thread current = Thread.currentThread();

	while (true) {
	    points = whiteboard.getPoints();

	    if (points != null) {
		for (int loop = 0; loop < 4; loop++) {
		    sum = 0;
		    for (int index = 0; index < 4; index++) {
			value = (points[loop * 4 + index]);
			if (value < 0) {value += 256;}
			sum += value << (index * 8);
		    }
		    foo[loop] = sum;
		}
		
		Graphics g = getGraphics();
		g.setColor(Color.red);
		g.drawLine(foo[0], foo[1], foo[2], foo[3]);

		/* System.out.println(foo[0] + ", " + foo[1] + ", " +
		   foo[2] + ", " + foo[3]); */
	    } else {
		// put sleep here eventually
	    }

	    try {
		current.sleep(200);
	    } catch (InterruptedException e) {
	    }
	}
    }

    public void mouseDragged(MouseEvent e)
    {
	Point current = e.getPoint();

	Graphics g = getGraphics();
	g.setColor(Color.black);
	g.drawLine(last.x, last.y, current.x, current.y);

	whiteboard.sendPoints(last.x, last.y, current.x, current.y);

	last = current;
    }

    public void mousePressed(MouseEvent e)
    {
	last = e.getPoint();
    }

    // do nothing for these
    public void mouseClicked(MouseEvent e) {}
    public void mouseMoved(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
}
