#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* A single Odyssey system call that multiplexes all multifidelity-related
   calls */

#include <sys/ioctl.h>
#include <fcntl.h>

#include "kernel/vfs/includes/ody.h"
#include "kernel/vfs/includes/odyapi.h"
#include "kernel/vfs/includes/ody_multif.h"
#include "include/odyssey.h"

extern int ody_ctl_fd;

extern void ody_ioctl_init(void);

int
ody_multif (vers, op, argsz, arg, retsz, ret)
     struct ody_vers *vers;
     unsigned int op;
     size_t argsz;
     void *arg;
     size_t *retsz;
     void *ret;
{
    struct ody_multif_args iarg;
    int result;

    iarg.vers = vers;
    iarg.op = op;
    iarg.argsz = argsz;
    iarg.arg = arg;
    iarg.retsz = retsz;
    iarg.ret = ret;

    ody_ioctl_init();
    result = ioctl(ody_ctl_fd, ODYI_MULTIF, &iarg);
    if (result < -4095) {
	    errno = -result;
	    return -1;
    }
    return result;
}
