#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* Map the Odyssey "system calls" to ioctls on the Odyssey control device */

#include <sys/ioctl.h>
#include <fcntl.h>

#include "kernel/vfs/includes/ody.h"
#include "kernel/vfs/includes/odyapi.h"
#include "kernel/vfs/includes/ody_pow.h"
#include "include/odyssey.h"

extern int ody_ctl_fd;

extern void ody_ioctl_init(void);

int
ody_bmod_start (int joules, float charge)
{
    struct ody_bmod_start_args iarg;
    int result;

    iarg.joules = joules;
    iarg.charge = charge;

    ody_ioctl_init();
    result = ioctl(ody_ctl_fd, ODYI_BMOD_START, &iarg);
    if (result < -4095) {
	    errno = -result;
	    return -1;
    }
    return result;
}

int
ody_bmod_stop ()
{
    int result;

    ody_ioctl_init();
    result = ioctl(ody_ctl_fd, ODYI_BMOD_STOP, 0);
    if (result < -4095) {
	    errno = -result;
	    return -1;
    }
    return result;
}

int ody_time_to_recharge (int seconds)
{
    struct ody_time_to_recharge_args iarg;
    int result;

    iarg.seconds = seconds;

    ody_ioctl_init();
    result = ioctl(ody_ctl_fd, ODYI_TIME_TO_RECHARGE, &iarg);
    if (result < -4095) {
	    errno = -result;
	    return -1;
    }
    return result;
}
