#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/time.h>

#include "include/odyssey.h"

void
handle_bandwidth(reqid, rsrc, val)
	int reqid;
	unsigned int rsrc;
	int val;
{
	printf("BINGO!\t(%d, %u, %d)\n", reqid, rsrc, val);
	exit(0);
}

int
main() 
{
	int                 result;
	struct ody_req_des  req;
	int                 response;
	struct timeval      timeout;

	req.ord_resource = ODY_GR_NETBW;
	req.ord_version.ov_gs = ODY_GENERIC_INTERFACE;
	req.ord_version.ov_type = ODY_NO_TYPE;
	req.ord_version.ov_tsvnum = ODY_UNUSED;
	req.ord_low = 0;
	req.ord_high = 1024 * 1024 * 2;  /* 2 Mbit */
	

	result = ody_request("/ody", &req, &response);
	
	if (result) {
		perror("ody_request");
		exit(errno);
	}
	
	while (1) {
		timeout.tv_sec = 5;
		timeout.tv_usec = 0;
		if (select(0, NULL, NULL, NULL, &timeout)) {
			perror("select");
		}
	}
	return 0;
}
    
