#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


#include <stdio.h>
#include <errno.h>
#include <assert.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>

#include "kernel/upcall/includes/upcall.h"

/* Register upcall 0 in class UC_TEST */

static int
handler(ucl, uca, argsz, argp, retszp, retp, flags)
    upclass_t ucl;
    upcall_t  uca;
    size_t    argsz;
    void      *argp;
    size_t    *retszp;
    void      *retp;
    int       flags;
{
    printf("handler: upclass is %d\n", (int) ucl);
    printf("handler: upcall is %d\n", (int) uca);
    printf("handler: argsz is %d\n", (int) argsz);
    printf("handler: argp[0] is %d\n", * ((int *) argp));
    if (retszp)
	printf("handler: *retszp is %d\n", *retszp);
    return 0;
}

void main(void)
{
    printf("uc_client is pid %d\n", getpid());

    if (upcall_reg(UC_TEST, 0, handler) < 0) {
	perror("upcall_reg");
	exit(1);
    }
    printf("Waiting ...\n");
    while(1);
}

