#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <assert.h>

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>

#include "kernel/upcall/includes/upcall.h"

/* Post upcall 0 in class UC_TEST */

void main(argc, argv)
     int argc;
     char *argv[];
{
    int pid;
    int mesg = 6382367; /* something random */

    if (argc == 2)
	pid = atoi(argv[1]);
    else {
	fprintf(stderr,"usage: uc_server <pid>\n");
	exit(1);
    }

    if (upcall_async(UC_TEST, 0, pid, sizeof(mesg), &mesg) < 0) {
	perror("upcall_async");
	exit(1);
    }

    printf("Upclass %d, upcall %d posted\n", UC_TEST, 0);
}
