#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#undef _KERNEL
#undef KERNEL

#include <sys/errno.h>
#include <sys/param.h>
#include <sys/mount.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "kernel/sets/common/sets_internal.h"

int main(int argc, char* argv[])
{
  int retval;

  /* Add in a way to unmount the filesystem */
  if (argc > 1 && !strcmp (argv[1], "-u")) {
    retval = unmount (SETS_CTLOBJ, 0);
    if (retval)
	if (errno == EAGAIN) {
	    /* give the daemons time to die */
	    sleep(1);
	    /* do part two to finalize the unmount */
	    retval = unmount(SETS_CTLOBJ, 0);
	} else {
	    printf ("errno is %d\n", errno);
	    perror(SETS_CTLOBJ);
	}
  } else {
    retval = mount(MOUNT_SETS, SETS_CTLOBJ, 0, NULL);
    if (retval) {
      printf ("errno is %d\n", errno);
      perror(SETS_CTLOBJ);
    }
  } /* endif */

  return (retval);
}
