#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


/* ioctl command values for upcall subsystem */

#ifndef _SETS_IOCTL_H
#define _SETS_IOCTL_H

/* Args struct for each of these ioctls */

struct setsi_open_args {
	char *spec;
	int   flags;
	int   handle;
};

struct setsi_close_args {
	int handle;
};

struct setsi_iterate_args {
	int    handle;
	int    flags;
	char  *name;
	u_int  buffer_size;
	u_int *error;
	int    fd;
};

struct setsi_digest_args {
	int   handle;
	char *buffer;
	int   buffer_size;
        int   retsz;
};

struct setsi_rew_iter_args {
	int handle;
};

struct setsi_rew_dig_args {
	int handle;
};

struct setsi_member_args {
	int   handle;
	char *name;
};

struct setsi_size_args {
	int handle;
	int size;
};

struct setsi_inter_args {
	int handle1;
	int handle2;
	int flags;
	int handle;
};

struct setsi_union_args {
	int handle1;
	int handle2;
	int flags;
	int handle;
};

struct setsi_restrict_args {
	int   handle1;
	char *fname;
	int   flags;
	int   handle;
};

#define SETSI_OPEN        _IOWR('s',  0, struct setsi_open_args)
#define SETSI_CLOSE       _IOW('s',   1, struct setsi_close_args)
#define SETSI_DAEMON      _IO('s',    2)
#define SETSI_DAEMON_KILL _IO('s',    3)
#define SETSI_ITERATE     _IOWR('s',  4, struct setsi_iterate_args)
#define SETSI_DIGEST      _IOWR('s',  5, struct setsi_digest_args)
#define SETSI_REW_ITER    _IOW('s',   6, struct setsi_rew_iter_args)
#define SETSI_REW_DIG     _IOW('s',   7, struct setsi_rew_dig_args)
#define SETSI_MEMBER      _IOW('s',   8, struct setsi_member_args)
#define SETSI_SIZE        _IOWR('s',  9, struct setsi_size_args)
#define SETSI_INTER       _IOWR('s', 10, struct setsi_inter_args)
#define SETSI_UNION       _IOWR('s', 11, struct setsi_union_args)
#define SETSI_RESTRICT    _IOWR('s', 12, struct setsi_restrict_args)

#ifdef _KERNEL
int	setsi_open        __P((struct proc *, struct setsi_open_args *));
int	setsi_close       __P((struct proc *, struct setsi_close_args *));
int	setsi_daemon      __P((struct proc *));
int	setsi_daemon_kill __P((struct proc *));
int	setsi_iterate     __P((struct proc *, struct setsi_iterate_args *));
int	setsi_digest      __P((struct proc *, struct setsi_digest_args *));
int	setsi_rew_iter    __P((struct proc *, struct setsi_rew_iter_args *));
int	setsi_rew_dig     __P((struct proc *, struct setsi_rew_dig_args *));
int	setsi_member      __P((struct proc *, struct setsi_member_args *));
int	setsi_size        __P((struct proc *, struct setsi_size_args *));
int	setsi_inter       __P((struct proc *, struct setsi_inter_args *));
int	setsi_union       __P((struct proc *, struct setsi_union_args *));
int	setsi_restrict    __P((struct proc *, struct setsi_restrict_args *));

#endif

#endif /* _SETS_IOCTL_H */
