#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


typedef int (*sets_expand_fn)     __P((FSOBJ_t dvp,
				       FSOBJ_t *vpp,
				       char *nm,
				       PROCESS_t p));
typedef int (*sets_cursexpand_fn) __P((CURSOBJ_t vp,
				       size_t *bufsize,
				       char **buf,
				       PROCESS_t p));
typedef int (*sets_prefetch_fn)   __P((FSOBJ_t vp,
				       int mode,
				       PROCESS_t p,
				       FILEOBJ_t *fp));

struct sets_domain {
    struct sets_domain *next;
    u_long file_type;
    sets_expand_fn expand_fn;
    sets_cursexpand_fn cursexpand_fn;
    sets_prefetch_fn prefetch_fn;
};

int sets_register_domain             __P((int,
					  sets_expand_fn,
					  sets_cursexpand_fn,
					  sets_prefetch_fn));
void sets_unregister_domain          __P((int));
int sets_exist_registrations  __P((void));
struct sets_domain *sets_find_domain __P((FSOBJ_t));
