#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include "kernel/sets/common/sets_internal.h"
#include "kernel/sets/common/sets_hash.h"

int do_set_size(struct procSetInfo *settbl, int handle, int *size)
{
	struct setType *myset;
	int i, result = 0;
	
	LOG_ENTRY(0, SETSIZE);
	
	DEBUG(UTIL, S_PRINTF("Entering setSize(%d)\n", handle); );

	if (handle < 0 || handle >= NOPENSETS) {
		result = -EBADF;
		goto out;
	}

	if ((myset = settbl->mySets[handle]) == NULL) {
		result = -EBADF;
		goto out;
	}
	
	/* Don't need a critical section, since this can be 
	 * an approximation anyway */
	for (i = 0; i < myset->resSize; i++) {
		switch (myset->resolved[i].state) {
		case ELEM_TAKEN:
		case ELEM_SEEN:
		case ELEM_OPENED:
		case ELEM_FAILED:
			result++;
			break;
			
		default:
			break;
		}
	}

	*size = result;
	result = 0;

out:
	LOG_EXIT(0, SETSIZE);
	return result;
}

