#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


/* XXX this really shouldn't be necessary */
#undef _KERNEL
#undef KERNEL

#include <sys/types.h>
#include <sys/param.h>
#include <sys/mount.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>

#include "upcall_ctlobj.h"
#include "upcall_mount.h"

int main(int argc, char* argv[])
{
  int retval;

  /* Add in a way to unmount the filesystem */
  if (argc > 1 && !strcmp (argv[1], "-u")) {
    retval = unmount (UC_CTLOBJ, 0);
    if (retval) {
      printf ("errno is %d\n", errno);
      perror(UC_CTLOBJ);
    }
  } else {
    retval = mount(MOUNT_UPCALL, UC_CTLOBJ, 0, NULL);
    if (retval) {
      printf ("errno is %d\n", errno);
      perror(UC_CTLOBJ);
    }
  } /* endif */

  return (retval);
}
