#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */


#include <sys/param.h>
#include <sys/types.h>
#include <sys/systm.h>
#include <sys/kernel.h>

#ifdef DEVFS
#include <sys/devfsext.h>
#endif
#include <sys/conf.h>

/* 
   From: "Jordan K. Hubbard" <jkh@time.cdrom.com>
   Subject: Re: New 3.0 SNAPshot CDROM about ready for production.. 
   To: "Robert.V.Baron" <rvb@GLUCK.CODA.CS.CMU.EDU>
   Date: Fri, 20 Feb 1998 15:57:01 -0800

   > Also I need a character device major number. (and might want to reserve
   > a block of 10 syscalls.)

   Just one char device number?  No block devices?  Very well, cdev 93 is yours!
*/

#define UC_DEV_NO     102	/* XXXXXX shouldn't be random XXXXXXXXX */

/* Type of device methods. */
#define D_OPEN_T    d_open_t
#define D_CLOSE_T   d_close_t
#define D_IOCTL_T   d_ioctl_t

/* rvb why */
D_OPEN_T    uc_open;
D_CLOSE_T   uc_close;
D_IOCTL_T   uc_ioctl;
void        uccattach __P((void));

static struct cdevsw uccdevsw =
{ 
  uc_open,      uc_close,       noread,            nowrite,
  uc_ioctl,     nostop,         nullreset,         nodevtotty,
  noselect,     nommap,         NULL,              "upcall", NULL, -1 };

static dev_t uccdev;

PSEUDO_SET(uccattach, uc);

int     ucdebug = 1;
#define UCDEBUG if (ucdebug) printf

void
uccattach(void)
{
  /*
   * In case we are an LKM, set up device switch.
   */
  if (0 == (uccdev = makedev(UC_DEV_NO, 0)))
    UCDEBUG("makedev returned null\n");
  else 
    UCDEBUG("makedev OK.\n");
    
  cdevsw_add(&uccdev, &uccdevsw, NULL);
  UCDEBUG("upcall: uccdevsw entry installed at %d.\n", major(uccdev));
}
