#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __UC_LINUX_H__
#define __UC_LINUX_H__

/* Function prototypes */
void uc_sysctl_init(void);
void uc_sysctl_clean(void);

/* debugging masks */
#define D_SYSUPCALL    1   

/* global variables */
extern int uc_debug;
extern int uc_print_entry;

#define ODEBUG(mask, format, a...)                                \
  do {                                                            \
  if (uc_debug & mask) {                                        \
    printk("(%s,l. %d): ",  __FUNCTION__, __LINE__);              \
    printk(format, ## a); }                                       \
} while (0) ;                            

#define ENTRY    \
    if(uc_print_entry) printk("Process %d entered %s\n",current->pid,__FUNCTION__)

#define EXIT    \
    if(uc_print_entry) printk("Process %d leaving %s\n",current->pid,__FUNCTION__)

#endif
