#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _ODY_SYS_H
#define _ODY_SYS_H

/* Args to the various ioctl functions */

struct ody_req_args {
    char *path;
    struct ody_reqargs *ora;
};

struct ody_freq_args {
    int fd;
    struct ody_reqargs *ora;
};

struct ody_cancel_args {
    char *path;
    int reqid;
};

struct ody_tsop_args {
    char *path;
    struct ody_vers *vers;
    unsigned int op;
    size_t argsz;
    void *arg;
    size_t *retsz;
    void *ret;
};

struct ody_ftsop_args {
    int fd;
    struct ody_vers *vers;
    unsigned int op;
    size_t argsz;
    void *arg;
    size_t *retsz;
    void *ret;
};


#define ODYI_REQ      _IOW('O', 0, struct ody_req_args)
#define ODYI_FREQ     _IOW('O', 1, struct ody_freq_args)
#define ODYI_CANCEL   _IOW('O', 2, struct ody_cancel_args)
#define ODYI_TSOP     _IOW('O', 3, struct ody_tsop_args)
#define ODYI_FTSOP    _IOW('O', 4, struct ody_ftsop_args)

#if defined(_KERNEL) && !defined(__linux__)
int ody_req     __P((struct proc *, struct ody_req_args *, int *));
int ody_freq    __P((struct proc *, struct ody_freq_args *, int *));
int ody_cancel  __P((struct proc *, struct ody_cancel_args *, int *));
int ody_tsop    __P((struct proc *, struct ody_tsop_args *, int *));
int ody_ftsop   __P((struct proc *, struct ody_ftsop_args *, int *));
#endif /* _KERNEL */

#endif /* _ODY_SYS_H_ */
