#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * ody_upcall.h
 *
 * Defines upclass descriptor for the kernel's upcall subsystem, and the
 * format for the argument buffer passed to applications from the viceroy.
 */

#ifndef _ODY_UPCALL_H_
#define _ODY_UPCALL_H_

#define ODY_NOTIFICATION  0x55    /* Number of the notify upcall */

#ifndef _KERNEL

struct ody_ucargs_t {
	int          oua_reqid;
	unsigned int oua_rsrc;
	int          oua_rval;
};

#endif


#ifdef _KERNEL
extern struct uc_ucld_t ody_ucld;

#ifdef __linux__
extern int ody_notify __P((struct uc_ucld_t     *ucldp,
			   void                 *tabp,
			   struct task_struct   *t,
			   upcall_t             upcall,
			   int                  reg,
			   struct uc_procent_t  **peh));
#else
extern int ody_notify __P((struct uc_ucld_t     *ucldp,
			   void                 *tabp,
			   struct proc          *p,
			   upcall_t             upcall,
			   int                  reg,
			   struct uc_procent_t  **peh));
#endif


#endif

#endif _ODY_UPCALL_H_
