#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* Used in fhtovp */
struct ofid_overlay {
    u_short      ov_len;
    u_short      ov_spare;
    struct ofid  ov_fid;
};

int ody_vfsopstats_init __P((void));
#ifdef NetBSD1_3
int ody_mount     __P((struct mount *, const char *, void *,
		       struct nameidata *, struct proc *));
#else
int ody_mount     __P((struct mount *, char *, caddr_t, struct nameidata *, 
		       struct proc *));
#endif
int ody_start     __P((struct mount *, int, struct proc *));
int ody_unmount   __P((struct mount *, int, struct proc *));
int ody_root      __P((struct mount *, struct vnode **));
int ody_quotactl  __P((struct mount *, int, uid_t, caddr_t, struct proc *));
int ody_statfs    __P((struct mount *, struct statfs *, struct proc *));
int ody_sync      __P((struct mount *, int, struct ucred *, struct proc *));
int ody_vget      __P((struct mount *, ino_t, struct vnode **));
int ody_fhtovp    __P((struct mount *, struct fid *, struct mbuf *, 
		       struct vnode **, int *, struct ucred **));
int ody_vptofh    __P((struct vnode *, struct fid *));
#ifdef __NetBSD__
void ody_init     __P((void));
#elif defined(__FreeBSD__)
int ody_init     __P((void));
#endif
int ody_getNewVnode __P((struct vnode **));
