#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

int
viceroy_root(void *mdp,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid);

int
viceroy_open(void *mdp, struct ofid *fid, int flag,
	struct ucred *cred, struct proc *p,
/*out*/	dev_t *dev, ino_t *inode, int *flags);

int
viceroy_close(void *mdp, struct ofid *fid, int flag,
	struct ucred *cred, struct proc *p);

void
viceroy_read(void);

void
viceroy_write(void);

int
viceroy_rdwr(void *mdp, struct ofid *fid, int offset,
	int ioflag,
        struct ucred *cred, struct proc *p,
/*i/o*/ int *count, int *rwflag, caddr_t data);

int
viceroy_ioctl(void *mdp, struct ofid *fid,
	int com, int flag, caddr_t data,
	struct ucred *cred, struct proc *p);

int
viceroy_getattr(void *mdp, struct ofid *fid,
	struct ucred *cred, struct proc *p,
/*out*/	struct vattr *vap);

int
viceroy_setattr(void *mdp, struct ofid *fid, struct vattr *vap,
	struct ucred *cred, struct proc *p);

int
viceroy_access(void *mdp, struct ofid *fid, int mode,
	struct ucred *cred, struct proc *p);

int
viceroy_readlink(void *mdp, struct ofid *fid,
	struct ucred *cred, struct proc *p,
/*out*/	char **str, int *len);

int
viceroy_fsync(void *mdp, struct ofid *fid,
	struct ucred *cred, struct proc *p);

int
viceroy_lookup(void *mdp, struct ofid *fid,
    	const char *nm, int len,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid, int *vtype);

int
viceroy_create(void *mdp, struct ofid *fid,
    	const char *nm, int len, int exclusive, int mode, struct vattr *va,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid, struct vattr *attr);

int
viceroy_remove(void *mdp, struct ofid *fid,
        const char *nm, int len,
	struct ucred *cred, struct proc *p);

int
viceroy_link(void *mdp, struct ofid *fid, struct ofid *tfid,
        const char *nm, int len,
	struct ucred *cred, struct proc *p);

int
viceroy_rename(void *mdp, struct ofid *fid, struct ofid *tfid,
        const char *nm, int len, const char *tnm, int tlen,
	struct ucred *cred, struct proc *p);

int
viceroy_mkdir(void *mdp, struct ofid *fid,
    	const char *nm, int len, struct vattr *va,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid, struct vattr *ova);

int
viceroy_rmdir(void *mdp, struct ofid *fid,
    	const char *nm, int len,
	struct ucred *cred, struct proc *p);

int
viceroy_symlink(void *mdp, struct ofid *fid,
        const char *lnm, int llen, const char *nm, int len, struct vattr *va,
	struct ucred *cred, struct proc *p);

int
viceroy_readdir(void *mdp, struct ofid *fid,
    	int count, int offset,
	struct ucred *cred, struct proc *p,
/*out*/	char *buffer, int *len);

int
viceroy_expand(void *mdp, struct ofid *fid,
    	const char *nm, int len,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid, int *vtype, int *cursor);

int
viceroy_cursexpand(void *mdp, struct ofid *fid,
	struct ucred *cred, struct proc *p,
/*out*/ char **buffer, int *retsz);

int
viceroy_prefetch(void *mdp, struct ofid *fid,
	int in_flags,
	struct ucred *cred, struct proc *p,
/*out*/ dev_t *dev, ino_t *ino, int *flags);

int
viceroy_fhtovp(void *mdp, struct ofid *fid,
	struct ucred *cred, struct proc *p,
/*out*/	struct ofid *VFid, int *vtype);

int
viceroy_request(void *mdp, struct ofid *fid, u_int rsrc, u_int gs,
	u_int type, u_int ts, int low, int high,
	struct ucred *cred, struct proc *p,
/*out*/ int *cancelled, int *value, int *result);

int
viceroy_cancel(void *mdp, int reqid,
	struct ucred *cred, struct proc *p);

int
viceroy_cancpid(void *mdp,
	struct ucred *cred, struct proc *p);

int
viceroy_tsop(void *mdp, struct ofid *fid, u_int gs,
	u_int type, u_int ts, u_int op,
	size_t argsz, caddr_t src_data,
	struct ucred *cred, struct proc *p,
/*out*/ size_t *retsz, caddr_t dest_data);

int 
viceroy_bmod_start (void* mdp, int joules, float charge);

int
viceroy_bmod_stop (void* mdp);

int 
viceory_bmod_time_to_recharge (void* mdp, int seconds);
