#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * Declarations for the Odyssey vnode operations.  Stolen shamelessly
 * from the Coda Minicache
 */

/* NetBSD interfaces to the vnodeops */
int ody_open      __P((void *));
int ody_close     __P((void *));
int ody_read      __P((void *));
int ody_write     __P((void *));
int ody_ioctl     __P((void *));
#ifdef NetBSD1_3
int ody_poll      __P((void *));
#else
int ody_select    __P((void *));
#endif
int ody_getattr   __P((void *));
int ody_setattr   __P((void *));
int ody_access    __P((void *));
int ody_readlink  __P((void *));
int ody_abortop   __P((void *));
int ody_fsync     __P((void *));
int ody_inactive  __P((void *));
int ody_lookup    __P((void *));
int ody_create    __P((void *));
int ody_remove    __P((void *));
int ody_link      __P((void *));
int ody_rename    __P((void *));
int ody_mkdir     __P((void *));
int ody_rmdir     __P((void *));
int ody_symlink   __P((void *));
int ody_readdir   __P((void *));
int ody_bmap      __P((void *));
int ody_strategy  __P((void *));
int ody_lock      __P((void *));
int ody_unlock    __P((void *));
int ody_islocked  __P((void *));
int ody_reclaim   __P((void *));
#ifdef SETS
int ody_expand(struct vnode *dvp,
	       struct vnode **vpp,
	       char *nm,
	       struct proc *p);
int ody_cursexpand(struct vnode *vp,
		   size_t *bufsize,
		   char **buf,
		   struct proc *p);
int ody_prefetch(struct vnode *vp,
		 int mode,
		 struct proc *p,
                 struct file **f);
#endif
int ody_vop_error __P((void *));
int ody_vop_nop   __P((void *));
#ifdef __FreeBSD__
int ody_fbsd_vnotsup __P((void *ap));
#endif

int (**ody_vnodeop_p)(void *);
int ody_rdwr __P((struct vnode *vp, struct uio *uiop, enum uio_rw rw,
		  int ioflag, struct ucred *cred, struct proc *p));

int ody_grab_vnode   __P((dev_t          dev,
			  ino_t          ino,
			  struct vnode **vpp));
void ody_print_vattr __P((struct vattr *));
void ody_print_cred  __P((struct ucred *cred));

