#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* 
 * Mach Operating System
 * Copyright (c) 1990 Carnegie-Mellon University
 * Copyright (c) 1989 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */

/*
 * Stolen shamelessly from the Coda MiniCache
 */

#ifndef _ODYIO_H_
#define _ODYIO_H_

/* Define ioctl commands for vcioctl, /dev/ody */

#ifdef __STDC__

#define ODYRESIZE  _IOW('o', 1, struct ody_resize )  /* Resize ODY NameCache */
#define ODYSTATS    _IO('o', 2)                      /* Collect stats */
#define ODYPRINT    _IO('o', 3)                      /* Print Cache */
#define ODYTEST     _IO('o', 4)                      /* Print Cache */

#else /* sys/ioctl.h puts the quotes on */

#define ODYRESIZE    _IOW(o, 1, struct ody_resize )  /* Resize CFS NameCache */
#define ODYSTATS      _IO(o, 2)                      /* Collect stats */
#define ODYPRINT      _IO(o, 3)                      /* Print Cache */
#define ODYTEST       _IO(o, 4)                      /* Print Cache */

#endif __STDC__


struct ody_resize { 
    int hashsize;
    int heapsize; 
};

#endif /* !_ODYIO_H_ */
