#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* Coda filesystem -- Linux Minicache
 *
 * Copyright (C) 1989 - 1997 Carnegie Mellon University
 *
 * Carnegie Mellon University encourages users of this software to
 * contribute improvements to the Coda project. Contact Peter Braam
 * <coda@cs.cmu.edu>
 */

/*
 * stolen for Odyssey
 */

#ifndef _ODYNC_HEADER_
#define _ODYNC_HEADER_

/*
 * Structure for an element in the Odyssey Credential Cache.
 */

struct ody_cache {
	struct list_head   oc_cclist;  /* list of all cache entries */
	struct list_head   oc_cnlist;  /* list of cache entries/onode */
	int                oc_mask;
	struct ody_cred    oc_cred;
};

/* credential cache */
void ody_cache_enter(struct inode *inode, int mask);
void ody_cache_clear_inode(struct inode *);
void ody_cache_clear_all(struct super_block *sb);
void ody_cache_clear_cred(struct super_block *sb, struct ody_cred *cred);
int ody_cache_check(struct inode *inode, int mask);

/* for downcalls and attributes and lookups */
void ody_flag_inode(struct inode *inode, int flag);
void ody_purge_children(struct inode *inode);
void ody_purge_dentries(struct inode *inode);


/*
 * Structure to contain statistics on the cache usage
 */

struct odync_statistics {
	unsigned	hits;
	unsigned	misses;
	unsigned	enters;
	unsigned	dbl_enters;
	unsigned	long_name_enters;
	unsigned	long_name_lookups;
	unsigned	long_remove;
	unsigned	lru_rm;
	unsigned	zapPfids;
	unsigned	zapFids;
	unsigned	zapFile;
	unsigned	zapUsers;
	unsigned	Flushes;
	unsigned        Sum_bucket_len;
	unsigned        Sum2_bucket_len;
	unsigned        Max_bucket_len;
	unsigned        Num_zero_len;
	unsigned        Search_len;
};


#define ODYNC_FIND		((u_long) 1)
#define ODYNC_REMOVE		((u_long) 2)
#define ODYNC_INIT		((u_long) 3)
#define ODYNC_ENTER		((u_long) 4)
#define ODYNC_LOOKUP		((u_long) 5)
#define ODYNC_ZAPPFID		((u_long) 6)
#define ODYNC_ZAPFID		((u_long) 7)
#define ODYNC_ZAPVNODE		((u_long) 8)
#define ODYNC_ZAPFILE		((u_long) 9)
#define ODYNC_PURGEUSER	((u_long) 10)
#define ODYNC_FLUSH		((u_long) 11)
#define ODYNC_PRINTODYNC	((u_long) 12)
#define ODYNC_PRINTSTATS	((u_long) 13)
#define ODYNC_REPLACE		((u_long) 14)

#endif _ODYNC_HEADER_
