#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 *  ody_fs_i.h
 *
 *  Copyright (C) 1998 Carnegie Mellon University
 *
 */

/*
 * stolen for Odyssey
 */

#ifndef _LINUX_ODY_FS_I
#define _LINUX_ODY_FS_I

#ifdef __KERNEL__
#include <linux/types.h>
#include <linux/list.h>
#include "kernel/vfs/includes/ody.h"



#define ODY_ONODE_MAGIC        0x39566593
/*
 * ody fs inode data
 */
struct ody_inode_info {
        struct ofid        o_fid;	/* Ody identifier */
        u_short	           o_flags;     /* flags (see below) */
        u_short	           o_ocount;    /* count of openers */
        u_short            o_owrite;    /* count of open for write */
        u_short            o_mmcount;   /* count of mmappers */
        struct inode      *o_ovp;       /* open inode  pointer */
        struct list_head   o_cnhead;    /* head of cache entries */
        struct inode      *o_vnode;     /*  inode associated with onode */
        int                o_magic;     /* to verify the data structure */
};

/* flags */
#define ON_VATTR       0x1         /* Validity of vattr in the onode */
#define ON_SYMLINK     0x2         /* Validity of symlink pointer in the onode */
#define ON_DYING       0x4	  /* Set for outstanding onodes from venus (which died) */
#define ON_PURGE       0x008
#define ON_ZAPDIR      0x010
#define ON_INITED      0x020
#define ON_UNCACHEABLE 0x080
#define ON_CURSOR      0x100

#define IS_UNCACHEABLE(onp) ((onp)->o_flags & ON_UNCACHEABLE)

int ody_onode_make(struct inode **, struct ofid *, struct super_block *);
int ody_onode_makectl(struct inode **inode, struct super_block *sb);
int ody_onode_make_ucctl(struct inode **inode, struct super_block *sb);
struct inode *ody_fid_to_inode(struct ofid *fid, struct super_block *sb);


#endif
#endif
