#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#define MAX_OPTYPES 32

struct optype {
    u_short pid;  /* later, list of pids */
    int num_params, num_discrete, num_continuous, num_fids;
    fid_param_t *discrete_params, *continuous_params;
    func_t *rsrc_hints[R_LAST];
    double constraints[Q_LAST];
    func_t utility;
};


/* Defines used internally by the multif support code */

extern int multif_register_fidelity        __P((int num_params,
						fid_param_t *params,
						int num_fids,
						int *optype_idp,
						struct ody_cred *cred,
						u_short pid));

extern int multif_hint_constraint          __P((int optype_id,
						quality_t which_quality,
						double constraint,
						struct ody_cred *cred,
						u_short pid));

extern int multif_hint_resource            __P((int optype_id,
						rsrc_t which_resource,
						func_t rsrc_func,
						struct ody_cred *cred,
						u_short pid));

extern int multif_begin_fidelity_op        __P((int optype_id,
						int *opidp,
						int num_params,
						fid_param_val_t *fidparams,
						struct ody_cred *cred,
						u_short pid));

extern int multif_end_fidelity_op          __P((int optype_id,
						int opid,
						int num_params,
						fid_param_val_t *fidparams,
						int num_fids,
						fid_param_val_t *fids,
						struct ody_cred *cred,
						u_short pid));

