#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __BMOD_H__
#define __BMOD_H__

/* Defines information necessary for battery modulation */
struct bmod_data {
    ds_hwlock_t      bm_lock;
    int              bm_is_modulated;
    float            bm_joules_total;
    float            bm_joules_left;
    struct timeval   bm_recharge_time;
};

/* Function Prototypes */
void bmod_init ();
int bmod_start (int joules, float charge);
int bmod_stop ();
int bmod_drain (float joules);
int bmod_set_time_to_recharge (int seconds);

/* Query functions */
float bmod_get_charge ();
float bmod_get_total_joules ();
float bmod_get_remaining_joules ();
struct timeval bmod_get_time_to_recharge ();

#endif
