#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* cm_rpc2_timeout
   Set timeout values for RPC2 connections */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "base/ds/ds_thread.h"
#include "base/ds/ds_hash.h"
#include "base/ds/ds_hwlock.h"
#include "base/ds/ds_rrlist.h"

#include <lwp/lwp.h>
#include <lwp/timer.h>
#include <rpc2/rpc2.h>

#include "include/cm_rpc2.h"
#include "include/cm.h"
#include "cm.private.h"

int
cmgr_rpc2_settimeout(crhp, timeout)
    cmgr_rpc2_handle_t *crhp;
    struct timeval timeout;
{
    if (RPC2_SetTimeout(*crhp, timeout) < 0) 
	return CMGR_BADCONN;
    return 0;
}
