#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "include/odyssey.h"
#include "odyssey/multif/multif.h"
#include "odyssey/multif/libmultif.h"

int
main(argc, argv)
    int argc;
    char *argv[];
{
    char *instr;
    int  rc;
    struct ody_vers vers;
    char *abuf;
    char *rbuf;
    int  abufsz;
    int  rbufsz;

    if (argc != 2) {
	fprintf(stderr,"Usage: multiftest <somestring>\n");
	exit (-1);
    }

    instr = argv[1];
    abufsz = strlen(instr)+1;
    abuf = malloc(abufsz);
    strcpy(abuf, instr);
    rbufsz = 256;
    rbuf = malloc(rbufsz);
    
    vers.ov_gs = ODY_GENERIC_INTERFACE;
    vers.ov_type = ODY_NO_TYPE;
    vers.ov_tsvnum = MULTIF_VERSION;

    rc = ody_multif(&vers, MULTIF_TEST, abufsz, abuf, &rbufsz, rbuf);
    
    if (rc) {
	perror("ody_multif");
	exit (errno);
    }

    printf("multiftest (%s) returns %s (%d)\n", abuf, rbuf, rbufsz);
    return 0;
}
