#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "include/odyssey.h"

void
tickle(reqid, rsrc, val)
    int reqid;
    unsigned int rsrc;
    int val;
{
    printf("Notification for rsrc %u (val %d), req %d\n",
	   rsrc, val, reqid);
}

int
main(argc, argv)
    int argc;
    char *argv[];
{
    char *fname;
    int  result;
    int  rc;
    struct ody_req_des rd;

    if (argc != 2) {
	fprintf(stderr,"Usage: reqtest <fname>\n");
	exit (-1);
    }

    fname = argv[1];

    rd.ord_resource = ODY_GR_NETBW;
    rd.ord_version.ov_gs = ODY_GENERIC_INTERFACE;
    rd.ord_version.ov_type = ODY_NO_TYPE;
    rd.ord_version.ov_tsvnum = ODY_GENERIC_INTERFACE;
    rd.ord_low = 10000;
    rd.ord_high = 100000;
    rd.ord_fp = tickle;

    rc = ody_request(fname, &rd, &result);

    if (rc) {
	printf("result was %d\n", result);
	perror("ody_request");
	exit (errno);
    }
    
    printf("ody_request rsrc %u [%d .. %d] succeeded: req %d\n",
	   rd.ord_resource, rd.ord_low, rd.ord_high, result);

    
    while (1) {
	sleep(5);
    }
    return 0;
}
