#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _RSRC_PRIVATE_H_
#define _RSRC_PRIVATE_H_

#define WINDOW_TIME 30 /* seconds: how far back to look in logs */

#define RTT_SHIFT   2  /* equivalent to alpha of 3/4 */
#define BW_SHIFT    3  /* equivalent to alpha of 7/8 */
/*
 * Simple structures to be used by the netmonitor's multiple-stream
 * estimator.
 */

LIST_HEAD(rsrc_connlist, rsrc_connent);

/*
 * Structure used by rsrc_netmon to decide about performance
 */

struct rsrc_connent {
    cmgr_id_t                 ce_cid;
    cmgr_status_t             ce_status;
    cmgr_connection_t         *ce_connp;
    long                      ce_connid; /* XXX */

    /* Some per-log stats */
    int                       ce_rtt; /* In microseconds */

    /* Round trip logs */
    cmgr_log_t                ce_rttlog;
    cmgr_logent_t             ce_rlent[CMGR_MAXLOGLENGTH];

    /* Throughput logs */
    int                       ce_tlcur; 
    cmgr_log_t                ce_tplog;
    cmgr_logent_t             ce_tlent[CMGR_MAXLOGLENGTH];

    /* Fraction of bandwidth in this log */
    double                    ce_fraction;
    double                    ce_bytes;

    /* Link for the list o' connections */
    LIST_ENTRY(rsrc_connent)  ce_list;
};


struct rsrc_log_conn {
    long       rlc_connid;      /* Which connection */
    int        rlc_bandwidth;   /* That connection's bandwidth */
};

struct rsrc_logent {
    struct timeval        rle_tv;        /* Time observation is made */
    int                   rle_bandwidth; /* Total bandwidth */
    long                  rle_conns;     /* Number of connections active */
    struct rsrc_log_conn *rle_rlcp;      /* per-connection list */
};
    

#endif /* _RSRC_PRIVATE_H_ */
