#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "include/odyssey.h"

int
main(argc, argv)
    int argc;
    char *argv[];
{
    char *fname;
    int  rc;
    struct ody_vers vers;
    char *abuf;
    char *rbuf;
    int  fnlen;
    int  rbufsz;

    if (argc != 2) {
	fprintf(stderr,"Usage: tsop <fname>\n");
	exit (-1);
    }

    fname = argv[1];
    fnlen = strlen(fname);
    abuf = malloc(fnlen+1);
    strcpy(abuf, fname);
    rbufsz = (fnlen+1)*3;
    rbuf = malloc(rbufsz);
    
    vers.ov_gs = ODY_GENERIC_INTERFACE;
    vers.ov_type = ODY_NO_TYPE;
    vers.ov_tsvnum = ODY_GENERIC_INTERFACE;

    rc = ody_tsop(fname, &vers, 0, fnlen+1, abuf, &rbufsz, rbuf);
    
    if (rc) {
	perror("ody_tsop");
	exit (errno);
    }

    printf("tsop (%s) returns %s (%d)\n", abuf, rbuf, rbufsz);
    return 0;
}
