#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __BITWARDEN_H__
#define __BITWARDEN_H__

/* important constants */
#define BITWARDEN_VERSION   1
#define BIT_TTYPE         0x4

#define BITW_MAX_DEPTH       524288
#define BITW_DEFAULT_DEPTH   65536
#define BITW_MAX_CHUNK       262144
#define BITW_DEFAULT_CHUNK   4096
#define BITW_DEFAULT_WORKERS 4

/* little utility macros */
#define ms(t) (t.tv_usec/1000.0+t.tv_sec*1000)

/* quality control */
typedef struct bitw_quality {
    int prefetch_depth;		/* KB */
    int chunk_size;		/* KB */
} bitw_quality_t;

extern struct warden bit_warden;

/* TSOPs */
#define BITW_SET_PARAMS      1

int bits_set_params(int fd,
		    bitw_quality_t *qual,
		    bitw_quality_t **oldq);

#endif
