#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* prototypes of warden methods */

static int       bitw_parse_args    __P((int cur, int argc, char *argv[]));

static int       bitw_init          __P((struct warden *wp));

static int       bitw_root          __P((struct warden *wp,
					 tome_t        tome,
					 struct viceroy_onode  **root_onodep));

static int       bitw_lookup        __P((struct warden *wp,
					 struct viceroy_onode  *odp,
					 struct ody_cred  *cred,
					 char          *name,
					 char          **remain,
					 struct viceroy_onode  **opp));

static int       bitw_access        __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       bitw_getattr       __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_vattr  *vap,
					 struct ody_cred  *cred));

static int       bitw_open          __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       bitw_close         __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       bitw_rdwr          __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           rwflag,
					 int           *count,
					 int           offset,
					 int           ioflag,
					 void          **data));

static int       bitw_rdwr_dispose  __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           count,
					 int           offset,
					 void          *data));

static int       bitw_tsop          __P((struct warden *wp,
					 int           tsvnum,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           opnum,
					 size_t        argsz,
					 void          *argp,
					 size_t        *retsz,
					 void          **retp));

static int       bitw_tsop_dispose  __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           opnum,
					 size_t        argsz,
					 void          *argp,
					 size_t        retsz,
					 void          *retp));

static cmgr_id_t bitw_getcid        __P((struct warden *wp,
					 struct viceroy_onode  *op));

static void      bitw_pstats        __P((struct warden *wp,
					 FILE          *fp));

#ifdef SETS
static int       bitw_expand        __P((struct warden *wp,
					 struct viceroy_onode  *odp,
					 struct ody_cred  *cred,
					 char          *name,
					 char          **remain,
					 struct viceroy_onode  **opp));

static int       bitw_cursexpand    __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 size_t        size,
					 size_t        *retsz,
					 char          *buf));
#endif
