#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * bitwarden_onode.c -- handling of bitwarden private onode data
 *
 * this code handles the data hung off of the onode by the warden.
 */

#include <stdlib.h>
#include <stdio.h>

#include <kernel/vfs/includes/ody.h>
#include "include/viceroy_onode.h"
#include "include/odytypes.h"

#include "base/ds/ds_thread.h"
#include "base/ds/ds_hash.h"
#include "base/ds/ds_hwlock.h"
#include "base/ds/ds_rrlist.h"

#include "include/cm_rpc2.h"
#include "include/cm.h"

#include "bitwarden.h"
#include "bitwarden_onode.h"

void bitw_onode_data_free(void *dp) {
    /* cast this right off into the right kind of thing */
    struct bitw_onode_data *wodp = (struct bitw_onode_data *) dp;
    
    if (wodp == NULL)
	return;			/* ignore attempts to free NULL */
    
    FREE(wodp->buf.buf);	/* free checks for NULL
				 * XXX: is this ever needed? see bitw_close */
    
    FREE(wodp);
}
