#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * bitwarden_onode.h -- bitwarden specific onode information and handlers
 *
 */

typedef struct bitw_buffer {
    char              *producer; /* pointer to end of pfetched data */
    char              *consumer; /* pointer to start of pfetched data */
    int               producer_left; /* from producer to end of buf */
    int               consumer_left; /* from producer to end of buf */
    int               prefetched; /* how much data? (starts at consumer) */
    int               prefetching; /* is there a prefetching thread running? */
    char              *buf;	/* the storage! */
} bitw_buffer_t;

struct bitw_onode_data {
    long           bytes_read;
    cmgr_id_t      cid;
    bitw_buffer_t  buf;
    ds_hwlock_t    buf_lock;
    bitw_quality_t params;
    float          rpc_msec;
    long           chunk_count;
    int            cur_reqid; /* Used in internal-request demo */
    struct bitw_onode_data *prev; /* chain of bitw onodes */
    struct bitw_onode_data *next;
};

void bitw_onode_data_free(void *dp);
