#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* structures private to the bitwarden */

#define BITW_MAXTOME 10

struct bitw_tome {
    struct viceroy_onode *bwt_root_onode;
};

struct bitw_data {
    struct bitw_tome *bwd_tomes[BITW_MAXTOME]; /* tome structs */
    uniq_t         bwd_current_uniq; /* current uniqifier */
    bitw_quality_t bwd_quality;	     /* current quality level to use
				      * XXX drop this !?! */
    ds_safeq_t     *bwd_workq;	/* message queue for workers */
    ds_hwlock_t    *bwd_monitor;     /* provide rough-grain locking */
    struct bitw_onode_data *onode_list;	/* list of my onodes */
    struct timeval last_pstats;	/* time of last bitw_pstats */
};

/* tsop declarations */

int bitw_set_params(struct warden *wp,
		    struct viceroy_onode *op,
		    size_t        argsz,
		    void          *argp,
		    size_t        *retsz,
		    void          **retp);
