#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * bitwarden_worker.c
 *
 *  Kip Walker, Jan 1997
 *
 * main routine for worker threads (handling prefetch)
 */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#include "base/ds/ds_thread.h"
#include "base/ds/ds_hash.h"
#include "base/ds/ds_safeq.h"
#include "base/ds/ds_hwlock.h"
#include "base/ds/ds_rrlist.h"

#include <kernel/vfs/includes/ody.h>
#include "include/viceroy_onode.h"
#include "include/odyssey.h"
#include "include/odytypes.h"
#include "include/cm_rpc2.h"
#include "include/cm.h"
#include "include/warden.h"
#include "include/onode-manager.h"

#include "bitwarden.h"
#include "bitwarden_private.h"
#include "bitwarden_onode.h"
#include "bitwarden_rpc2.h"
#include "bitwarden_worker.h"

int bitw_worker_main(void *pp)
{
    struct bitw_worker_params *bwwp = (struct bitw_worker_params *)pp;
    struct bitw_worker_msg *msg;
    long len;
    
    while (1) {
	ds_thread_log(100, "worker trying to dequeue");
	msg = (struct bitw_worker_msg *)ds_safeq_deq(bwwp->workq);
	ds_thread_log(100, "worker got message");
	/* need to check a uniquifier or something to see that the
	   onode/buffer is still valid/open (msg->ofid_uniq) */
	switch(msg->type) {
	case PREFETCH:
	    ds_thread_log(0, "prefetching for %d\n", msg->d.prefetch.wod->cid);
	    len = bitw_prefetch(msg->d.prefetch.wod);
	    break;
	default:
	    break;
	}
	FREE(msg);
    }
}
