#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifdef WARDEN
#undef WARDEN
#endif

#include <stdio.h>
#include <string.h>

#include "include/odyssey.h"
#include "include/odytypes.h"
#include "base/ds/ds_thread.h"
#include "base/ds/ds_hash.h"
#include "base/ds/ds_hwlock.h"
#include "base/ds/ds_rrlist.h"

#include <include/viceroy_onode.h>
#include <kernel/vfs/includes/ody.h>
#include "include/cm_rpc2.h"
#include "include/cm.h"
#include "include/warden.h"
#include "include/onode-manager.h"

#include "mapwarden.h"
#include "libodymap_tsops.h"

/* Allows apps to specify how ANVIL map data type should be degraded by
   providing a list of ANVIL feature ids that should be filtered */
int map_set_filter (char *pathname, int* filterids, int num_ids)
{
    struct ody_vers vers;
    int              retsz = 0;

    /* Set up the Odyssey version structure */
    vers.ov_gs = ODY_GENERIC_INTERFACE;
    vers.ov_type = MAP_TTYPE;
    vers.ov_tsvnum = MAPWARDEN_VERSION;

    /* Make the TSOP - it does not allocate memory dynamically */
    return (ody_tsop (pathname, &vers, MAPW_SET_FILTER, 
		      num_ids * sizeof(int), filterids, &retsz, NULL));
}
