#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* API exported by Odyssey for operations on QuickTime objects */

#ifndef _ODY_QT_API_H_
#define _ODY_QT_API_H

#define QT_VERSION 1
#define QT_TTYPE 0x1

/* TSOPs applicable to QuickTime movies */

enum qt_tsop_nums {QT_OPENMOVIE=1,
		   QT_GETFRAME};

struct qtw_track_hdr {
    char codec_name[256];
    unsigned int compression_type, depth;
    int ave_fvid_size, max_fvid_size;
    int anim_type, imagex, imagey;
    int anim_flags;
    int total_time, last_frame;
    int act_type, cmap_rev;
};

struct qtw_frame_request {
    int track_ID;
    int zztime;
};

struct qtw_frame_info {
    int trackID;
    int frame_no;
    int time_dur;
    int zztime;
    unsigned xapi_rev;
    unsigned flags;
    unsigned xpos,ypos;
    unsigned xsize,ysize;
    unsigned special;
    unsigned size;
};

int ody_qt_openmovie        __P((int fd, int *num_tracks,
				 struct qtw_track_hdr *tracks));

int ody_qt_getframe         __P((int fd,
				 struct qtw_frame_request *frame_spec,
				 struct qtw_frame_info *frame,
				 int vidcodec_maxsize));

int ody_qt_path_openmovie        __P((char *path, int *num_tracks,
				      struct qtw_track_hdr *tracks));

int ody_qt_path_getframe         __P((char *path,
				      struct qtw_frame_request *frame_spec,
				      struct qtw_frame_info *frame,
				      int vidcodec_maxsize));

#endif /* _ODY_QT_API_H */

