#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* non-RPC2 data structures passed to from the QuickTime server */
/* relies on int32_t, u_int32_t, being defined correctly for the target
   platform */
/* when shipped, the integers are to be sent in network byte order */
/* if you use htonl, ntohl, make sure they operate on 32-bit integers */

typedef struct {
char codec_name[256];
int32_t compression_type, depth;
int32_t ave_fvid_size, max_fvid_size;
int32_t anim_type, imagex, imagey;
int32_t anim_flags;
int32_t total_time, last_frame;
int32_t act_type, cmap_rev;
}
QT_TrackHdr;

typedef struct {
int32_t track_ID;
int32_t frame_no;
int32_t time_dur;
int32_t zztime;
u_int32_t xapi_rev;
u_int32_t flags;
u_int32_t xpos,ypos;
u_int32_t xsize,ysize;
u_int32_t special;
u_int32_t bufpos;
u_int32_t size;
}
QT_FrameInfo;
