#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef _QT_WARDEN_PRIVATE_H
#define _QT_WARDEN_PRIVATE_H

#define QT_MAXTOMES   10

/* Distinguishing the root onode from its children which are movie onodes */
#define QT_ROOT_VNUM  0
#define QT_ROOT_UNIQ  0
#define QT_MOVIE_UNIQ 1  

/* Onode specific data */
struct onode_data {
    cmgr_id_t od_cid;
    int num_tracks;
    int thumbnail_track; /* 1 if track 0 is to be fetched as thumbnail */
    struct qtw_track_hdr *all_hdrs;
    int already_opened;
    struct qtw_prefetch *prefetch;
    struct cache_entry *thumbnail;
    int thumbnail_fd;
    QT_FrameInfo *thumbnail_frame_list;
};

/* the hostnames of the tome servers -- cannot be in the warden structure,
   since it is accessed by the parseargs routine, which comes before the
   init routine */

/* Tome specific data */
struct qtt_data {
    cmgr_id_t qtd_cid;
    struct viceroy_onode *qtd_root_onode;
};

struct qtw_data {
    struct qtt_data *qtw_tome[QT_MAXTOMES];
    int qtw_pf_avail;             /* # prefetch worker threads available */
    ds_safeq_t *qtw_prefetch_req; /* queue of prefetch requests for worker
				     threads */
    struct cache_entry *qtw_cache_files;
    int qtw_ncache_files;
};

#endif /* _QT_WARDEN_PRIVATE_H */

