#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * qtw_cache.h
 *
 * manage the viceroy-supported disk cache for the QuickTime warden
 */

#define CACHE_SPACE 8192 /* max kilobytes to cache */
#define CACHE_FILES 32   /* max objects to cache */

/* Cache-entry specific data */
struct qtw_cache_data {
    struct viceroy_onode *qtwc_op;
};

/* Get a new (unused) cache entry */
struct cache_entry *qtw_cache_create(struct cache_entry *cache_files,
				     int ncache_files,
				     struct viceroy_onode *op);

/* Open a cache entry for read/write, return a file descriptor */
int qtw_cache_open(struct cache_entry *cep, int flags);

/* Close a cache entry that was opened for read/write */
int qtw_cache_close(struct cache_entry *cep, int fd, int modified);

/* release a cache entry */
void qtw_cache_release(struct cache_entry *cep);
