#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __LIBODYSPEECH_TSOPS_H__
#define __LIBODYSPEECH_TSOPS_H__

typedef struct {
  char localEnabled;
  char hybridEnabled;
  char remoteEnabled;
  float localFidelity;
  float hybridFidelity;
  float remoteFidelity;
  float localRecPerByteCost;
  float hybridVQPerByteCost;
  float hybridRecPerByteCost;
  float remoteRecPerByteCost;
} StrategyModel;

enum strategyType { SPEECHW_STRATEGY_LOCAL,
		    SPEECHW_STRATEGY_HYBRID,
		    SPEECHW_STRATEGY_REMOTE };

enum fidelityType { SPEECHW_FIDELITY_REDUCED,
		    SPEECHW_FIDELITY_FULL };

/* Function prototypes */
int speechSetStrategy (int fd, enum strategyType strategy);
int speechSetFidelity (int fd, enum fidelityType fidelity);
int speechInitModel (int fd, char* model, StrategyModel* pModel);
int speechRecognize (int fd, char* model, char* utterance, int uttlen,
		     char* outputBuffer, int outbuflen);
int speechCloseModel (int fd, char* model);
#if 0
int speechSetSearchEffort (int fd, float effort);
#endif
int dumpStats (int fd, char* filename);

#endif
