#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __ODYJANUS_H__
#define __ODYJANUS_H__

/* Possible data types */
#define DATATYPE_ADC 'A'
#define DATATYPE_MEL 'M'
#define DATATYPE_HYP 'H'
#define DATATYPE_LOAD_MODEL 'L'
#define DATATYPE_UNLOAD_MODEL 'U'

/* Maximum string length for recognized speech */
#define DEF_TRANSLATION_SIZE 256

/* Temporary file name used to store ADC files */
#define TEMP_FILENAME "/tmp/odyjanus.adc"

/* Name and path of RPC server program */
#define RPC_SERVER_PROG "speechsrv"
#define OPT_RPC_SERVER_PROG "speechsrv" /* For now */

/* An input header defines data to be sent on the pipe to the Janus server */
typedef struct {
  char inputType;
  char outputType;
  /*  int searchEffortPercent; */
  char model[256];
  char fidelity[16];
  int inputDataLength;
} InputHeader;

/* An output header defines data to be sent on the pipe from the Janus server */
typedef struct {
  int rc;
  int outputDataLength;
} OutputHeader;

#endif
