#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifndef __SPEECHW_COMM_H__
#define __SPEECHW_COMM_H__

/* Flags which say whether a connection is local or not */
#define ISLOCAL  1
#define NOTLOCAL 0

/* Function Prototypes */
int speechwConnectToServers (ServerLocations* pLocations, 
			     SpeechConnections* pConnections);
cmgr_id_t speechwConnectToServer (char* hostname, int port, int islocal);
cmgr_connection_t* speechwGetConnection (cmgr_id_t connectionId);
int speechwInitModelRPC (cmgr_id_t connectionId, char* model, float* pFidelity,
			 float* pRecPerByteCost, float* pVQPerByteCost, 
			 float* pRecNoVQPerByteCost);
int speechwCloseModelRPC (cmgr_id_t connectionId, char* model);
int speechwMakeRPC (cmgr_id_t connectionId, cmgr_connection_t* pConnection,
		    RecognitionParms* pRecognitionParms, int* pJanusRC, 
		    RPC2_BoundedBS* pTranslationBBS, SE_Descriptor sed,
		    struct timeval* ptvStart, struct timeval* ptvEnd);
int speechwRecognizeADC (cmgr_id_t connectionId, char* model, char* fidelity,
			 char* buffer, int len, char** pTranslation, 
			 /* int searchEffortPercent, */
			 struct timeval* ptvStart, struct timeval* ptvEnd);
int speechwCreateMEL (cmgr_id_t connectionId, char* buffer, int len,
		      char** pFilename, struct timeval* ptvStart, 
		      struct timeval* ptvEnd);
int speechwRecognizeMEL (cmgr_id_t connectionId, char* mdoel, char* fidelity,
			 char* filename,
			 char** pTranslation, /* int searchEffortPercent, */
			 struct timeval* ptvStart, struct timeval* ptvEnd);
int speechwGetTranslationLocal (SpeechClientData* pData, 
				SpeechConnectionData* pConn, char* model,
				char* buffer, int len, char** pTranslation);
int speechwGetTranslationIntermediate (SpeechClientData* pData, 
				       SpeechConnectionData* pConn,
				       char* model, char* buffer, int len, 
				       char** pTranslation);
int speechwGetTranslationRemote (SpeechClientData* pData, 
				 SpeechConnectionData* pConn, char* model,
				 char* buffer, int len, char** pTranslation);
int speechwGetTranslation (struct viceroy_onode* op, SpeechClientData* pData,
			   SpeechConnectionData* pConn, char* model,
			   char* buffer, int len, char** pTranslation);

#endif
