#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* prototypes of warden methods */

static int       wboard_parse_arg   __P((int cur, int argc, char *argv[]));

static int       wboard_init        __P((struct warden *wp));

#ifdef INSTRUMENTED
static void      wboard_pstats      __P((struct warden *wp,
					 FILE *));
#endif

static int       wboard_root        __P((struct warden *wp,
					 tome_t        tome,
					 struct viceroy_onode  **root_onodep));

static int       wboard_lookup      __P((struct warden *wp,
					 struct viceroy_onode  *odp,
					 struct ody_cred  *cred,
					 char          *name,
					 char          **remain,
					 struct viceroy_onode  **opp));

static int       wboard_access      __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       wboard_getattr     __P((struct warden *wp,
					 struct viceroy_onode *op,
					 struct ody_vattr *vap,
					 struct ody_cred *cred));

static int       wboard_tsop         __P((struct warden *wp,
					 int           tsvnum,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           opnum,
					 size_t        argsz,
					 void          *argp,
					 size_t        *retsz,
					 void          **retp));

static int       wboard_tsop_dispose __P((struct warden *wp,
					  struct viceroy_onode  *op,
					  struct ody_cred  *cred,
					  int           opnum,
					  size_t        argsz,
					  void          *argp,
					  size_t        retsz,
					  void          *retp));

static cmgr_id_t wboard_getcid       __P((struct warden *wp,
					  struct viceroy_onode  *op));
