#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#define DEFAULT_CACHE_SIZE 20480   /* 20 MB */
#define AVERAGE_PAGE_SIZE     16   /* for picking #cfiles */
#define	MIN(a,b) (((a)<(b))?(a):(b))

TAILQ_HEAD(webw_cache_head, cache_entry);

void webw_cache_init(struct cache_entry *cfile_list);
void webw_cache_add_cfiles(struct cache_entry *cfile_list);
int webw_cache_lookup(char *url, struct cache_entry **c_entry);
struct cache_entry *webw_cache_enter(char *key,
				     struct viceroy_onode *op,
				     int flags,
				     struct webw_page_data *wpdata);

int webw_dump_dbuf(struct webw_dbuf *chain, int fd);
int webw_cache_readdir(int offset, int count, void *data);
int webw_cache_flush(void);
