#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifdef INSTRUMENTED

/*
 * webwarden_instr.c -- instrumentation support code for web warden
 */

#include <stdlib.h>
#include <stdio.h>

#include <odyssey.h>
#include <odytypes.h>
#include <ds_safeq.h>
#include <ds_thread.h>
#include <ds_hash.h>
#include <ds_hwlock.h>
#include <ds_histo.h>
#include <ds_rrlist.h>

#include <include/viceroy_onode.h>
#include <cm_rpc2.h>
#include <cm.h>
#include <warden.h>
#include <onode-manager.h>

#include "swww.h"
#include "webwarden.h"
#include "webwarden-private.h"
#include "webwarden_instr.h"

/*
 * webw_init_histo -- accepts a point to the web warden's data structure,
 *                    and does the necessary initializations for the
 *                    web warden's histograms
 */
void webw_init_histo(struct webw_data *wp)
{
    struct webw_histos *histos;
    int                 rc = 0;

    ALLOC(wp->wwd_histos, struct webw_histos);
    histos = wp->wwd_histos;
    
    /* XXX these are all just first guesses as to how these should look */
    rc += InitHisto(&(histos->wh_obj_sizes),     0, 200, 400, LINEAR);
    rc += InitHisto(&(histos->wh_obj_times),     0, 300, 600, LINEAR);
    rc += InitHisto(&(histos->wh_obj_speeds),    0,  10,  50, LINEAR);

    rc += InitHisto(&(histos->wh_buf_perobject), 0,  40,  40, LINEAR);
    rc += InitHisto(&(histos->wh_buf_sizes),     0,  33,  33, LINEAR);
    rc += InitHisto(&(histos->wh_buf_times),     0,  10,  50, LINEAR);
    rc += InitHisto(&(histos->wh_buf_speeds),    0,  10,  50, LINEAR);

    /* XXX 100 seems to be an overflow! */
    rc += InitHisto(&(histos->wh_fidelities),    0, 101, 101, LINEAR);

    ASSERT(rc == 0);
}

#endif /* INSTRUMENTED */
