#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * STRUCTURES
 */
struct webw_histos {
    /* object-centric */
    struct hgram wh_obj_sizes;	    /* dist. of obj. sizes         (KB) */
    struct hgram wh_obj_times;      /* dist. of obj. fetch times   (sec) */
    struct hgram wh_obj_speeds;     /* dist. of obj. fetch speeds  (KB/sec) */

    /* buffer-centric */
    struct hgram wh_buf_perobject;  /* dist. of buffers used per object */
    struct hgram wh_buf_sizes;	    /* dist. of buffer sizes       (KB) */
    struct hgram wh_buf_times;      /* dist. of buffer fetch times (sec) */
    struct hgram wh_buf_speeds;     /* dist. of buffer speeds      (KB/sec) */

    /* fidelity-centric */
    struct hgram wh_fidelities;     /* dist. of fidelities used */
};

/*
 * PROTOTYPES
 */

void webw_init_histo(struct webw_data *wp);
