#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* defines */

#define WEBW_WORKERS     4
#define WEBW_PREFETCHERS 8

/* prototypes of warden methods */

static int       webw_parse_arg     __P((int cur, int argc, char *argv[]));

static int       webw_init          __P((struct warden *wp));

#ifdef INSTRUMENTED
static void      webw_pstats        __P((struct warden *wp,
					 FILE *));
#endif

static int       webw_root          __P((struct warden *wp,
					 tome_t        tome,
					 struct viceroy_onode  **root_onodep));

static int       webw_lookup        __P((struct warden *wp,
					 struct viceroy_onode  *odp,
					 struct ody_cred  *cred,
					 char          *name,
					 char          **remain,
					 struct viceroy_onode  **opp));

static int       webw_access        __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       webw_getattr       __P((struct warden *wp, 
					 struct viceroy_onode  *op,
					 struct ody_vattr  *vap,
					 struct ody_cred  *cred));

static int       webw_open          __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       webw_close         __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           mode));

static int       webw_rdwr          __P((struct warden *wp,
					 struct viceroy_onode *op,
					 struct ody_cred *cred,
					 int rwflag,
					 int *count,
					 int offset,
					 int ioflag,
					 void **data));

static int       webw_rdwr_dispose  __P((struct warden *wp,
					 struct viceroy_onode *op,
					 struct ody_cred *cred,
					 int count,
					 int offset,
					 void *data));

static int       webw_readdir       __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           *count,
					 int            offset,
					 void          *data));

static int       webw_tsop          __P((struct warden *wp,
					 int           tsvnum,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           opnum,
					 size_t        argsz,
					 void          *argp,
					 size_t        *retsz,
					 void          **retp));

static int       webw_tsop_dispose  __P((struct warden *wp,
					 struct viceroy_onode  *op,
					 struct ody_cred  *cred,
					 int           opnum,
					 size_t        argsz,
					 void          *argp,
					 size_t        retsz,
					 void          *retp));

static cmgr_id_t   webw_getcid      __P((struct warden *wp,
					 struct viceroy_onode  *op));
