#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/* structures private to the webwarden */

struct webw_data {
    char               *wwd_server;       /* server name */
    cmgr_id_t           wwd_cid;          /* RPC2 conn. ID to wwd_server */
    ds_safeq_t         *wwd_workq;	  /* queue for worker threads */
#ifdef SETS
    ds_safeq_t         *wwd_prefq;	  /* queue for prefetch threads */
#endif
    uniq_t              wwd_current_uniq; /* current uniqifier */
    webw_quality_t      wwd_img_quality;  /* current image quality level */
    webw_quality_t      wwd_html_quality; /* current html quality level */
    ds_hwlock_t        *wwd_monitor;      /* provide rough-grain locking */
#ifdef INSTRUMENTED
    struct webw_histos *wwd_histos;       /* pointer to web warden's
					     measurement data structures */
#endif /* INSTRUMENTED */
};
