#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

#ifdef SETS

#define MAX_TEXT_LEN    256
#define URL_LIST_LEN    OC_MAXDATASIZE /* this is important because it forces
					* the producer to truncate the url
					* list in a way that will avoid 
					* splitting entries when delivering
					* to the kernel */
#define SKIPWHITESPACE(c) while (isspace(c[0])) c++;

#define PARSE_LINKS     0x01
#define PARSE_IMGS      0x02

int       webw_sets_init     __P((void));

int       webw_expand        __P((struct warden *wp,
				  struct viceroy_onode  *odp,
				  struct ody_cred  *cred,
				  char          *name,
				  char          **remain,
				  struct viceroy_onode  **opp));

int       webw_cursexpand    __P((struct warden *wp,
				  struct viceroy_onode  *op,
				  struct ody_cred  *cred,
				  size_t        size,
				  size_t        *retsz,
				  char          *buf));

int       webw_prefetch      __P((struct warden *wp,
				  struct viceroy_onode  *op,
				  struct ody_cred  *cred,
				  int            mode));

void      webw_parsehtml     __P((char               *url,
				  struct webw_urlbuf *list,
				  struct warden      *wp,
				  int                 action));

void      findAttrValue       __P((char  *start,
				   char  *name,
				   int    namelen,
				   char **attr_value,
				   int   *aval_len));

char     *makeAbsolute       __P((char *url,
				  char *link,
				  int   linklen));

int       processAbsoluteLink __P((struct webw_urlbuf *list,
				   char               *newlink));

int       webw_pick_filter    __P((char *url,
				   struct webw_urlbuf *the_list));

int       webw_find_string    __P((char *text,
				   struct webw_dbuf *start_dbuf,
				   int start_offset,
				   struct webw_dbuf **found_dbuf,
				   int *found_offset));

int       webw_do_prefetch      __P((struct warden *wp,
				     struct viceroy_onode  *op,
				     struct ody_cred  *cred,
				     int            mode,
				     fetch_type     prefetch_mode));

int       webw_filter_url       __P((char *url,
				     struct webw_urlbuf *list));

#endif
