#ifndef _ODYBLURB_
#define _ODYBLURB_
/*
 *          Odyssey: an Experimental Platform for Mobile Computing
 *  
 *            Copyright (c) 1997-2000 Carnegie Mellon University
 *                   Additional copyrights listed below
 * 
 *  This  code  is  distributed "AS IS" without warranty of any kind under
 *  the terms of the GNU General Public Licence Version 2, as shown in the
 *  file  LICENSE.  The  technical and financial  contributors to Odyssey
 *  are listed in the file CREDITS.
 * 
 *                         Additional copyrights
 *                            none currently
 */
#endif /* _ODYBLURB_ */

/*
 * macros
 */

/* this is a client-only, non-general macro (not to be confused with a
   similar one used by the server). I assume that the client is the sink */
#define setupVMSE(descriptor, vmaddr, vmlen) \
        bzero(descriptor, sizeof(SE_Descriptor)); \
        (descriptor)->Tag = SMARTFTP; \
        (descriptor)->Value.SmartFTPD.Tag = FILEINVM; \
        (descriptor)->Value.SmartFTPD.TransmissionDirection = SERVERTOCLIENT; \
        (descriptor)->Value.SmartFTPD.ByteQuota = -1; \
        (descriptor)->Value.SmartFTPD.FileInfo.ByAddr.vmfile.SeqBody = vmaddr;\
        (descriptor)->Value.SmartFTPD.FileInfo.ByAddr.vmfile.MaxSeqLen = vmlen;

#define WEBW_RPC2_ERROR_MESSAGE "<HR> <H1>Transfer interrupted " \
                                "(lost contact with Odyssey webserver)</H1>\n"

/*
 * structs
 */

/* initialization parameters for the worker thread */
struct webw_worker_params {
    int               wwp_num;
    ds_safeq_t       *wwp_workq;
    struct webw_data *wwp_data;
};

#define WEBW_REQ_FETCH    1
#define WEBW_REQ_PARSE    2

/* requests passed to the worker via the workq */
struct webw_worker_request {
    struct viceroy_onode   *wwr_op;
    cmgr_id_t       wwr_cid;	/* XXX put in union - only for REQ_FETCH */
    int             wwr_reqid;	/* XXX put in union - only for REQ_FETCH */
    int             wwr_reqtype;
#ifdef INSTRUMENTED
    struct timeval  wwr_fetchstart; /* time fetch was started */
#endif /* INSTRUMENTED */
};

/*
 * prototypes
 */
int webw_worker_shell(void *pp);
void webw_worker_fetch(struct webw_worker_params *params,
		       struct webw_worker_request *req,
		       char                       *buffer);
void webw_worker_parse(struct webw_worker_request *req);
